/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager_$type } from "./IAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "./DVContainer";
import { Type, enumGetBox, typeCast, Point_$type, markType } from "./type";
import { DependencyProperty } from "./DependencyProperty";
import { TrendLineType_$type } from "./TrendLineType";
import { Brush } from "./Brush";
import { PenLineCap_$type } from "./PenLineCap";
import { DoubleCollection } from "./DoubleCollection";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ICategoryScaler_$type } from "./ICategoryScaler";
import { IScaler_$type } from "./IScaler";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior_$type } from "./ConsolidatedItemHitTestBehavior";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { Rect } from "./Rect";
import { IFastItemsSource_$type } from "./IFastItemsSource";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { NumericYAxis } from "./NumericYAxis";
import { ScalerParams } from "./ScalerParams";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { CollisionAvoider } from "./CollisionAvoider";
import { NonCollisionAvoider } from "./NonCollisionAvoider";
import { PropertyMetadata } from "./PropertyMetadata";
import { truncate, isNaN_ } from "./number";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
export class AnchoredCategorySeries extends CategorySeries {
    constructor() {
        super();
        this.oi = null;
        this.om = false;
        this.ok = null;
        this.of = null;
        this.op = null;
        this.mq = new CategoryFramePreparer(1, this, this.mu, this, this, this.mu.cl);
    }
    get oj() {
        if (this.oi == null) {
            this.oi = DVContainer.instance.createInstance(IAnchoredCategorySeriesInteractionManager_$type, () => this.b1.n);
        }
        return this.oi;
    }
    be() {
        let a = new AnchoredCategorySeriesView(this);
        return a;
    }
    h9(a) {
        super.h9(a);
        this.oe = a;
    }
    get valueColumn() {
        return this.ok;
    }
    set valueColumn(a) {
        if (this.ok != a) {
            let b = this.ok;
            this.ok = a;
            if (!this.om) {
                this.raisePropertyChanged("ValueColumn", b, this.ok);
            }
        }
    }
    get pa() {
        return this.c(AnchoredCategorySeries.oz);
    }
    set pa(a) {
        this.h(AnchoredCategorySeries.oz, a);
    }
    c5(a) {
        let b = new Rect(0, 0, 0, 1, 1);
        let c = this.fetchXAxis();
        let d = this.fetchYAxis();
        let e = this.k7(this.bh);
        let f = c != null ? this.mq.r(typeCast(ICategoryScaler_$type, c), b, b, e) : 0;
        return this.oj.c$a(this, this.valueColumn, c, d, f, a);
    }
    ob(a, b, c) {
        if (b < a || a < 0 || a > this.valueColumn.count || b < 0 || b > this.valueColumn.count || c == null) {
            return null;
        }
        let d = new Array((b - a) + 1);
        let e = c.b3;
        let f = null;
        if (e) {
            f = c.i$b;
        }
        for (let g = a; g <= b; g++) {
            let h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.by.item(g);
        }
        return d;
    }
    ie(a, b, c, d) {
        super.ie(a, b, c, d);
        if (this.oe.cx && this.oe.cw.g$b(a, b, c, d)) {
            this.it(false);
            this.h1();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.valueColumn);
                    this.valueColumn = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.valueColumn = this.bv(this.ot);
                }
                let e = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (e != null && !e.cb()) {
                    this.oe.cl.g(this.ej);
                    this.it(false);
                }
                break;
            case AnchoredCategorySeries.$$p[2]:
                if (this.by != null) {
                    this.by.deregisterColumn(this.valueColumn);
                    this.valueColumn = this.bv(this.ot);
                }
                this.op = this.ot;
                break;
            case "ValueColumn":
                if (this.oe.cx) {
                    this.oe.cw.g$i();
                }
                let f = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (f != null && !f.cb()) {
                    this.oe.cl.g(this.ej);
                    this.it(false);
                }
                break;
            case "TrendLineBrush":
                this.i4();
                break;
            case "ErrorBarSettings":
                this.it(false);
                break;
            case "TrendLineType":
                this.h1();
                break;
            case AnchoredCategorySeries.$$p[1]:
                this.it(false);
                break;
        }
    }
    am(a) {
        if (this.valueColumn == null || this.valueColumn.count == 0) {
            return null;
        }
        if (a == this.fetchXAxis()) {
            return new AxisRange(0, this.valueColumn.count - 1);
        }
        if (a == this.fetchYAxis()) {
            return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
        }
        return null;
    }
    hh(a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.oe.cl.g(this.ej);
                break;
        }
        if (this.oe.cx) {
            this.oe.cw.g$e(a, b, c, d);
        }
    }
    nl() {
        return this.on(this.mu);
    }
    on(a) {
        let b = 0;
        let c = a.bq;
        let d = a.bp;
        let e = this.getEffectiveViewport1(a);
        let f = typeCast(NumericYAxis.$, this.fetchYAxis());
        if (!c.isEmpty && !d.isEmpty && f != null) {
            let g = new ScalerParams(0, c, d, f.bz, e);
            b = f.dj(f.jq, g);
        }
        return b;
    }
    oy(a, b, c) {
        let d = this.on(c);
        if (a.count > 0) {
            let e = d;
            a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
            a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
        }
    }
    oc(a, b, c, d) {
        return this.od(a, b, c, d, false);
    }
    od(a, b, c, d, e) {
        return CategorySeries.mg(a, b, c, d, e);
    }
    ds(a, b, c) {
        let d = super.ds(a, b, c);
        let e = c;
        if (this.valueColumn == null || this.valueColumn.count == 0 || e.cl.d < 1) {
            d = false;
        }
        return d;
    }
    he(a, b) {
        super.he(a, b);
        let c = b;
        c.cr();
        if (c.cx) {
            c.cw.g$d();
        }
    }
    nz(a, b) {
        super.nz(a, b);
        this.mr(b).d(a, b);
    }
    n2(a, b) {
        super.n2(a, b);
        let c = typeCast(AnchoredCategorySeriesView.$, b);
        c.by = true;
        if (c.cx) {
            c.cw.g$g(a.p);
        }
        if (this.li()) {
            CategoryMarkerManager.b(this, a.m, b.co, this.lk);
            this.nw(b, a);
            b.ch();
        }
        this.ov(a, b);
    }
    is(a, b, c, d, e) {
        super.is(a, b, c, d, e);
        let f = this.az.a$h.item(d);
        let g = f;
        g.cl.g(this.ej);
        f.ay(c);
        if (this.cb(g)) {
            return;
        }
        if (this.of == null) {
            this.of = new CategoryFrame(3);
        }
        this.of.u();
        this.nz(this.of, g);
        this.n2(this.of, g);
    }
    ov(a, b) {
    }
    i4() {
        super.i4();
        if (this.e6 < 0) {
            return;
        }
        this.oe.c1();
        if (this.trendLineBrush != null) {
            this.oe.cz();
        }
        else {
            this.oe.cy();
        }
    }
    fh(a, b) {
        if (this.oe.cx && a == this.oe.cw.g$j) {
            return null;
        }
        return super.fh(a, b);
    }
    get currentCategoryMode() {
        return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.fetchXAxis()));
    }
    get scaler() {
        return typeCast(ICategoryScaler_$type, this.fetchXAxis());
    }
    get yScaler() {
        return typeCast(IScaler_$type, this.fetchYAxis());
    }
    get bucketizer() {
        return this.oe.cl;
    }
    get currentMode2Index() {
        return this.no();
    }
    provideCollisionDetector() {
        if (this.og == 1) {
            return new CollisionAvoider();
        }
        return NonCollisionAvoider.a;
    }
    get trendlinePreparer() {
        return this.oe.cx ? this.oe.cw : null;
    }
    hn(a) {
        super.hn(a);
        if (this.oe.cx) {
            this.a1.exportTrendlineData(this, a, this.oe.cw.g$j);
        }
    }
    fe(a) {
        let b = this.fetchXAxis();
        let c = this.fetchYAxis();
        return this.oj.c$b(this, a, this.nm(this.bh), this.valueColumn, b, c, this.oh == 1, (d) => super.fe(d));
    }
    get mayContainUnknowns() {
        return this.valueColumn == null || this.valueColumn.mayContainUnknowns;
    }
    d8() {
        return this.valueColumn == null || this.valueColumn.count == 0 ? NaN : this.valueColumn.item(0);
    }
    an() {
        if (this.valueColumn == null) {
            return null;
        }
        let a = this.ml();
        let b = new ScalerParams(0, this.br.mk, this.br.mx, a.bz, this.getEffectiveViewport());
        let c = (a.dm(this.br.mx.left, b));
        let d = (a.dm(this.br.mx.right, b));
        let e = null;
        if (a.b3) {
            e = a;
            c = e.i$f(c);
            d = e.i$f(d);
        }
        else {
            c = Math.floor(c);
            d = Math.ceil(d);
        }
        if (isNaN_(c) || isNaN_(d)) {
            return null;
        }
        c = Math.max(0, Math.min(this.valueColumn.count - 1, c));
        d = Math.max(0, Math.min(this.valueColumn.count - 1, d));
        let f = 1.7976931348623157E+308;
        let g = -1.7976931348623157E+308;
        for (let h = truncate(c); h <= truncate(d); h++) {
            let i = h;
            if (e != null) {
                i = e.i$b._inner[h];
            }
            f = Math.min(f, this.valueColumn.item(i));
            g = Math.max(g, this.valueColumn.item(i));
        }
        return new AxisRange(f, g);
    }
    get useHighMarkerFidelity() {
        return this.nh;
    }
}
AnchoredCategorySeries.oz = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredCategorySeries.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
AnchoredCategorySeries.$t = markType(AnchoredCategorySeries, 'AnchoredCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasSingleValueCategory_$type, IHasCategoryTrendline_$type, ITrendLineSeries_$type]);
Type.dep(DependencyProperty, PropertyMetadata, AnchoredCategorySeries, 'raisePropertyChanged', ['ConsolidatedItemHitTestBehavior:oh:o0', [ConsolidatedItemHitTestBehavior_$type, enumGetBox(ConsolidatedItemHitTestBehavior_$type, 0)], 'MarkerCollisionAvoidance:og:o1', [CategorySeriesMarkerCollisionAvoidance_$type, enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, 1)], 'ValueMemberPath:ot:o9', [2, null], 'TrendLineType::o7', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::o6', [1, 1.5], 'TrendLinePeriod::o5', [1, 7], 'TrendLineBrush::o2', [Brush.$, null], 'TrendLineZIndex:oo:o8', [1, 1001], 'TrendLineDashArray:pb:o3', [DoubleCollection.$], 'TrendLineDashCap:pc:o4', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
export class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    constructor(a) {
        super(a);
        this.i = null;
        this.h = null;
        this.j = 0;
        this.i = a;
    }
    getBucketWithoutUnknowns(a) {
        let b = this.h;
        let c = this.j;
        let d = a * this.d;
        let e = d + this.d - 1;
        let f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        let g = 1.7976931348623157E+308;
        let h = -1.7976931348623157E+308;
        let i = true;
        for (let j = d; j <= e; ++j) {
            let k = b[j];
            g = g < k ? g : k;
            h = h > k ? h : k;
            i = false;
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    }
    getBucket(a) {
        let b = this.h;
        let c = this.j;
        let d = a * this.d;
        let e = d + this.d - 1;
        let f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        let g = 0;
        let h = 0;
        let i = true;
        for (let j = d; j <= e; ++j) {
            let k = b[j];
            if (!i) {
                if (!isNaN_(k)) {
                    g = g < k ? g : k;
                    h = h > k ? h : k;
                }
            }
            else {
                if (!isNaN_(k)) {
                    g = k;
                    h = k;
                    i = false;
                }
            }
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    }
    cacheValues() {
        this.j = this.i.cu.valueColumn.count;
        this.h = this.i.cu.valueColumn.asArray();
    }
    unCacheValues() {
        this.h = null;
    }
}
AnchoredCategoryBucketCalculator.$t = markType(AnchoredCategoryBucketCalculator, 'AnchoredCategoryBucketCalculator', CategoryBucketCalculator.$);
export class AnchoredCategorySeriesView extends CategorySeriesView {
    constructor(a) {
        super(a);
        this.cu = null;
        this.cv = null;
        this.cu = a;
    }
    get cw() {
        if (this.cv == null) {
            this.cv = CategoryTrendLineManagerFactory.a(this.cv, this.e.ao(), this.e.jc, this.e, this.e.b1);
        }
        return this.cv;
    }
    set cw(a) {
        this.cv = a;
    }
    get cx() {
        return this.cv != null;
    }
    c1() {
        this.cu.pa = null;
    }
    cz() {
        this.cu.pa = this.cu.trendLineBrush;
    }
    cy() {
        this.cu.pa = this.cu.ki;
    }
    cm() {
        return new AnchoredCategoryBucketCalculator(this);
    }
    c0() {
        this.cl.cacheValues();
    }
    c2() {
        this.cl.unCacheValues();
    }
    c3(a) {
        let b = this.co.item(a);
        return this.ck(b);
    }
    a2(a, b) {
        if (a.d) {
            if (this.cu.trendLineType != 0 && !b) {
                let c = this.cw.g$j;
                c.ac = this.cu.trendLineThickness;
                c._stroke = this.cu.pa;
                c.ai = this.cu.pb;
                c.ad = this.cu.pc;
                a.u(c);
            }
        }
        super.a2(a, b);
    }
    getDefaultTooltipTemplate() {
        return this.cu.oj.c$c(this.e, this.cu.ot);
    }
}
AnchoredCategorySeriesView.$t = markType(AnchoredCategorySeriesView, 'AnchoredCategorySeriesView', CategorySeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.AnchoredCategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.AnchoredCategorySeries" />*/
//# sourceMappingURL=AnchoredCategorySeries_combined.js.map