/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { typeCast, Type, markType, Point_$type, typeGetValue, fromEnum, runOn, Number_$type } from "./type";
import { AxisLabelPanelBaseView } from "./AxisLabelPanelBaseView";
import { Rect } from "./Rect";
import { Extensions } from "./Extensions";
import { Axis } from "./Axis";
import { List$1 } from "./List$1";
import { LabelPosition } from "./LabelPosition";
import { XamDataChart } from "./XamDataChart";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { IAngleScaler_$type } from "./IAngleScaler";
import { CategoryAxisRenderer } from "./CategoryAxisRenderer";
import { DependencyProperty } from "./DependencyProperty";
import { PolarAxisRenderingManager } from "./PolarAxisRenderingManager";
import { AxisLabelManager } from "./AxisLabelManager";
import { ViewportUtils } from "./ViewportUtils";
import { RadialAxisRenderingParameters } from "./RadialAxisRenderingParameters";
import { CategoryTickmarkValues } from "./CategoryTickmarkValues";
import { MathUtil } from "./MathUtil";
import { SeriesViewer } from "./SeriesViewer";
import { ScalerParams } from "./ScalerParams";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { PropertyMetadata } from "./PropertyMetadata";
import { isNaN_, isInfinity } from "./number";
import { NumericAxisBase } from "./NumericAxisBase";
import { LogarithmicTickmarkValues } from "./LogarithmicTickmarkValues";
import { PolarAxisRenderingParameters } from "./PolarAxisRenderingParameters";
import { RadialAxisLabelPanel } from "./RadialAxisLabelPanel";
import { LinearTickmarkValues } from "./LinearTickmarkValues";
import { RangeInfo } from "./RangeInfo";
import { IPolarRadialRenderingParameters_$type } from "./IPolarRadialRenderingParameters";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
export class AngleAxisLabelPanel extends AxisLabelPanelBase {
    constructor() {
        super();
        this.cr = false;
        this.cx = null;
        this.cv = 0;
        this.cs = 0;
        this.cu = 0;
        this.ct = 0;
    }
    ad() {
        return new AngleAxisLabelPanelView(this);
    }
    b6(a) {
        super.b6(a);
        this.cq = a;
    }
    ao(a, b) {
        if (!Extensions.b(b)) {
            return false;
        }
        if (this.ac == null || this.ac.ib.isEmpty) {
            return super.ao(a, b);
        }
        return true;
    }
    ay() {
        let a = new List$1(Rect.$, 0);
        if (this.a3.count != this.a2.count) {
            return a;
        }
        this.cq.aw(a);
        let b = false;
        this.am = this.al(a);
        if (!this.ac.br()) {
            b = true;
            this.a7 = this.cv / 2;
            this.a7 = this.a7 + this.cw();
        }
        else {
            b = true;
            this.cq.ab();
        }
        if (b) {
            for (let c = 0; c < a.count; c++) {
                let d = this.a3._inner[c];
                let e = this.a2._inner[c];
                let f = a._inner[c];
                let g = this.cx(e.a);
                let h = g.x - this.ba(d) / 2;
                let i = g.y - this.a9(d) / 2;
                f.x = h;
                f.y = i;
                a._inner[c] = f;
            }
        }
        return a;
    }
    cw() {
        let a;
        let b;
        b = this.ac;
        a = null;
        if (b != null) {
            a = typeCast(XamDataChart.$, b.a9);
        }
        if (a == null || b == null) {
            return 0;
        }
        let c = new List$1(Axis.$, 0);
        for (let d = 0; d < a.axes.count; d++) {
            let e = a.axes._inner[d];
            if ((typeCast(NumericAngleAxis.$, e) !== null || typeCast(CategoryAngleAxis.$, e) !== null) && typeCast(AngleAxisLabelPanel.$, e.ap) !== null && e.ap.a3.count > 0 && (!e.br()) && !e.bq() && (e.ag == null || this.ac.ag == null || e.ag.kv == b.ag.kv)) {
                c.add(e);
            }
        }
        let f = c.indexOf(b);
        if (f == -1) {
            return 0;
        }
        let g = 0;
        let h = 5;
        if (f == 0) {
            g += h;
        }
        else {
            g += c._inner[f - 1].ap.a7;
            g += c._inner[f].ap.a7 * 2 + h;
        }
        return g;
    }
    ah() {
        return 4;
    }
    as(a) {
        return a == 4 || a == 5;
    }
}
AngleAxisLabelPanel.$t = markType(AngleAxisLabelPanel, 'AngleAxisLabelPanel', AxisLabelPanelBase.$);
export class CategoryAngleAxis extends CategoryAxisBase {
    constructor() {
        super();
        this.ke = null;
        this.kb = null;
        this.kf = false;
        this.kj = NaN;
        this.kc = null;
        this.kk = 0;
        this.kh = 0;
        this.ki = 0;
        this.kv = 1;
        this.ab = CategoryAngleAxis.$;
        this.kb = this.ka();
        this.ke = new PolarAxisRenderingManager();
    }
    ax() {
        return new CategoryAngleAxisView(this);
    }
    f5(a) {
        super.f5(a);
        this.j9 = a;
    }
    get_bs() {
        return true;
    }
    get bs() {
        return this.get_bs();
    }
    ao() {
        let a = new AngleAxisLabelPanel();
        a.cx = (b) => {
            let c = this.a9 != null ? this.a9.mk : Rect.empty;
            let d = !c.isEmpty ? this.ib : Rect.empty;
            return this.k8(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, this.ap.a7);
        };
        return a;
    }
    kt(a) {
        return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
    }
    ka() {
        let a = ((() => {
            let $ret = new AxisLabelManager();
            $ret.a = this;
            $ret.f = this.ck;
            $ret.e = this.cj;
            $ret.b = this.ap;
            return $ret;
        })());
        if (this.as != null) {
            this.as.registerAxis(this);
        }
        let b = new CategoryAxisRenderer(a);
        b.u = () => {
            let c = this.ay.at();
            let d = this.ay.aw();
            let e = this.ay.au();
            let f = this.ay.av();
            this.gr();
            this.fv(c);
            this.fv(d);
            this.fv(e);
            this.fv(f);
        };
        b.o = (c, d) => !d.isEmpty && !c.isEmpty && this.kd != null;
        b.d = (c, d, e, f) => this.j8(c, d, e, f);
        b.v = () => {
            if (!this.kf) {
                this.kf = true;
                this.kd.cb();
                this.kf = false;
            }
        };
        b.g = (c) => {
            let d = typeGetValue(c);
            if (d > this.ir.count - 1) {
                d -= this.ir.count;
            }
            let e = this.ir.item(d);
            return this.eq(e);
        };
        b.b.c = (c) => {
            if ((this.as == null || this.as.visibility == 0) && this.kd != null && this.kj != c) {
                let d = typeCast(XamDataChart.$, this.a9);
                if (d == null) {
                    return;
                }
                this.kj = c;
                this.ap.a6 = c;
                d.hp();
                for (let e of fromEnum(d.axes)) {
                    if (e != this && typeCast(AngleAxisLabelPanel.$, e.ap) !== null) {
                        e.ay.y();
                    }
                }
            }
        };
        b.k = (c, d, e) => {
            let f = typeCast(RadialAxisRenderingParameters.$, c);
            this.ke.m(d, e, c.z, c.aa, f.minLength, f.maxLength, f.center);
        };
        b.l = (c, d, e, f) => {
            let g = typeCast(RadialAxisRenderingParameters.$, c);
            this.ke.n(d, e, f, g.z, c.aa, g.minLength, g.maxLength, g.center);
        };
        b.m = (c, d) => this.getScaledAngle(d);
        b.q = (c, d) => {
            if (this.kt(d - this.kk) < 0) {
                return false;
            }
            if (this.kt(d - this.kk - (2 * Math.PI)) > 0) {
                return false;
            }
            return true;
        };
        b.j = (c) => {
            let d = typeCast(RadialAxisRenderingParameters.$, c);
            if (d.e == d.k._inner[0]) {
                this.ke.i(c.t, c.n, c.z, c.aa, d.center, d.minAngle, d.maxAngle);
            }
        };
        b.e = (c) => {
            c.n = this.kn();
            c.r = c.n;
        };
        b.p = (c, d, e) => {
            let f = typeCast(RadialAxisRenderingParameters.$, c);
            if (e) {
                return false;
            }
            let g = this.k8(d, f.center, c.aa, c.z, 0);
            if (g.x < c.z.right && g.x >= c.z.left && g.y < c.z.bottom && g.y >= c.z.top) {
                return true;
            }
            return false;
        };
        b.a = (c, d, e, f) => {
            let g = c.y;
            let h = new ScalerParams(0, c.aa, c.z, this.bz, g);
            let i = d;
            if (this.categoryMode != 0) {
                let j = (e * f) + 1;
                j = Math.min(j, this.ja);
                let k = this.dj(j, h);
                i = (d + k) / 2;
            }
            return i;
        };
        b.f = runOn(this, this.getGroupCenter);
        b.i = runOn(this, this.kq);
        return b;
    }
    k8(a, b, c, d, e) {
        let f = this.kn();
        let g = ViewportUtils.b(e, c, d);
        if (this.as != null && (this.as.c == 5 || this.as.c == 1)) {
            g *= -1;
        }
        let h = b.x + (f + g) * Math.cos(a);
        let i = b.y + (f + g) * Math.sin(a);
        h = ViewportUtils.c(h, c, d);
        i = ViewportUtils.f(i, c, d);
        return { $type: Point_$type, x: h, y: i };
    }
    kn() {
        if (this.kd == null) {
            return 0;
        }
        if (!this.bq()) {
            return this.kd.k0();
        }
        else {
            return this.kd.k1((this.eo));
        }
    }
    j8(a, b, c, d) {
        if (this.ir == null) {
            return null;
        }
        let e = new RadialAxisRenderingParameters();
        let f = this.ir.count - 1;
        let g = this.ay.at();
        let h = this.ay.aw();
        let i = this.ay.au();
        let j = this.ay.av();
        e.t = g;
        e.w = h;
        e.u = i;
        e.v = j;
        e.l = f;
        e.m = 0;
        e.h = false;
        e.z = a;
        e.y = c;
        e.x = d;
        e.aa = b;
        e.g = this.kg();
        e.p = this.kr;
        e.o = this.dw();
        e.q = this.ks;
        e.s = this.er;
        let k = this.ke.f(b);
        let l = this.ke.g(b);
        let m = 0.5 * this.kd.kv;
        let n = 0.5 * this.kd.ku;
        let o = k;
        let p = l;
        let q = this.kd.k0();
        if (isNaN_(q) || isInfinity(q)) {
            return null;
        }
        if (p >= m) {
            p = q;
        }
        if (o < n) {
            o = n;
        }
        let r = a.width;
        this.ke.k(b, e, 0, this.ir.count, this.bz, runOn(this, this.getUnscaledAngle), r);
        let s = { $type: Point_$type, x: 0.5, y: 0.5 };
        e.center = s;
        e.maxLength = p;
        e.minLength = o;
        e.effectiveMaximum = q;
        e.ae = this.ir.count;
        e.ab = this.categoryMode;
        e.ad = true;
        e.ac = this.bz;
        e.af = this.jd;
        e.f = new CategoryTickmarkValues();
        e.j = this.b9;
        return e;
    }
    getMinMaxAngle(a, b, c) {
        let d = this.ke.l(a, b, c);
        b = d.p1;
        c = d.p2;
        return {
            p1: b,
            p2: c
        };
    }
    ac() {
        super.ac();
        this.gj(false);
    }
    get kd() {
        if (this.kc != null) {
            return this.kc;
        }
        let a = typeCast(XamDataChart.$, this.a9);
        if (a != null) {
            for (let b = 0; b < a.axes.count; b++) {
                if (typeCast(NumericRadiusAxis.$, a.axes._inner[b]) !== null) {
                    return a.axes._inner[b];
                }
            }
        }
        return this.kc;
    }
    set kd(a) {
        this.kc = a;
    }
    ah() {
        return this.kd;
    }
    getCategorySize(a, b, c) {
        return 2 * Math.PI / this.ja;
    }
    i3(a, b, c) {
        let d = !isNaN_(this.i0) ? MathUtil.b(this.i0, 0, 1) : 0;
        let e = 0;
        if (!isNaN_(this.i7)) {
            e = Math.min(this.i7, 1);
        }
        let f = 1 - 0.5 * d;
        return this.getCategorySize(a, b, c) * f / (this.jd - (this.jd - 1) * e);
    }
    getGroupCenter(a, b, c, d) {
        let e = 0.5;
        if (this.jd > 1) {
            let f = !isNaN_(this.i0) ? MathUtil.b(this.i0, 0, 1) : 0;
            let g = 0;
            if (!isNaN_(this.i7)) {
                g = Math.min(this.i7, 1);
            }
            let h = 1 - 0.5 * f;
            let i = h / (this.jd - (this.jd - 1) * g);
            let j = (h - i) / (this.jd - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    }
    kq(a) {
        let b = 0.5;
        if (this.jd > 1) {
            let c = !isNaN_(this.i0) ? MathUtil.b(this.i0, 0, 1) : 0;
            let d = 0;
            if (!isNaN_(this.i7)) {
                d = Math.min(this.i7, 1);
            }
            let e = 1 - 0.5 * c;
            let f = e / (this.jd - (this.jd - 1) * d);
            let g = (e - f) / (this.jd - 1);
            b = 0.25 * c + 0.5 * f + a * g;
        }
        return b;
    }
    gk(a) {
        super.gk(a);
        let b = this.a9 != null ? this.a9.mk : Rect.empty;
        let c = !b.isEmpty ? this.ib : Rect.empty;
        let d = this.h6();
        let e = this.h5();
        let f = this.kb.c(a, c, b, d, e);
        if (f != null) {
            this.kl = f.f.m;
            this.km = f.f.l;
        }
    }
    kp(a, b) {
        let c;
        let d;
        let e = this.ke.l(b, c, d);
        c = e.p1;
        d = e.p2;
        if (c == 0) {
            if (this.bz) {
                return this.ja;
            }
            else {
                return 0;
            }
        }
        let f = this.getUnscaledAngle(c);
        if (f < 0 || f > this.ja) {
            f = this.getUnscaledAngle(c + Math.PI * 2);
        }
        return f;
    }
    ko(a, b) {
        let c;
        let d;
        let e = this.ke.l(b, c, d);
        c = e.p1;
        d = e.p2;
        if (d > Math.PI * 2) {
            d = d - Math.PI * 2;
        }
        if (d == Math.PI * 2) {
            if (this.bz) {
                return 0;
            }
            else {
                return this.ja;
            }
        }
        let f = this.getUnscaledAngle(d);
        if (f < 0 || f > this.ja) {
            f = this.getUnscaledAngle(d + Math.PI * 2);
        }
        return f;
    }
    getScaledAngle(a) {
        let b = this.ja;
        let c = b >= 2 ? (a) / (b) : b == 1 ? 0.5 : NaN;
        if (this.b0) {
            c = 1 - c;
        }
        return (c * 2 * Math.PI) + this.kk;
    }
    getUnscaledAngle(a) {
        if (a < this.kk) {
            a += 2 * Math.PI;
        }
        let b = (a - this.kk) / (2 * Math.PI);
        if (this.bz) {
            b = 1 - b;
        }
        return b * (this.ja);
    }
    dj(a, b) {
        return this.getScaledAngle(a);
    }
    dm(a, b) {
        return this.getUnscaledAngle(a);
    }
    f7(a, b, c, d) {
        super.f7(a, b, c, d);
        let e = typeCast(XamDataChart.$, this.a9);
        switch (b) {
            case "CrossingAxis":
                let f = typeCast(NumericRadiusAxis.$, d);
                this.k4(f);
                if (f != null) {
                    f.la(this);
                }
                this.b6 = true;
                this.gj(false);
                break;
            case CategoryAngleAxis.$$p[0]:
                this.kk = this.ku;
                while (this.kk < 0) {
                    this.kk += 360;
                }
                while (this.kk >= 360) {
                    this.kk -= 360;
                }
                this.kk = (this.kk * Math.PI) / 180;
                this.b6 = true;
                this.gj(false);
                for (let g of fromEnum(this.cl)) {
                    g.it(false);
                    g.h1();
                }
                break;
            case "Label":
                if (e != null) {
                    for (let h of fromEnum(e.axes)) {
                        h.b6 = true;
                        h.gi();
                    }
                }
                break;
            case "CrossingValue":
                if (e != null) {
                    for (let i of fromEnum(e.axes)) {
                        if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                            i.b6 = true;
                            i.gi();
                        }
                    }
                }
                break;
            case "LabelSettings":
                this.kb = this.ka();
                this.k2();
                this.b6 = true;
                this.gj(false);
                break;
        }
    }
    k2() {
        this.kj = NaN;
    }
    k4(a) {
        this.kd = a;
    }
    get kr() {
        return this.c(CategoryAngleAxis.k5);
    }
    set kr(a) {
        this.h(CategoryAngleAxis.k5, a);
    }
    get kl() {
        return this.kh;
    }
    set kl(a) {
        if (this.kl != a) {
            let b = this.kh;
            this.kh = a;
            this.gd("ActualInterval", b, this.kl);
        }
    }
    get ks() {
        return this.c(CategoryAngleAxis.k6);
    }
    set ks(a) {
        this.h(CategoryAngleAxis.k6, a);
    }
    get km() {
        return this.ki;
    }
    set km(a) {
        if (this.km != a) {
            let b = this.ki;
            this.ki = a;
            this.gd("ActualMinorInterval", b, this.km);
        }
    }
    kg() {
        return false;
    }
    get_av() {
        return 2;
    }
    get av() {
        return this.get_av();
    }
    cd() {
        if (this.b6 && this.ce) {
            this.a3 = this.a2();
        }
        if (this.ir == null) {
            return false;
        }
        let a = this.ir.count;
        if (a != this.kw) {
            let b = new AxisRangeChangedEventArgs(1, 1, this.kw, a);
            this.kw = a;
            this.ge(b);
            return true;
        }
        return false;
    }
    get kw() {
        return this.kv;
    }
    set kw(a) {
        this.kv = a;
    }
    get isVertical() {
        return this.b5;
    }
    j$c(a, b) {
        return this.dm.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dj.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.fz.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.f0.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.f1.apply(this, arguments);
    }
    get j$a() {
        return this.bz;
    }
}
CategoryAngleAxis.k5 = DependencyProperty.i("Interval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    a.gd("Interval", b.oldValue, b.newValue);
    a.gj(false);
}));
CategoryAngleAxis.k6 = DependencyProperty.i("MinorInterval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    (typeCast(CategoryAngleAxis.$, a)).gd("MinorInterval", b.oldValue, b.newValue);
    (typeCast(CategoryAngleAxis.$, a)).gj(false);
}));
CategoryAngleAxis.$t = markType(CategoryAngleAxis, 'CategoryAngleAxis', CategoryAxisBase.$, [IAngleScaler_$type]);
Type.dep(DependencyProperty, PropertyMetadata, CategoryAngleAxis, 'gd', ['StartAngleOffset:ku:k7', [1, 0]]);
export class NumericAngleAxis extends NumericAxisBase {
    constructor() {
        super();
        this.kr = null;
        this.ks = false;
        this.kt = NaN;
        this.ku = 0;
        this.kp = null;
        this.ab = NumericAngleAxis.$;
        this.kr = new PolarAxisRenderingManager();
        this.ir = this.ip();
    }
    ax() {
        return new NumericAngleAxisView(this);
    }
    f5(a) {
        super.f5(a);
        this.ko = a;
    }
    get_bs() {
        return true;
    }
    get bs() {
        return this.get_bs();
    }
    ao() {
        let a = new AngleAxisLabelPanel();
        a.cx = (b) => {
            let c = this.a9 != null ? this.a9.mk : Rect.empty;
            let d = !c.isEmpty ? this.ib : Rect.empty;
            return this.k4(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, this.ap.a7);
        };
        return a;
    }
    kv() {
        if (this.kq == null) {
            return 0;
        }
        if (!this.bq()) {
            return this.kq.k0();
        }
        else {
            return this.kq.k1((this.eo));
        }
    }
    kx(a) {
        return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
    }
    ip() {
        let a = super.ip();
        a.b.c = (b) => {
            if ((this.as == null || this.as.visibility == 0) && this.kq != null && this.kt != b) {
                let c = typeCast(XamDataChart.$, this.a9);
                if (c == null) {
                    return;
                }
                this.kt = b;
                this.ap.a6 = b;
                c.hp();
                for (let d of fromEnum(c.axes)) {
                    if (d != this && typeCast(AngleAxisLabelPanel.$, d.ap) !== null) {
                        d.ay.y();
                    }
                }
            }
        };
        a.e = (b) => {
            b.n = this.kv();
            b.r = b.n;
        };
        a.j = (b) => {
            let c = typeCast(PolarAxisRenderingParameters.$, b);
            if (c.e == c.k._inner[0]) {
                this.kr.i(b.t, b.n, b.z, b.aa, c.center, c.minAngle, c.maxAngle);
            }
        };
        a.k = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            this.kr.m(c, d, b.z, b.aa, e.minLength, e.maxLength, e.center);
        };
        a.l = (b, c, d, e) => {
            let f = typeCast(PolarAxisRenderingParameters.$, b);
            this.kr.n(c, d, e, f.z, b.aa, f.minLength, f.maxLength, f.center);
        };
        a.d = (b, c, d, e) => {
            let f = typeCast(PolarAxisRenderingParameters.$, this.is(b, c, d, e));
            return f;
        };
        a.v = () => {
            if (!this.ks) {
                this.ks = true;
                this.kq.cb();
                this.ks = false;
            }
        };
        a.m = (b, c) => this.getScaledAngle(c);
        a.o = (b, c) => !c.isEmpty && !b.isEmpty && this.kq != null;
        a.q = (b, c) => {
            if (this.kx(c - this.ku) < 0) {
                return false;
            }
            if (this.kx(c - this.ku - (2 * Math.PI)) > 0) {
                return false;
            }
            return true;
        };
        a.p = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            let f = this.k4(this.getScaledAngle(e.l), e.center, b.aa, b.z, 0);
            let g = this.k4(c, e.center, b.aa, b.z, 0);
            if (d && MathUtil.e(f.x - g.x, f.y - g.y) < 2) {
                return false;
            }
            if (g.x < b.z.right && g.x >= b.z.left && g.y < b.z.bottom && g.y >= b.z.top) {
                return true;
            }
            return false;
        };
        a.r = (b, c, d, e) => {
            if (c < b.m && typeCast(LogarithmicTickmarkValues.$, b.f) !== null) {
                return b.m;
            }
            else if (c > b.l && (typeCast(LogarithmicTickmarkValues.$, b.f) !== null || b.h)) {
                return b.l;
            }
            return c;
        };
        return a;
    }
    k4(a, b, c, d, e) {
        let f = this.kv();
        let g = ViewportUtils.b(e, c, d);
        if (this.as != null && (this.as.c == 5 || this.as.c == 1)) {
            g *= -1;
        }
        let h = b.x + (f + g) * Math.cos(a);
        let i = b.y + (f + g) * Math.sin(a);
        h = ViewportUtils.c(h, c, d);
        i = ViewportUtils.f(i, c, d);
        return { $type: Point_$type, x: h, y: i };
    }
    dj(a, b) {
        return this.getScaledAngle(a);
    }
    getScaledAngle1(a, b, c) {
        let d = 0;
        if (b) {
            d = (Math.log(a) - this.jm) / (this.jl - this.jm);
        }
        else {
            d = (a - this.jg) / (this.jf - this.jg);
        }
        if (c) {
            d = 1 - d;
        }
        return (d * 2 * Math.PI) + this.ku;
    }
    getScaledAngle(a) {
        return this.getScaledAngle1(a, this.i6, this.b0);
    }
    dm(a, b) {
        return this.getUnscaledAngle(a);
    }
    getUnscaledAngle(a) {
        let b = (a - this.ku) / (2 * Math.PI);
        if (this.bz) {
            b = 1 - b;
        }
        if (this.i6) {
            return Math.exp(b * (this.jl - this.jm) + this.jm);
        }
        else {
            return this.jg + b * (this.jf - this.jg);
        }
    }
    f7(a, b, c, d) {
        super.f7(a, b, c, d);
        let e = typeCast(XamDataChart.$, this.a9);
        switch (b) {
            case "CrossingAxis":
                let f = typeCast(NumericRadiusAxis.$, d);
                this.k2(f);
                if (f != null) {
                    f.la(this);
                }
                this.gj(false);
                break;
            case NumericAngleAxis.$$p[0]:
                this.ku = this.ky;
                while (this.ku < 0) {
                    this.ku += 360;
                }
                while (this.ku >= 360) {
                    this.ku -= 360;
                }
                this.ku = (this.ky * Math.PI) / 180;
                this.gj(false);
                for (let g of fromEnum(this.ci())) {
                    g.it(false);
                    g.h1();
                }
                break;
            case "Label":
                if (e != null) {
                    for (let h of fromEnum(e.axes)) {
                        h.gi();
                    }
                }
                break;
            case "CrossingValue":
                if (e != null) {
                    for (let i of fromEnum(e.axes)) {
                        if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                            i.gi();
                        }
                    }
                }
                break;
            case "LabelSettings":
                this.ir = this.ip();
                this.k0();
                this.b6 = true;
                this.gj(false);
                break;
        }
    }
    k0() {
        this.kt = NaN;
    }
    it() {
        return new PolarAxisRenderingParameters();
    }
    is(a, b, c, d) {
        let e = typeCast(PolarAxisRenderingParameters.$, super.is(a, b, c, d));
        let f = this.kr.f(b);
        let g = this.kr.g(b);
        let h = 0.5 * this.kq.kv;
        let i = 0.5 * this.kq.ku;
        let j = f;
        let k = g;
        let l = this.kq.k0();
        if (isNaN_(l) || isInfinity(l)) {
            return null;
        }
        if (k >= h) {
            k = l;
        }
        if (j < i) {
            j = i;
        }
        let m = a.width;
        this.kr.k(b, e, this.jg, this.jf, this.bz, runOn(this, this.getUnscaledAngle), m);
        let n = { $type: Point_$type, x: 0.5, y: 0.5 };
        e.center = n;
        e.maxLength = k;
        e.minLength = j;
        e.effectiveMaximum = l;
        return e;
    }
    getMinMaxAngle(a, b, c) {
        let d = this.kr.l(a, b, c);
        b = d.p1;
        c = d.p2;
        return {
            p1: b,
            p2: c
        };
    }
    gk(a) {
        super.gk(a);
        let b = this.a9 != null ? this.a9.mk : Rect.empty;
        let c = !b.isEmpty ? this.ib : Rect.empty;
        let d = this.h6();
        let e = this.h5();
        let f = this.ir.c(a, c, b, d, e);
        if (f != null) {
            this.je = f.f.m;
            this.jh = f.f.l;
        }
    }
    get kq() {
        if (this.kp != null) {
            return this.kp;
        }
        let a = typeCast(XamDataChart.$, this.a9);
        if (a != null) {
            for (let b = 0; b < a.axes.count; b++) {
                if (a.axes._inner[b].b2) {
                    return a.axes._inner[b];
                }
            }
        }
        return this.kp;
    }
    set kq(a) {
        this.kp = a;
    }
    ah() {
        return this.kq;
    }
    k2(a) {
        this.kq = a;
    }
    gu(a, b) {
        super.gu(a, b);
        if (b.height != a.height || b.width != a.width) {
            this.cb();
        }
    }
    get_av() {
        return 2;
    }
    get av() {
        return this.get_av();
    }
}
NumericAngleAxis.$t = markType(NumericAngleAxis, 'NumericAngleAxis', NumericAxisBase.$, [IAngleScaler_$type]);
Type.dep(DependencyProperty, PropertyMetadata, NumericAngleAxis, 'gd', ['StartAngleOffset:ky:k3', [1, 0]]);
export class NumericRadiusAxis extends NumericAxisBase {
    constructor() {
        super();
        this.kr = null;
        this.ks = false;
        this.kt = NaN;
        this.kv = 0;
        this.ku = 0;
        this.kx = 0;
        this.ko = null;
        this.ab = NumericRadiusAxis.$;
        this.kv = this.k5;
        this.ku = this.k4;
        this.kr = new PolarAxisRenderingManager();
        this.ir = this.ip();
    }
    ax() {
        return new NumericRadiusAxisView(this);
    }
    f5(a) {
        super.f5(a);
        this.kq = a;
    }
    get_b2() {
        return true;
    }
    get b2() {
        return this.get_b2();
    }
    di() {
        let a = this.kv;
        let b = this.ku;
        let c = Math.min(this.kz(), this.ky()) * (a - b) / 2;
        c = Math.max(c, 14);
        return c;
    }
    kz() {
        return this.ib.width;
    }
    ky() {
        return this.ib.height;
    }
    ao() {
        return new RadialAxisLabelPanel();
    }
    kw(a) {
        if (a == null) {
            return 0;
        }
        return a;
    }
    ip() {
        let a = super.ip();
        a.b.c = (b) => {
            if ((this.as == null || this.as.visibility == 0) && this.kp != null) {
                if ((this.as == null || (this.as.c == 4 || this.as.c == 5)) && this.kt != b) {
                    this.kt = b;
                    this.ap.a6 = b;
                    this.a9.hp();
                }
            }
        };
        a.k = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            this.kr.i(c, d, e.z, e.aa, e.center, e.minAngle, e.maxAngle);
        };
        a.l = (b, c, d, e) => {
            if (d == e) {
                return;
            }
            let f = typeCast(PolarAxisRenderingParameters.$, b);
            this.kr.j(c, d, e, f.z, f.aa, f.center, f.minAngle, f.maxAngle);
        };
        a.m = (b, c) => this.k1(c);
        a.q = (b, c) => {
            let d = typeCast(PolarAxisRenderingParameters.$, b);
            return c <= d.effectiveMaximum;
        };
        a.n = (b, c) => {
            let d = typeCast(PolarAxisRenderingParameters.$, b);
            return c <= d.effectiveMaximum;
        };
        a.j = (b) => {
            let c = typeCast(PolarAxisRenderingParameters.$, b);
            this.kr.m(b.t, c.crossingAngleRadians, b.z, b.aa, c.minLength, c.maxLength, c.center);
        };
        a.e = (b) => {
            b.n = this.as == null || (this.as.c == 4 || this.as.c == 0) ? b.z.top : b.z.bottom;
            b.r = b.n;
            let c = typeCast(PolarAxisRenderingParameters.$, b);
            c.crossingAngleRadians = (this.kw(this.eo) * Math.PI) / 180;
            if (this.as == null || (this.as.c == 4 || this.as.c == 5)) {
                c.n = ViewportUtils.f(0.5, c.aa, c.z) - b.z.top;
                c.r = c.n;
                let d = typeCast(RadialAxisLabelPanel.$, this.ap);
                if (d != null) {
                    let e = 0;
                    if (this.as != null && this.as.c == 4) {
                        e = 1;
                    }
                    d.de = { $type: Point_$type, x: ViewportUtils.c(0.5, c.aa, c.z), y: e };
                    d.db = c.crossingAngleRadians;
                }
            }
        };
        a.p = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            if (this.kp == null) {
                return false;
            }
            if (c > e.effectiveMaximum) {
                return false;
            }
            let f = false;
            f = this.as == null || (this.as.c == 4 || this.as.c == 5);
            let g = 0;
            if (f) {
                g = this.kx;
            }
            let h = e.center.x + c * Math.cos(g);
            let i = e.center.y + c * Math.sin(g);
            h = ViewportUtils.c(h, e.aa, e.z);
            i = ViewportUtils.f(i, e.aa, e.z);
            if (h <= b.z.right && h >= b.z.left && ((i <= b.z.bottom && i >= b.z.top) || !f)) {
                return true;
            }
            return false;
        };
        a.h = (b, c) => {
            let d = typeCast(PolarAxisRenderingParameters.$, b);
            return new LabelPosition(ViewportUtils.c(d.center.x + c, d.aa, d.z));
        };
        a.r = (b, c, d, e) => {
            if (c < b.m) {
                return b.m;
            }
            else if (c > b.l) {
                return b.l;
            }
            return c;
        };
        return a;
    }
    dj(a, b) {
        return this.k1(a);
    }
    k2(a, b, c, d, e) {
        let f = 0;
        if (b) {
            if (a <= 0) {
                f = (Math.log(this.jg) - this.jm) / (this.jl - this.jm);
            }
            else {
                f = (Math.log(a) - this.jm) / (this.jl - this.jm);
            }
        }
        else {
            f = (a - this.jg) / (this.jf - this.jg);
        }
        if (c) {
            f = 1 - f;
        }
        f = e + (f * (d - e));
        f /= 2;
        return f;
    }
    k1(a) {
        return this.k2(a, this.i6, this.b0, this.kv, this.ku);
    }
    k3(a) {
        let b = a * 2;
        b = (b - this.ku) / (this.kv - this.ku);
        if (this.bz) {
            b = 1 - b;
        }
        if (this.i6) {
            return Math.exp(b * (this.jl - this.jm) + this.jm);
        }
        else {
            return this.jg + b * (this.jf - this.jg);
        }
    }
    dm(a, b) {
        return this.k3(a);
    }
    f7(a, b, c, d) {
        switch (b) {
            case "CrossingValue":
                this.kx = this.kw(this.eo) * Math.PI / 180;
                break;
        }
        super.f7(a, b, c, d);
        switch (b) {
            case NumericRadiusAxis.$$p[1]:
                this.kv = this.k5;
                if (this.kv < 0) {
                    this.kv = 0.1;
                }
                if (this.kv > 1) {
                    this.kv = 1;
                }
                if (this.ku >= this.kv) {
                    this.ku = this.kv - 0.01;
                    if (this.ku < 0) {
                        this.ku = 0;
                        this.kv = 0.01;
                    }
                }
                this.b6 = true;
                this.gj(false);
                if (this.kp != null) {
                    this.kp.gi();
                }
                for (let e of fromEnum(this.ci())) {
                    e.it(false);
                }
                break;
            case NumericRadiusAxis.$$p[0]:
                this.ku = this.k4;
                if (this.ku < 0) {
                    this.ku = 0.1;
                }
                if (this.ku > 1) {
                    this.ku = 1;
                }
                if (this.ku >= this.kv) {
                    this.ku = this.kv - 0.01;
                    if (this.ku < 0) {
                        this.ku = 0;
                        this.kv = 0.01;
                    }
                }
                this.b6 = true;
                this.gj(false);
                if (this.kp != null) {
                    this.kp.gi();
                }
                for (let f of fromEnum(this.ci())) {
                    f.dh = true;
                    f.it(false);
                }
                if (this.a9 != null) {
                    this.a9.hx();
                }
                break;
            case "CrossingAxis":
                let g = typeCast(NumericAngleAxis.$, d);
                let h = typeCast(CategoryAngleAxis.$, d);
                if (g == null && h == null) {
                    this.la(null);
                }
                if (g != null) {
                    this.la(g);
                    g.k2(this);
                }
                if (h != null) {
                    this.la(h);
                    h.k4(this);
                }
                this.b6 = true;
                this.gj(false);
                break;
            case "IsInverted":
                if (this.kp != null) {
                    this.kp.b6 = true;
                    this.kp.gj(false);
                }
                break;
        }
    }
    la(a) {
        this.kp = a;
    }
    get kp() {
        if (this.ko != null) {
            return this.ko;
        }
        let a = typeCast(XamDataChart.$, this.a9);
        if (a != null) {
            for (let b = 0; b < a.axes.count; b++) {
                if (typeCast(NumericAngleAxis.$, a.axes._inner[b]) !== null || typeCast(CategoryAngleAxis.$, a.axes._inner[b]) !== null) {
                    return a.axes._inner[b];
                }
            }
        }
        return this.ko;
    }
    set kp(a) {
        this.ko = a;
    }
    ah() {
        return this.kp;
    }
    it() {
        return new PolarAxisRenderingParameters();
    }
    is(a, b, c, d) {
        let e = typeCast(PolarAxisRenderingParameters.$, super.is(a, b, c, d));
        let f = this.kr.f(b);
        let g = this.kr.g(b);
        let h = 0.5 * this.kv;
        let i = 0.5 * this.ku;
        let j, k;
        if (Rect.l_op_Equality(b, SeriesViewer.mu)) {
            k = this.jf;
            j = this.jg;
        }
        else {
            k = Math.min(g, h);
            j = this.k3(f);
            k = this.k3(k);
            let l = this.lb(a, b, j, k);
            j = l.p2;
            k = l.p3;
        }
        let m = { $type: Point_$type, x: 0.5, y: 0.5 };
        let n = f;
        let o = g;
        let p = Math.min(a.width, a.height) * (this.kv - this.ku) / 2;
        e.center = m;
        let q = Math.max(o, n);
        let r = Math.min(n, o);
        e.maxLength = q;
        e.minLength = r;
        let s = Math.min(j, k);
        let t = Math.max(j, k);
        if (s < this.jg) {
            s = this.jg;
        }
        if (t > this.jf) {
            t = this.jf;
        }
        this.jj = s;
        this.ji = t;
        e.k.add(((() => {
            let $ret = new RangeInfo();
            $ret.d = s;
            $ret.c = t;
            $ret.b = p;
            return $ret;
        })()));
        let u = typeCast(IAngleScaler_$type, this.kp);
        if (u != null) {
            let v;
            let w;
            let x = u.getMinMaxAngle(b, v, w);
            v = x.p1;
            w = x.p2;
            e.minAngle = Math.min(v, w);
            e.maxAngle = Math.max(v, w);
        }
        let y = this.k0();
        if (o >= h) {
            o = y;
        }
        if (n < i) {
            n = i;
        }
        e.minLength = n;
        e.maxLength = o;
        e.effectiveMaximum = y;
        e.f = this.iw;
        let z = typeCast(LinearTickmarkValues.$, e.f);
        if (z != null) {
            z.y = this.k6(m, e.minLength, e.maxLength, b, a);
        }
        return e;
    }
    lb(a, b, c, d) {
        let e = { $type: Point_$type, x: 0.5, y: 0.5 };
        let f = 0;
        if (this.bz) {
            f = this.k1(this.jg);
        }
        else {
            f = this.k1(this.jf);
        }
        let g = 0;
        if (this.eo != null) {
            g = this.kx;
        }
        let h = e.x + f * Math.cos(g);
        let i = e.y + f * Math.sin(g);
        e.x = ViewportUtils.c(e.x, b, a);
        e.y = ViewportUtils.f(e.y, b, a);
        h = ViewportUtils.c(h, b, a);
        i = ViewportUtils.f(i, b, a);
        if (h >= a.left && h <= a.right && i >= a.top && i <= a.bottom) {
            if (this.bz) {
                d = this.jg;
            }
            else {
                d = this.jf;
            }
        }
        if (e.x >= a.left && e.x <= a.right && e.y >= a.top && e.y <= a.bottom) {
            if (this.bz) {
                c = this.jf;
            }
            else {
                c = this.jg;
            }
        }
        return {
            p2: c,
            p3: d
        };
    }
    k6(a, b, c, d, e) {
        let f = ViewportUtils.d(c - b, d, e);
        let g = f / Math.min(e.width, e.height);
        if (g > 0.7) {
            return 10;
        }
        return 5;
    }
    k0() {
        let a = 0;
        if (!this.bz) {
            a = this.k1(this.jf);
        }
        else {
            a = this.k1(this.jg);
        }
        return a;
    }
    ke(a) {
        if (this.kp != null) {
            this.kp.gi();
        }
    }
    gk(a) {
        super.gk(a);
        let b = this.a9 != null ? this.a9.mk : Rect.empty;
        let c = !b.isEmpty ? this.ib : Rect.empty;
        let d = this.h6();
        let e = this.h5();
        let f = this.ir.c(a, c, b, d, e);
        if (f != null) {
            this.je = f.f.m;
            this.jh = f.f.l;
        }
    }
    gu(a, b) {
        super.gu(a, b);
        if (b.height != a.height || b.width != a.width) {
            this.cb();
        }
    }
    k9(a, b, c, d, e) {
        let f = typeCast(IPolarRadialRenderingParameters_$type, this.is(b, c, d, e));
        if (f == null) {
            return;
        }
        this.kr.j(a.c, f.minLength, f.maxLength, b, c, f.center, f.minAngle, f.maxAngle);
    }
    get_av() {
        return 3;
    }
    get av() {
        return this.get_av();
    }
}
NumericRadiusAxis.$t = markType(NumericRadiusAxis, 'NumericRadiusAxis', NumericAxisBase.$);
Type.dep(DependencyProperty, PropertyMetadata, NumericRadiusAxis, 'gd', ['InnerRadiusExtentScale:k4:lc', [1, 0], 'RadiusExtentScale:k5:ld', [1, 0.75]]);
export class AngleAxisLabelPanelView extends AxisLabelPanelBaseView {
    constructor(a) {
        super(a);
        this.av = null;
        this.av = a;
    }
    al() {
        super.al();
        this.av.cr = true;
    }
    aw(a) {
        this.av.cv = -1.7976931348623157E+308;
        this.av.cs = -1.7976931348623157E+308;
        this.av.cu = -1.7976931348623157E+308;
        this.av.ct = -1.7976931348623157E+308;
        for (let b = 0; b < this.a.a3.count; b++) {
            let c = this.a.a3._inner[b];
            let d = this.a.a2._inner[b];
            let e = this.av.cx(d.a);
            let f = this.m(c);
            let g = this.l(c);
            let h = f + this.p() + this.q();
            let i = g + this.r() + this.o();
            let j = e.x - h / 2;
            let k = e.y - i / 2;
            this.av.cu = Math.max(f, this.av.cu);
            this.av.ct = Math.max(g, this.av.ct);
            this.av.cv = Math.max(h, this.av.cv);
            this.av.cs = Math.max(i, this.av.cs);
            let l = new Rect(0, j, k, h, i);
            a.add(l);
        }
    }
    o() {
        return 0;
    }
    p() {
        return 0;
    }
    q() {
        return 0;
    }
    r() {
        return 0;
    }
}
AngleAxisLabelPanelView.$t = markType(AngleAxisLabelPanelView, 'AngleAxisLabelPanelView', AxisLabelPanelBaseView.$);
export class CategoryAngleAxisView extends CategoryAxisBaseView {
    constructor(a) {
        super(a);
        this.ba = null;
        this.ba = a;
    }
}
CategoryAngleAxisView.$t = markType(CategoryAngleAxisView, 'CategoryAngleAxisView', CategoryAxisBaseView.$);
export class NumericAngleAxisView extends NumericAxisBaseView {
    constructor(a) {
        super(a);
        this.ba = null;
        this.ba = a;
    }
}
NumericAngleAxisView.$t = markType(NumericAngleAxisView, 'NumericAngleAxisView', NumericAxisBaseView.$);
export class NumericRadiusAxisView extends NumericAxisBaseView {
    constructor(a) {
        super(a);
        this.ba = null;
        this.ba = a;
    }
}
NumericRadiusAxisView.$t = markType(NumericRadiusAxisView, 'NumericRadiusAxisView', NumericAxisBaseView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.CategoryAngleAxis" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.CategoryAngleAxis" />*/
/*<BeginStatics Name="Infragistics.Controls.Charts.NumericAngleAxis" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.NumericAngleAxis" />*/
/*<BeginStatics Name="Infragistics.Controls.Charts.NumericRadiusAxis" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.NumericRadiusAxis" />*/
//# sourceMappingURL=AngleAxisLabelPanel_combined.js.map