/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventProxy } from "./EventProxy";
import { Point_$type, runOn, markType, PointUtil, String_$type, Delegate_$type } from "./type";
import { Rect } from "./Rect";
import { MouseEventArgs } from "./MouseEventArgs";
import { Dictionary$2 } from "./Dictionary$2";
import { List$1 } from "./List$1";
export class BaseDOMEventProxy extends EventProxy {
    constructor() {
        super(...arguments);
        this.bp = null;
        this.bo = null;
        this.bd = false;
        this.bm = 0;
        this.bn = 0;
        this.bk = 0;
        this.bl = 0;
        this.bq = 0;
        this.cn = null;
        this.cm = null;
        this.bc = false;
        this.br = -1;
        this.bg = false;
        this.be = false;
        this.bb = false;
    }
    d() {
        let a = new DOMEventProxy(this.bp, this.bo);
        a.z = this.z;
        a.ai = this.ai;
        return a;
    }
    a9(a) {
        return DOMEventProxy.co(a);
    }
    ce(a) {
        if (!this.aa) {
            if (this.bf(a)) {
                a.preventDefault();
            }
        }
    }
    bf(e_) {
        return (e_.originalEvent.cancelable || e_.originalEvent.cancelable == undefined);
    }
    ca() {
        let source_ = this.bp.getNativeElement();
        BaseDOMEventProxy.cd(source_);
    }
    static cd(source_) {
        if (BaseDOMEventProxy.bi) {
            source_.style.touchAction = 'none';
        }
        else {
            source_.style.msTouchAction = 'none';
        }
        source_.style.msUserSelect = 'none';
        source_.style.webkitTouchCallout = 'none';
        source_.style.webkitUserSelect = 'none';
        source_.style.khtmlUserSelect = 'none';
        source_.style.mozUserSelect = 'none';
        source_.style.userSelect = 'none';
    }
    static b7(source_) {
        if (BaseDOMEventProxy.bi) {
            source_.style.touchAction = 'auto';
        }
        else {
            source_.style.msTouchAction = 'auto';
        }
        source_.style.msUserSelect = 'auto';
        source_.style.webkitTouchCallout = 'none';
        source_.style.webkitUserSelect = 'auto';
        source_.style.khtmlUserSelect = 'auto';
        source_.style.mozUserSelect = 'auto';
        source_.style.userSelect = 'auto';
    }
    b8() {
        let source_ = this.bp.getNativeElement();
        BaseDOMEventProxy.b7(source_);
    }
    am() {
        super.am();
        if (!this.aa) {
            this.ca();
        }
        else {
            this.b8();
        }
    }
    bw() {
        let ver_ = -1;
        let matchIE_ = /Trident\/([\d.]+)/;
        if ((matchIE_.exec(navigator.userAgent) != null)) {
            ver_ = (parseFloat(RegExp.$1));
        }
        return ver_;
    }
    bv() {
        let ver_ = -1;
        let matchIE_ = /Edge\/([\d.]+)/;
        if ((matchIE_.exec(navigator.userAgent) != null)) {
            ver_ = (parseFloat(RegExp.$1));
        }
        return ver_;
    }
    static cc(e_) {
        let a = BaseDOMEventProxy.bx >= 6;
        let oe_ = e_.originalEvent;
        if ((((typeof e_.pageX == 'undefined')) || a) && oe_.clientX != null) {
            let od_;
            if ((e_.target !== undefined)) {
                od_ = e_.target.ownerDocument;
            }
            else {
                od_ = e_.originalEvent.target.ownerDocument;
            }
            let ed_ = od_ ? od_ : document;
            let doc_ = ed_.documentElement;
            let body_ = ed_.body;
            let clientX_ = oe_.clientX;
            let clientY_ = oe_.clientY;
            let scrollLeft_ = doc_ && doc_.scrollLeft || body_ && body_.scrollLeft || 0;
            let scrollTop_ = doc_ && doc_.scrollTop || body_ && body_.scrollTop || 0;
            let clientLeft_ = doc_ && doc_.clientLeft || body_ && body_.clientLeft || 0;
            let clientTop_ = doc_ && doc_.clientTop || body_ && body_.clientTop || 0;
            e_.pageX = clientX_ + (scrollLeft_ - clientLeft_);
            e_.pageY = clientY_ + (scrollTop_ - clientTop_);
        }
        if ((!e_.pageX)) {
            e_.pageX = e_.originalEvent.pageX;
        }
        if ((!e_.pageY)) {
            e_.pageY = e_.originalEvent.pageY;
        }
        if (((typeof e_.button == 'undefined')) && ((typeof oe_.button != 'undefined'))) {
            e_.button = oe_.button;
        }
    }
    static co(a) {
        let b = BaseDOMEventProxy.bx >= 6;
        let source_ = a.getNativeElement();
        let d_ = source_.ownerDocument;
        let doc_ = d_ ? d_.documentElement : null;
        let z_ = doc_ ? doc_.msContentZoomFactor : null;
        let body_ = doc_.body;
        if ((z_ && z_ > 1) || b) {
            let rect_ = source_.getBoundingClientRect();
            let x_ = (rect_.left);
            let y_ = (rect_.top);
            let scrollLeft_ = (doc_ && doc_.scrollLeft || body_ && body_.scrollLeft || 0);
            let scrollTop_ = (doc_ && doc_.scrollTop || body_ && body_.scrollTop || 0);
            let clientLeft_ = (doc_ && doc_.clientLeft || body_ && body_.clientLeft || 0);
            let clientTop_ = (doc_ && doc_.clientTop || body_ && body_.clientTop || 0);
            let c = x_ + scrollLeft_ - clientLeft_;
            let d = y_ + scrollTop_ - clientTop_;
            return new Rect(0, c, d, 0, 0);
        }
        else {
            let e = a.getOffset();
            return new Rect(0, e.left, e.top, 0, 0);
        }
    }
    get bt() {
        return this.bq;
    }
    set bt(a) {
        this.bq = a;
    }
    ch(a) {
        this.aj = a;
        BaseDOMEventProxy.cc(a);
        let b = BaseDOMEventProxy.co(this.bp);
        this.bm = a.pageX - b.left;
        this.bn = a.pageY - b.top;
        this.bk = this.bm - this.ba.left;
        this.bl = this.bn - this.ba.top;
        this.cn = { $type: Point_$type, x: this.bm, y: this.bn };
        this.cm = { $type: Point_$type, x: this.bk, y: this.bl };
    }
    ci(e_) {
        this.aj = e_;
        BaseDOMEventProxy.cc(e_);
        if (BaseDOMEventProxy.bh || BaseDOMEventProxy.bi) {
            let a = e_.pageX;
            let b = e_.pageY;
            let c = BaseDOMEventProxy.co(this.bp);
            this.bm = a - c.left;
            this.bn = b - c.top;
        }
        else {
            this.bq = 0;
            if (!e_.originalEvent.targetTouches || e_.originalEvent.targetTouches.length < 1) {
                return;
            }
            ;
            this.bq = (e_.originalEvent.targetTouches.length);
            let d = (e_.originalEvent.targetTouches[0].pageX);
            let e = (e_.originalEvent.targetTouches[0].pageY);
            let f = BaseDOMEventProxy.co(this.bp);
            this.bm = d - f.left;
            this.bn = e - f.top;
        }
        this.bk = this.bm - this.ba.left;
        this.bl = this.bn - this.ba.top;
        this.cn = { $type: Point_$type, x: this.bm, y: this.bn };
        this.cm = { $type: Point_$type, x: this.bk, y: this.bl };
    }
    b5(e_) {
        this.cg(e_);
        if (this.ah(this.cn)) {
            let delta_ = 0;
            if (e_.wheelDelta) {
                delta_ = e_.wheelDelta / 120;
            }
            ;
            if (e_.originalEvent && e_.originalEvent.wheelDelta) {
                delta_ = e_.originalEvent.wheelDelta / 120;
            }
            ;
            if (e_.detail) {
                delta_ = -e_.detail / 3;
            }
            ;
            if (e_.originalEvent && e_.originalEvent.detail) {
                delta_ = -e_.originalEvent.detail / 3;
            }
            ;
            delta_ = delta_ / 10;
            let a = this.ae(this.cm, delta_);
            if (a) {
                this.ce(e_);
            }
        }
    }
    cb() {
        if (this.bc) {
            if (this.br == -1) {
                this.br = this.bo.setTimeout(runOn(this, this.b9), 500);
            }
            else {
                window.clearTimeout(this.br);
                this.br = -1;
                this.br = this.bo.setTimeout(runOn(this, this.b9), 500);
            }
        }
    }
    by() {
        this.bc = true;
        if (this.br != -1) {
            window.clearTimeout(this.br);
            this.br = -1;
        }
    }
    b9() {
        this.bc = false;
    }
    get bj() {
        return this.be;
    }
    set bj(a) {
        this.be = a;
    }
    b3(a) {
        if (this.be || this.bc) {
            return;
        }
        this.ch(a);
        if (this.bg) {
            this.bg = false;
            this.ay(this.cm);
        }
    }
    b4(a) {
        if (this.be || this.bc) {
            return;
        }
        this.ch(a);
        this.cg(a);
        let b = new MouseEventArgs();
        b.position = this.cn;
        if (this.ah(this.cn)) {
            if (!this.bg) {
                this.bg = true;
                this.ax(this.cn);
            }
            this.az(this.cn, true, false);
            this.ao(this.cm, false);
        }
        else if (this.bg) {
            this.b3(a);
        }
    }
    cf(a) {
        this.bp.focus();
    }
    b2(a) {
        if (this.be || this.bc) {
            return;
        }
        this.cf(a);
        this.ch(a);
        this.cg(a);
        if (this.ah(this.cn)) {
            this.bb = true;
            this.aw(this.cn);
            this.ap(this.cm, false);
            this.ce(a);
        }
    }
    cj(a) {
        if (this.be || this.bc) {
            return;
        }
        if (this.bb) {
            this.b6(a);
        }
    }
    b6(a) {
        if (this.be || this.bc) {
            return;
        }
        this.cg(a);
        if (PointUtil.equals(this.cn, null) || PointUtil.equals(this.cm, null)) {
            this.ch(a);
        }
        let b = this.ah(this.cn) || this.bb || this.bg;
        this.bb = false;
        this.a0(this.cn);
        this.an(this.cm, false);
        if (b) {
            this.ce(a);
        }
    }
    bz(a) {
        this.b0(a, true);
    }
    b1(a) {
        this.b0(a, false);
    }
    cl(a) {
        return BaseDOMEventProxy.ck(a);
    }
    static ck(a) {
        let b;
        switch (a.which) {
            case 33:
                b = 10;
                break;
            case 34:
                b = 11;
                break;
            case 36:
                b = 13;
                break;
            case 37:
                b = 14;
                break;
            case 38:
                b = 15;
                break;
            case 39:
                b = 16;
                break;
            case 40:
                b = 17;
                break;
            case 9:
                b = 2;
                break;
            case 32:
                b = 9;
                break;
            case 13:
                b = 3;
                break;
            case 27:
                b = 8;
                break;
            case 16:
                b = 4;
                break;
            case 17:
                b = 5;
                break;
            case 18:
                b = 6;
                break;
            case 8:
                b = 1;
                break;
            case 35:
                b = 12;
                break;
            case 45:
                b = 18;
                break;
            case 46:
                b = 19;
                break;
            case 106:
                b = 78;
                break;
            case 107:
                b = 79;
                break;
            case 109:
                b = 80;
                break;
            case 110:
                b = 81;
                break;
            case 111:
                b = 82;
                break;
            case 220:
                b = 85;
                break;
            case 192:
                b = 86;
                break;
            case 191:
                b = 84;
                break;
            case 186:
                b = 83;
                break;
            case 189:
                b = 88;
                break;
            case 187:
                b = 87;
                break;
            default:
                if (112 <= a.which && a.which <= 123) {
                    b = (56 + a.which - 112);
                }
                else if (65 <= a.which && a.which <= 90) {
                    b = (30 + a.which - 65);
                }
                else if (48 <= a.which && a.which <= 57) {
                    b = (20 + a.which - 48);
                }
                else if (96 <= a.which && a.which <= 105) {
                    b = (68 + a.which - 96);
                }
                else {
                    b = 0;
                }
                break;
        }
        return b;
    }
    b0(a, b) {
        let c = this.cl(a);
        let d = c != 0;
        this.cg(a);
        if (d) {
            let e = false;
            if (b) {
                e = this.ac(c);
            }
            else {
                e = this.ad(c);
            }
            if (e) {
                this.ce(a);
            }
        }
    }
    cg(a) {
        this.aj = a;
        this.a7 = 0;
        if (a.shiftKey) {
            this.a7 = this.a7 | 4;
        }
        if (a.altKey) {
            this.a7 = this.a7 | 1;
        }
        if (a.ctrlKey) {
            this.a7 = this.a7 | 2;
        }
        this.af = a.button == 2;
    }
    a8() {
        let a = BaseDOMEventProxy.co(this.bp);
        let b = a.left;
        let c = a.top;
        return { $type: Point_$type, x: b, y: c };
    }
}
BaseDOMEventProxy.bh = false;
BaseDOMEventProxy.bi = false;
BaseDOMEventProxy.bx = 0;
BaseDOMEventProxy.bu = 0;
BaseDOMEventProxy.$t = markType(BaseDOMEventProxy, 'BaseDOMEventProxy', EventProxy.$);
export class DOMEventProxy extends BaseDOMEventProxy {
    constructor(a, b) {
        super();
        this.c0 = 0;
        this.c1 = "";
        this.cq = false;
        this.cx = null;
        this.ct = new Dictionary$2(String_$type, List$1.$.specialize(Delegate_$type), 0);
        this.dn = null;
        this.cy = -1;
        this.dp = null;
        this.cv = 0;
        this.cw = 0;
        this.cu = 5;
        this.cp = false;
        this.dm = null;
        this.bo = b;
        this.ai = (c) => true;
        this.z = false;
        DOMEventProxy.cz++;
        this.c0 = DOMEventProxy.cz;
        this.c1 = ".DOMProxy" + this.c0.toString();
        this.a7 = 0;
        this.bp = a;
        BaseDOMEventProxy.bh = false;
        try {
            BaseDOMEventProxy.bh = (window.navigator.msPointerEnabled && MSGesture !== undefined);
        }
        catch (c) {
        }
        BaseDOMEventProxy.bi = false;
        try {
            BaseDOMEventProxy.bi = (window.PointerEvent || window.navigator.pointerEnabled);
        }
        catch (d) {
        }
        BaseDOMEventProxy.bx = this.bw();
        BaseDOMEventProxy.bu = this.bv();
        this.ak(this.bp, "");
        this.ah = (e) => true;
    }
    c2(a, b, c) {
    }
    ak(a, b) {
        let c = a;
        let d = this.c1 + b;
        if (!this.bo.supportsDOMEvents()) {
            return;
        }
        let e = new List$1(Delegate_$type, 0);
        this.ct.addItem(d, e);
        this.c2(a, b, e);
        if ((!BaseDOMEventProxy.bh && !BaseDOMEventProxy.bi)) {
            e.add(c.listen("mousemove", runOn(this, this.b4)));
            e.add(c.listen("mouseleave", runOn(this, this.b3)));
            e.add(c.listen("mousedown", runOn(this, this.b2)));
            e.add(c.listen("mouseup", runOn(this, this.b6)));
            e.add(this.bo.globalListen("window", "mouseup", runOn(this, this.cj)));
        }
        e.add(c.listen("keydown", runOn(this, this.bz)));
        e.add(c.listen("keyup", runOn(this, this.b1)));
        let source_ = this.bp.getNativeElement();
        if (!this.aa) {
            BaseDOMEventProxy.cd(source_);
        }
        if (BaseDOMEventProxy.bh || BaseDOMEventProxy.bi) {
            let f = this.bp.getNativeElement();
            if ((window.MSGesture !== undefined)) {
                let g = (new MSGesture());
                g.target = f;
                this.cx = g;
                e.add(c.listen("MSGestureStart", runOn(this, this.c5)));
                e.add(c.listen("MSGestureChange", runOn(this, this.c3)));
                e.add(c.listen("MSGestureEnd", runOn(this, this.c4)));
            }
            if (BaseDOMEventProxy.bi) {
                e.add(c.listen("pointerdown", runOn(this, this.c8)));
                e.add(c.listen("pointerup", runOn(this, this.db)));
                e.add(c.listen("pointercancel", runOn(this, this.c7)));
                e.add(c.listen("pointermove", runOn(this, this.c9)));
                e.add(c.listen("pointerout", runOn(this, this.da)));
                e.add(c.listen("lostpointercapture", runOn(this, this.c6)));
            }
            else {
                e.add(c.listen("MSPointerDown", runOn(this, this.c8)));
                e.add(c.listen("MSPointerUp", runOn(this, this.db)));
                e.add(c.listen("MSPointerCancel", runOn(this, this.c7)));
                e.add(c.listen("MSPointerMove", runOn(this, this.c9)));
                e.add(c.listen("MSPointerOut", runOn(this, this.da)));
                e.add(c.listen("MSLostPointerCapture", runOn(this, this.c6)));
            }
        }
        e.add(c.listen("DOMMouseScroll", runOn(this, this.b5)));
        e.add(c.listen("mousewheel", runOn(this, this.b5)));
        e.add(c.listen("gesturestart", runOn(this, this.c5)));
        e.add(c.listen("gesturechange", runOn(this, this.c3)));
        e.add(c.listen("gestureend", runOn(this, this.c4)));
        e.add(c.listen("touchstart", runOn(this, this.de)));
        e.add(c.listen("touchmove", runOn(this, this.dd)));
        e.add(c.listen("touchend", runOn(this, this.dc)));
    }
    db(e_) {
        let a = this.cr(e_);
        if (a) {
            this.bt = this.bt - 1;
            if (this.bt < 0) {
                this.bt = 0;
            }
        }
        if (this.bt < 2 && this.cq && a) {
            this.cq = false;
            let b = (e_.originalEvent.scale);
            this.au(this.cm, b);
        }
        else {
            if (a) {
                this.dc(e_);
            }
            else {
                this.b6(e_);
            }
        }
    }
    c6(e_) {
        let a = this.cr(e_);
        if (a) {
            this.bt--;
            if (this.bt < 0) {
                this.bt = 0;
            }
        }
        if (this.bt < 2 && this.cq && a) {
            this.cq = false;
            let b = (e_.originalEvent.scale);
            this.au(this.cm, b);
        }
    }
    c7(e_) {
        let a = this.cr(e_);
        if (a) {
            this.bt--;
            if (this.bt < 0) {
                this.bt = 0;
            }
        }
        if (this.bt < 2 && this.cq && a) {
            this.cq = false;
            let b = (e_.originalEvent.scale);
            this.au(this.cm, b);
        }
    }
    c8(e_) {
        let a = this.cr(e_);
        if (this.cx != null && a) {
            this.bt++;
            this.cx.addPointer((e_.originalEvent.pointerId));
        }
        let eventSource_ = this.bp.getNativeElement();
        if (BaseDOMEventProxy.bi) {
            eventSource_.setPointerCapture(e_.originalEvent.pointerId);
        }
        else {
            eventSource_.msSetPointerCapture(e_.originalEvent.pointerId);
        }
        if (this.bt > 1 && !this.cq && a) {
            this.cq = true;
            this.ci(e_);
            let b = (e_.originalEvent.scale);
            this.a2(this.cm, b);
        }
        else {
            if (a) {
                this.de(e_);
            }
            else {
                this.b2(e_);
            }
        }
    }
    cr(e_) {
        let pointerEvent_ = e_.originalEvent;
        let a = false;
        if (BaseDOMEventProxy.bi) {
            a = (pointerEvent_.pointerType == 'touch');
        }
        else {
            a = (pointerEvent_.pointerType == pointerEvent_.MSPOINTER_TYPE_TOUCH);
        }
        return a;
    }
    c9(e_) {
        let a = this.cr(e_);
        if (this.cq) {
            return;
        }
        if (a) {
            this.dd(e_);
        }
        else {
            this.b4(e_);
        }
    }
    da(e_) {
        let a = this.cr(e_);
        if (this.cq) {
            return;
        }
        if (a) {
        }
        else {
            this.b3(e_);
        }
    }
    c5(e_) {
        this.bg = true;
        this.cg(e_);
        this.ci(e_);
        this.dg();
        if (this.ah(this.cn)) {
            this.ce(e_);
            if ((BaseDOMEventProxy.bh || BaseDOMEventProxy.bi) && this.bt < 2) {
                return;
            }
            let a = (e_.originalEvent.scale);
            this.a2(this.cm, a);
        }
    }
    c3(e_) {
        this.bg = true;
        this.cg(e_);
        this.ci(e_);
        if (this.ah(this.cn)) {
            this.ce(e_);
            if ((BaseDOMEventProxy.bh || BaseDOMEventProxy.bi) && this.bt < 2) {
                return;
            }
            let a = (e_.originalEvent.scale);
            this.a1(this.cm, a);
        }
    }
    c4(e_) {
        this.ce(e_);
        let a = (e_.originalEvent.scale);
        this.bg = false;
        this.cg(e_);
        this.ci(e_);
        if ((!BaseDOMEventProxy.bh && !BaseDOMEventProxy.bi) || this.cq) {
            this.au(this.cm, a);
        }
    }
    de(e_) {
        this.bg = true;
        this.cg(e_);
        this.ci(e_);
        this.dn = this.cm;
        if (this.ah(this.cn)) {
            if (!this.z) {
                this.ce(e_);
            }
            else {
                this.bj = true;
            }
            this.az(this.cn, false, true);
            this.aw(this.cn);
            this.ap(this.cm, true);
            this.dj();
        }
    }
    dj() {
        if (this.cy == -1) {
            this.cv = this.cn.x;
            this.cw = this.cn.y;
            this.cy = this.bo.setTimeout(runOn(this, this.dh), 1500);
        }
    }
    dg() {
        if (Math.abs(this.cv - this.cn.x) > this.cu || Math.abs(this.cw - this.cn.y) > this.cu) {
            this.dk();
        }
    }
    dk() {
        if (this.cy != -1) {
            window.clearTimeout(this.cy);
            this.cy = -1;
        }
    }
    dh() {
        this.cy = -1;
        if (this.bj) {
            this.bj = false;
            this.by();
        }
        this.av(this.cm);
    }
    dd(a) {
        this.bg = true;
        this.cg(a);
        this.ci(a);
        if (this.bj) {
            if (this.ah(this.cn) && this.cs()) {
                this.bj = false;
                this.by();
            }
        }
        this.dg();
        this.dl();
        if (this.ah(this.cn) && this.bt == 1 && !this.bj) {
            this.ce(a);
            if (!this.cp) {
                this.cp = true;
                this.dm = this.cm;
                this.at(this.dm);
            }
            else {
                this.az(this.cn, true, true);
                this.ao(this.cm, true);
                this.as(this.cm);
            }
        }
    }
    cs() {
        let a = { $type: Point_$type, x: this.dn.x - this.cm.x, y: this.dn.y - this.cm.y };
        if (Math.abs(a.x) < 2 && Math.abs(a.y) < 2) {
            return false;
        }
        if (Math.abs(a.x) > Math.abs(a.y)) {
            a.y = 0;
        }
        if (Math.abs(a.y) > Math.abs(a.x)) {
            a.x = 0;
        }
        return this.ai(a);
    }
    dc(a) {
        this.bg = false;
        this.cg(a);
        this.ci(a);
        this.dk();
        if (this.bj) {
            this.bj = false;
            this.by();
        }
        this.ce(a);
        this.az(this.cn, false, true);
        this.a0(this.cn);
        if (this.bt == 0) {
            this.di(this.cn);
            this.cb();
        }
        if (this.cp && this.bt == 0) {
            this.cp = false;
            this.dm = null;
            this.ar(this.cm);
            this.cb();
        }
        this.an(this.cm, true);
    }
    di(a) {
        if (Rect.l_op_Equality(this.dp, null)) {
            this.dp = new Rect(0, a.x - 50, a.y - 50, 100, 100);
            this.bo.setTimeout(runOn(this, this.dl), 500);
        }
        else {
            if (a.x >= this.dp.x && a.x <= this.dp.right && a.y >= this.dp.y && a.y <= this.dp.bottom) {
                this.dl();
                this.aq(a);
            }
        }
    }
    dl() {
        this.dp = null;
    }
    df(a) {
        if (this.ct.containsKey(a)) {
            let b = this.ct.item(a);
            this.ct.removeItem(a);
            for (let c = 0; c < b.count; c++) {
                b._inner[c]();
            }
            b.clear();
        }
    }
    a6(a, b) {
        let c = a;
        let d = this.c1 + b;
        this.df(d);
    }
    al() {
        if (this.bp == null) {
            return;
        }
        this.df(this.c1);
        this.bp = null;
    }
}
DOMEventProxy.cz = 0;
DOMEventProxy.$t = markType(DOMEventProxy, 'DOMEventProxy', BaseDOMEventProxy.$);
/*<BeginStatics Name="Infragistics.Controls.BaseDOMEventProxy" />*/
/*<EndStatics Name="Infragistics.Controls.BaseDOMEventProxy" />*/
/*<BeginStatics Name="Infragistics.Controls.DOMEventProxy" />*/
/*<EndStatics Name="Infragistics.Controls.DOMEventProxy" />*/
//# sourceMappingURL=BaseDOMEventProxy_combined.js.map