/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { XYChart } from "./XYChart";
import { CategoryChartType_$type } from "./CategoryChartType";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { TransitionInSpeedType_$type } from "./TransitionInSpeedType";
import { CategoryXAxis } from "./CategoryXAxis";
import { List$1 } from "./List$1";
import { DataSeriesType_$type } from "./DataSeriesType";
import { NumericYAxis } from "./NumericYAxis";
import { IDataSeriesAdapterRule_$type } from "./IDataSeriesAdapterRule";
import { SimpleCategorySeriesRule } from "./SimpleCategorySeriesRule";
import { SubCollectionsRule } from "./SubCollectionsRule";
import { Brush } from "./Brush";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { ArrayExtension } from "./ArrayExtension";
import { typeCast, runOn, delegateCombine, enumGetBox, markType, TypeRegistrar } from "./type";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { ScalerParams } from "./ScalerParams";
export class CategoryChart extends XYChart {
    constructor() {
        super();
        this.od = 1000;
        this.nf = null;
        this.m0 = 9;
        this.m2 = 1;
        this.ni = false;
        this.m4 = 0;
        this.nd = 0;
        this.nq = 0;
        this.nr = 0;
        this.np = 0;
        this.ns = 0;
        this.nt = NaN;
        this.nk = false;
        this.oe = 10;
        this.nv = NaN;
        this.nu = NaN;
        this.nw = 0;
        this.mw = null;
        this.mx = null;
        this.nh = false;
        this.nj = true;
        this.eo();
    }
    e1() {
        super.e1();
        if (this.dataChart == null) {
            return;
        }
        let a = this.dataChart.bk.i.e();
        this.my = a.d;
        this.mz = a.e;
        this.mf = this.l8 = a.k;
    }
    e3(a, b) {
        super.e3(a, b);
        a.e8 = this.of;
        a.bu = this.ng;
    }
    fj(a, b, c) {
        super.fj(a, b, c);
        switch (a) {
            case "TransitionInDuration":
                this.o2((d) => d.e8 = this.of);
                break;
            case "TransitionInEasingFunction":
                this.o2((d) => d.bu = this.ng);
                break;
        }
    }
    get of() {
        return this.od;
    }
    set of(a) {
        let b = this.of;
        if (a != b) {
            this.od = a;
            this.fi("TransitionInDuration", b, this.of);
        }
    }
    get ng() {
        return this.nf;
    }
    set ng(a) {
        let b = this.ng;
        if (a != b) {
            this.nf = a;
            this.fi("TransitionInEasingFunction", b, this.ng);
        }
    }
    ew(a) {
        super.ew(a);
        a.ca = this.nl;
    }
    e2(a, b) {
        super.e2(a, b);
        let c = typeCast(HorizontalAnchoredCategorySeries.$, a);
        if (c == null) {
            return;
        }
        c.og = this.m3;
        c.nd = this.nm;
        c.mw = this.m5;
        c.bo = this.ne;
        c.trendLineBrush = ArrayExtension.getModulus$1(Brush.$, this.o, b);
        c.trendLineType = this.ai;
        c.trendLineThickness = this.ca;
        c.lg = this.ad(a, b);
        if (a.cx) {
            a.iy(ArrayExtension.getModulus$1(Brush.$, this.my, b), ArrayExtension.getModulus$1(Brush.$, this.mz, b));
        }
    }
    m6() {
        return new CategoryXAxis();
    }
    nb() {
        return new NumericYAxis();
    }
    em() {
        this.xAxis = this.m6();
        this.xAxis.name = "xAxis";
        let a = this.xAxis;
        a.propertyChanged = delegateCombine(a.propertyChanged, runOn(this, this.o4));
        this.yAxis = this.nb();
        this.yAxis.name = "yAxis";
        let b = this.yAxis;
        b.propertyChanged = delegateCombine(b.propertyChanged, runOn(this, this.o5));
        if (this.xAxis.as == null) {
            this.xAxis.as = new AxisLabelSettings();
        }
        if (this.yAxis.as == null) {
            this.yAxis.as = new AxisLabelSettings();
        }
    }
    lf(a) {
        super.lf(a);
        a.i0 = this.nn;
    }
    get m1() {
        return this.m0;
    }
    set m1(a) {
        if (a != this.m0) {
            let b = this.m1;
            this.m0 = a;
            this.fi("ChartType", enumGetBox(CategoryChartType_$type, b), enumGetBox(CategoryChartType_$type, this.m1));
        }
    }
    get m3() {
        return this.m2;
    }
    set m3(a) {
        let b = this.m3;
        if (a != b) {
            this.m2 = a;
            this.fi("MarkerCollisionAvoidance", enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, b), enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, this.m3));
        }
    }
    get nm() {
        return this.ni;
    }
    set nm(a) {
        let b = this.nm;
        if (a != b) {
            this.ni = a;
            this.fi("IsTransitionInEnabled", b, this.nm);
        }
    }
    get m5() {
        return this.m4;
    }
    set m5(a) {
        let b = this.m5;
        if (a != b) {
            this.m4 = a;
            this.fi("TransitionInMode", enumGetBox(CategoryTransitionInMode_$type, b), enumGetBox(CategoryTransitionInMode_$type, this.m5));
        }
    }
    get ne() {
        return this.nd;
    }
    set ne(a) {
        let b = this.ne;
        if (a != b) {
            this.nd = a;
            this.fi("TransitionInSpeedType", enumGetBox(TransitionInSpeedType_$type, b), enumGetBox(TransitionInSpeedType_$type, this.ne));
        }
    }
    get n4() {
        return this.nq;
    }
    set n4(a) {
        let b = this.n4;
        if (a != b) {
            this.nq = a;
            this.fi("XAxisInterval", b, this.n4);
        }
    }
    get n5() {
        return this.nr;
    }
    set n5(a) {
        let b = this.n5;
        if (a != b) {
            this.nr = a;
            this.fi("XAxisMinorInterval", b, this.n5);
        }
    }
    get n3() {
        return this.np;
    }
    set n3(a) {
        let b = this.n3;
        if (a != b) {
            this.np = a;
            this.fi("XAxisGap", b, this.n3);
        }
    }
    get n6() {
        return this.ns;
    }
    set n6(a) {
        let b = this.n6;
        if (a != b) {
            this.ns = a;
            this.fi("XAxisOverlap", b, this.n6);
        }
    }
    get n9() {
        return this.nt;
    }
    set n9(a) {
        let b = this.n9;
        if (a != b) {
            this.nt = a;
            this.fi("YAxisInterval", b, this.n9);
        }
    }
    get no() {
        return this.nk;
    }
    set no(a) {
        let b = this.no;
        if (a != b) {
            this.nk = a;
            this.fi("YAxisIsLogarithmic", b, this.no);
        }
    }
    get og() {
        return this.oe;
    }
    set og(a) {
        let b = this.og;
        if (a != b) {
            this.oe = a;
            this.fi("YAxisLogarithmBase", b, this.og);
        }
    }
    get ob() {
        return this.nv;
    }
    set ob(a) {
        let b = this.ob;
        if (a != b) {
            this.nv = a;
            this.fi("YAxisMinimumValue", b, this.ob);
        }
    }
    get oa() {
        return this.nu;
    }
    set oa(a) {
        let b = this.oa;
        if (a != b) {
            this.nu = a;
            this.fi("YAxisMaximumValue", b, this.oa);
        }
    }
    get oc() {
        return this.nw;
    }
    set oc(a) {
        let b = this.oc;
        if (a != b) {
            this.nw = a;
            this.fi("YAxisMinorInterval", b, this.oc);
        }
    }
    get n2() {
        return this.xAxis.kn;
    }
    get n1() {
        return this.xAxis.km;
    }
    get n8() {
        return this.yAxis.jg;
    }
    get n7() {
        return this.yAxis.jf;
    }
    get my() {
        return this.mw;
    }
    set my(a) {
        let b = this.my;
        if (a != b) {
            this.mw = a;
            this.fi("NegativeBrushes", b, this.my);
        }
    }
    get mz() {
        return this.mx;
    }
    set mz(a) {
        let b = this.mz;
        if (a != b) {
            this.mx = a;
            this.fi("NegativeOutlines", b, this.mz);
        }
    }
    get nl() {
        return this.nh;
    }
    set nl(a) {
        let b = this.nl;
        if (a != b) {
            this.nh = a;
            this.fi("AnimateSeriesWhenAxisRangeChanges", b, this.nl);
        }
    }
    get nn() {
        return this.nj;
    }
    set nn(a) {
        let b = this.nn;
        if (a != b) {
            this.nj = a;
            this.fi("YAxisAbbreviateLargeNumbers", b, this.nn);
        }
    }
    get_ba() {
        let a = new List$1(DataSeriesType_$type, 0);
        if (TypeRegistrar.isRegistered("AreaSeries")) {
            a.add(2);
        }
        if (TypeRegistrar.isRegistered("ColumnSeries")) {
            a.add(1);
        }
        if (TypeRegistrar.isRegistered("LineSeries")) {
            a.add(0);
        }
        if (TypeRegistrar.isRegistered("PointSeries")) {
            a.add(10);
        }
        if (TypeRegistrar.isRegistered("SplineSeries")) {
            a.add(6);
        }
        if (TypeRegistrar.isRegistered("SplineAreaSeries")) {
            a.add(7);
        }
        if (TypeRegistrar.isRegistered("StepAreaSeries")) {
            a.add(5);
        }
        if (TypeRegistrar.isRegistered("StepLineSeries")) {
            a.add(4);
        }
        if (TypeRegistrar.isRegistered("WaterfallSeries")) {
            a.add(8);
        }
        return a;
    }
    get ba() {
        return this.get_ba();
    }
    o4(a, b) {
        switch (b.propertyName) {
            case "ActualMinimum":
                this.fn("XAxisActualMinimum");
                break;
            case "ActualMaximum":
                this.fn("XAxisActualMaximum");
                break;
        }
    }
    o5(a, b) {
        switch (b.propertyName) {
            case "ActualMinimumValue":
                this.fn("YAxisActualMinimum");
                break;
            case "ActualMaximumValue":
                this.fn("YAxisActualMaximum");
                break;
        }
    }
    fy() {
        super.fy();
        this.xAxis.er = XYChart.i7(this.xAxis, this.s.dataSeries);
        this.xAxis.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
    }
    get xAxis() {
        return this._xAxis;
    }
    set xAxis(a) {
        this._xAxis = a;
    }
    get yAxis() {
        return this._yAxis;
    }
    set yAxis(a) {
        this._yAxis = a;
    }
    m8(seriesType_) {
        return (this.externalObject.createSeries(seriesType_).i);
    }
    na(a, b) {
        switch (a) {
            case 2: return this.m8(1);
            case 3: return this.m8(10);
            case 0: return this.m8(0);
            case 1: return this.m8(2);
            case 6: return this.m8(6);
            case 7: return this.m8(7);
            case 4: return this.m8(4);
            case 5: return this.m8(5);
            case 8: return this.m8(8);
            case 9: return this.m9(b);
            default: return this.m8(1);
        }
    }
    m9(a) {
        return this.m8(a);
    }
    nx(a) {
        return this.xAxis.dj(a, new ScalerParams(1, this.gi, this.gh, this.xAxis.bz));
    }
    nz(a) {
        return this.xAxis.dm(a, new ScalerParams(1, this.gi, this.gh, this.xAxis.bz));
    }
    ny(a) {
        return this.yAxis.dj(a, new ScalerParams(1, this.gi, this.gh, this.yAxis.bz));
    }
    n0(a) {
        return this.yAxis.dm(a, new ScalerParams(1, this.gi, this.gh, this.yAxis.bz));
    }
    r(a) {
        switch (this.m1) {
            case 1: return 2;
            case 0: return 0;
            case 3: return 10;
            case 6: return 6;
            case 7: return 7;
            case 5: return 5;
            case 4: return 4;
            case 8: return 8;
            case 9: return a.suggestedSeries;
            default:
            case 2: return 1;
        }
    }
    ag(a, b) {
        let c = this.na(this.m1, a.suggestedSeries);
        c.ot = a.findMatchingHint(0).path;
        c.xAxis = this.xAxis;
        c.yAxis = this.yAxis;
        return c;
    }
    fw(a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.i5 = true;
            this.yAxis.js = 10;
        }
    }
    fz() {
        this.yAxis.i5 = this.no;
        this.yAxis.js = this.og;
    }
    f1(a) {
        super.f1(a);
        let b = typeCast(HorizontalAnchoredCategorySeries.$, a);
        if (b == null) {
            return;
        }
        b.xAxis = null;
        b.yAxis = null;
    }
    get_a9() {
        return ((() => {
            let $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleCategorySeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    }
    get a9() {
        return this.get_a9();
    }
    ek(a, b) {
        let c = typeCast(HorizontalAnchoredCategorySeries.$, a);
        if (c != null) {
            c.og = this.m3;
            c.lg = this.ad(a, b);
        }
    }
    o2(a) {
        this.o3((b, c) => a(b));
    }
    o3(a) {
        if (this.dataChart == null) {
            return;
        }
        for (let b = 0; b < this.dataChart.series.count; b++) {
            a(typeCast(HorizontalAnchoredCategorySeries.$, this.dataChart.series._inner[b]), b);
        }
    }
    gj() {
        return this.xAxis;
    }
    gk() {
        return this.yAxis;
    }
    fi(a, b, c) {
        super.fi(a, b, c);
        switch (a) {
            case "ChartType":
                this.fy();
                break;
            case "MarkerCollisionAvoidance":
                this.o2((d) => d.og = this.m3);
                break;
            case "IsTransitionInEnabled":
                this.o2((d) => d.nd = this.nm);
                break;
            case "TransitionInMode":
                this.o2((d) => d.mw = this.m5);
                break;
            case "TransitionInSpeedType":
                this.o2((d) => d.bo = this.ne);
                break;
            case "XAxisInterval":
                this.xAxis.ki = this.n4;
                break;
            case "XAxisMinorInterval":
                this.xAxis.kj = this.n5;
                break;
            case "XAxisGap":
                this.xAxis.i0 = this.n3;
                break;
            case "XAxisOverlap":
                this.xAxis.i7 = this.n6;
                break;
            case "YAxisInterval":
                this.yAxis.jk = this.n9;
                break;
            case "YAxisIsLogarithmic":
                this.yAxis.i5 = this.no;
                break;
            case "YAxisLogarithmBase":
                this.yAxis.js = this.og;
                break;
            case "YAxisMinimumValue":
                this.yAxis.jo = this.ob;
                break;
            case "YAxisMaximumValue":
                this.yAxis.jn = this.oa;
                break;
            case "YAxisMinorInterval":
                this.yAxis.jp = this.oc;
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.o3((d, e) => {
                    if (d.cx) {
                        d.iy(ArrayExtension.getModulus$1(Brush.$, this.my, e), ArrayExtension.getModulus$1(Brush.$, this.mz, e));
                    }
                });
                break;
            case "AnimateSeriesWhenAxisRangeChanges":
                if (this.dataChart != null) {
                    this.dataChart.ca = this.nl;
                }
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.lk((d) => d.i0 = this.nn);
                break;
        }
    }
}
CategoryChart.$t = markType(CategoryChart, 'CategoryChart', XYChart.$);
//# sourceMappingURL=CategoryChart.js.map