/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "./DependencyProperty";
import { List$1 } from "./List$1";
import { Base, Number_$type, typeCast, Array_$type, markType, TypeRegistrar } from "./type";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { Rect } from "./Rect";
import { MathUtil } from "./MathUtil";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { LinearCategorySnapper } from "./LinearCategorySnapper";
import { NumericYAxis } from "./NumericYAxis";
import { LabelPosition } from "./LabelPosition";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { PropertyMetadata } from "./PropertyMetadata";
import { truncate, isNaN_, isInfinity } from "./number";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
export class CategoryXAxis extends CategoryAxisBase {
    constructor() {
        super();
        this.kl = 1;
        this.kk = 1;
        this.kb = 0;
        this.kc = 0;
        this.iy = new List$1(Number_$type, 0);
        this.ab = CategoryXAxis.$;
    }
    ax() {
        return new CategoryXAxisView(this);
    }
    f5(a) {
        super.f5(a);
        this.j9 = a;
    }
    get kn() {
        return this.kl;
    }
    set kn(a) {
        this.kl = a;
    }
    get km() {
        return this.kk;
    }
    set km(a) {
        this.kk = a;
    }
    ao() {
        if (this.cf) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    }
    getCategorySize(a, b, c) {
        let d = this.h9(b, c);
        return d.width / (this.ja * a.width);
    }
    i3(a, b, c) {
        let d = !isNaN_(this.i0) ? MathUtil.b(this.i0, 0, 1) : 0;
        let e = 0;
        if (!isNaN_(this.i7)) {
            e = Math.min(this.i7, 1);
        }
        else {
            e = 0;
        }
        ;
        let f = 1 - 0.5 * d;
        let g = this.jd == 0 ? 1 : this.jd;
        let h = this.getCategorySize(a, b, c) * f / (g - (g - 1) * e);
        return h;
    }
    getGroupCenter(a, b, c, d) {
        let e = 0.5;
        if (this.jd > 1) {
            let f = !isNaN_(this.i0) ? MathUtil.b(this.i0, 0, 1) : 0;
            let g = 0;
            if (!isNaN_(this.i7)) {
                g = Math.min(this.i7, 1);
            }
            let h = 1 - 0.5 * f;
            let i = h / (this.jd - (this.jd - 1) * g);
            let j = (h - i) / (this.jd - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    }
    c7() {
        return this.ki;
    }
    ks(a) {
        let b = this.a9 != null ? this.a9.mk : Rect.empty;
        b = b.copy();
        let c = this.ib;
        let d = this.h8();
        let e = new Rect(0, 0, 0, 1, 1);
        let f = new ScalerParams(0, e, e, this.bz, d);
        let g = !b.isEmpty && !c.isEmpty && this.ir != null ? this.ir.indexOf(a) : -1;
        let h = g > -1 ? this.dj(g, f) : NaN;
        if (!isNaN_(h) && this.a9.cx) {
            if (!isNaN_(h)) {
                if (h < b.left + 0.1 * b.width) {
                    h = h + 0.4 * b.width;
                    b.x = h - 0.5 * b.width;
                }
                if (h > b.right - 0.1 * b.width) {
                    h = h - 0.4 * b.width;
                    b.x = h - 0.5 * b.width;
                }
            }
            this.a9.kh(b, false, true);
        }
    }
    dj(a, b) {
        if (!b.c.isEmpty) {
            let c = this.kh(a, NumericScaler.ac, b.c, this.categoryMode);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.kh(a, b.e, b.d, this.categoryMode);
    }
    j8(a) {
        if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
            return a.asArray();
        }
        return null;
    }
    fz(a, b, c, d, e) {
        let f;
        let g = e.e;
        let h = e.d;
        let i = e.c;
        let j = e.a;
        let k = !i.isEmpty;
        let l = this.categoryMode == 0 ? this.ja - 1 : this.ja;
        if (l < 0) {
            l = 0;
        }
        let m = i.left;
        let n = i.width;
        let o = g.left;
        let p = g.width;
        let q = h.left;
        let r = h.width;
        let s = 0;
        let t = 1;
        let u = this.j8(a);
        let v = false;
        if (u != null) {
            v = true;
        }
        let w;
        for (let x = 0; x < b.count; x++) {
            w = b.item(x);
            for (let y = c; y < d; y++) {
                if (v) {
                    f = u[y];
                }
                else {
                    f = a.item(y);
                }
                if (k) {
                    let z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (j) {
                        z = 1 - z;
                    }
                    z = m + n * (z - s) / t;
                    let aa = (z - (o * r)) / p;
                    f[w] = aa;
                }
                else {
                    let ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (j) {
                        ab = 1 - ab;
                    }
                    ab = q + r * (ab - o) / p;
                    f[w] = ab;
                }
            }
        }
    }
    dk(a, b, c) {
        if (!b.c.isEmpty) {
            let d = this.kh(a, NumericScaler.ac, b.c, c);
            d = (d - b.d.left) / b.d.width;
            d = b.d.left + b.d.width * (d - b.e.left) / b.e.width;
            return d;
        }
        return this.kh(a, b.e, b.d, c);
    }
    kh(a, b, c, d) {
        let e = d == 0 ? this.ja - 1 : this.ja;
        if (e < 0) {
            e = 0;
        }
        let f = e >= 1 ? (a) / (e) : e == 0 ? 0.5 : NaN;
        if (this.b0) {
            f = 1 - f;
        }
        return c.left + c.width * (f - b.left) / b.width;
    }
    dm(a, b) {
        if (!b.c.isEmpty) {
            let c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            c = (c * b.d.width) + b.d.left;
            c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
            return c;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    }
    dn(a, b, c) {
        if (!b.c.isEmpty) {
            let d = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            d = (d * b.d.width) + b.d.left;
            d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
            return d;
        }
        return this.getUnscaledValue3(a, b.e, b.d, c);
    }
    getUnscaledValue3(a, b, c, d) {
        let e = b.left + (a - c.left) * b.width / c.width;
        if (this.b0) {
            e = 1 - e;
        }
        let f = d == 0 ? this.ja - 1 : this.ja;
        if (f < 0) {
            f = 0;
        }
        return e * f;
    }
    kt(a, b) {
        if (a == NaN || b == NaN || this.ir == null || this.ir.count == 0) {
            return;
        }
        let c = a / this.ir.count;
        let d = (b + 1) / this.ir.count;
        this.a9.my = new Rect(0, c, this.a9.my.y, d - c, this.a9.my.height);
    }
    gk(a) {
        super.gk(a);
        let b = this.a9 != null ? this.a9.mk : Rect.empty;
        let c = this.ib;
        let d = this.h6();
        let e = this.h5();
        let f = new ScalerParams(0, b, c, this.bz, d);
        let g = this.ay.at();
        let h = this.ay.aw();
        let i = this.ay.au();
        let j = this.ay.av();
        let k = this.ay.e();
        let l = this.ay.f();
        let m = this.ay.g();
        let n = this.ir;
        let o = this.ka();
        this.gr();
        this.fv(g);
        this.fv(h);
        this.fv(i);
        this.fv(j);
        this.cj.clear();
        this.ck.clear();
        this.iy.clear();
        this.ay.ao(this, b, c);
        if (b.isEmpty || c.isEmpty) {
            this.bg.count = 0;
        }
        if (this.bg.count == 0) {
            this.ay.t();
        }
        if (this.as != null) {
            this.as.registerAxis(this);
        }
        if (this.itemsSource == null || o == null || n.count == 0) {
            this.bg.count = 0;
            this.ay.t();
            return;
        }
        if (!b.isEmpty && !c.isEmpty) {
            let p = this.dm(e.left, f);
            let q = this.dm(e.right, f);
            if (this.bz) {
                p = Math.ceil(p);
                q = Math.floor(q);
            }
            else {
                p = Math.floor(p);
                q = Math.ceil(q);
            }
            let r = c.bottom;
            let s = r - c.top;
            if (this.ag != null) {
                let t = typeCast(NumericYAxis.$, this.ag);
                if (t != null) {
                    let u = this.gn(r, s, b, c, d, c.top, c.bottom);
                    r = u.p0;
                    s = u.p1;
                }
            }
            this.f3(g, r, c, k, true);
            this.ay.aj(s);
            let v = Math.min(p, q);
            let w = Math.max(p, q);
            let x = new LinearCategorySnapper(1, v, w, e.width, this.ki, this.categoryMode, this.dw());
            let y = Math.floor((v - 0) / x.g);
            let z = Math.ceil((w - 0) / x.g);
            this.kd = x.g;
            if (!isNaN_(y) && !isNaN_(z)) {
                let aa = truncate(y);
                let ab = truncate(z);
                let ac = this.kg(0 + aa * x.g, f);
                let ad = this.dj(x.g, f);
                let ae = Math.abs(ad - this.dj(0, f));
                this.ay.ak(ad);
                let af = truncate(Math.ceil(e.right));
                let ag = truncate(Math.floor(e.left));
                let ah = this.kj;
                let ai = ah > 0 && ah < x.g;
                let aj = c.right;
                let ak = this.iy;
                let al = x.g;
                let am = truncate(al);
                let an = this.jd;
                let ao = this.bz;
                let ap = this.categoryMode;
                for (let aq = aa; aq <= ab; ++aq) {
                    let ar = this.kg(0 + (aq + 1) * x.g, f);
                    if (ac <= aj) {
                        if (aq % 2 == 0) {
                            this.gt(h, ac, ar, c);
                        }
                        this.gs(i, ac, c, l, false);
                        ak.add(ac);
                    }
                    if (this.categoryMode != 0 && this.jd != 0 && this.b9) {
                        if (ai) {
                            let as = ae * this.kj;
                            if (this.bz) {
                                let at = ac;
                                while (at - as > ar) {
                                    at -= as;
                                    if (Math.abs(at - ar) < 0.0001) {
                                        break;
                                    }
                                    this.gs(j, at, c, m, false);
                                }
                            }
                            else {
                                let au = ac;
                                while (au + as < ar) {
                                    au += as;
                                    if (Math.abs(au - ar) < 0.0001) {
                                        break;
                                    }
                                    this.gs(j, au, c, m, false);
                                }
                            }
                            this.ke = this.kj;
                        }
                        else {
                            for (let av = 0; av < truncate(x.g); av++) {
                                for (let aw = 0; aw < this.jd; aw++) {
                                    let ax = this.getGroupCenter(aw, b, c, d);
                                    if (this.bz) {
                                        ax = -ax;
                                    }
                                    let ay = this.dj(av + aq * x.g, f) + ax;
                                    this.gs(j, ay, c, m, false);
                                }
                            }
                            this.ke = 0.5;
                        }
                    }
                    let az = this.kf(aq * al, ac, ap == 0, f);
                    let a0 = truncate(Math.round(az));
                    if (a0 >= ag && a0 <= af) {
                        let a1 = 0;
                        if (al >= 1) {
                            a1 = aq * truncate(Math.floor(al));
                        }
                        else {
                            if ((aq * al) * 2 % 2 == 0) {
                                a1 = truncate(Math.floor(aq * al));
                            }
                            else {
                                a1 = -1;
                            }
                        }
                        if (o != null && a1 < n.count && a1 >= 0) {
                            let a2 = o.getItem(a1);
                            let a3 = this.eq(a2);
                            if (!isNaN_(az) && !isInfinity(az) && a3 != null) {
                                if ((typeof a3 === 'string') && Base.equalsStatic(a3, "")) {
                                }
                                else {
                                    this.cj.add1(a3);
                                    this.ck.add(new LabelPosition(az));
                                }
                            }
                        }
                    }
                    ac = ar;
                }
            }
            if ((this.as == null || this.as.visibility == 0) && this.ag != null) {
                if (this.as != null && (this.as.location == 4 || this.as.location == 5)) {
                    this.a9.hp();
                }
            }
            this.ay.ap(this.cj, this.ck);
            this.jy();
        }
    }
    cd() {
        if (this.b6 && this.ce) {
            this.a3 = this.a2();
        }
        if (this.ir == null) {
            return false;
        }
        let a = this.ir.count;
        if (a != this.km) {
            let b = new AxisRangeChangedEventArgs(1, 1, this.km, a);
            this.km = a;
            this.ge(b);
            return true;
        }
        return false;
    }
    get ki() {
        return this.c(CategoryXAxis.ku);
    }
    set ki(a) {
        this.h(CategoryXAxis.ku, a);
    }
    get kd() {
        return this.kb;
    }
    set kd(a) {
        if (this.kd != a) {
            let b = this.kb;
            this.kb = a;
            this.gd("ActualInterval", b, this.kd);
        }
    }
    get kj() {
        return this.c(CategoryXAxis.kv);
    }
    set kj(a) {
        this.h(CategoryXAxis.kv, a);
    }
    get ke() {
        return this.kc;
    }
    set ke(a) {
        if (this.ke != a) {
            let b = this.kc;
            this.kc = a;
            this.gd("ActualMinorInterval", b, this.ke);
        }
    }
    iu(a) {
        if (a == null) {
            return false;
        }
        let b = this.a5();
        if (b == null) {
            return false;
        }
        return b.ac;
    }
    get_av() {
        return 0;
    }
    get av() {
        return this.get_av();
    }
    ka() {
        return this.ir;
    }
    kg(a, b) {
        return this.dj(a, b);
    }
    kf(a, b, c, d) {
        if (!c) {
            let e = this.kg(a + 1, d);
            return (b + e) / 2;
        }
        return b;
    }
    get isVertical() {
        return this.b5;
    }
    j$c(a, b) {
        return this.dm.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dj.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.fz.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.f0.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.f1.apply(this, arguments);
    }
    get j$a() {
        return this.bz;
    }
}
CategoryXAxis.ku = DependencyProperty.i("Interval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    a.gd("Interval", b.oldValue, b.newValue);
    a.gj(false);
}));
CategoryXAxis.kv = DependencyProperty.i("MinorInterval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    (typeCast(CategoryXAxis.$, a)).gd("MinorInterval", b.oldValue, b.newValue);
    (typeCast(CategoryXAxis.$, a)).gj(false);
}));
CategoryXAxis.$t = markType(CategoryXAxis, 'CategoryXAxis', CategoryAxisBase.$);
export class CategoryXAxisView extends CategoryAxisBaseView {
    constructor(a) {
        super(a);
        this.ba = null;
        this.ba = a;
    }
}
CategoryXAxisView.$t = markType(CategoryXAxisView, 'CategoryXAxisView', CategoryAxisBaseView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.CategoryXAxis" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.CategoryXAxis" />*/
//# sourceMappingURL=CategoryXAxis_combined.js.map