/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { TrendLineType_$type } from "./TrendLineType";
import { DependencyProperty } from "./DependencyProperty";
import { Brush } from "./Brush";
import { PenLineCap_$type } from "./PenLineCap";
import { DoubleCollection } from "./DoubleCollection";
import { PriceDisplayType_$type } from "./PriceDisplayType";
import { Type, enumGetBox, EnumUtil, typeCast, fromEnum, runOn, Point_$type, markType } from "./type";
import { CategoryFrame } from "./CategoryFrame";
import { ISortingAxis_$type } from "./ISortingAxis";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { Rect } from "./Rect";
import { List$1 } from "./List$1";
import { RectUtil } from "./RectUtil";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { AxisRange } from "./AxisRange";
import { ScalerParams } from "./ScalerParams";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { Pool$1 } from "./Pool$1";
import { Path } from "./Path";
import { PathGeometry } from "./PathGeometry";
import { PathFigure } from "./PathFigure";
import { LineSegment } from "./LineSegment";
import { GeometryGroup } from "./GeometryGroup";
import { LineGeometry } from "./LineGeometry";
import { RectangleGeometry } from "./RectangleGeometry";
import { PropertyMetadata } from "./PropertyMetadata";
import { truncate, isNaN_ } from "./number";
import { boxArray$1 } from "./array";
import { FinancialPriceBucketCalculator } from "./FinancialPriceBucketCalculator";
import { Extensions } from "./Extensions";
export class FinancialPriceSeries extends FinancialSeries {
    constructor() {
        super();
        this.ab = FinancialPriceSeries.$;
        this.lq = new CategoryFrame(5);
        this.ls = new CategoryFrame(5);
        this.lp = new CategoryFrame(5);
    }
    be() {
        return new FinancialPriceSeriesView(this);
    }
    h9(a) {
        super.h9(a);
        this.ow = a;
    }
    get pg() {
        return this.c(FinancialPriceSeries.o6);
    }
    set pg(a) {
        this.h(FinancialPriceSeries.o6, a);
    }
    hh(a, b, c, d) {
        super.hh(a, b, c, d);
        if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
            this.ln.i$i();
        }
        this.ow.bs.e(this.ej);
        if (this.ow.b2) {
            this.ow.b0.g$e(a, b, c, d);
        }
        if (this.l7 != null) {
            this.l7.cb();
        }
        this.it(true);
    }
    bc() {
        if (this.bd == 0) {
            return 1;
        }
        else {
            return super.bc();
        }
    }
    k9(a) {
        if (this.lp == null || this.lp.f.count == 0) {
            return Rect.empty;
        }
        let b = this.kv(a);
        let c = this.bh.bq;
        let d = this.bh.bp;
        let e = this.getEffectiveViewport1(this.bh);
        let f = this.ai(this.ln, this.lp.f, this.ni(this.bh), this.nj(this.bh), a, true);
        let g = f[0];
        let h = f[1];
        let i = Math.abs(b.x - g[0]);
        let j = Math.abs(b.x - h[0]);
        let k = this.oy(this.l3, e);
        k = Math.max(k, 3);
        let l = (k - 1) / 2;
        if (i < j) {
            let m = g[0] - l;
            let n = g[0];
            let o = g[0] + l;
            let p = g[1];
            let q = g[2];
            let r = g[3];
            let s = g[4];
            let t = Math.min(Math.min(Math.min(p, q), r), s);
            let u = Math.max(Math.max(Math.max(p, q), r), s);
            return new Rect(0, m, t, Math.abs(o - m), u - t);
        }
        else {
            let v = h[0] - l;
            let w = h[0];
            let x = h[0] + l;
            let y = h[1];
            let z = h[2];
            let aa = h[3];
            let ab = h[4];
            let ac = Math.min(Math.min(Math.min(y, z), aa), ab);
            let ad = Math.max(Math.max(Math.max(y, z), aa), ab);
            return new Rect(0, v, ac, Math.abs(x - v), ad - ac);
        }
    }
    ov(a, b) {
        let c = a[0] - b;
        let d = a[0];
        let e = a[0] + b;
        let f = a[1];
        let g = a[2];
        let h = a[3];
        let i = a[4];
        let j = Math.min(Math.min(Math.min(f, g), h), i);
        let k = Math.max(Math.max(Math.max(f, g), h), i);
        let l = Math.min(g, h);
        let m = Math.max(g, h);
        let n = Math.min(f, i);
        let o = Math.max(f, i);
        if (this.ox == 1) {
            let p = new Array(3);
            let q = new Rect(0, c, f, b, 0);
            let r = new Rect(0, d, i, b, 0);
            let s = new Rect(0, d, l, 0, m - l);
            p[0] = q;
            p[1] = r;
            p[2] = s;
            return p;
        }
        else {
            let t = new Array(2);
            let u = new Rect(0, d, l, 0, m - l);
            let v = new Rect(0, c, n, b * 2, o - n);
            t[0] = u;
            t[1] = v;
            return t;
        }
    }
    aj(a) {
        let b = new List$1(Rect.$, 0);
        let c = this.kv(a);
        let d = this.bh.bq;
        let e = this.bh.bp;
        let f = this.getEffectiveViewport1(this.bh);
        let g = this.ai(this.ln, this.lp.f, this.ni(this.bh), this.nj(this.bh), a, true);
        let h = g[0];
        let i = g[1];
        let j = Math.abs(c.x - h[0]);
        let k = Math.abs(c.x - i[0]);
        let l = this.oy(this.l3, f);
        l = Math.max(l, 3);
        let m = (l - 1) / 2;
        if (j < k) {
            return this.ov(h, m);
        }
        else {
            return this.ov(i, m);
        }
    }
    dd(a, b) {
        if (this.dg(a, b)) {
            return true;
        }
        return false;
    }
    dg(a, b) {
        let c = this.la(a);
        if (c.isEmpty) {
            return false;
        }
        let d = RectUtil.r(c, (this.en / 2) + this.d5(b));
        if (d.containsPoint(a)) {
            let e = this.ak(a);
            if (e != null) {
                for (let f = 0; f < e.length; f++) {
                    let g = e[f];
                    let h = RectUtil.r(g, (this.en / 2) + this.d5(b));
                    if (h.containsPoint(a)) {
                        return true;
                    }
                }
            }
        }
        return false;
    }
    ie(a, b, c, d) {
        switch (b) {
            case FinancialSeries.$$p[9]:
                this.ow.b8();
                break;
            case "TrendLineType":
                let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.ow.b0 = CategoryTrendLineManagerFactory.a(this.ow.b0, this.ln, this.jc, this, this.b1);
                }
                break;
        }
        super.ie(a, b, c, d);
        if (this.ow.b2 && this.ow.b0 != null && this.ow.b0.g$b(a, b, c, d)) {
            this.it(false);
            this.h1();
        }
        switch (b) {
            case FinancialPriceSeries.$$p[0]:
                if (this.jc != null) {
                    this.o5();
                    this.lp.w();
                    this.od(this.lp, this.ow);
                }
                this.h1();
                break;
            case "TrendLineBrush":
                this.i4();
                break;
            case "TrendLineType":
                this.h1();
                break;
            case FinancialSeries.$$p[5]:
            case FinancialPriceSeries.$$p[1]:
                this.ib();
                break;
        }
    }
    o5() {
        this.ow.cc();
        if (this.bg != null) {
            this.bg.cc();
        }
    }
    am(a) {
        if (a != null && a == this.l7 && this.md != null && !isNaN_(this.md.minimum) && this.mb != null && !isNaN_(this.mb.maximum)) {
            return new AxisRange(this.md.minimum, this.mb.maximum);
        }
        return null;
    }
    an() {
        if (this.md == null || this.mb == null) {
            return null;
        }
        let a = new ScalerParams(0, this.br.mk, this.br.mx, this.ln.bz, this.getEffectiveViewport());
        let b = (this.ln.dm(this.br.mx.left, a));
        let c = (this.ln.dm(this.br.mx.right, a));
        let d = null;
        if (this.ln.b3) {
            d = this.ln;
            b = d.i$f(b);
            c = d.i$f(c);
        }
        else {
            b = Math.floor(b);
            c = Math.ceil(c);
        }
        b = Math.max(0, Math.min(this.md.count - 1, b));
        c = Math.max(0, Math.min(this.md.count - 1, c));
        let e = 1.7976931348623157E+308;
        let f = -1.7976931348623157E+308;
        for (let g = truncate(b); g <= truncate(c); g++) {
            let h = g;
            if (d != null) {
                h = d.i$b._inner[g];
            }
            e = Math.min(e, this.md.item(h));
            f = Math.max(f, this.mb.item(h));
        }
        return new AxisRange(e, f);
    }
    d8() {
        return this.mf == null || this.mf.count == 0 ? NaN : this.mf.item(0);
    }
    c5(a) {
        let b = this.by != null ? this.by.indexOf(a) : -1;
        let c = this.bh.bq;
        c = c.copy();
        let d = this.bh.bp;
        let e = new Rect(0, 0, 0, 1, 1);
        let f = this.k7(this.bh);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.ln != null) {
                let g = new ScalerParams(0, e, e, this.ln.bz, f);
                let h = this.ln.dj(b, g);
                if (h < c.left + 0.1 * c.width) {
                    h = h + 0.4 * c.width;
                }
                if (h > c.right - 0.1 * c.width) {
                    h = h - 0.4 * c.width;
                }
                c.x = h - 0.5 * c.width;
            }
            if (this.l7 != null && this.md != null && this.mb != null && b < this.md.count && b < this.mb.count) {
                let i = new ScalerParams(0, e, e, this.l7.bz, f);
                let j = this.l7.dj(this.md.item(b), i);
                let k = this.l7.dj(this.mb.item(b), i);
                if (!isNaN_(j) && !isNaN_(k)) {
                    let l = Math.abs(j - k);
                    if (c.height < l) {
                        c.height = l;
                        c.y = Math.min(j, k);
                    }
                    else {
                        if (j < c.top + 0.1 * c.height) {
                            j = j + 0.4 * c.height;
                        }
                        if (j > c.bottom - 0.1 * c.height) {
                            j = j - 0.4 * c.height;
                        }
                        c.y = j - 0.5 * c.height;
                    }
                }
            }
            this.bm.ap(this.br, c, true);
        }
        return b >= 0;
    }
    ds(a, b, c) {
        let d = super.ds(a, b, c);
        if (this.mf == null || this.l9 == null || this.mb == null || this.md == null) {
            d = false;
        }
        return d;
    }
    ob(a, b) {
        super.ob(a, b);
        let c = b.bq;
        let d = b.bp;
        let e = this.getEffectiveViewport1(b);
        let f = this.ln;
        let g = this.l7;
        let h = new ScalerParams(0, c, d, f.bz, e);
        let i = ((() => {
            let $ret = new ScalerParams(0, c, d, g.bz, e);
            $ret.b = this.d8();
            return $ret;
        })());
        a.f.clear();
        a.m.clear();
        a.p.clear();
        let j = 0;
        let k = typeCast(ISortingAxis_$type, this.ln);
        if (k != null && (k.i$b == null || k.i$b.count != this.by.count)) {
            return;
        }
        j = this.nc(c, d, e);
        let l = typeCast(FinancialPriceSeriesView.$, b);
        if (this.trendLineType != 0) {
            let m = new Array(this.by.count);
            let n = 0;
            for (let o of fromEnum(this.m3)) {
                m[n] = o;
                n++;
            }
            if (this.ow.b2) {
                this.ow.b0.prepareLineCore(a.p, this.trendLineType, boxArray$1(m), this.trendLinePeriod, (p) => this.ln.dj(p, h), (p) => this.l7.dj(p, i), ((() => {
                    let $ret = new TrendResolutionParams();
                    $ret.c = b.bs.b;
                    $ret.d = b.bs.c;
                    $ret.e = b.bs.d;
                    $ret.a = j;
                    $ret.b = this.ej;
                    $ret.f = d;
                    return $ret;
                })()));
            }
        }
        let p = this.ln.dm(2, h) - this.ln.dm(1, h);
        for (let q = b.bs.c; q <= b.bs.d; ++q) {
            let r;
            if (k == null) {
                r = b.bs.getBucket(q);
            }
            else {
                let s = k.i$b._inner[q];
                let t = k.i$d(s);
                let u = this.mf.item(s);
                let v = this.mb.item(s);
                let w = this.md.item(s);
                let x = this.l9.item(s);
                let y = u;
                let z = v;
                let aa = w;
                let ab = x;
                let ac = t;
                while (q < b.bs.d) {
                    s = k.i$b._inner[q + 1];
                    ac = k.i$d(s);
                    if (ac - t > p * this.ej) {
                        break;
                    }
                    q++;
                    z = Math.max(z, this.mb.item(s));
                    aa = Math.min(aa, this.md.item(s));
                    ab = this.l9.item(s);
                }
                let ad = NaN;
                if (!isNaN_(t)) {
                    ad = this.ln.dj(t, h);
                }
                r = [ad, y, z, aa, ab];
            }
            if (!isNaN_(r[0])) {
                if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
                    r[0] = r[0] + j;
                }
                else {
                    r[0] = f.dj(r[0], h) + j;
                }
                r[1] = g.dj(r[1], i);
                r[2] = g.dj(r[2], i);
                r[3] = g.dj(r[3], i);
                r[4] = g.dj(r[4], i);
                a.f.add(r);
            }
        }
        return;
    }
    he(a, b) {
        super.he(a, b);
        let c = typeCast(FinancialPriceSeriesView.$, b);
        c.b6();
        if (a) {
            c.b1.count = 0;
        }
        if (c.b2 && c.b0 != null) {
            c.b0.g$d();
        }
    }
    get_mp() {
        return true;
    }
    get mp() {
        return this.get_mp();
    }
    od(a, b) {
        super.od(a, b);
        if (this.ln == null || this.l7 == null) {
            return;
        }
        let c = false;
        if (b.bv(a)) {
            c = true;
            b.bx(a);
        }
        this.lv.x(this, this.mt(), this.ln, runOn(this, this.lf), this.ni(b), this.nj(b));
        let d = false;
        let e = this.lv.c;
        if (e != null) {
            d = true;
        }
        let f = typeCast(FinancialPriceSeriesView.$, b);
        f.b5();
        f.b3 = false;
        if (f.b2) {
            f.b0.g$d();
        }
        if (this.trendLineType != 0) {
            f.b0.g$g(a.p);
        }
        if (d) {
            this.o4(a, b, c);
        }
        else {
            f.b1.count = 0;
            this.o3(a, b);
        }
    }
    d7() {
        let a = this.getEffectiveViewport1(this.bh);
        return this.oy(this.l3, a);
    }
    o4(a, b, c) {
        let d = this.ox;
        let e = this.getEffectiveViewport1(b);
        let f = this.oy(b, e);
        let g = (f - 1) / 2;
        let h = typeCast(FinancialPriceSeriesView.$, b);
        h.b3 = true;
        let i = a.f;
        let j = 0;
        let k = this.by.count;
        let l = this.ln;
        let m = new ScalerParams(0, b.bq, b.bp, l.bz, e);
        let n = this.ki;
        let o = this.op;
        if (o == null) {
            o = n;
        }
        let p = this.kj;
        let q = this.ph;
        if (q == null) {
            q = p;
        }
        for (let r = 0; r < i.count; ++r) {
            let s = i._inner[r][0] - g;
            let t = i._inner[r][0];
            let u = i._inner[r][0] + g;
            let v = i._inner[r][1];
            let w = i._inner[r][2];
            let x = i._inner[r][3];
            let y = i._inner[r][4];
            if (isNaN_(v) || isNaN_(w) || isNaN_(x) || isNaN_(y)) {
                continue;
            }
            let z = h.b1.item(j);
            j++;
            let aa = v < y;
            let ab = new PathGeometry();
            if (c) {
                switch (d) {
                    case 0:
                        if (aa) {
                            let ac = v;
                            v = y;
                            y = ac;
                        }
                        let ad = new PathFigure();
                        ad._startPoint = { $type: Point_$type, x: t, y: x };
                        ad._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: v };
                            return $ret;
                        })()));
                        let ae = new PathFigure();
                        ae._startPoint = { $type: Point_$type, x: s, y: y };
                        ae._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: u, y: y };
                            return $ret;
                        })()));
                        ae._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: u, y: v };
                            return $ret;
                        })()));
                        ae._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: s, y: v };
                            return $ret;
                        })()));
                        ae._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: s, y: y };
                            return $ret;
                        })()));
                        let af = new PathFigure();
                        af._startPoint = { $type: Point_$type, x: t, y: y };
                        af._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: w };
                            return $ret;
                        })()));
                        ab.b.add(ad);
                        ab.b.add(ae);
                        ab.b.add(af);
                        break;
                    case 1:
                        let ag = new PathFigure();
                        ag._startPoint = { $type: Point_$type, x: s, y: v };
                        ag._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: v };
                            return $ret;
                        })()));
                        let ah = new PathFigure();
                        ah._startPoint = { $type: Point_$type, x: t, y: x };
                        ah._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: w };
                            return $ret;
                        })()));
                        let ai = new PathFigure();
                        ai._startPoint = { $type: Point_$type, x: t, y: y };
                        ai._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: u, y: y };
                            return $ret;
                        })()));
                        ab.b.add(ag);
                        ab.b.add(ah);
                        ab.b.add(ai);
                        break;
                }
            }
            if (aa) {
                this.lv.al = o;
                this.lv.ah = o;
                this.lv.am = this.lv.ai = q;
                this.lv.f = true;
            }
            else {
                this.lv.al = n;
                this.lv.ah = n;
                this.lv.am = this.lv.ai = p;
                this.lv.f = false;
            }
            this.oa(i, r, k, l, m, b.n);
            if (d == 1) {
                this.lv.ae(z, true, false, false, false);
            }
            else {
                this.lv.ae(z, false, false, false, false);
            }
            if (c) {
                z.aj = ab;
            }
        }
        h.b1.count = j;
        h.b7();
    }
    oy(a, b) {
        let c = this.ln.i3(a.bq, a.bp, b);
        c = Math.max(c, this.ej * 0.9);
        c = Math.max(c, 3);
        return c;
    }
    o3(a, b) {
        let c = this.ox;
        let d = this.getEffectiveViewport1(b);
        let e = this.oy(b, d);
        let f = (e - 1) / 2;
        let g = typeCast(FinancialPriceSeriesView.$, b);
        let h = g.cf();
        let i = g.ce();
        let j = a.f;
        for (let k = 0; k < j.count; ++k) {
            let l = j._inner[k][0] - f;
            let m = j._inner[k][0];
            let n = j._inner[k][0] + f;
            let o = j._inner[k][1];
            let p = j._inner[k][2];
            let q = j._inner[k][3];
            let r = j._inner[k][4];
            if (isNaN_(o) || isNaN_(p) || isNaN_(q) || isNaN_(r)) {
                continue;
            }
            let s = o < r;
            let t = s ? i : h;
            switch (c) {
                case 0:
                    if (s) {
                        let u = o;
                        o = r;
                        r = u;
                    }
                    t.c.add(((() => {
                        let $ret = new LineGeometry();
                        $ret.c = { $type: Point_$type, x: m, y: q };
                        $ret.b = { $type: Point_$type, x: m, y: o };
                        return $ret;
                    })()));
                    t.c.add(((() => {
                        let $ret = new RectangleGeometry();
                        $ret.d = new Rect(0, l, r, n - l, o - r);
                        return $ret;
                    })()));
                    t.c.add(((() => {
                        let $ret = new LineGeometry();
                        $ret.c = { $type: Point_$type, x: m, y: r };
                        $ret.b = { $type: Point_$type, x: m, y: p };
                        return $ret;
                    })()));
                    break;
                case 1:
                    t.c.add(((() => {
                        let $ret = new LineGeometry();
                        $ret.c = { $type: Point_$type, x: l, y: o };
                        $ret.b = { $type: Point_$type, x: m, y: o };
                        return $ret;
                    })()));
                    t.c.add(((() => {
                        let $ret = new LineGeometry();
                        $ret.c = { $type: Point_$type, x: m, y: q };
                        $ret.b = { $type: Point_$type, x: m, y: p };
                        return $ret;
                    })()));
                    t.c.add(((() => {
                        let $ret = new LineGeometry();
                        $ret.c = { $type: Point_$type, x: m, y: r };
                        $ret.b = { $type: Point_$type, x: n, y: r };
                        return $ret;
                    })()));
                    break;
            }
        }
    }
    fh(a, b) {
        if (this.ow.b2 && a == this.ow.b0.g$j) {
            return null;
        }
        return super.fh(a, b);
    }
    i4() {
        super.i4();
        if (this.e6 < 0) {
            return;
        }
        this.ow.cd();
    }
    hn(a) {
        super.hn(a);
        if (this.ow.b2) {
            this.a1.exportTrendlineData(this, a, this.ow.b0.g$j);
        }
    }
    iy(a, b) {
        super.iy(a, b);
        this.ph = b;
    }
}
FinancialPriceSeries.o6 = DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialPriceSeries.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
FinancialPriceSeries.$t = markType(FinancialPriceSeries, 'FinancialPriceSeries', FinancialSeries.$, [ITrendLineSeries_$type]);
Type.dep(DependencyProperty, PropertyMetadata, FinancialPriceSeries, 'raisePropertyChanged', ['DisplayType:ox:o7', [PriceDisplayType_$type, enumGetBox(PriceDisplayType_$type, 0)], 'NegativeOutline:ph:o8', [Brush.$, null], 'TrendLineType::pe', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::pd', [1, 1.5], 'TrendLinePeriod::pc', [1, 7], 'TrendLineBrush::o9', [Brush.$, null], 'TrendLineZIndex:o0:pf', [1, 1001], 'TrendLineDashArray:pi:pa', [DoubleCollection.$], 'TrendLineDashCap:pj:pb', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
export class FinancialPriceSeriesView extends FinancialSeriesView {
    constructor(a) {
        super(a);
        this.by = null;
        this.b1 = null;
        this.b4 = null;
        this.ci = ((() => {
            let $ret = new Path();
            $ret.aj = new GeometryGroup();
            return $ret;
        })());
        this.ch = ((() => {
            let $ret = new Path();
            $ret.aj = new GeometryGroup();
            return $ret;
        })());
        this.bz = null;
        this.cg = new Path();
        this.b3 = false;
        this.by = a;
        this.b4 = new List$1(Path.$, 0);
        this.b1 = ((() => {
            let $ret = new Pool$1(Path.$);
            $ret.create = runOn(this, this.cj);
            $ret.activate = runOn(this, this.b9);
            $ret.disactivate = runOn(this, this.cb);
            $ret.destroy = runOn(this, this.ca);
            return $ret;
        })());
    }
    cj() {
        let a = new Path();
        this.b4.add(a);
        a._visibility = 1;
        return a;
    }
    b9(a) {
        a._visibility = 0;
    }
    cb(a) {
        a._visibility = 1;
    }
    ca(a) {
        this.b4.remove(a);
    }
    bt() {
        return new FinancialPriceBucketCalculator(this);
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.bu.op = ((() => {
                let $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.by.ph = this.bu.op;
            this.bu.ej = 5;
            this.bu.en = 1;
        }
    }
    get b0() {
        if (this.bz == null) {
            this.bz = CategoryTrendLineManagerFactory.a(this.bz, this.e.ao(), this.e.jc, this.e, this.e.b1);
        }
        return this.bz;
    }
    set b0(a) {
        this.bz = a;
    }
    get b2() {
        return this.bz != null;
    }
    cc() {
        if (this.by.ox == 1) {
            this.ci._stroke = this.e.ki;
        }
        else {
            this.ci._stroke = this.e.kj;
        }
        if (this.by.ox == 1) {
            this.ch._stroke = this.bu.op;
        }
        else {
            this.ch._stroke = this.by.ph;
        }
    }
    b6() {
        this.an();
        this.b1.count = 0;
        this.b5();
    }
    b5() {
        let a = typeCast(GeometryGroup.$, this.ci.aj);
        let b = typeCast(GeometryGroup.$, this.ch.aj);
        Extensions.d(a);
        Extensions.d(b);
    }
    cf() {
        this.an();
        return typeCast(GeometryGroup.$, this.ci.aj);
    }
    ce() {
        this.an();
        return typeCast(GeometryGroup.$, this.ch.aj);
    }
    cd() {
        this.by.pg = null;
        if (this.by.trendLineBrush != null) {
            this.by.pg = this.by.trendLineBrush;
        }
        else {
            this.by.pg = this.by.ki;
        }
    }
    a8() {
        super.a8();
        this.ci.ac = this.e.en;
        this.ci.ai = this.e.kq;
        this.ci.ad = this.e.kr;
        if (this.by.ox == 1) {
            this.ci._stroke = this.e.ki;
        }
        else {
            this.ci._stroke = this.e.kj;
            this.ci._fill = this.e.ki;
        }
        this.ch.ac = this.e.en;
        this.ch.ai = this.e.kq;
        this.ch.ad = this.e.kr;
        if (this.by.ox == 1) {
            this.ch._stroke = this.bu.op;
        }
        else {
            this.ch._stroke = this.by.ph;
            this.ch._fill = this.bu.op;
        }
    }
    a9() {
        super.a9();
        let a = this.bk();
        this.ci.ac = this.e.en + 3;
        if (this.by.ox == 1) {
            this.ci._stroke = a;
        }
        else {
            this.ci._stroke = a;
            this.ci._fill = a;
        }
        this.ch.ac = this.e.en + 3;
        if (this.by.ox == 1) {
            this.ch._stroke = a;
        }
        else {
            this.ch._stroke = a;
            this.ch._fill = a;
        }
    }
    z(a) {
        return this.b4._inner[a];
    }
    y(a) {
        let b = this.b4._inner[a];
        this.cg._visibility = b._visibility;
        this.cg.aj = b.aj;
        let c = this.bl(a);
        this.cg._fill = c;
        this.cg._stroke = c;
        this.cg.ac = this.e.en + 3;
        return this.cg;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (this.b3) {
                for (let c = 0; c < this.b4.count; c++) {
                    let d = this.x(c, b);
                    if (d._visibility == 0) {
                        a.s(d);
                    }
                }
            }
            else {
                a.s(this.ci);
                a.s(this.ch);
            }
        }
    }
    a2(a, b) {
        if (a.d) {
            if (this.by.trendLineType != 0 && !b) {
                let c = this.b0.g$j;
                c.ac = this.by.trendLineThickness;
                c._stroke = this.by.pg;
                c.ai = this.by.pi;
                c.ad = this.by.pj;
                a.u(c);
            }
        }
        super.a2(a, b);
    }
    ai(a) {
        super.ai(a);
        this.e.a1.exportPathData(a, this.ci, "positivePathShape", ["Positive", "Main"]);
        this.e.a1.exportPathData(a, this.ch, "negativePathShape", ["Negative"]);
    }
    b7() {
        this.an();
    }
    b8() {
        if (this.b2) {
            this.bz = CategoryTrendLineManagerFactory.a(this.bz, this.e.ao(), this.e.jc, this.e, this.e.b1);
        }
    }
}
FinancialPriceSeriesView.$t = markType(FinancialPriceSeriesView, 'FinancialPriceSeriesView', FinancialSeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.FinancialPriceSeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.FinancialPriceSeries" />*/
//# sourceMappingURL=FinancialPriceSeries_combined.js.map