import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { Type } from "./type";
import { IFastItemColumn$1 } from "./IFastItemColumn$1";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasHighLowValueCategory } from "./IHasHighLowValueCategory";
import { RangeCategoryFramePreparer } from "./RangeCategoryFramePreparer";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { List$1 } from "./List$1";
import { Polyline } from "./Polyline";
import { Polygon } from "./Polygon";
import { Rect } from "./Rect";
import { Axis } from "./Axis";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "./FastItemsSourceEventAction";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderSurface } from "./RenderSurface";
export declare class RangeCategoryBucketCalculator extends CategoryBucketCalculator {
    j: RangeCategorySeriesView;
    constructor(a: RangeCategorySeriesView);
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private l;
    private k;
    private i;
    private h;
    cacheValues(): void;
    unCacheValues(): void;
    static $t: Type;
}
export declare abstract class RangeCategorySeries extends CategorySeries implements IIsCategoryBased, IHasHighLowValueCategory {
    protected be(): SeriesView;
    h9(a: SeriesView): void;
    od: RangeCategorySeriesView;
    constructor();
    private _RangeFramePreparer;
    RangeFramePreparer: RangeCategoryFramePreparer;
    om: string;
    lowColumn: IFastItemColumn$1<number>;
    private og;
    oj: string;
    highColumn: IFastItemColumn$1<number>;
    private oe;
    protected mv(): CategoryTransitionInMode;
    n2(a: CategoryFrame, b: CategorySeriesView): void;
    protected oo(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    c5(a: any): boolean;
    protected ie(a: any, b: string, c: any, d: any): void;
    am(a: Axis): AxisRange;
    protected hh(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    ds(a: Rect, b: Rect, c: SeriesView): boolean;
    nz(a: CategoryFrame, b: CategorySeriesView): void;
    readonly currentCategoryMode: CategoryMode;
    readonly scaler: ICategoryScaler;
    readonly yScaler: IScaler;
    readonly bucketizer: IBucketizer;
    readonly currentMode2Index: number;
    provideCollisionDetector(): IDetectsCollisions;
    readonly mayContainUnknowns: boolean;
    iv(a: Rect, b: RenderSurface): void;
    private ob;
    is(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    d8(): number;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class RangeCategorySeriesView extends CategorySeriesView {
    cu: RangeCategorySeries;
    constructor(a: RangeCategorySeries);
    cv(a: Polyline, b: Polygon, c: Polyline, d: number, e: List$1<number[]>, f: boolean): void;
    cm(): CategoryBucketCalculator;
    getDefaultTooltipTemplate(): string;
    static $t: Type;
}
