/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { Type, markType, typeCast, Point_$type } from "./type";
import { isNaN_ } from "./number";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { IHasHighLowValueCategory_$type } from "./IHasHighLowValueCategory";
import { RangeCategoryFramePreparer } from "./RangeCategoryFramePreparer";
import { DependencyProperty } from "./DependencyProperty";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ICategoryScaler_$type } from "./ICategoryScaler";
import { IScaler_$type } from "./IScaler";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { IFastItemsSource_$type } from "./IFastItemsSource";
import { AxisRange } from "./AxisRange";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CollisionAvoider } from "./CollisionAvoider";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { PropertyMetadata } from "./PropertyMetadata";
import { FastFlattener } from "./FastFlattener";
import { stringIsNullOrEmpty } from "./string";
export class RangeCategoryBucketCalculator extends CategoryBucketCalculator {
    constructor(a) {
        super(a);
        this.j = null;
        this.l = 0;
        this.k = 0;
        this.i = null;
        this.h = null;
        this.j = a;
    }
    getBucketWithoutUnknowns(a) {
        let b = false;
        let c = this.i;
        let d = this.h;
        let e = this.l;
        let f = this.k;
        let g = Math.min(e, f);
        let h = a * this.d;
        let i = Math.min(h + this.d - 1, g - 1);
        let j = 1.7976931348623157E+308;
        let k = -1.7976931348623157E+308;
        let l = true;
        let m = 0;
        let n = 0;
        let o;
        let p;
        for (let q = h; q <= i; ++q) {
            m = c[q];
            n = d[q];
            if (m < n) {
                o = m;
                p = n;
            }
            else {
                p = m;
                o = n;
            }
            if (!l) {
                j = j < o ? j : o;
                k = k > o ? k : o;
                j = j < p ? j : p;
                k = k > p ? k : p;
            }
            else {
                j = Math.min(j, o);
                k = Math.max(k, o);
                k = Math.max(k, p);
                j = Math.min(j, p);
                l = false;
            }
        }
        if (b && n < m) {
            let r = j;
            j = k;
            k = r;
        }
        if (!l) {
            let s = new Array(3);
            s[0] = 0.5 * (h + i);
            s[1] = j;
            s[2] = k;
            return s;
        }
        let t = new Array(3);
        t[0] = NaN;
        t[1] = NaN;
        t[2] = NaN;
        return t;
    }
    getBucket(a) {
        let b = false;
        let c = this.i;
        let d = this.h;
        let e = this.l;
        let f = this.k;
        let g = Math.min(e, f);
        let h = a * this.d;
        let i = Math.min(h + this.d - 1, g - 1);
        let j = NaN;
        let k = NaN;
        let l = true;
        let m = 0;
        let n = 0;
        let o;
        let p;
        for (let q = h; q <= i; ++q) {
            m = c[q];
            n = d[q];
            if (m < n) {
                o = m;
                p = n;
            }
            else {
                p = m;
                o = n;
            }
            if (!l) {
                if (!isNaN_(o)) {
                    j = j < o ? j : o;
                    k = k > o ? k : o;
                }
                if (!isNaN_(p)) {
                    j = j < p ? j : p;
                    k = k > p ? k : p;
                }
            }
            else {
                if (!isNaN_(o)) {
                    if (isNaN_(j)) {
                        j = o;
                    }
                    else {
                        j = Math.min(j, o);
                    }
                    if (!isNaN_(k)) {
                        k = Math.max(k, o);
                    }
                }
                if (!isNaN_(p)) {
                    if (isNaN_(k)) {
                        k = p;
                    }
                    else {
                        k = Math.max(k, p);
                    }
                    if (!isNaN_(j)) {
                        j = Math.min(j, p);
                    }
                }
                if (!isNaN_(j) && !isNaN_(k)) {
                    l = false;
                }
            }
        }
        if (n < m && b) {
            let r = j;
            j = k;
            k = r;
        }
        if (!l) {
            let s = new Array(3);
            s[0] = 0.5 * (h + i);
            s[1] = j;
            s[2] = k;
            return s;
        }
        let t = new Array(3);
        t[0] = NaN;
        t[1] = NaN;
        t[2] = NaN;
        return t;
    }
    cacheValues() {
        this.l = this.j.cu.lowColumn.count;
        this.k = this.j.cu.highColumn.count;
        this.i = this.j.cu.lowColumn.asArray();
        this.h = this.j.cu.highColumn.asArray();
    }
    unCacheValues() {
        this.i = null;
        this.h = null;
    }
}
RangeCategoryBucketCalculator.$t = markType(RangeCategoryBucketCalculator, 'RangeCategoryBucketCalculator', CategoryBucketCalculator.$);
export class RangeCategorySeries extends CategorySeries {
    constructor() {
        super();
        this._RangeFramePreparer = null;
        this.og = null;
        this.oe = null;
        this.ob = null;
        this.RangeFramePreparer = new RangeCategoryFramePreparer(1, this, this.od, this, this, this.od.cl);
    }
    be() {
        return new RangeCategorySeriesView(this);
    }
    h9(a) {
        super.h9(a);
        this.od = a;
    }
    get RangeFramePreparer() {
        return this._RangeFramePreparer;
    }
    set RangeFramePreparer(a) {
        this._RangeFramePreparer = a;
    }
    get lowColumn() {
        return this.og;
    }
    set lowColumn(a) {
        if (this.og != a) {
            let b = this.og;
            this.og = a;
            this.raisePropertyChanged("LowColumn", b, this.og);
        }
    }
    get highColumn() {
        return this.oe;
    }
    set highColumn(a) {
        if (this.oe != a) {
            let b = this.oe;
            this.oe = a;
            this.raisePropertyChanged("HighColumn", b, this.oe);
        }
    }
    mv() {
        return 11;
    }
    n2(a, b) {
        super.n2(a, b);
        b.by = true;
        CategoryMarkerManager.b(this, a.m, b.co, this.lk);
        this.nw(b, a);
    }
    oo(a, b, c, d, e, f) {
        this.od.cv(a, b, c, d, e, f);
    }
    c5(a) {
        let b = new Rect(0, 0, 0, 1, 1);
        let c = this.bh != null ? this.bh.bq : Rect.empty;
        c = c.copy();
        let d = this.bh != null ? this.bh.bp : Rect.empty;
        let e = !c.isEmpty && !d.isEmpty && this.by != null ? this.by.indexOf(a) : -1;
        let f = this.fetchXAxis();
        let g = this.fetchYAxis();
        let h = this.k7(this.bh);
        let i;
        if (f != null) {
            let j = new ScalerParams(0, b, b, f.bz, h);
            i = f.dj(e, j);
        }
        else {
            i = NaN;
        }
        let k = f != null ? this.RangeFramePreparer.r(typeCast(ICategoryScaler_$type, f), b, b, h) : 0;
        i += k;
        if (e >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (!isNaN_(i)) {
                if (i < c.left + 0.1 * c.width) {
                    i = i + 0.4 * c.width;
                }
                if (i > c.right - 0.1 * c.width) {
                    i = i - 0.4 * c.width;
                }
                c.x = i - 0.5 * c.width;
            }
            if (g != null && this.highColumn != null && e < this.highColumn.count) {
                let l = new ScalerParams(0, b, b, g.bz, h);
                let m = g.dj(this.highColumn.item(e), l);
                let n = g.dj(this.lowColumn.item(e), l);
                if (!isNaN_(m) && !isNaN_(n)) {
                    let o = Math.abs(n - m);
                    if (c.height < o) {
                        c.height = o;
                        c.y = Math.min(n, m);
                    }
                    else {
                        if (n < c.top + 0.1 * c.height) {
                            n = n + 0.4 * c.height;
                        }
                        if (n > c.bottom - 0.1 * c.height) {
                            n = n - 0.4 * c.height;
                        }
                        c.y = n - 0.5 * c.height;
                    }
                }
            }
            if (this.bm != null) {
                this.bm.ap(this.br, c, true);
            }
        }
        return e >= 0;
    }
    ie(a, b, c, d) {
        super.ie(a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.lowColumn);
                    c.deregisterColumn(this.highColumn);
                    this.lowColumn = null;
                    this.highColumn = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.lowColumn = this.bv(this.om);
                    this.highColumn = this.bv(this.oj);
                }
                if (!this.ng()) {
                    this.mu.cl.g(this.ej);
                    this.it(false);
                }
                break;
            case RangeCategorySeries.$$p[1]:
                if (this.by != null) {
                    this.by.deregisterColumn(this.lowColumn);
                    this.lowColumn = this.bv(this.om);
                }
                break;
            case "LowColumn":
                if (!this.ng()) {
                    this.mu.cl.g(this.ej);
                    this.it(false);
                }
                break;
            case RangeCategorySeries.$$p[0]:
                if (this.by != null) {
                    this.by.deregisterColumn(this.highColumn);
                    this.highColumn = this.bv(this.oj);
                }
                break;
            case "HighColumn":
                if (!this.ng()) {
                    this.mu.cl.g(this.ej);
                    this.it(false);
                }
                break;
        }
    }
    am(a) {
        if (this.lowColumn == null || this.lowColumn.count == 0 || this.highColumn == null || this.highColumn.count == 0) {
            return null;
        }
        if (a == this.fetchXAxis()) {
            let b = Math.min(this.lowColumn.count, this.highColumn.count);
            return new AxisRange(0, b - 1);
        }
        if (a == this.fetchYAxis()) {
            let c = Math.min(this.lowColumn.minimum, this.highColumn.minimum);
            let d = Math.max(this.lowColumn.maximum, this.highColumn.maximum);
            return new AxisRange(Math.min(c, d), Math.max(c, d));
        }
        return null;
    }
    hh(a, b, c, d) {
        if (this.fetchXAxis() != null && typeCast(ISortingAxis_$type, this.fetchXAxis()) !== null) {
            this.fetchXAxis().i$i();
        }
        let e = this.fetchXAxis();
        switch (a) {
            case 3:
                if (d == this.om || d == this.oj) {
                    if (e != null) {
                        e.cb();
                    }
                    if (!this.ng()) {
                        this.it(true);
                    }
                }
                break;
            case 1:
                if (e != null) {
                    e.cb();
                }
                this.mu.cl.g(this.ej);
                if (!this.ng()) {
                    this.it(true);
                }
                break;
            case 0:
                if (e != null) {
                    e.cb();
                }
                this.mu.cl.g(this.ej);
                if (!this.ng()) {
                    this.it(true);
                }
                break;
            case 2:
                if (e != null) {
                    e.cb();
                }
                if (this.om != null && this.oj != null && this.mu.cl.d > 0 && !this.ng()) {
                    this.it(true);
                }
                break;
            case 4:
                if (e != null) {
                    e.cb();
                }
                this.mu.cl.g(this.ej);
                if (!this.ng()) {
                    this.it(true);
                }
                break;
        }
    }
    ds(a, b, c) {
        let d = super.ds(a, b, c);
        if (this.lowColumn == null || this.lowColumn.count == 0 || this.highColumn == null || this.highColumn.count == 0) {
            d = false;
        }
        return d;
    }
    nz(a, b) {
        super.nz(a, b);
        this.RangeFramePreparer.d(a, b);
    }
    get currentCategoryMode() {
        return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.fetchXAxis()));
    }
    get scaler() {
        return typeCast(ICategoryScaler_$type, this.fetchXAxis());
    }
    get yScaler() {
        return typeCast(IScaler_$type, this.fetchYAxis());
    }
    get bucketizer() {
        return this.mu.cl;
    }
    get currentMode2Index() {
        return this.no();
    }
    provideCollisionDetector() {
        return new CollisionAvoider();
    }
    get mayContainUnknowns() {
        return this.lowColumn == null || this.lowColumn.mayContainUnknowns || this.highColumn == null || this.highColumn.mayContainUnknowns;
    }
    iv(a, b) {
        let c = this.dh;
        super.iv(a, b);
        if (!c) {
            this.bh.az(b);
            return;
        }
        this.bh.az(b);
        if (this.cb(this.bg)) {
            return;
        }
        let d = new RangeCategoryFramePreparer(1, this, typeCast(ISupportsMarkers_$type, this.bg), this.br.bk.m, this, this.bg.cl);
        if (!this.db) {
            this.mo = new CategoryFrame(3);
            this.mo.u();
            d.d(this.mo, this.bg);
        }
        this.db = false;
        this.n2(this.mo, this.bg);
        this.dh = false;
    }
    is(a, b, c, d, e) {
        super.is(a, b, c, d, e);
        let f = this.az.a$h.item(d);
        let g = f;
        g.cl.g(this.ej);
        f.ay(c);
        if (this.cb(g)) {
            return;
        }
        let h = new RangeCategoryFramePreparer(1, this, typeCast(ISupportsMarkers_$type, f), f, this, f.cl);
        if (this.ob == null) {
            this.ob = new CategoryFrame(3);
        }
        this.ob.u();
        h.d(this.ob, g);
        this.n2(this.ob, g);
    }
    d8() {
        return this.lowColumn == null || this.lowColumn.count == 0 ? NaN : this.lowColumn.item(0);
    }
    get useHighMarkerFidelity() {
        return this.nh;
    }
}
RangeCategorySeries.$t = markType(RangeCategorySeries, 'RangeCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasHighLowValueCategory_$type]);
Type.dep(DependencyProperty, PropertyMetadata, RangeCategorySeries, 'raisePropertyChanged', ['HighMemberPath:oj:op', [2, null], 'LowMemberPath:om:oq', [2, null]]);
export class RangeCategorySeriesView extends CategorySeriesView {
    constructor(a) {
        super(a);
        this.cu = null;
        this.cu = a;
    }
    cv(a, b, c, d, e, f) {
        a.aj.clear();
        b.aj.clear();
        c.aj.clear();
        let g = FastFlattener.b(d, e, true, f, this.e.ej);
        let h = FastFlattener.b(d, e, false, f, this.e.ej);
        let i = g.count;
        let j = h.count;
        let k;
        let l;
        let m;
        let n;
        for (let o = 0; o < i; o++) {
            k = g.item(o);
            l = e._inner[k];
            m = l[0];
            n = l[1];
            a.aj.add({ $type: Point_$type, x: m, y: n });
            b.aj.add({ $type: Point_$type, x: m, y: n });
        }
        let p;
        let q;
        for (let r = 0; r < j; r++) {
            k = h.item(r);
            l = e._inner[k];
            if (f) {
                p = l[0];
                q = l[2];
            }
            else {
                p = l[2];
                q = l[3];
            }
            c.aj.add({ $type: Point_$type, x: p, y: q });
            b.aj.add({ $type: Point_$type, x: p, y: q });
        }
        a.ab = a.aj.count > 0;
        b.ab = b.aj.count > 0;
        c.ab = c.aj.count > 0;
    }
    cm() {
        return new RangeCategoryBucketCalculator(this);
    }
    getDefaultTooltipTemplate() {
        let a = "<div class='ui-chart-default-tooltip-content'>";
        let b = null;
        if (this.cu.fetchXAxis().bt) {
            b = this.cu.fetchXAxis();
        }
        else if (this.cu.fetchYAxis().bt) {
            b = this.cu.fetchYAxis();
        }
        if (b.bw) {
            let c = b;
            a += "<span>${item." + c.dateTimeMemberPath + "}</span><br/>";
        }
        else if (b != null && b.er != null) {
            a += "<span>${item." + b.er + "}</span><br/>";
        }
        a += "<span";
        let d = this.e.az.a$q(this.e);
        if (!stringIsNullOrEmpty(d)) {
            a += " style='color:" + d + "'";
        }
        a += ">" + this.cu.fj + ": </span><span class='ui-priority-primary'>" + "${item." + this.cu.om + "} - ${item." + this.cu.oj + "}</span></div>";
        return a;
    }
}
RangeCategorySeriesView.$t = markType(RangeCategorySeriesView, 'RangeCategorySeriesView', CategorySeriesView.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.RangeCategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.RangeCategorySeries" />*/
//# sourceMappingURL=RangeCategoryBucketCalculator_combined.js.map