/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialIndicator } from "./FinancialIndicator";
import { String_$type, Number_$type, typeCast, fromEnum, markType } from "./type";
import { DependencyProperty } from "./DependencyProperty";
import { PropertyMetadata } from "./PropertyMetadata";
import { List$1 } from "./List$1";
import { AxisRange } from "./AxisRange";
import { isNaN_ } from "./number";
export class StrategyBasedIndicator extends FinancialIndicator {
    constructor() {
        super();
        this.p3();
    }
    p3() {
        this.po = this.pp;
        this.ab = this.p2;
    }
    pv() {
        return -2147483648;
    }
    p4(a) {
    }
    px() {
        return -2147483648;
    }
    pu() {
        return -2147483648;
    }
    static p8(a, b, c) {
        let d = DependencyProperty.i(c, Number_$type, b, new PropertyMetadata(2, a, (e, f) => (typeCast(StrategyBasedIndicator.$, e)).raisePropertyChanged(c, f.oldValue, f.newValue)));
        StrategyBasedIndicator.ps.add(c);
        return d;
    }
    static p7(a, b) {
        return StrategyBasedIndicator.p8(a, b, "Period");
    }
    static p5(a, b) {
        return StrategyBasedIndicator.p8(a, b, "LongPeriod");
    }
    static p9(a, b) {
        return StrategyBasedIndicator.p8(a, b, "ShortPeriod");
    }
    o1(a, b) {
        let c = this.lz(a, b);
        let d = this.l0(c);
        return this.po.b(c, d);
    }
    oy(a, b) {
        let c = this.lz(a, b);
        if (b == 0) {
            return false;
        }
        if (!this.mu(this.o1(a, b))) {
            return false;
        }
        let d = this.l0(c);
        if (this.ov != null) {
            c.minimumValue = this.ov.c;
            c.maximumValue = this.ov.b;
        }
        let e = this.po.a(c, d);
        for (let f = 0; f < this.o3 && f < c.indicatorColumn.count; f++) {
            c.indicatorColumn.item(f, NaN);
        }
        if (this.l7 != null && this.pr(c)) {
            this.l7.cb();
        }
        return e;
    }
    pr(a) {
        if (!isNaN_(a.minimumValue) && !isNaN_(a.maximumValue) && a.specifiesRange) {
            let b = this.ov;
            this.ov = new AxisRange(a.minimumValue, a.maximumValue);
            return this.pq(b, this.ov);
        }
        let c = 1.7976931348623157E+308;
        let d = -1.7976931348623157E+308;
        for (let e of fromEnum(a.indicatorColumn)) {
            if (!isNaN_(e)) {
                c = Math.min(c, e);
                d = Math.max(d, e);
            }
        }
        let f = this.ov;
        this.ov = new AxisRange(c, d);
        return this.pq(f, this.ov);
    }
    pq(a, b) {
        if (a == null || b == null) {
            return true;
        }
        if (a.c != b.c) {
            return true;
        }
        if (a.b != b.b) {
            return true;
        }
        return false;
    }
    pw(a) {
        if (a == -2147483648) {
            return 0;
        }
        if (a > this.indicatorColumn.count && this.indicatorColumn.count > 0) {
            a = this.indicatorColumn.count - 1;
        }
        if (a < 1) {
            return 1;
        }
        return a;
    }
    lz(a, b) {
        let c = super.lz(a, b);
        c.indicatorColumn = this.indicatorColumn;
        c.period = this.pw(this.pv());
        c.shortPeriod = this.pw(this.px());
        c.longPeriod = this.pw(this.pu());
        c.multiplier = this.pt();
        return c;
    }
    pt() {
        return 1;
    }
    static p6(a, b) {
        let c = DependencyProperty.i("Multiplier", Number_$type, b, new PropertyMetadata(2, a, (d, e) => (typeCast(StrategyBasedIndicator.$, d)).raisePropertyChanged("Multiplier", e.oldValue, e.newValue)));
        StrategyBasedIndicator.ps.add("Multiplier");
        return c;
    }
    ie(a, b, c, d) {
        super.ie(a, b, c, d);
        if (StrategyBasedIndicator.ps.contains(b)) {
            if (this.l7 != null && !this.l7.cb()) {
                this.l3.bs.e(this.ej);
                this.oy(0, this.indicatorColumn.count);
                if (this.ow.b2) {
                    this.ow.b0.g$i();
                }
                this.it(false);
            }
        }
    }
}
StrategyBasedIndicator.ps = new List$1(String_$type, 0);
StrategyBasedIndicator.$t = markType(StrategyBasedIndicator, 'StrategyBasedIndicator', FinancialIndicator.$);
/*<BeginStatics Name="Infragistics.Controls.Charts.StrategyBasedIndicator" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.StrategyBasedIndicator" />*/
//# sourceMappingURL=StrategyBasedIndicator.js.map