/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FastItemDateTimeColumn } from "./FastItemDateTimeColumn";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { DependencyProperty } from "./DependencyProperty";
import { List$1 } from "./List$1";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "./Rect";
import { NumericScaler } from "./NumericScaler";
import { SeriesViewer } from "./SeriesViewer";
import { Type, typeCast, Number_$type, Date_$type, fromEnum, runOn, delegateRemove, delegateCombine, markType, TypeRegistrar } from "./type";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { SortedListView$1 } from "./SortedListView$1";
import { ArrayExtension } from "./ArrayExtension";
import { IFastItemsSource_$type } from "./IFastItemsSource";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { MathUtil } from "./MathUtil";
import { PropertyMetadata } from "./PropertyMetadata";
import { truncate, isNaN_ } from "./number";
import { dateMinValue, dateSubtract, dateAdd, dateMaxValue } from "./date";
export class TimeAxisBase extends CategoryAxisBase {
    constructor() {
        super();
        this.j9 = null;
        this.ki = null;
        this.kd = false;
        this.kl = dateMaxValue();
        this.kk = dateMinValue();
        this.actualRangeChanged = null;
        FastItemDateTimeColumn.m();
    }
    dj(a, b) {
        if (!b.c.isEmpty) {
            let c = this.kq(a, NumericScaler.ac, b.c, Rect.empty);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.kq(a, b.e, b.d, b.c);
    }
    kq(a, b, c, d) {
        let e;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            e = -1;
        }
        else {
            e = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        let f = 0;
        if (this.categoryMode == 2) {
            f = this.getGroupCenter(0, b, c, d);
        }
        if (this.bz) {
            e = 1 - e;
            f = -f;
        }
        return c.left + c.width * (e - b.left) / b.width - f;
    }
    kr(a, b, c) {
        let d;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            d = -1;
        }
        else {
            d = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        let e = 0;
        if (this.bz) {
            d = 1 - d;
            e = -e;
        }
        return c.left + c.width * (d - b.left) / b.width - e;
    }
    dm(a, b) {
        if (!b.c.isEmpty) {
            let c = b.d.left;
            let d = b.d.width;
            if (this.categoryMode != 0) {
                let e = this.getCategorySize(b.e, b.d, b.c);
                c += e / 2;
                d -= e;
            }
            let f = b.e.left + b.e.width * (a - c) / this.width;
            f = (f * b.d.width) + b.d.left;
            f = this.getUnscaledValue3(f, NumericScaler.ac, b.c, this.categoryMode);
            return f;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    }
    getUnscaledValue3(a, b, c, d) {
        let e = b.left + b.width * (a - c.left) / c.width;
        if (this.bz) {
            e = 1 - e;
        }
        return truncate(Math.floor(this.actualMinimumValue.getTime() + e * (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime())));
    }
    i$h() {
        this.k2();
    }
    k2() {
        let a = this.a9 != null ? this.a9.mk : Rect.empty;
        let b = !a.isEmpty ? this.ib : Rect.empty;
        let c = (new Date());
        let d = (new Date());
        let e = false;
        if (!a.isEmpty && !b.isEmpty && this.ka != null) {
            let f = typeCast(FastItemDateTimeColumn.$, this.ka);
            if (f != null) {
                if (this.kj == null) {
                    this.k3();
                }
            }
            else {
                this.kj = null;
            }
            if (this.ka.count > 0) {
                e = true;
                let g = this.kj == null ? 0 : this.kj._inner[0];
                let h = this.kj == null ? this.ka.count - 1 : this.kj._inner[this.ka.count - 1];
                c = this.ka.item(g);
                d = this.ka.item(h);
                this.ke = false;
                if (this.categoryMode == 2) {
                    let i = this.k0(c, d);
                    if (+c != +(dateMinValue())) {
                        c = dateSubtract(+c, +i);
                    }
                    d = dateAdd(+d, +i);
                }
            }
        }
        if (this.kh()) {
            e = true;
            c = this.minimumValue;
        }
        if (this.kg()) {
            e = true;
            d = this.maximumValue;
        }
        let j = +(this.actualMinimumValue) != +c || +(this.actualMaximumValue) != +d;
        if (e && j) {
            let k = this.actualMinimumValue;
            let l = this.actualMaximumValue;
            this.actualMinimumValue = c;
            this.actualMaximumValue = d;
            this.k7();
            if (this.actualRangeChanged != null) {
                this.actualRangeChanged(this, new AxisRangeChangedEventArgs(k.getTime(), this.actualMinimumValue.getTime(), l.getTime(), this.actualMaximumValue.getTime()));
            }
        }
    }
    k7() {
    }
    get ka() {
        return this.j9;
    }
    set ka(a) {
        if (this.j9 != a) {
            let b = this.j9;
            this.j9 = a;
            this.gd("DateTimeColumn", b, this.j9);
        }
    }
    get kj() {
        return this.ki;
    }
    set kj(a) {
        this.ki = a;
    }
    get i$b() {
        if (this.kj == null) {
            let a = typeCast(FastItemDateTimeColumn.$, this.ka);
            if (a != null) {
                this.k3();
            }
            else {
                this.kj = null;
            }
        }
        return this.kj;
    }
    k3() {
        if (this.kf) {
            this.kj = new List$1(Number_$type, 0);
            let a = this.kj;
            let b = this.ka.count;
            for (let c = 0; c < b; c++) {
                a.add(c);
            }
        }
        else {
            let d = typeCast(FastItemDateTimeColumn.$, this.ka);
            this.kj = d.f();
        }
    }
    i$e(a, b, c, d) {
        let e = d;
        let f = new ScalerParams(0, a, b, this.bz, c);
        let g, h;
        if (this.bz) {
            h = this.dm(e.left, f);
            g = this.dm(e.right, f);
        }
        else {
            g = this.dm(e.left, f);
            h = this.dm(e.right, f);
        }
        let i = 0;
        for (let j = 0; j < this.kj.count; j++) {
            if (this.ka == null) {
                break;
            }
            let k = this.ka.item(this.kj._inner[j]);
            if (k.getTime() >= g) {
                break;
            }
            i = j;
        }
        return i;
    }
    i$g(a, b, c, d) {
        let e = d;
        let f = new ScalerParams(0, a, b, this.bz, c);
        let g, h;
        if (this.bz) {
            h = this.dm(e.left, f);
            g = this.dm(e.right, f);
        }
        else {
            g = this.dm(e.left, f);
            h = this.dm(e.right, f);
        }
        let i = this.kj.count - 1;
        let j = i;
        for (let k = i; k >= 0; k--) {
            if (this.ka == null || this.kj.count <= k) {
                break;
            }
            let l = this.kj._inner[k];
            if (l >= this.ka.count) {
                break;
            }
            let m = this.ka.item(l);
            if (m.getTime() < h) {
                break;
            }
            j = Math.min(k + 1, this.kj.count - 1);
        }
        return j;
    }
    i$d(a) {
        if (this.ka == null) {
            return NaN;
        }
        let b = this.j9.item(a);
        let c = b.getTime();
        let d = c;
        return d;
    }
    i$c(a) {
        let b = this;
        if (b.i$b == null) {
            return -1;
        }
        let c = new SortedListView$1(Date_$type, this.ka, b.i$b);
        let ticks_ = a;
        let d = (new Date(ticks_));
        let e = this.ks(d, c);
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            let diff1_ = d.getTime() - c.item(e - 1).getTime();
            let diff2_ = c.item(e).getTime() - d.getTime();
            let f = e - 1;
            let g = e;
            if (f < 0 && g >= 0) {
                return g;
            }
            if (g > b.i$b.count - 1 && f < b.i$b.count) {
                return f;
            }
            if (f < 0 && g < 0) {
                return -1;
            }
            if (f > b.i$b.count - 1 && g > b.i$b.count - 1) {
                return -1;
            }
            let h = diff1_ / (diff1_ + diff2_);
            if (isNaN_(h)) {
                h = 0;
            }
            return f + h;
        }
        if (e >= 0 && e < b.i$b.count) {
            return e;
        }
        let i = this.h6();
        if (e == b.i$b.count && this.a9 != null && this.dj(a, new ScalerParams(0, this.a9.mk, this.ib, this.bz, i)) < (this.ib.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.a9 != null && Math.abs(this.dj(a, new ScalerParams(0, this.a9.mk, this.ib, this.bz, i)) - this.ib.left) < 2) {
            return 0;
        }
        return -1;
    }
    ks(a, b) {
        let c = this;
        if (this.ka == null || c.i$b == null) {
            return -1;
        }
        let d = -1;
        let e = ArrayExtension.binarySearch$11(Date_$type, b, (f) => {
            if (a < f) {
                return -1;
            }
            if (a > f) {
                return 1;
            }
            return 0;
        });
        if (e >= 0) {
            d = e;
        }
        else {
            d = ~e;
        }
        while (d >= 0 && d < b.count && d - 1 >= 0 && +(b.item(d)) == +(b.item(d - 1))) {
            d--;
        }
        return d;
    }
    i$f(a) {
        let b = this;
        if (b.i$b == null || this.ka == null || b.i$b.count != this.ka.count) {
            return -1;
        }
        let c = new SortedListView$1(Date_$type, this.ka, b.i$b);
        let ticks_ = a;
        let d = (new Date(ticks_));
        let e = this.ks(d, c);
        let f = this.h6();
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            let g = +d - +(c.item(e - 1));
            let h = +(c.item(e)) - +d;
            if (g < h) {
                e = e - 1;
            }
        }
        if (e >= 0 && e < b.i$b.count) {
            return b.i$b._inner[e];
        }
        if (e == b.i$b.count && this.a9 != null && this.dj(a, new ScalerParams(0, this.a9.mk, this.ib, this.bz, f)) < (this.ib.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.a9 != null && Math.abs(this.dj(a, new ScalerParams(0, this.a9.mk, this.ib, this.bz, f)) - this.ib.left) < 2) {
            return 0;
        }
        return -1;
    }
    i$i() {
        this.kj = null;
        this.gi();
    }
    get_ke() {
        return this.kd;
    }
    set_ke(a) {
        this.kd = a;
    }
    get ke() {
        return this.get_ke();
    }
    set ke(a) {
        this.set_ke(a);
    }
    f9(a) {
        super.f9(a);
        this.dateTimeMemberPath = a;
    }
    gc(a) {
        super.gc(a);
        this.minimumValue = a;
    }
    gb(a) {
        super.gc(a);
        this.maximumValue = a;
    }
    cd() {
        if (this.b6 && this.ce) {
            this.a3 = this.a2();
        }
        let a = this.actualMinimumValue.getTime();
        let b = this.actualMaximumValue.getTime();
        this.k2();
        let c = !this.kh() ? this.actualMinimumValue.getTime() : this.minimumValue.getTime();
        let d = !this.kg() ? this.actualMaximumValue.getTime() : this.maximumValue.getTime();
        let e = new AxisRangeChangedEventArgs(a, c, b, d);
        this.ge(e);
        return true;
    }
    kh() {
        return (this.minimumValue != null);
    }
    kg() {
        return (this.maximumValue != null);
    }
    get actualMinimumValue() {
        return this.kl;
    }
    set actualMinimumValue(a) {
        let b = +(this.kl) != +a;
        if (b) {
            let c = this.kl;
            this.kl = a;
            this.gd("ActualMinimumValue", c, a);
        }
    }
    et() {
        return this.actualMinimumValue;
    }
    get actualMaximumValue() {
        return this.kk;
    }
    set actualMaximumValue(a) {
        let b = +(this.kk) != +a;
        if (b) {
            let c = this.kk;
            this.kk = a;
            this.gd("ActualMaximumValue", c, a);
        }
    }
    es() {
        return this.maximumValue;
    }
    k4(a) {
        this.gk(a);
        if (this.ir == null) {
            return;
        }
        for (let b of fromEnum(this.ci())) {
            b.it(a);
        }
    }
    f7(a, b, c, d) {
        super.f7(a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                let e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.ka);
                    this.ka = null;
                    e.event = delegateRemove(e.event, runOn(this, this.k1));
                }
                let f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.kj = null;
                    this.ka = this.kb(this.dateTimeMemberPath);
                    f.event = delegateCombine(f.event, runOn(this, this.k1));
                }
                this.k4(false);
                break;
            case TimeAxisBase.$$p[0]:
                if (this.ir != null) {
                    this.ir.deregisterColumn(this.ka);
                    this.ka = this.kb(this.dateTimeMemberPath);
                    this.kj = null;
                }
                break;
            case TimeAxisBase.$$p[3]:
                this.cb();
                this.k4(false);
                break;
            case TimeAxisBase.$$p[2]:
                this.cb();
                this.k4(false);
                break;
            case "DateTimeColumn":
                this.k2();
                break;
        }
    }
    k1(a, b) {
        this.kj = null;
    }
    kb(a) {
        return TimeAxisBase.kc(a, this);
    }
    static kc(a, b) {
        if (a == null) {
            return b.ir.registerColumnDateTime(null, null, false);
        }
        let c = null;
        let d = SeriesViewer.bb(a, b.coercionMethods);
        c = d.a;
        return b.ir.registerColumnDateTime(a, c, b.expectFunctions);
    }
    ao() {
        if (this.cf) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    }
    get_av() {
        return 0;
    }
    get av() {
        return this.get_av();
    }
    gk(a) {
        super.gk(a);
        let b = this.ay.at();
        let c = this.ay.aw();
        let d = this.ay.au();
        let e = this.ay.av();
        let f = this.ay.e();
        let g = this.ay.f();
        let h = this.ay.g();
        this.gr();
        this.fv(b);
        this.fv(c);
        this.fv(d);
        this.fv(e);
        this.cj.clear();
        this.ck.clear();
        this.iy.clear();
        this.ap.ac = this;
        let i = this.a9 != null ? this.a9.mk : Rect.empty;
        let j = !i.isEmpty ? this.ib : Rect.empty;
        this.ap.cn = i;
        this.ap.cm = j;
        if (i.isEmpty || j.isEmpty) {
            this.bg.count = 0;
        }
        if (this.bg.count == 0) {
            this.ap.ab.clear();
        }
        if (this.as != null) {
            this.as.registerAxis(this);
        }
        this.k2();
    }
    get_bw() {
        return true;
    }
    get bw() {
        return this.get_bw();
    }
    startCursor() {
    }
    resetCursor() {
    }
    StartTimeCursor() {
        this.startCursor();
    }
    ResetTimeCursor() {
        this.resetCursor();
    }
    getCategorySize(a, b, c) {
        if (this.ja == 0) {
            return 0;
        }
        let d = this.h9(b, c);
        return d.width / (this.ja * a.width);
    }
    getGroupCenter(a, b, c, d) {
        return this.getCategorySize(b, c, d) * 0.5;
    }
    i3(a, b, c) {
        let d = !isNaN_(this.i0) ? MathUtil.b(this.i0, 0, 1) : 0;
        let e = 1 - 0.5 * d;
        let f = this.getCategorySize(a, b, c) * e;
        return f;
    }
    get_b3() {
        return true;
    }
    get b3() {
        return this.get_b3();
    }
    k0(a, b) {
        return (0);
    }
    preferredCategoryMode(a) {
        return this.bu ? 0 : 1;
    }
    get isVertical() {
        return this.b5;
    }
    j$c(a, b) {
        return this.dm.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dj.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.fz.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.f0.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.f1.apply(this, arguments);
    }
    get j$a() {
        return this.bz;
    }
    get i$a() {
        return this.bw;
    }
}
TimeAxisBase.$t = markType(TimeAxisBase, 'TimeAxisBase', CategoryAxisBase.$, [ISortingAxis_$type, IDateTimeAxis_$type]);
Type.dep(DependencyProperty, PropertyMetadata, TimeAxisBase, 'gd', ['DateTimeMemberPath::k8', [2, null], 'IsDataPreSorted:kf:k9', [0, false], 'MaximumValue::la', [3, null], 'MinimumValue::lb', [3, null]]);
/*<BeginStatics Name="Infragistics.Controls.Charts.TimeAxisBase" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.TimeAxisBase" />*/
//# sourceMappingURL=TimeAxisBase.js.map