/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { TimeAxisBase } from "./TimeAxisBase";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { TimeAxisBreakCollection } from "./TimeAxisBreakCollection";
import { TimeAxisLabelFormatCollection } from "./TimeAxisLabelFormatCollection";
import { OrderedDictionary$2 } from "./OrderedDictionary$2";
import { TimeAxisBreak } from "./TimeAxisBreak";
import { List$1 } from "./List$1";
import { TimeAxisIntervalCollection } from "./TimeAxisIntervalCollection";
import { runOn, delegateCombine, Number_$type, fromEnum, fromEn, typeCast, Date_$type, markType } from "./type";
import { ScalerParams } from "./ScalerParams";
import { KeyValuePair$2 } from "./KeyValuePair$2";
import { Rect } from "./Rect";
import { TimeAxisInterval } from "./TimeAxisInterval";
import { NumericYAxis } from "./NumericYAxis";
import { LabelPosition } from "./LabelPosition";
import { Extensions } from "./Extensions";
import { SortedListView$1 } from "./SortedListView$1";
import { Dictionary$2 } from "./Dictionary$2";
import { truncate, isNaN_ } from "./number";
import { dateFromTicks, dateMaxValue, dateAdd, dateSubtract, dateAddMonths, dateFromValues, dateGetMonth, dateGetTimeOfDay, dateAddDays, dateAddHours, dateMinValue } from "./date";
import { timeSpanTicks, timeSpanInit3, timeSpanInit1, timeSpanFromDays, timeSpanFromHours, timeSpanFromMinutes, timeSpanTotalMilliseconds, timeSpanFromTicks } from "./timespan";
import { dateToStringFormat } from "./dateExtended";
export class TimeXAxis extends TimeAxisBase {
    constructor() {
        super();
        this.lt = 0;
        this.ld = null;
        this.lj = null;
        this._omission = 0;
        this.lc = null;
        this.lh = null;
        this.l3 = 0;
        this.lp = dateMaxValue();
        this.lo = dateMinValue();
        this.l1 = 0;
        this.ab = TimeXAxis.$;
        this.omission = (0);
        this.lt = -2147483648;
        this.ld = new TimeAxisBreakCollection();
        let a = this.le;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.l6));
        this.lh = new TimeAxisIntervalCollection();
        let b = this.li;
        b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.l7));
        this.lj = new TimeAxisLabelFormatCollection();
        let c = this.lk;
        c.collectionChanged = delegateCombine(c.collectionChanged, runOn(this, this.l8));
        this.l3 = (0);
    }
    dj(a, b) {
        let c = new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
        let d = this.lt != -2147483648 ? this.lt : 0;
        let e = this.lc != null ? this.lc.count : 0;
        while (d < e) {
            let f = this.lc.item1(d);
            if (f.d.getTime() <= a && f.c.getTime() >= a) {
                return NaN;
            }
            if (f.c.getTime() <= a) {
                c = new KeyValuePair$2(TimeAxisBreak.$, Number_$type, 1, f, this.lc.item(f));
                d++;
            }
            else {
                break;
            }
        }
        if (d > 0) {
            d -= 1;
        }
        if (this.lt != -2147483648) {
            this.lt = d;
        }
        let g;
        let h;
        if (c.key != null) {
            g = c.value;
            h = c.key.c;
        }
        else {
            g = 0;
            h = this.actualMinimumValue;
        }
        let fromPrecedingBreak_ = +(dateFromTicks(truncate(a))) - +h;
        let i = (fromPrecedingBreak_ / ((this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime()) - this.omission));
        let j = g + i;
        j -= b.e.left;
        j /= b.e.width;
        let k = b.d.left;
        let l = b.d.right;
        let m = b.d.width;
        if (this.categoryMode != 0) {
            let n = this.getCategorySize(b.e, b.d, b.c);
            k += n / 2;
            l -= n / 2;
            m -= n;
        }
        if (this.bz) {
            return l - m * j;
        }
        return k + m * j;
    }
    f0(a, b, c, d) {
        this.lt = 0;
        for (let e = b; e < c; e++) {
            a.item(e, this.dj(a.item(e), d));
        }
        this.lt = -2147483648;
    }
    startCursor() {
        this.lt = 0;
    }
    resetCursor() {
        this.lt = -2147483648;
    }
    dm(a, b) {
        let c = b.d.left;
        let d = b.d.width;
        if (this.categoryMode != 0) {
            let e = this.getCategorySize(b.e, b.d, b.c);
            c += e / 2;
            d -= e;
        }
        let f = b.e.left + b.e.width * (a - c) / d;
        if (this.bz) {
            f = 1 - f;
        }
        let g = new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
        if (this.lc != null) {
            for (let h of fromEnum(this.lc)) {
                if (h.value >= f && h.value <= f) {
                    return h.key.d.getTime();
                }
                if (h.value < f && h.value > g.value) {
                    g = h;
                }
            }
        }
        let precedingBreakEnd_;
        let i;
        if (g.key != null) {
            i = g.value;
            precedingBreakEnd_ = g.key.c;
        }
        else {
            i = 0;
            precedingBreakEnd_ = this.actualMinimumValue;
        }
        let portionFromPrecedingBreak_ = f - i;
        let actualRange_ = +(this.actualMaximumValue) - +(this.actualMinimumValue) - this.omission;
        return (precedingBreakEnd_.getTime() + portionFromPrecedingBreak_ * actualRange_);
    }
    get le() {
        return this.ld;
    }
    get lk() {
        return this.lj;
    }
    f7(a, b, c, d) {
        super.f7(a, b, c, d);
        switch (b) {
            case "ActualMaximumValue":
                this.l5();
                break;
            case "DateTimeColumn":
                this.l1 = this.l0();
                break;
        }
    }
    gv(a, b) {
        super.gv(a, b);
        this.l4();
        this.k7();
    }
    gu(a, b) {
        super.gu(a, b);
        this.l4();
        this.k7();
    }
    cd() {
        let a = super.cd();
        this.l4();
        return a;
    }
    get omission() {
        return this._omission;
    }
    set omission(a) {
        this._omission = a;
    }
    l5() {
        let a = this.lm(this.le);
        let b = (0);
        for (let c of fromEnum(a)) {
            b += (+(c.c) - +(c.d));
        }
        this.omission = b;
    }
    lm(a) {
        let b = new List$1(TimeAxisBreak.$, 0);
        if (a == null || +(this.actualMaximumValue) == +(dateMaxValue())) {
            return b;
        }
        for (let c of fromEn(a)) {
            if (c.c >= this.actualMinimumValue && c.d <= this.actualMaximumValue) {
                b.add(c);
            }
            if (c.i != (0)) {
                let d = +(c.c) - +(c.d);
                let e = dateAdd(+(c.d), +(c.i));
                while (e <= this.actualMaximumValue) {
                    let f = this.lq(e, d);
                    let g = ((() => {
                        let $ret = new TimeAxisBreak();
                        $ret.d = e;
                        $ret.c = f;
                        return $ret;
                    })());
                    if (g.c >= this.actualMinimumValue && g.d <= this.actualMaximumValue) {
                        b.add(g);
                    }
                    if (dateSubtract(+(dateMaxValue()), +(c.i)) < g.d) {
                        break;
                    }
                    e = this.lq(g.d, c.i);
                }
            }
        }
        return b;
    }
    lq(a, b) {
        let c = dateFromTicks(a.getTime());
        c.setMilliseconds(c.getMilliseconds() + b);
        return c;
    }
    l4() {
        this.lc = new OrderedDictionary$2(TimeAxisBreak.$, Number_$type);
        if (+(this.actualMaximumValue) == +(dateMaxValue()) || this.le == null || this.le.count == 0 || this.a9 == null) {
            return;
        }
        let a = new List$1(TimeAxisBreak.$, 1, this.lm(this.le));
        a.aa((b, c) => b.d < c.d ? -1 : b.d > c.d ? 1 : 0);
        let b = this.a9.mk;
        let c = new ScalerParams(0, this.a9.mk, this.a9.mx, this.bz, this.a9.mo);
        let d = +(this.actualMaximumValue) - +(this.actualMinimumValue) - this.omission;
        let e = 0;
        for (let f of fromEnum(a)) {
            let g = timeSpanTicks((+(f.d) - +(this.actualMinimumValue))) / timeSpanTicks(d);
            let h = timeSpanTicks((+(f.c) - +(this.actualMinimumValue))) / timeSpanTicks(d);
            if (h < 0 || g - e > 1) {
                continue;
            }
            this.lc.addItem(f, g - e);
            e += (h - g);
        }
    }
    eq(a) {
        if (!(typeCast(Date_$type, a) !== null)) {
            return super.eq(a);
        }
        let b = TimeXAxis.lu(a, this.l3, this.lk);
        return b == null ? super.eq(a) : b;
    }
    static lu(a, b, c) {
        let d = null;
        if (b == (0)) {
            return null;
        }
        let e;
        if (c == null || c.count == 0) {
            e = TimeXAxis.lx(b);
        }
        else {
            for (let f of fromEnum(c)) {
                if (f.b > b) {
                    continue;
                }
                if (d == null || f.b > d.b) {
                    d = f;
                }
            }
            if (d == null) {
                return null;
            }
            e = d.a;
        }
        return dateToStringFormat(a, e);
    }
    get_ke() {
        return super.get_ke() || (this.li != null && this.li.count > 0);
    }
    set_ke(a) {
        super.set_ke(a);
    }
    get ke() {
        return this.get_ke();
    }
    set ke(a) {
        this.set_ke(a);
    }
    get li() {
        return this.lh;
    }
    lw() {
        return TimeXAxis.lx(this.l3);
    }
    static lx(a) {
        a = Math.abs(a);
        if (a > timeSpanInit3(1825, 0, 0, 0)) {
            return "yyyy";
        }
        if (a > timeSpanInit3(365, 0, 0, 0)) {
            return "MMM yyyy";
        }
        if (a > timeSpanInit3(4, 0, 0, 0)) {
            return "MMM dd";
        }
        if (a > timeSpanInit3(1, 0, 0, 0)) {
            return "MMM dd hh:mmtt";
        }
        if (a > timeSpanInit1(0, 10, 0)) {
            return "hh:mm";
        }
        return "hh:mm:ss";
    }
    lf() {
        let a = this.l3;
        if (a == (0)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.a = 8;
                $ret.d = 1;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(365 * 100)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.a = 8;
                $ret.d = 10;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(365 * 5)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.a = 8;
                $ret.d = 1;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(365 * 2)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.a = 7;
                $ret.d = 3;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(150)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.a = 7;
                $ret.d = 1;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(60)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.a = 5;
                $ret.d = 10;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(30)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.a = 5;
                $ret.d = 5;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(20)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.a = 5;
                $ret.d = 2;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(4)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.a = 5;
                $ret.d = 1;
                return $ret;
            })());
        }
        if (a >= timeSpanFromDays(1)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.a = 4;
                $ret.d = 12;
                return $ret;
            })());
        }
        if (a >= timeSpanFromHours(6)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.a = 4;
                $ret.d = 1;
                return $ret;
            })());
        }
        if (a >= timeSpanFromMinutes(30)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.a = 3;
                $ret.d = 5;
                return $ret;
            })());
        }
        if (a >= timeSpanFromMinutes(10)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.a = 3;
                $ret.d = 2;
                return $ret;
            })());
        }
        return ((() => {
            let $ret = new TimeAxisInterval();
            $ret.a = 2;
            $ret.d = 30;
            return $ret;
        })());
    }
    lg() {
        if (this.li == null || this.li.count == 0) {
            return this.lf();
        }
        if (this.l3 == (0)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.a = 8;
                $ret.d = 1;
                return $ret;
            })());
        }
        let a = null;
        for (let b of fromEnum(this.li)) {
            if (b.e > this.l3) {
                continue;
            }
            if (a == null || b.e > a.e) {
                a = b;
            }
        }
        return a == null ? this.lf() : a;
    }
    gk(a) {
        super.gk(a);
        let b = this.a9 != null ? this.a9.mk : Rect.empty;
        let c = !b.isEmpty ? this.ib : Rect.empty;
        let d = this.h6();
        let e = this.h5();
        let f = new ScalerParams(0, b, c, this.bz, d);
        if (this.ka == null && !this.kg() && !this.kh()) {
            return;
        }
        if (!b.isEmpty && !c.isEmpty) {
            let g = c.bottom;
            let h = g - c.top;
            if (this.ag != null) {
                let i = typeCast(NumericYAxis.$, this.ag);
                if (i != null) {
                    let j = this.gn(g, h, b, c, d, c.top, c.bottom);
                    g = j.p0;
                    h = j.p1;
                }
            }
            if (isNaN_(g)) {
                g = 0;
            }
            this.f3(this.ay.at(), g, c, this.ay.e(), true);
            this.ap.a6 = h;
            let k = truncate(Math.ceil(e.right));
            let l = truncate(Math.floor(e.left));
            let m = this.ay.aw();
            let n = this.ay.f();
            let o = this.ay.au();
            this.k7();
            let p = new List$1(Date_$type, 1, this.ll());
            let q = new List$1(Number_$type, 0);
            for (let r = 0; r < p.count; r++) {
                q.add(p._inner[r].getTime());
            }
            this.f0(q, 0, q.count, f);
            for (let s = 0; s < p.count; s++) {
                let t = p._inner[s];
                let u = q._inner[s];
                let v = truncate(Math.round(u));
                if (v <= k) {
                    if (s % 2 == 0) {
                        let w = s < q.count - 1 ? q._inner[s + 1] : e.right;
                        this.gt(m, u, w, c);
                    }
                    this.gs(o, u, c, n, false);
                    this.iy.add(u);
                }
                if (v >= l && v <= k) {
                    let x = this.eq(t);
                    if (x != null) {
                        this.cj.add1(x);
                        this.ck.add(new LabelPosition(u));
                    }
                }
            }
        }
        if ((this.as == null || this.as.visibility == 0) && this.ag != null) {
            if (this.as != null && (this.as.location == 4 || this.as.location == 5)) {
                this.a9.hp();
            }
        }
        this.ap.a1 = this.cj;
        this.ap.a2 = this.ck;
        this.jy();
    }
    ll() {
        let a = this.a9 != null ? this.a9.mk : Rect.empty;
        let b = !a.isEmpty ? this.ib : Rect.empty;
        let c = this.h6();
        let d = this.h5();
        let e = new ScalerParams(0, a, b, this.bz, c);
        let f = this.lg();
        let g = this.visibleMinimum;
        if (!this.kh() && f != null) {
            if (f.a == 7 && g.getDate() != 1) {
                g = dateAddMonths(g, 1);
                g = dateFromValues(g.getFullYear(), dateGetMonth(g), 1, 0, 0, 0, 0);
            }
            else if (f.a == 5 && dateGetTimeOfDay(g) != (0)) {
                g = dateAddDays(g, 1);
                g = dateFromValues(g.getFullYear(), dateGetMonth(g), g.getDate(), 0, 0, 0, 0);
            }
            else if (f.a == 4 && g.getMinutes() != 0) {
                g = dateAddHours(g, 1);
                g = dateFromValues(g.getFullYear(), dateGetMonth(g), g.getDate(), g.getHours(), 0, 0, 0);
            }
        }
        let h = new List$1(Date_$type, 0);
        let i = 0;
        let j = 10000;
        if (f.d == 0) {
            return h;
        }
        while (g <= this.visibleMaximum && i++ < j) {
            let k = this.ln(g);
            let l = g;
            if (k.key != null) {
                l = f.c(k.key.c);
            }
            h.add(l);
            while (g <= l) {
                g = f.b(g);
            }
        }
        return h;
    }
    ln(a) {
        if (this.lc == null) {
            return new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
        }
        for (let b of fromEnum(this.lc)) {
            if (b.key.d <= a && b.key.c >= a) {
                return b;
            }
        }
        return new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
    }
    get visibleMinimum() {
        return this.lp;
    }
    set visibleMinimum(a) {
        this.lp = a;
    }
    get visibleMaximum() {
        return this.lo;
    }
    set visibleMaximum(a) {
        this.lo = a;
    }
    k7() {
        super.k7();
        if (this.a9 == null || !Extensions.b(this.a9.mx)) {
            return;
        }
        let a = new ScalerParams(0, this.a9.mk, this.a9.mx, this.bz, this.a9.mo);
        let b = this.a9.mx.left;
        let c = this.a9.mx.right;
        if (this.categoryMode != 0) {
            let d = this.getCategorySize(a.e, a.d, a.c);
            b += d / 2;
            c -= d / 2;
        }
        let e = truncate(this.dm(b, a));
        let f = truncate(this.dm(c, a));
        if (e < 0 || f < 0) {
            this.l3 = (0);
            return;
        }
        e = Math.min(dateMaxValue().getTime(), e);
        f = Math.min(dateMaxValue().getTime(), f);
        this.visibleMinimum = dateFromTicks(Math.min(e, f));
        this.visibleMaximum = dateFromTicks(Math.max(e, f));
        this.l3 = +(this.visibleMaximum) - +(this.visibleMinimum);
    }
    getOffset1(a, b, c, d, e) {
        return 0;
    }
    i$f(a) {
        if (this.le == null || this.le.count == 0) {
            return super.i$f(a);
        }
        let b = this;
        if (b.i$b == null) {
            return -1;
        }
        let c = new SortedListView$1(Date_$type, this.ka, b.i$b);
        let ticks_ = a;
        let d = (new Date(ticks_));
        let e = this.ks(d, c);
        e = Math.max(0, Math.min(b.i$b.count - 1, e));
        let f = c.item(e);
        let g;
        let h;
        if (f < d) {
            g = e;
            h = g + 1;
        }
        else {
            h = e;
            g = e - 1;
        }
        if (g < 0) {
            return h;
        }
        if (h >= b.i$b.count) {
            return g;
        }
        let i = c.item(g);
        let j = c.item(h);
        let k = new ScalerParams(0, this.a9.my, this.ib, this.bz, this.a9.mo);
        this.startCursor();
        let l = this.dj(i.getTime(), k);
        let m = this.dj(a, k);
        let n = this.dj(j.getTime(), k);
        this.resetCursor();
        if (Math.abs(l - m) < Math.abs(n - m)) {
            return this.kj._inner[g];
        }
        else {
            return this.kj._inner[h];
        }
    }
    l6(a, b) {
        this.l5();
        this.l4();
        if (this.ap != null) {
            this.ap.ak = this.le.count > 0;
        }
        this.gj(false);
        for (let c of fromEnum(this.ci())) {
            c.it(false);
        }
    }
    l8(a, b) {
        this.gj(false);
    }
    l7(a, b) {
        this.gj(false);
    }
    get_bu() {
        return false;
    }
    get bu() {
        return this.get_bu();
    }
    getWindowRectForSelection(a, b) {
        let c = +(this.actualMaximumValue) - +(this.actualMinimumValue);
        let d = timeSpanTotalMilliseconds((+a - +(this.actualMinimumValue))) / timeSpanTotalMilliseconds(c);
        let e = 1 - (timeSpanTotalMilliseconds((+(this.actualMaximumValue) - +b)) / timeSpanTotalMilliseconds(c));
        e = Math.min(1, e);
        return new Rect(0, d, NaN, Math.max(0, e - d), NaN);
    }
    getCategorySize(a, b, c) {
        if (this.l3 != (0)) {
            let d = timeSpanFromTicks(truncate((timeSpanTicks(this.l3) * (a.width / (this.a9 != null ? this.a9.mk.width : 1)))));
            let e = timeSpanTicks(d) / timeSpanTicks(this.l1);
            let f = b.width / 4;
            return Math.min(f, b.width / (e + 1));
        }
        return super.getCategorySize(a, b, c);
    }
    l0() {
        if (this.ka == null || this.ka.count < 2 || this.kj == null) {
            return (0);
        }
        let a = Math.min(5, this.ka.count);
        let b = this.ka.item(this.kj._inner[0]);
        let c = new Dictionary$2(Number_$type, Number_$type, 0);
        let d = 0;
        let e = (0);
        for (let f = 0; f < a; f++) {
            let g = this.ka.item(this.kj._inner[f]);
            let h = +g - +b;
            if (!c.containsKey(h)) {
                c.addItem(h, 0);
            }
            c.item(h, c.item(h) + 1);
            if (c.item(h) > d) {
                d = c.item(h);
                e = h;
            }
            b = g;
        }
        return e;
    }
    k3() {
        super.k3();
        this.l1 = this.l0();
    }
    get isVertical() {
        return this.b5;
    }
    j$c(a, b) {
        return this.dm.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dj.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.fz.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.f0.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.f1.apply(this, arguments);
    }
    get j$a() {
        return this.bz;
    }
    get i$a() {
        return this.bw;
    }
}
TimeXAxis.$t = markType(TimeXAxis, 'TimeXAxis', TimeAxisBase.$, [ITimeRangeSelectorAxis_$type]);
//# sourceMappingURL=TimeXAxis.js.map