/**
 * Provides data for Axis RangeChanged events.
*/
export class AxisRangeChangedEventArgs {
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
         * Gets the minimum value before the range changed. The reported minimum is the effective,
         * not the set value.
        */
    get oldMinimumValue() {
        return this.i.oldMinimumValue;
    }
    /**
         * Gets the minimum value after the range changed. The reported minimum is the effective,
         * not the set value.
        */
    get minimumValue() {
        return this.i.minimumValue;
    }
    /**
         * Gets the maximum value before the range changed. The reported maximum is the effective,
         * not the set value.
        */
    get oldMaximumValue() {
        return this.i.oldMaximumValue;
    }
    /**
         * Gets the maximum value after the range changed. The reported maximum is the effective,
         * not the set value.
        */
    get maximumValue() {
        return this.i.maximumValue;
    }
}
//# sourceMappingURL=igx-axis-range-changed-event-args.js.map