import { IgxSeriesComponent } from './igx-series-component';
import { IgxSeriesViewerComponent } from './igx-series-viewer-component';
import { ChartCursorEventArgs as ChartCursorEventArgs_internal } from "./ChartCursorEventArgs";
/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
export declare class ChartCursorEventArgs {
    protected _implementation: any;
    readonly i: ChartCursorEventArgs_internal;
    private onImplementationCreated();
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets the ItemsSource item associated with the current event.
    */
    readonly item: any;
    /**
     * Gets the series associated with the current event.
    */
    readonly series: IgxSeriesComponent;
    /**
     * Gets the Chart associated with the current event.
    */
    readonly seriesViewer: IgxSeriesViewerComponent;
    /**
     * Provides a human readable expresion of the event arguments.
    
    */
    toString(): string;
}
