/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
export class ChartCursorEventArgs {
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
         * Gets the ItemsSource item associated with the current event.
        */
    get item() {
        return this.i.item;
    }
    /**
         * Gets the series associated with the current event.
        */
    get series() {
        if (this.i.series == null) {
            return null;
        }
        return this.i.series.externalObject;
    }
    /**
         * Gets the Chart associated with the current event.
        */
    get seriesViewer() {
        if (this.i.seriesViewer == null) {
            return null;
        }
        return this.i.seriesViewer.externalObject;
    }
    /**
         * Provides a human readable expresion of the event arguments.
        
        */
    toString() {
        let iv = this.i.toString();
        return (iv);
    }
}
//# sourceMappingURL=igx-chart-cursor-event-args.js.map