import { IgxCollection } from './IgxCollection';
import { SyncableObservableCollection$2 } from './SyncableObservableCollection$2';
import { IndicatorDisplayType_$type } from './IndicatorDisplayType';
import { ensureEnum } from './componentUtil';
export class IndicatorDisplayTypeCollection extends IgxCollection {
    constructor(list) {
        super();
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _ensureOuter(item) {
        return ensureEnum(IndicatorDisplayType_$type, item);
    }
    _createInnerColl() {
        let coll = new SyncableObservableCollection$2(IndicatorDisplayType_$type, IndicatorDisplayType_$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-indicator-display-type-collection.js.map