import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxLegendBaseComponent } from './igx-legend-base-component';
import { ItemLegend } from "./ItemLegend";
/**
 * Represents a legend that displays an item for each point in the series.
*
* You can use the `IgxItemLegendComponent` to display a legend item for each data member bound to the `IgxItemLegendComponent`
*/
export const IgxItemLegendComponent_PROVIDERS = [{ provide: IgxLegendBaseComponent, useExisting: forwardRef(() => IgxItemLegendComponent) }];
export class IgxItemLegendComponent extends IgxLegendBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ItemLegend();
    }
    get i() {
        return this._implementation;
    }
}
IgxItemLegendComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-item-legend',
                template: ``,
                providers: [{ provide: IgxLegendBaseComponent, useExisting: forwardRef(() => IgxItemLegendComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxItemLegendComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-item-legend-component.js.map