/**
 * Provides data for legend mouse button related events.
*/
export class LegendMouseEventArgs {
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
         * Gets a reference to the object that raised the event.
        */
    get originalSource() {
        return this.i.originalSource;
    }
    /**
         * Gets the ItemsSource item associated with the current event.
        */
    get item() {
        return this.i.item;
    }
    /**
         * Gets the series associated with the current event.
        */
    get series() {
        return this.i.series;
    }
    /**
         * Gets the Chart associated with the current event.
        */
    get chart() {
        return this.i.chart;
    }
    /**
         * The legend item in context.
        */
    get legendItem() {
        return this.i.legendItem;
    }
    /**
         * Provides a human readable description of the mouse button event.
        
        */
    toString() {
        let iv = this.i.toString();
        return (iv);
    }
}
//# sourceMappingURL=igx-legend-mouse-event-args.js.map