import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxStraightNumericAxisBaseComponent } from './igx-straight-numeric-axis-base-component';
import { IgxNumericAxisBaseComponent } from './igx-numeric-axis-base-component';
import { IgxAxisComponent } from './igx-axis-component';
import { NumericXAxis } from "./NumericXAxis";
/**
 * Represents a IgxDataChartComponent numeric X axis.
*
* The `IgxNumericXAxisComponent` treats the data as continuously varying numerical data items. Labels on this axis are placed along the X-axis. The location of labels varies according to the value in a data column that is mapped using the `IgxNumericXAxisComponent` property of Scatter Series or `IgxNumericXAxisComponent` property of Bar Series.
*
* ```html
*
* ```
*/
export const IgxNumericXAxisComponent_PROVIDERS = [{ provide: IgxStraightNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericXAxisComponent) }, { provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericXAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxNumericXAxisComponent) }];
export class IgxNumericXAxisComponent extends IgxStraightNumericAxisBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new NumericXAxis();
    }
    get i() {
        return this._implementation;
    }
    scrollRangeIntoView(minimum, maximum) {
        this.i.k8(minimum, maximum);
    }
}
IgxNumericXAxisComponent.decorators = [
    { type: Component, args: [{
                selector: 'igx-numeric-x-axis',
                template: ``,
                providers: [{ provide: IgxStraightNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericXAxisComponent) }, { provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericXAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxNumericXAxisComponent) }],
                changeDetection: ChangeDetectionStrategy.OnPush
            },] },
];
/** @nocollapse */
IgxNumericXAxisComponent.ctorParameters = () => [];
//# sourceMappingURL=igx-numeric-x-axis-component.js.map