/**
 * EventArgs class for property updated events.
*/
export class PropertyUpdatedEventArgs {
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
         * Name of the property being updated.
        */
    get propertyName() {
        return this.i.propertyName;
    }
    /**
         * Old or previous value of the property being updated.
        */
    get oldValue() {
        return this.i.oldValue;
    }
    /**
         * New or current value of the property being updated.
        */
    get newValue() {
        return this.i.newValue;
    }
}
//# sourceMappingURL=igx-property-updated-event-args.js.map