import { Type } from '@angular/core';
import { IgxCategorySeriesComponent } from './igx-category-series-component';
import { IgxMarkerSeriesComponent } from './igx-marker-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { RangeCategorySeries } from "./RangeCategorySeries";
/**
 * Represents the base class for all IgxDataChartComponent ranged category/value series.
*/
export declare const IgxRangeCategorySeriesComponent_PROVIDERS: ({
    provide: typeof IgxMarkerSeriesComponent;
    useExisting: Type<any>;
} | {
    provide: typeof IgxSeriesComponent;
    useExisting: Type<any>;
})[];
export declare abstract class IgxRangeCategorySeriesComponent extends IgxCategorySeriesComponent {
    readonly i: RangeCategorySeries;
    constructor();
    /**
     * Gets or sets the value mapping property for the current series object.
    */
    lowMemberPath: string;
    /**
     * Gets or sets the value mapping property for the current series object.
    */
    highMemberPath: string;
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    */
    scrollIntoView(item: any): boolean;
}
