import { IgxCollection } from './IgxCollection';
import { markType } from './type';
import { SyncableObservableCollection$2 } from './SyncableObservableCollection$2';
import { Series as Series_internal } from './Series';
import { IgxSeriesComponent as IgxSeriesComponent } from './igx-series-component';
export class SeriesCollection extends IgxCollection {
    constructor(list) {
        super();
        if (!IgxSeriesComponent.$type) {
            IgxSeriesComponent.$type = markType(IgxSeriesComponent, "IgxSeriesComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxSeriesComponent.$type) {
            IgxSeriesComponent.$type = markType(IgxSeriesComponent, "IgxSeriesComponent");
        }
        let coll = new SyncableObservableCollection$2(IgxSeriesComponent.$type, Series_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgxSeriesComponent._createFromInternal(int);
                ext._implementation = int;
            }
            return ext;
        };
        return coll;
    }
}
//# sourceMappingURL=igx-series-collection.js.map