import { forwardRef, Input } from '@angular/core';
import { SplineType, SplineType_$type } from './SplineType';
import { IgxHorizontalAnchoredCategorySeriesComponent } from './igx-horizontal-anchored-category-series-component';
import { IgxAnchoredCategorySeriesComponent } from './igx-anchored-category-series-component';
import { IgxCategorySeriesComponent } from './igx-category-series-component';
import { IgxMarkerSeriesComponent } from './igx-marker-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { ensureEnum } from "./componentUtil";
/**
 * Represents the base class for all IgxDataChartComponent spline series.
*/
export const IgxSplineSeriesBaseComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesBaseComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesBaseComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesBaseComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesBaseComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesBaseComponent) }];
export class IgxSplineSeriesBaseComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    constructor() {
        super();
    }
    get i() {
        return this._implementation;
    }
    /**
         * Gets whether the current series shows an area or line shape.
        */
    get isAreaOrLine() {
        return this.i.ci;
    }
    /**
         * Gets or sets the type of spline to be rendered.
        */
    get splineType() {
        return this.i.py;
    }
    set splineType(v) {
        this.i.py = ensureEnum(SplineType_$type, v);
    }
}
IgxSplineSeriesBaseComponent.propDecorators = {
    "splineType": [{ type: Input },],
};
//# sourceMappingURL=igx-spline-series-base-component.js.map