import { TimeAxisLabelFormat as TimeAxisLabelFormat_internal } from "./TimeAxisLabelFormat";
/**
 * Settings for a label format on a time axis.
 * Label formats can be applied to a time axis, which are dynamic, according to the visible range.  During zooming, the visible range of the axis can change, and so a different label format is selected.  The label format selected will be the one with the largest range smaller than the visible range of the axis.
*/
export declare class TimeAxisLabelFormat {
    protected createImplementation(): TimeAxisLabelFormat_internal;
    protected _implementation: any;
    readonly i: TimeAxisLabelFormat_internal;
    private onImplementationCreated();
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The visible axis range at which to apply this label format.
    */
    range: number;
    /**
     * The DateTime format string to apply.
     * Some common DateTime format strings are: yyyy, MM/dd/yy, and hh:mm:ss.
    */
    format: string;
}
