import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "./type";
import { DependencyProperty } from "./DependencyProperty";
import { IFastItemColumn$1 } from "./IFastItemColumn$1";
import { TrendLineType } from "./TrendLineType";
import { Brush } from "./Brush";
import { PenLineCap } from "./PenLineCap";
import { DoubleCollection } from "./DoubleCollection";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { Rect } from "./Rect";
import { Axis } from "./Axis";
import { List$1 } from "./List$1";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "./FastItemsSourceEventAction";
import { PointCollection } from "./PointCollection";
import { Clipper } from "./Clipper";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderingContext } from "./RenderingContext";
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    private oi;
    readonly oj: IAnchoredCategorySeriesInteractionManager;
    oe: AnchoredCategorySeriesView;
    protected be(): SeriesView;
    h9(a: SeriesView): void;
    om: boolean;
    constructor();
    ot: string;
    valueColumn: IFastItemColumn$1<number>;
    private ok;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    pa: Brush;
    static readonly oz: DependencyProperty;
    trendLineThickness: number;
    pc: PenLineCap;
    pb: DoubleCollection;
    trendLinePeriod: number;
    oo: number;
    c5(a: any): boolean;
    protected ob(a: number, b: number, c: Axis): any[];
    protected ie(a: any, b: string, c: any, d: any): void;
    am(a: Axis): AxisRange;
    protected hh(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected nl(): number;
    on(a: CategorySeriesView): number;
    oy(a: PointCollection, b: number, c: CategorySeriesView): void;
    oc(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    od(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    ds(a: Rect, b: Rect, c: SeriesView): boolean;
    he(a: boolean, b: SeriesView): void;
    nz(a: CategoryFrame, b: CategorySeriesView): void;
    n2(a: CategoryFrame, b: CategorySeriesView): void;
    of: CategoryFrame;
    is(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    ov(a: CategoryFrame, b: CategorySeriesView): void;
    protected i4(): void;
    fh(a: any, b: Point): any;
    readonly currentCategoryMode: CategoryMode;
    readonly scaler: ICategoryScaler;
    readonly yScaler: IScaler;
    readonly bucketizer: IBucketizer;
    readonly currentMode2Index: number;
    provideCollisionDetector(): IDetectsCollisions;
    readonly trendlinePreparer: IPreparesCategoryTrendline;
    protected op: string;
    abstract ow(a: Axis): void;
    abstract ox(a: Axis): void;
    protected hn(a: any): void;
    og: CategorySeriesMarkerCollisionAvoidance;
    fe(a: Point): any;
    oh: ConsolidatedItemHitTestBehavior;
    readonly mayContainUnknowns: boolean;
    d8(): number;
    an(): AxisRange;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
    static $t: Type;
}
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    cu: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private cv;
    cw: ITrendLineManager;
    readonly cx: boolean;
    c1(): void;
    cz(): void;
    cy(): void;
    cm(): CategoryBucketCalculator;
    c0(): void;
    c2(): void;
    c3(a: number): Rect;
    protected a2(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
    static $t: Type;
}
