import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { Point, Type, IList$1 } from "./type";
import { AxisLabelPanelBaseView } from "./AxisLabelPanelBaseView";
import { Rect } from "./Rect";
import { Axis } from "./Axis";
import { List$1 } from "./List$1";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { IAngleScaler } from "./IAngleScaler";
import { CategoryAxisRenderer } from "./CategoryAxisRenderer";
import { DependencyProperty } from "./DependencyProperty";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { PolarAxisRenderingManager } from "./PolarAxisRenderingManager";
import { ScalerParams } from "./ScalerParams";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { NumericAxisBase } from "./NumericAxisBase";
import { NumericAxisRenderer } from "./NumericAxisRenderer";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { GeometryGroup } from "./GeometryGroup";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
import { NumericAxisBaseView } from "./NumericAxisBaseView";
export declare class AngleAxisLabelPanel extends AxisLabelPanelBase {
    ad(): AxisLabelPanelBaseView;
    b6(a: AxisLabelPanelBaseView): void;
    cq: AngleAxisLabelPanelView;
    constructor();
    cr: boolean;
    cx: (arg1: number) => Point;
    ao(a: number, b: Rect): boolean;
    cv: number;
    cs: number;
    cu: number;
    ct: number;
    ay(): List$1<Rect>;
    private cw();
    ah(): AxisLabelsLocation;
    as(a: AxisLabelsLocation): boolean;
    static $t: Type;
}
export declare class CategoryAngleAxis extends CategoryAxisBase implements IAngleScaler {
    ax(): AxisView;
    f5(a: AxisView): void;
    j9: CategoryAngleAxisView;
    protected get_bs(): boolean;
    readonly bs: boolean;
    private ke;
    constructor();
    ao(): AxisLabelPanelBase;
    kb: CategoryAxisRenderer;
    private kf;
    private kt(a);
    private kj;
    private ka();
    private k8(a, b, c, d, e);
    private kn();
    private j8(a, b, c, d);
    getMinMaxAngle(a: Rect, b: number, c: number): {
        p1: number;
        p2: number;
    };
    ac(): void;
    private kc;
    kd: NumericRadiusAxis;
    ah(): Axis;
    ku: number;
    private kk;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    i3(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    kq(a: number): number;
    protected gk(a: boolean): void;
    kp(a: Rect, b: Rect): number;
    ko(a: Rect, b: Rect): number;
    getScaledAngle(a: number): number;
    getUnscaledAngle(a: number): number;
    dj(a: number, b: ScalerParams): number;
    dm(a: number, b: ScalerParams): number;
    protected f7(a: any, b: string, c: any, d: any): void;
    private k2();
    k4(a: NumericRadiusAxis): void;
    static readonly k5: DependencyProperty;
    kr: number;
    private kh;
    kl: number;
    static readonly k6: DependencyProperty;
    ks: number;
    private ki;
    km: number;
    protected kg(): boolean;
    protected get_av(): AxisOrientation;
    readonly av: AxisOrientation;
    cd(): boolean;
    private kv;
    kw: number;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare class NumericAngleAxis extends NumericAxisBase implements IAngleScaler {
    ax(): AxisView;
    f5(a: AxisView): void;
    ko: NumericAngleAxisView;
    kr: PolarAxisRenderingManager;
    protected get_bs(): boolean;
    readonly bs: boolean;
    constructor();
    ao(): AxisLabelPanelBase;
    private kv();
    private kx(a);
    private ks;
    private kt;
    ip(): NumericAxisRenderer;
    private k4(a, b, c, d, e);
    dj(a: number, b: ScalerParams): number;
    getScaledAngle1(a: number, b: boolean, c: boolean): number;
    getScaledAngle(a: number): number;
    dm(a: number, b: ScalerParams): number;
    getUnscaledAngle(a: number): number;
    ky: number;
    private ku;
    protected f7(a: any, b: string, c: any, d: any): void;
    private k0();
    it(): NumericAxisRenderingParameters;
    is(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    getMinMaxAngle(a: Rect, b: number, c: number): {
        p1: number;
        p2: number;
    };
    protected gk(a: boolean): void;
    private kp;
    kq: NumericRadiusAxis;
    ah(): Axis;
    k2(a: NumericRadiusAxis): void;
    protected gu(a: Rect, b: Rect): void;
    protected get_av(): AxisOrientation;
    readonly av: AxisOrientation;
    static $$p: string[];
    static $t: Type;
}
export declare class NumericRadiusAxis extends NumericAxisBase {
    ax(): AxisView;
    f5(a: AxisView): void;
    kq: NumericRadiusAxisView;
    protected get_b2(): boolean;
    readonly b2: boolean;
    di(): number;
    private kz();
    private ky();
    private kr;
    constructor();
    ao(): AxisLabelPanelBase;
    ks: boolean;
    private kw(a);
    private kt;
    ip(): NumericAxisRenderer;
    dj(a: number, b: ScalerParams): number;
    k2(a: number, b: boolean, c: boolean, d: number, e: number): number;
    k1(a: number): number;
    k3(a: number): number;
    dm(a: number, b: ScalerParams): number;
    k5: number;
    kv: number;
    k4: number;
    ku: number;
    protected f7(a: any, b: string, c: any, d: any): void;
    protected kx: number;
    la(a: Axis): void;
    private ko;
    kp: Axis;
    ah(): Axis;
    it(): NumericAxisRenderingParameters;
    is(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    private lb(a, b, c, d);
    private k6(a, b, c, d, e);
    k0(): number;
    ke(a: AxisRangeChangedEventArgs): void;
    protected gk(a: boolean): void;
    protected gu(a: Rect, b: Rect): void;
    k9(a: GeometryGroup, b: Rect, c: Rect, d: Rect, e: Rect): void;
    protected get_av(): AxisOrientation;
    readonly av: AxisOrientation;
    static $$p: string[];
    static $t: Type;
}
export declare class AngleAxisLabelPanelView extends AxisLabelPanelBaseView {
    protected av: AngleAxisLabelPanel;
    constructor(a: AngleAxisLabelPanel);
    al(): void;
    aw(a: List$1<Rect>): void;
    o(): number;
    p(): number;
    q(): number;
    r(): number;
    static $t: Type;
}
export declare class CategoryAngleAxisView extends CategoryAxisBaseView {
    protected ba: CategoryAngleAxis;
    constructor(a: CategoryAngleAxis);
    static $t: Type;
}
export declare class NumericAngleAxisView extends NumericAxisBaseView {
    protected ba: NumericAngleAxis;
    constructor(a: NumericAngleAxis);
    static $t: Type;
}
export declare class NumericRadiusAxisView extends NumericAxisBaseView {
    protected ba: NumericRadiusAxis;
    constructor(a: NumericRadiusAxis);
    static $t: Type;
}
