import { XYChart } from "./XYChart";
import { DomWrapper, EventArgs, Type, IList } from "./type";
import { ZoomSliderWidget } from "./ZoomSliderWidget";
import { List$1 } from "./List$1";
import { DataSeriesType } from "./DataSeriesType";
import { IDataSeriesAdapterRule } from "./IDataSeriesAdapterRule";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode } from "./FinancialChartYAxisMode";
import { FinancialChartType } from "./FinancialChartType";
import { HorizontalAlignment } from "./HorizontalAlignment";
import { FinancialIndicatorTypeCollection } from "./FinancialIndicatorTypeCollection";
import { FinancialOverlayTypeCollection } from "./FinancialOverlayTypeCollection";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { FinancialChartZoomSliderType } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "./BrushCollection";
import { IndicatorDisplayTypeCollection } from "./IndicatorDisplayTypeCollection";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { CustomIndicatorNameCollection } from "./CustomIndicatorNameCollection";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Axis } from "./Axis";
import { DataSeries } from "./DataSeries";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { Series } from "./Series";
import { TitleSettings } from "./TitleSettings";
import { FinancialIndicatorType } from "./FinancialIndicatorType";
import { FinancialOverlayType } from "./FinancialOverlayType";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ObservableCollection$1 } from "./ObservableCollection$1";
import { FinancialChartEnumCollectionPickerToolViewModel } from "./FinancialChartEnumCollectionPickerToolViewModel";
import { FinancialChartEnumCollectionPickerToolView } from "./FinancialChartEnumCollectionPickerToolView";
import { FinancialChartEnumCollectionPickerVisualData } from "./FinancialChartEnumCollectionPickerVisualData";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartTrendLinePicker } from "./FinancialChartTrendLinePicker";
import { FinancialChartVolumeTypePicker } from "./FinancialChartVolumeTypePicker";
import { TrendLineType } from "./TrendLineType";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorVisualData } from "./FinancialChartRangeSelectorVisualData";
export declare class FinancialChart extends XYChart {
    protected fk(a: string, b: any, c: any): void;
    private ty(a, b);
    private tx(a, b);
    private tu(a, b);
    private t6();
    private om;
    provideGrid(a: DomWrapper): void;
    onDocumentClick(a: string[]): void;
    private qu;
    private qs;
    private qq;
    private qr;
    private qt;
    private pm();
    getContext(): FinancialChartContext;
    provideContainer(a: any): void;
    private ug(a, b, c);
    private ut(a, b);
    private th();
    private ur(a, b);
    setGridRows(): void;
    protected e1(): void;
    private uc();
    private ud();
    private ul();
    private t4();
    protected ey(a: XamDataChart): void;
    private uu(a);
    private uv(a);
    qe(): number;
    e9(source_: any, a: number, b: any): void;
    fa(source_: any, a: number, b: any): void;
    e8(source_: any): void;
    fc(source_: any, a: number, b: any, c: any): void;
    private nu;
    private nv;
    private rc;
    rj: any;
    private rd;
    rk: any;
    private q9;
    rg: any;
    private re;
    rl: any;
    private rf;
    rm: any;
    private ra;
    rh: any;
    private rb;
    ri: any;
    private pb;
    pc: ZoomSliderWidget;
    protected get_bw(): number;
    protected set_bw(a: number): void;
    bw: number;
    protected get_ay(): boolean;
    protected set_ay(a: boolean): void;
    ay: boolean;
    private p8;
    qi: number;
    constructor();
    private ne;
    private xAxis;
    private or;
    private yAxis;
    private oq;
    private volumeAxis;
    private nd;
    private volumeXAxis;
    private op;
    private indicatorAxis;
    private nc;
    private indicatorXAxis;
    private pz;
    private p2;
    private p1;
    private p4;
    protected gj(): Axis;
    protected gk(): Axis;
    protected r(a: DataSeries): DataSeriesType;
    protected get_ba(): List$1<DataSeriesType>;
    protected readonly ba: List$1<DataSeriesType>;
    protected get_a9(): List$1<IDataSeriesAdapterRule>;
    protected readonly a9: List$1<IDataSeriesAdapterRule>;
    private nh(a);
    private ot(a);
    private ng(a);
    protected em(): void;
    protected f1(a: Series): void;
    protected ek(a: Series, b: number): void;
    protected fw(a: DataSeries): void;
    protected fz(): void;
    private nz();
    private ny(a);
    private n8(a);
    private n1(a);
    private rt(a);
    private o5(seriesType_);
    private ni(axisType_);
    private ou(axisType_);
    private o0();
    private o1();
    private oz();
    private o2();
    private readonly ph;
    private og;
    private readonly oh;
    private readonly pk;
    private oe;
    private readonly of;
    private readonly pi;
    private oi;
    private readonly oj;
    private readonly pj;
    private on;
    private readonly oo;
    protected ag(a: DataSeries, b: DataSeriesType): Series;
    protected fy(): void;
    protected lh(a: (arg1: Axis) => void): void;
    protected ll(a: (arg1: Axis) => void, b: boolean): void;
    protected lj(a: (arg1: TitleSettings) => void): void;
    protected ln(a: (arg1: TitleSettings) => void): void;
    protected lm(a: (arg1: AxisLabelSettings) => void): void;
    protected li(a: (arg1: AxisLabelSettings) => void): void;
    protected ex(a: XamDataChart): void;
    private static q7;
    private rn;
    private sm();
    private to(a, b);
    private tf();
    private ti(a);
    private tk(a);
    private tj(a);
    private q1(a, b);
    protected er(a: (arg1: Series, arg2: number) => void): void;
    private o7;
    private volumeChart;
    private t8();
    private pl(a);
    private pp(a);
    private pn(a);
    private po(a);
    private t7();
    private o3(indicatorName_);
    private o6(a);
    private un(a);
    cn(): any;
    rs(): string;
    private o4(overlayName_);
    private um();
    private pu;
    private uk();
    protected eu(): void;
    protected get_a2(): boolean;
    protected readonly a2: boolean;
    protected readonly py: boolean;
    private us(a, b);
    private t9();
    protected ff(a: (arg1: XamDataChart) => void, b: boolean): void;
    private tm(a, b);
    protected ld(a: Axis): void;
    protected lf(a: Axis): void;
    private t2(a);
    protected e2(a: Series, b: number): void;
    protected fi(a: string, b: any, c: any): void;
    private uh(a, b, c);
    private readonly px;
    private tn(a, b);
    private pq(a, b);
    private ub();
    private tr(a, b);
    private tw(a, b);
    private tv(a, b);
    private tp(a, b);
    private tq(a, b);
    private t0(a, b);
    private t3(a);
    private t1(a);
    private tg();
    private uf(a, b);
    private uq(a, b);
    private ts(a, b);
    private uo();
    private pt;
    private tz(a, b);
    private tl(a, b);
    private uj(a, b, c, d);
    private ui(a);
    private tt(a, b);
    private up();
    private pg;
    pw: boolean;
    private q0;
    q8: number;
    private qa;
    qm: number;
    private qc;
    qo: number;
    private qb;
    qn: number;
    private qd;
    qp: number;
    readonly ql: number;
    readonly qk: number;
    private n0;
    n2: FinancialChartVolumeType;
    private n3;
    n4: FinancialChartXAxisMode;
    private n5;
    n6: FinancialChartYAxisMode;
    private pd;
    pr: boolean;
    private nw;
    nx: FinancialChartType;
    protected get_lt(): HorizontalAlignment;
    protected set_lt(a: HorizontalAlignment): void;
    lt: HorizontalAlignment;
    private pe;
    ps: boolean;
    private oa;
    ob: FinancialIndicatorTypeCollection;
    private oc;
    od: FinancialOverlayTypeCollection;
    private p0;
    private indicatorCharts;
    private pf;
    pv: boolean;
    protected get_by(): number;
    protected set_by(a: number): void;
    by: number;
    protected get_gq(): AxisLabelsLocation;
    protected set_gq(a: AxisLabelsLocation): void;
    gq: AxisLabelsLocation;
    private o8;
    zoomSliderChart: XamDataChart;
    private os;
    private zoomSliderAxis;
    private nf;
    private zoomSliderXAxis;
    private n7;
    n9: FinancialChartZoomSliderType;
    private my;
    m6: BrushCollection;
    private mz;
    m7: BrushCollection;
    private m0;
    m8: BrushCollection;
    private m1;
    m9: BrushCollection;
    private m3;
    nb: BrushCollection;
    private m2;
    na: BrushCollection;
    private mx;
    m5: BrushCollection;
    private mw;
    m4: BrushCollection;
    private p9;
    qj: number;
    private p7;
    qh: number;
    private p6;
    qg: number;
    private ok;
    ol: IndicatorDisplayTypeCollection;
    private qw;
    q3: number;
    private p5;
    qf: number;
    private qz;
    q6: number;
    private qx;
    q4: number;
    private qv;
    q2: number;
    private qy;
    q5: number;
    private nr;
    nt: FinancialChartRangeSelectorOptionCollection;
    ns: FinancialChartRangeSelectorOptionCollection;
    private nn;
    customIndicatorNames: CustomIndicatorNameCollection;
    applyCustomIndicators: (sender: any, e: FinancialChartCustomIndicatorArgs) => void;
    protected get_a3(): boolean;
    protected set_a3(a: boolean): void;
    a3: boolean;
    static $t: Type;
}
export declare abstract class FinancialChartEnumCollectionPickerTool$2<TColl extends ObservableCollection$1<TEnum>, TEnum> extends TemplatedHtmlControl {
    protected $tColl: Type;
    protected $tEnum: Type;
    constructor($tColl: Type, $tEnum: Type, a: string, b: any, c: string);
    l(a: any): void;
    abstract s(): string;
    u(a: string[]): void;
    n: TColl;
    private w();
    protected o: FinancialChartEnumCollectionPickerToolView;
    p: FinancialChartEnumCollectionPickerToolViewModel;
    private v(a, b, c);
    changed: (sender: any, e: EventArgs) => void;
    q(): FinancialChartEnumCollectionPickerVisualData;
    static $t: Type;
}
export declare class FinancialChartIndicatorPicker extends FinancialChartEnumCollectionPickerTool$2<FinancialIndicatorTypeCollection, FinancialIndicatorType> {
    constructor(a: number);
    constructor(a: number, b: any);
    constructor(a: number, ..._rest: any[]);
    u(a: string[]): void;
    s(): string;
    static $t: Type;
}
export declare class FinancialChartOverlayPicker extends FinancialChartEnumCollectionPickerTool$2<FinancialOverlayTypeCollection, FinancialOverlayType> {
    constructor(a: number);
    constructor(a: number, b: any);
    constructor(a: number, ..._rest: any[]);
    u(a: string[]): void;
    s(): string;
    static $t: Type;
}
export declare class FinancialChartToolbar extends TemplatedHtmlControl {
    bp(a: DomWrapper): void;
    bx(a: string[]): void;
    private static a6;
    private n;
    constructor(a: FinancialChart, b: any);
    private s;
    t: FinancialChartRangeSelector;
    private ac;
    ad: FinancialChartTypePicker;
    private y;
    z: FinancialChartTrendLinePicker;
    private ag;
    ah: FinancialChartVolumeTypePicker;
    private o;
    p: FinancialChartIndicatorPicker;
    private q;
    r: FinancialChartOverlayPicker;
    private by(a, b, c);
    private br(a, b);
    private bq(a, b);
    private bs(a, b);
    private bu(a, b);
    private bv(a, b);
    private bt(a, b);
    x: FinancialChartToolbarViewModel;
    w(): FinancialChartToolbarContext;
    l(a: any): void;
    private bw();
    private av;
    az: Date;
    private au;
    ay: Date;
    private at;
    ax: Date;
    private as;
    aw: Date;
    rangeChanged: (sender: any, e: EventArgs) => void;
    chartTypeChanged: (sender: any, e: EventArgs) => void;
    trendLineTypeChanged: (sender: any, e: EventArgs) => void;
    volumeTypeChanged: (sender: any, e: EventArgs) => void;
    indicatorTypesChanged: (sender: any, e: EventArgs) => void;
    overlayTypesChanged: (sender: any, e: EventArgs) => void;
    bz(): void;
    private aa;
    ab: FinancialChartType;
    private am;
    an: TrendLineType;
    private ae;
    af: FinancialChartVolumeType;
    private ai;
    aj: FinancialIndicatorTypeCollection;
    private ak;
    al: FinancialOverlayTypeCollection;
    static ar(a: IList, b: IList): boolean;
    ao(): FinancialChartToolbarVisualData;
    private u;
    v: FinancialChartRangeSelectorOptionCollection;
    private ap;
    aq: boolean;
    static $t: Type;
}
export declare class FinancialChartRangeSelector extends TemplatedHtmlControl {
    private static w;
    p: FinancialChartRangeSelectorViewModel;
    u: Date;
    t: Date;
    s: Date;
    r: Date;
    z(): void;
    constructor(a: any);
    l(a: any): void;
    private y();
    rangeChanged: (sender: any, e: EventArgs) => void;
    q(): FinancialChartRangeSelectorVisualData;
    n: FinancialChartRangeSelectorOptionCollection;
    private o;
    static $t: Type;
}
