/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Brush } from "./Brush";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { BaseError, EventArgs, Base, runOn, delegateRemove, delegateCombine, typeCast, fromEnum, EnumUtil, Number_$type, String_$type, enumGetBox, Type, markType, TypeRegistrar, typeCastObjTo$t, fromEn } from "./type";
import { ZoomSliderWidget } from "./ZoomSliderWidget";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { List$1 } from "./List$1";
import { DataSeriesType_$type } from "./DataSeriesType";
import { IDataSeriesAdapterRule_$type } from "./IDataSeriesAdapterRule";
import { SimpleFinancialPriceSeriesRule } from "./SimpleFinancialPriceSeriesRule";
import { SubCollectionsRule } from "./SubCollectionsRule";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { FinancialIndicatorTypeCollection } from "./FinancialIndicatorTypeCollection";
import { FinancialOverlayTypeCollection } from "./FinancialOverlayTypeCollection";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "./BrushCollection";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { Rect } from "./Rect";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { Series } from "./Series";
import { MarkerSeries } from "./MarkerSeries";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { ArrayExtension } from "./ArrayExtension";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ObservableCollection$1 } from "./ObservableCollection$1";
import { ScalerParams } from "./ScalerParams";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { stringReplace, stringJoin, stringIsNullOrEmpty, stringToString$1 } from "./string";
import { timeSpanFromDays } from "./timespan";
import { dateMaxValue, dateMinValue } from "./date";
import { isNaN_, isInfinity } from "./number";
import { FinancialChartEnumCollectionPickerToolViewModel } from "./FinancialChartEnumCollectionPickerToolViewModel";
import { FinancialChartEnumCollectionPickerToolView } from "./FinancialChartEnumCollectionPickerToolView";
import { SRProvider } from "./SRProvider";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartTrendLinePicker } from "./FinancialChartTrendLinePicker";
import { FinancialChartVolumeTypePicker } from "./FinancialChartVolumeTypePicker";
import { TrendLineType_$type } from "./TrendLineType";
import { FinancialChartChartTypePickerContext } from "./FinancialChartChartTypePickerContext";
import { FinancialChartIndicatorPickerContext } from "./FinancialChartIndicatorPickerContext";
import { FinancialChartOverlayPickerContext } from "./FinancialChartOverlayPickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartTrendLinePickerContext } from "./FinancialChartTrendLinePickerContext";
import { FinancialChartVolumeTypePickerContext } from "./FinancialChartVolumeTypePickerContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
var FinancialChart = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChart, _super);
    function FinancialChart() {
        var _this = _super.call(this) || this;
        _this.om = null;
        _this.qu = null;
        _this.qs = null;
        _this.qq = null;
        _this.qr = null;
        _this.qt = null;
        _this.nu = null;
        _this.rc = null;
        _this.rd = null;
        _this.q9 = null;
        _this.re = null;
        _this.rf = null;
        _this.ra = null;
        _this.rb = null;
        _this.pb = null;
        _this.p8 = 40;
        _this.og = null;
        _this.oe = null;
        _this.oi = null;
        _this.on = null;
        _this.rn = null;
        _this.o7 = null;
        _this.pu = false;
        _this.pt = false;
        _this.pg = false;
        _this.q0 = 10;
        _this.qa = NaN;
        _this.qc = NaN;
        _this.qb = NaN;
        _this.qd = 0;
        _this.n0 = 0;
        _this.n3 = 0;
        _this.n5 = 0;
        _this.pd = true;
        _this.nw = 0;
        _this.pe = false;
        _this.oa = null;
        _this.oc = null;
        _this.p0 = null;
        _this.pf = true;
        _this.o8 = null;
        _this.n7 = 1;
        _this.my = null;
        _this.mz = null;
        _this.m0 = null;
        _this.m1 = null;
        _this.m3 = null;
        _this.m2 = null;
        _this.mx = null;
        _this.mw = null;
        _this.p9 = 1;
        _this.p7 = 1;
        _this.p6 = 1;
        _this.ok = null;
        _this.qw = -2147483648;
        _this.p5 = 2;
        _this.qz = 3;
        _this.qx = 10;
        _this.qv = 30;
        _this.qy = 9;
        _this.nr = null;
        _this.ns = null;
        _this.nn = null;
        _this.applyCustomIndicators = null;
        _this.eo();
        _this.t6();
        return _this;
    }
    FinancialChart.prototype.fk = function (a, b, c) {
        _super.prototype.fk.call(this, a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.nv = new FinancialChartToolbar(this, this.rk);
                break;
            case "Toolbar":
                var d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.tu));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.tx));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.ty));
                    d.l(null);
                }
                if (this.nv != null) {
                    this.nv.af = this.n2;
                    this.nv.an = this.ai;
                    this.nv.ab = this.nx;
                    this.nv.aq = this.pr;
                    if (this.qr != null) {
                        this.nv.l(this.qr);
                    }
                    var e = this.nv;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.tu));
                    ;
                    var f = this.nv;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.tx));
                    var g = this.nv;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.ty));
                }
                break;
            case "ChartType":
                if (this.nv != null) {
                    this.nv.ab = this.nx;
                }
                break;
            case "VolumeType":
                if (this.nv != null) {
                    this.nv.af = this.n2;
                }
                break;
            case "TrendLineType":
                if (this.nv != null) {
                    this.nv.an = this.ai;
                }
                break;
            case "IsToolbarVisible":
                if (this.nv == null) {
                    break;
                }
                this.nv.aq = this.pr;
                this.setGridRows();
                break;
        }
    };
    FinancialChart.prototype.ty = function (a, b) {
        this.n2 = this.nv.af;
    };
    FinancialChart.prototype.tx = function (a, b) {
        this.ai = this.nv.an;
    };
    FinancialChart.prototype.tu = function (a, b) {
        this.nx = this.nv.ab;
    };
    FinancialChart.prototype.t6 = function () {
        this.om = new IndicatorPane();
    };
    FinancialChart.prototype.provideGrid = function (a) {
        this.qu = a;
        this.up();
        this.setGridRows();
        if (this.nv != null) {
            this.nv.bp(a);
        }
    };
    FinancialChart.prototype.onDocumentClick = function (a) {
        if (this.nv != null) {
            this.nv.bx(a);
        }
    };
    FinancialChart.prototype.pm = function () {
        return (navigator.userAgent.indexOf("Trident/7") >= 0);
    };
    FinancialChart.prototype.getContext = function () {
        var a = this.nv.w();
        var b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.cm;
        b.toolbarContainer = this.qr;
        b.indicatorsContainer = this.qq;
        b.volumeContainer = this.qs;
        b.zoomContainer = this.qt;
        return b;
    };
    FinancialChart.prototype.provideContainer = function (a) {
        var b = a;
        if (b != null) {
            var c = "financialChartMainGrid";
            var d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.nv == null) {
                this.nv = new FinancialChartToolbar(this, this.rk);
            }
            this.nv.x.isIndicatorPickerVisible = this.pi;
            this.nv.x.isOverlayPickerVisible = this.pj;
            this.qr = b.getSubRenderer(d);
            this.nv.l(this.qr);
            var e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            var f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.qq = b.getSubRenderer(f);
            var g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.qs = b.getSubRenderer(g);
            var h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.qt = b.getSubRenderer(h);
            a = b.getSubRenderer(e);
        }
        else {
            this.qr = null;
            if (this.nv != null) {
                this.nv.l(null);
            }
        }
        _super.prototype.provideContainer.call(this, a);
        if (this.volumeChart != null) {
            this.volumeChart.provideContainer(this.qs);
        }
        if (this.om != null) {
            this.om.h(this.qq);
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.provideContainer(this.qt);
            if (a != null) {
                this.th();
            }
            else {
                this.pc = null;
            }
        }
        this.setGridRows();
    };
    FinancialChart.prototype.ug = function (a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    };
    FinancialChart.prototype.ut = function (a, b) {
        this.ug(a, b, this.qt);
        if (b == null) {
            return;
        }
        this.th();
    };
    FinancialChart.prototype.th = function () {
        var _this = this;
        if (this.qt == null) {
            return;
        }
        this.pc = ZoomSliderWidget.a(this.externalObject, this.qt.rootWrapper);
        var a = this.pc;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, function (a, b) {
            if (_this.dataChart != null) {
                _this.dataChart.my = new Rect(0, _this.pc.r.left, _this.dataChart.mk.top, _this.pc.r.width, _this.dataChart.mk.height);
            }
        });
    };
    FinancialChart.prototype.ur = function (a, b) {
        this.ug(a, b, this.qs);
    };
    FinancialChart.prototype.setGridRows = function () {
        if (this.qu == null) {
            return;
        }
        var a = new Array(5);
        a[0] = (this.pr ? this.qi : 0) + "px";
        a[1] = "auto";
        a[2] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[3] = this.volumeChart == null ? "0px" : "100px";
        a[4] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.pc != null) {
            var b = this.pc;
            if (a[4] == "0px") {
                b.hide();
            }
            else {
                b.show();
            }
        }
        this.qu.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin.apply(void 0, tslib_1.__spread([" "], a)), "auto", "1fr"));
        this.qu.setStyleProperty("grid-template-rows", stringJoin.apply(void 0, tslib_1.__spread([" "], a)));
        if (this.cm == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.om != null) {
            this.om.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.pc != null) {
            this.pc.m();
        }
    };
    FinancialChart.prototype.e1 = function () {
        _super.prototype.e1.call(this);
        this.gq = 3;
        this.lt = 0;
        this.by = NaN;
        this.bw = 30;
        this.ay = true;
        this.a3 = false;
        if (this.dataChart != null) {
            var a = this.dataChart.bk.i.e();
            this.m6 = a.d;
            this.m7 = a.e;
            this.m5 = a.d;
        }
        var b = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(116, 70, 185, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(159, 179, 40, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(46, 156, 166, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(63, 81, 181, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(154, 154, 154, .3)";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "rgba(67, 156, 71, .3)";
            return $ret;
        })()));
        this.m8 = b;
        var c = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#7446B9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#9FB328";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#2E9CA6";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#3F51B5";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#9A9A9A";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#439C47";
            return $ret;
        })()));
        this.m9 = c;
    };
    FinancialChart.prototype.uc = function () {
        if (this.om != null) {
            this.om.b = null;
            this.om.b = this.indicatorCharts;
        }
        this.setGridRows();
    };
    FinancialChart.prototype.ud = function () {
        this.setGridRows();
    };
    FinancialChart.prototype.ul = function () {
        this.uc();
    };
    FinancialChart.prototype.t4 = function () {
        if (this.pc == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        var a = this.cm.rootWrapper.width();
        var b = this.dataChart.mx.left + this.dataChart.mx.width;
        var c = this.dataChart.mx.left;
        var d = a - b;
        this.pc.d = c - this.pc.f;
        this.pc.c = d - this.pc.e;
        if (this.pc.c < 0) {
            var e = this.pc.c;
            this.pc.c = 0;
            this.dataChart.ei += (e * -1);
        }
        if (this.pc.d < 0) {
            var f = this.pc.d;
            this.pc.d = 0;
            this.dataChart.eg += (f * -1);
        }
        this.zoomSliderChart.eg = c;
        this.zoomSliderChart.ei = d;
        this.zoomSliderChart.ec = this.pc.b;
    };
    FinancialChart.prototype.ey = function (a) {
        _super.prototype.ey.call(this, a);
        if (a != null) {
            a.eb = 0;
        }
    };
    FinancialChart.prototype.uu = function (a) {
        return a.md();
    };
    FinancialChart.prototype.uv = function (a) {
        if (a == null || a.d == null || a.d.rootWrapper == null) {
            return null;
        }
        var b = a.d.rootWrapper.getOffset();
        return new Rect(0, b.left, b.top, a.d.rootWrapper.width(), a.d.rootWrapper.height());
    };
    FinancialChart.prototype.qe = function () {
        if (this.qu == null) {
            return NaN;
        }
        var a = this.qu.getOffset();
        return this.qu.width() + (a == null ? 0 : a.left);
    };
    FinancialChart.prototype.e9 = function (source_, a, b) {
        _super.prototype.e9.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hu(source_, a, b);
        }
    };
    FinancialChart.prototype.fa = function (source_, a, b) {
        _super.prototype.fa.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hv(source_, a, b);
        }
    };
    FinancialChart.prototype.e8 = function (source_) {
        _super.prototype.e8.call(this, source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hr(source_);
        }
    };
    FinancialChart.prototype.fc = function (source_, a, b, c) {
        _super.prototype.fc.call(this, source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.hw(source_, a, b, c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "nv", {
        get: function () {
            return this.nu;
        },
        set: function (a) {
            var b = this.nv;
            if (a != b) {
                this.nu = a;
                this.fi("Toolbar", b, this.nv);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rj", {
        get: function () {
            return this.rc;
        },
        set: function (a) {
            var b = this.rj;
            if (a != b) {
                this.rc = a;
                this.fi("RangeSelectorTemplate", b, this.rj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rk", {
        get: function () {
            return this.rd;
        },
        set: function (a) {
            var b = this.rk;
            if (a != b) {
                this.rd = a;
                this.fi("ToolbarTemplate", b, this.rk);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rg", {
        get: function () {
            return this.q9;
        },
        set: function (a) {
            var b = this.rg;
            if (a != b) {
                this.q9 = a;
                this.fi("ChartTypePickerTemplate", b, this.rg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rl", {
        get: function () {
            return this.re;
        },
        set: function (a) {
            var b = this.rl;
            if (a != b) {
                this.re = a;
                this.fi("TrendLineTypePickerTemplate", b, this.rl);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rm", {
        get: function () {
            return this.rf;
        },
        set: function (a) {
            var b = this.rm;
            if (a != b) {
                this.rf = a;
                this.fi("VolumeTypePickerTemplate", b, this.rm);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "rh", {
        get: function () {
            return this.ra;
        },
        set: function (a) {
            var b = this.rh;
            if (a != b) {
                this.ra = a;
                this.fi("IndicatorPickerTemplate", b, this.rh);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ri", {
        get: function () {
            return this.rb;
        },
        set: function (a) {
            var b = this.ri;
            if (a != b) {
                this.rb = a;
                this.fi("OverlayPickerTemplate", b, this.ri);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pc", {
        get: function () {
            return this.pb;
        },
        set: function (a) {
            var b = this.pc;
            if (a != b) {
                this.pb = a;
                this.fi("ZoomSlider", b, this.pc);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_bw = function () {
        return _super.prototype.get_bw.call(this);
    };
    FinancialChart.prototype.set_bw = function (a) {
        _super.prototype.set_bw.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "bw", {
        get: function () {
            return this.get_bw();
        },
        set: function (a) {
            this.set_bw(a);
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_ay = function () {
        return _super.prototype.get_ay.call(this);
    };
    FinancialChart.prototype.set_ay = function (a) {
        _super.prototype.set_ay.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "ay", {
        get: function () {
            return this.get_ay();
        },
        set: function (a) {
            this.set_ay(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qi", {
        get: function () {
            return this.p8;
        },
        set: function (a) {
            var b = this.qi;
            if (a != b) {
                this.p8 = a;
                this.fi("ToolbarHeight", b, this.qi);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxis", {
        get: function () {
            return this.ne;
        },
        set: function (a) {
            var b = this.xAxis;
            if (a != b) {
                this.ne = a;
                this.fi("XAxis", b, this.xAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "yAxis", {
        get: function () {
            return this.or;
        },
        set: function (a) {
            var b = this.yAxis;
            if (a != b) {
                this.or = a;
                this.fi("YAxis", b, this.yAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeAxis", {
        get: function () {
            return this.oq;
        },
        set: function (a) {
            var b = this.volumeAxis;
            if (a != b) {
                this.oq = a;
                this.fi("VolumeAxis", b, this.volumeAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeXAxis", {
        get: function () {
            return this.nd;
        },
        set: function (a) {
            var b = this.volumeXAxis;
            if (a != b) {
                this.nd = a;
                this.fi("VolumeXAxis", b, this.volumeXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorAxis", {
        get: function () {
            return this.op;
        },
        set: function (a) {
            var b = this.indicatorAxis;
            if (a != b) {
                this.op = a;
                this.fi("IndicatorAxis", b, this.indicatorAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorXAxis", {
        get: function () {
            return this.nc;
        },
        set: function (a) {
            var b = this.indicatorXAxis;
            if (a != b) {
                this.nc = a;
                this.fi("IndicatorXAxis", b, this.indicatorXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p2", {
        get: function () {
            return this.pz;
        },
        set: function (a) {
            var b = this.p2;
            if (a != b) {
                this.pz = a;
                this.fi("IndicatorAxes", b, this.p2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "p4", {
        get: function () {
            return this.p1;
        },
        set: function (a) {
            var b = this.p4;
            if (a != b) {
                this.p1 = a;
                this.fi("IndicatorXAxes", b, this.p4);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.gj = function () {
        return this.xAxis;
    };
    FinancialChart.prototype.gk = function () {
        return this.yAxis;
    };
    FinancialChart.prototype.r = function (a) {
        return 20;
    };
    FinancialChart.prototype.get_ba = function () {
        return ((function () {
            var $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "ba", {
        get: function () {
            return this.get_ba();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_a9 = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "a9", {
        get: function () {
            return this.get_a9();
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.nh = function (a) {
        return this.ni(a);
    };
    FinancialChart.prototype.ot = function (a) {
        return this.ou(a);
    };
    FinancialChart.prototype.ng = function (a) {
        var b = this.nh(0);
        b.name = a;
        return b;
    };
    FinancialChart.prototype.em = function () {
        this.xAxis = this.ng("xAxis");
        this.yAxis = this.ot(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.ot(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.ng("volumeXAxis");
        this.indicatorAxis = this.ot(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.ng("indicatorXAxis");
        this.p2 = new List$1(NumericYAxis.$, 0);
        this.p4 = new List$1(CategoryAxisBase.$, 0);
        this.p2.add(this.indicatorAxis);
        this.p4.add(this.indicatorXAxis);
        if (this.xAxis.as == null) {
            this.xAxis.as = new AxisLabelSettings();
        }
        if (this.yAxis.as == null) {
            this.yAxis.as = new AxisLabelSettings();
        }
        if (this.volumeAxis.as == null) {
            this.volumeAxis.as = new AxisLabelSettings();
        }
        if (this.volumeXAxis.as == null) {
            this.volumeAxis.as = new AxisLabelSettings();
        }
        if (this.indicatorAxis.as == null) {
            this.indicatorAxis.as = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.as == null) {
            this.indicatorXAxis.as = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.ot(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.ng("zoomSliderXAxis");
        if (this.zoomSliderAxis.as == null) {
            this.zoomSliderAxis.as = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.as == null) {
            this.zoomSliderXAxis.as = new AxisLabelSettings();
        }
        this.lb(this.zoomSliderAxis, function (a) { return a.visibility = 1; });
        this.lb(this.zoomSliderXAxis, function (a) { return a.visibility = 1; });
    };
    FinancialChart.prototype.f1 = function (a) {
        _super.prototype.f1.call(this, a);
        a.hc();
    };
    FinancialChart.prototype.ek = function (a, b) {
        var c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.lg = this.ad(a, b);
        }
    };
    FinancialChart.prototype.fw = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.i5 = true;
            this.yAxis.js = 10;
        }
    };
    FinancialChart.prototype.fz = function () {
        this.yAxis.i5 = this.pw;
        this.yAxis.js = this.q8;
    };
    FinancialChart.prototype.nz = function () {
        var a;
        if (this.nx == 0) {
            if (this.s == null || this.s.dataSeries == null || this.s.dataSeries.count == 0 || stringIsNullOrEmpty(this.s.dataSeries._inner[0].getMemberPathFor(12))) {
                a = 4;
            }
            else {
                a = 1;
            }
        }
        else {
            a = this.nx;
        }
        a = this.ny(a);
        return a;
    };
    FinancialChart.prototype.ny = function (a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.n8 = function (a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.n1 = function (a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.rt = function (a) {
        var b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    };
    FinancialChart.prototype.o5 = function (seriesType_) {
        return (this.externalObject.createSeries(seriesType_).i);
    };
    FinancialChart.prototype.ni = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.ou = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.o0 = function () {
        return this.o5(1);
    };
    FinancialChart.prototype.o1 = function () {
        return this.o5(0);
    };
    FinancialChart.prototype.oz = function () {
        return this.o5(2);
    };
    FinancialChart.prototype.o2 = function () {
        return this.o5(20);
    };
    Object.defineProperty(FinancialChart.prototype, "ph", {
        get: function () {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "oh", {
        get: function () {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pk", {
        get: function () {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "of", {
        get: function () {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pi", {
        get: function () {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "oj", {
        get: function () {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pj", {
        get: function () {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "oo", {
        get: function () {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.ag = function (a, b) {
        var c = this.rt(a);
        switch (this.nz()) {
            case 3:
                var d = this.o0();
                this.oh.setValueMemberPath(d, c);
                this.oh.setXAxis(d, this.xAxis);
                this.oh.setYAxis(d, this.yAxis);
                this.oh.setCategoryMode(d, 1);
                return d;
            case 4:
                var e = this.o1();
                this.oh.setValueMemberPath(e, c);
                this.oh.setXAxis(e, this.xAxis);
                this.oh.setYAxis(e, this.yAxis);
                this.oh.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                var f = this.o2();
                this.of.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.of.setHighMemberPath(f, a.getMemberPathFor(12));
                this.of.setLowMemberPath(f, a.getMemberPathFor(13));
                this.of.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.of.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.of.setXAxis(f, this.xAxis);
                this.of.setYAxis(f, this.yAxis);
                this.of.setDisplayType(f, this.nx == 2 ? 0 : 1);
                this.of.setCategoryMode(f, 1);
                return f;
        }
    };
    FinancialChart.prototype.fy = function () {
        _super.prototype.fy.call(this);
        this.t2(this.xAxis);
        this.un(false);
        if (this.n2 != 0 && this.volumeChart != null) {
            this.t8();
        }
        this.t2(this.volumeXAxis);
        this.t2(this.indicatorXAxis);
        this.uk();
        this.um();
        if (this.n9 != 0) {
            this.t9();
            this.t2(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.lh = function (a) {
        _super.prototype.lh.call(this, a);
        a(this.volumeXAxis);
        if (this.p4 != null) {
            try {
                for (var _a = tslib_1.__values(fromEnum(this.p4)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var b = _b.value;
                    a(b);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        a(this.zoomSliderXAxis);
        var e_1, _c;
    };
    FinancialChart.prototype.ll = function (a, b) {
        _super.prototype.ll.call(this, a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.p2 != null) {
                try {
                    for (var _a = tslib_1.__values(fromEnum(this.p2)), _b = _a.next(); !_b.done; _b = _a.next()) {
                        var c = _b.value;
                        a(c);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
            a(this.zoomSliderAxis);
        }
        var e_2, _c;
    };
    FinancialChart.prototype.lj = function (a) {
        _super.prototype.lj.call(this, a);
        this.lc(this.volumeXAxis, a);
        this.lc(this.indicatorXAxis, a);
        this.lc(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.ln = function (a) {
        _super.prototype.ln.call(this, a);
        this.lc(this.volumeAxis, a);
        this.lc(this.indicatorAxis, a);
        this.lc(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.lm = function (a) {
        _super.prototype.lm.call(this, a);
        this.lb(this.volumeAxis, a);
        this.lb(this.indicatorAxis, a);
        this.lb(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.li = function (a) {
        _super.prototype.li.call(this, a);
        this.lb(this.volumeXAxis, a);
        this.lb(this.indicatorXAxis, a);
        this.lb(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.ex = function (a) {
        var _this = this;
        _super.prototype.ex.call(this, a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.nl = a.nn = false;
            a.ay = null;
        }
        else {
            SyncManager.d(a, ((function () {
                var $ret = new SyncSettings();
                $ret.ae = _this.sm();
                $ret.ac = true;
                $ret.ad = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.bc = 2;
    };
    FinancialChart.prototype.sm = function () {
        if (this.rn == null) {
            FinancialChart.q7++;
            this.rn = FinancialChart.q7.toString();
        }
        return this.rn;
    };
    FinancialChart.prototype.to = function (a, b) {
        this.tf();
        this.t4();
    };
    FinancialChart.prototype.tf = function () {
        if (this.yAxis.br()) {
            return;
        }
        var a = this.yAxis.ap.a5;
        if (this.n2 != 0) {
            a = Math.max(a, this.volumeAxis.ap.a5);
        }
        try {
            for (var _a = tslib_1.__values(fromEnum(this.p2)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                a = Math.max(a, b.ap.a5);
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_3) throw e_3.error; }
        }
        this.yAxis.ds = this.volumeAxis.ds = a;
        try {
            for (var _d = tslib_1.__values(fromEnum(this.p2)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var c = _e.value;
                c.ds = a;
            }
        }
        catch (e_4_1) { e_4 = { error: e_4_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
            }
            finally { if (e_4) throw e_4.error; }
        }
        this.zoomSliderAxis.ds = this.yAxis.ds;
        var e_3, _c, e_4, _f;
    };
    FinancialChart.prototype.ti = function (a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (var b = 0; b < this.indicatorCharts.count; b++) {
            var c = this.indicatorCharts._inner[b];
            for (var d = 0; d < c.series.count; d++) {
                a(c.series._inner[d], b);
            }
        }
    };
    FinancialChart.prototype.tk = function (a) {
        if (this.volumeChart == null) {
            return;
        }
        for (var b = 0; b < this.volumeChart.series.count; b++) {
            a(this.volumeChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.tj = function (a) {
        if (this.dataChart == null) {
            return;
        }
        var b = this.s == null || this.s.dataSeries == null ? 0 : this.s.dataSeries.count;
        var c = this.od == null ? 0 : this.od.count;
        for (var d = 0; d < this.dataChart.series.count; d++) {
            if (this.po(this.dataChart.series._inner[d])) {
                continue;
            }
            var e = d - (b * c);
            a(this.dataChart.series._inner[d], e);
        }
    };
    FinancialChart.prototype.q1 = function (a, b) {
        if (a.bp != this.dataChart) {
            return b;
        }
        var c = this.s == null || this.s.dataSeries == null ? 0 : this.s.dataSeries.count;
        var d = this.od == null ? 0 : this.od.count;
        return b - (c * d);
    };
    FinancialChart.prototype.er = function (a) {
        _super.prototype.er.call(this, a);
        this.tk(a);
        this.ti(a);
    };
    Object.defineProperty(FinancialChart.prototype, "volumeChart", {
        get: function () {
            return this.o7;
        },
        set: function (a) {
            var b = this.volumeChart;
            if (a != b) {
                this.o7 = a;
                this.fi("VolumeChart", b, this.volumeChart);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.t8 = function () {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        var a = new List$1(Series.$, 0);
        var b = -1;
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.po(d)) {
                continue;
            }
            b++;
            var e = void 0;
            var f = this.n2;
            f = this.n1(f);
            switch (f) {
                case 2:
                    e = this.o1();
                    break;
                case 3:
                    e = this.oz();
                    break;
                default:
                case 1:
                    e = this.o0();
                    break;
            }
            this.oh.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.oh.setXAxis(e, this.volumeXAxis);
            this.oh.setYAxis(e, this.volumeAxis);
            this.oh.setValueMemberPath(e, this.s != null && this.s.dataSeries != null && this.s.dataSeries.count > b ? this.s.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.fj = d.fj + " Volume";
            e.kk = ArrayExtension.getModulus$1(Brush.$, this.na, b);
            e.kn = ArrayExtension.getModulus$1(Brush.$, this.nb, b);
            e.en = this.qj;
            a.add(e);
        }
        for (var g = 0; g < a.count; g++) {
            var h = a._inner[g];
            this.volumeChart.series.add(h);
            this.e2(h, g);
        }
    };
    FinancialChart.prototype.pl = function (a) {
        if (!this.ph) {
            return false;
        }
        return this.oh.matchesType(a);
    };
    FinancialChart.prototype.pp = function (a) {
        if (!this.pk) {
            return false;
        }
        return this.of.matchesType(a);
    };
    FinancialChart.prototype.pn = function (a) {
        if (!this.pi) {
            return false;
        }
        return this.oj.matchesType(a);
    };
    FinancialChart.prototype.po = function (a) {
        if (!this.pj) {
            return false;
        }
        return this.oo.matchesType(a);
    };
    FinancialChart.prototype.t7 = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = 0;
        var b = this.ob == null ? 0 : this.ob.count;
        var c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var d = b + c;
        for (var e = 0; e < d; e++) {
            var f = new List$1(Series.$, 0);
            var g = this.indicatorCharts._inner[e];
            var h = e >= b;
            var i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.ob._inner[e]);
            var j = -1;
            for (var k = 0; k < this.dataChart.series.count; k++) {
                var l = this.dataChart.series._inner[k];
                if (this.po(l)) {
                    continue;
                }
                j++;
                var m = void 0;
                if (h) {
                    var n = this.o3("Custom");
                    this.oj.handleCustomIndicatorEvent(n, runOn(this, this.tm));
                    m = n;
                }
                else {
                    m = this.o6(this.ob._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.oj.setXAxis(m, this.p4._inner[e]);
                this.oj.setYAxis(m, this.p2._inner[e]);
                m.itemsSource = l.itemsSource;
                this.oj.setOpenMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(11));
                this.oj.setHighMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(12));
                this.oj.setLowMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(13));
                this.oj.setCloseMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(14));
                this.oj.setVolumeMemberPath(m, this.s.dataSeries._inner[j].getMemberPathFor(15));
                m.fj = l.fj + " " + i;
                m.kk = ArrayExtension.getModulus$1(Brush.$, this.m4, e);
                m.en = this.qg;
                if (this.pn(m)) {
                    this.oj.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.m5, e));
                    this.oj.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.ol, e));
                }
                if (this.q3 != -2147483648 && this.pn(m)) {
                    this.oj.setPeriodOverride(m, this.q3);
                }
                if (this.pn(m)) {
                    this.oj.setSmoothingPeriod(m, this.q6);
                }
                if (this.pn(m)) {
                    this.oj.setSignalPeriod(m, this.q5);
                }
                if (this.pn(m)) {
                    this.oj.setShortPeriod(m, this.q4);
                    this.oj.setLongPeriod(m, this.q2);
                }
                this.e2(m, e);
                f.add(m);
            }
            try {
                for (var _a = tslib_1.__values(fromEnum(f)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var o = _b.value;
                    g.series.add(o);
                }
            }
            catch (e_5_1) { e_5 = { error: e_5_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_5) throw e_5.error; }
            }
        }
        var e_5, _c;
    };
    FinancialChart.prototype.o3 = function (indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    };
    FinancialChart.prototype.o6 = function (a) {
        return this.o3(EnumUtil.getName(FinancialIndicatorType_$type, a));
    };
    FinancialChart.prototype.un = function (a) {
        if (this.nv == null) {
            return;
        }
        var b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.nv.ax = b.actualMinimumValue;
        this.nv.aw = b.actualMaximumValue;
        if (a) {
            this.nv.az = b.visibleMinimum;
            this.nv.ay = b.visibleMaximum;
        }
        this.nv.bz();
    };
    FinancialChart.prototype.cn = function () {
        var _this = this;
        var a = ((function () {
            var $ret = new FinancialChartVisualData();
            $ret.mainChart = _super.prototype.cn.call(_this);
            $ret.volumeChart = _this.volumeChart == null ? null : _this.volumeChart.n8();
            $ret.toolbar = _this.nv == null ? null : _this.nv.ao();
            $ret.zoomChart = _this.zoomSliderChart == null ? null : _this.zoomSliderChart.n8();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            try {
                for (var _a = tslib_1.__values(fromEnum(this.indicatorCharts)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var b = _b.value;
                    a.indicatorCharts.add1(b.n8());
                }
            }
            catch (e_6_1) { e_6 = { error: e_6_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_6) throw e_6.error; }
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.uu(this.dataChart).x;
            a.mainChartTop = this.uu(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.uu(this.volumeChart).x;
            a.volumeChartTop = this.uu(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.uu(this.zoomSliderChart).x;
            a.zoomChartTop = this.uu(this.zoomSliderChart).y;
        }
        if (this.nv != null) {
            var c = this.uv(this.nv);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            try {
                for (var _d = tslib_1.__values(fromEnum(this.indicatorCharts)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var d = _e.value;
                    a.indicatorChartLefts.add(this.uu(d).x);
                    a.indicatorChartTops.add(this.uu(d).y);
                }
            }
            catch (e_7_1) { e_7 = { error: e_7_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                }
                finally { if (e_7) throw e_7.error; }
            }
        }
        return a;
        var e_6, _c, e_7, _f;
    };
    FinancialChart.prototype.rs = function () {
        var a = this.cn();
        a.scaleByViewport();
        return a.serialize();
    };
    FinancialChart.prototype.o4 = function (overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    };
    FinancialChart.prototype.um = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = new List$1(Series.$, 0);
        try {
            for (var _a = tslib_1.__values(fromEnum(this.dataChart.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                if (this.po(b)) {
                    a.add(b);
                }
            }
        }
        catch (e_8_1) { e_8 = { error: e_8_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_8) throw e_8.error; }
        }
        try {
            for (var _d = tslib_1.__values(fromEnum(a)), _e = _d.next(); !_e.done; _e = _d.next()) {
                var c = _e.value;
                this.dataChart.series.remove(c);
            }
        }
        catch (e_9_1) { e_9 = { error: e_9_1 }; }
        finally {
            try {
                if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
            }
            finally { if (e_9) throw e_9.error; }
        }
        if (this.od == null) {
            return;
        }
        var d = new List$1(Series.$, 0);
        for (var e = 0; e < this.dataChart.series.count; e++) {
            var f = this.dataChart.series._inner[e];
            for (var g = 0; g < this.od.count; g++) {
                var h = this.od._inner[g];
                var i = void 0;
                switch (h) {
                    case 1:
                        i = this.o4(EnumUtil.getName(FinancialOverlayType_$type, h));
                        break;
                    default:
                    case 0:
                        i = this.o4(EnumUtil.getName(FinancialOverlayType_$type, h));
                        break;
                }
                i.name = f.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, h);
                this.oo.setXAxis(i, this.xAxis);
                this.oo.setYAxis(i, this.yAxis);
                i.itemsSource = f.itemsSource;
                var j = e * this.od.count + g;
                i.kk = ArrayExtension.getModulus$1(Brush.$, this.m8, j);
                i.kn = ArrayExtension.getModulus$1(Brush.$, this.m9, j);
                i.en = this.qh;
                i.fj = f.fj + " " + EnumUtil.getName(FinancialOverlayType_$type, h);
                var k = f;
                if (k == null) {
                    continue;
                }
                this.oo.setOpenMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(11));
                this.oo.setHighMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(12));
                this.oo.setLowMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(13));
                this.oo.setCloseMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(14));
                this.oo.setVolumeMemberPath(i, this.s.dataSeries._inner[e].getMemberPathFor(15));
                d.add(i);
            }
        }
        var l = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(l, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (var m = 0; m < l.length; m++) {
            l[m].e6 = -1;
        }
        d.o(l);
        try {
            for (var _g = tslib_1.__values(fromEnum(d)), _h = _g.next(); !_h.done; _h = _g.next()) {
                var n = _h.value;
                this.dataChart.series.add(n);
            }
        }
        catch (e_10_1) { e_10 = { error: e_10_1 }; }
        finally {
            try {
                if (_h && !_h.done && (_j = _g.return)) _j.call(_g);
            }
            finally { if (e_10) throw e_10.error; }
        }
        var e_8, _c, e_9, _f, e_10, _j;
    };
    FinancialChart.prototype.uk = function () {
        if (this.pu) {
            return;
        }
        this.pu = true;
        if (this.indicatorCharts != null) {
            var a = this.indicatorCharts;
            this.indicatorCharts = null;
            try {
                for (var _a = tslib_1.__values(fromEnum(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var b = _b.value;
                    this.t3(b);
                }
            }
            catch (e_11_1) { e_11 = { error: e_11_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_11) throw e_11.error; }
            }
        }
        if ((this.ob == null || this.ob.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            this.uc();
            this.ul();
            this.pu = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.p2.clear();
        this.p4.clear();
        var c = this.ob == null ? 0 : this.ob.count;
        var d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var e = c + d;
        for (var f = 0; f < e; f++) {
            var g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.t1(g);
            var h = f >= c;
            g.gm = h ? this.customIndicatorNames._inner[f - c] : EnumUtil.getName(FinancialIndicatorType_$type, this.ob._inner[f]);
            if (this.indicatorAxis != null) {
                var i = void 0;
                var j = void 0;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.bw) {
                        j = this.nh(0);
                    }
                    else {
                        j = this.nh(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.p2.add(i);
                this.p4.add(j);
                if (this.aw) {
                    this.lf(i);
                }
                if (this.aw) {
                    this.ld(j);
                }
            }
        }
        this.t7();
        this.uc();
        if (this.nv != null) {
            this.nv.aj = this.ob;
        }
        this.tg();
        this.ul();
        this.pu = false;
        var e_11, _c;
    };
    FinancialChart.prototype.eu = function () {
        _super.prototype.eu.call(this);
        this.ld(this.xAxis);
        this.ld(this.volumeXAxis);
        if (this.p4 != null) {
            try {
                for (var _a = tslib_1.__values(fromEnum(this.p4)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var a = _b.value;
                    this.ld(a);
                }
            }
            catch (e_12_1) { e_12 = { error: e_12_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_12) throw e_12.error; }
            }
        }
        this.lf(this.yAxis);
        this.lf(this.volumeAxis);
        if (this.p2 != null) {
            try {
                for (var _d = tslib_1.__values(fromEnum(this.p2)), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var b = _e.value;
                    this.lf(b);
                }
            }
            catch (e_13_1) { e_13 = { error: e_13_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                }
                finally { if (e_13) throw e_13.error; }
            }
        }
        var e_12, _c, e_13, _f;
    };
    FinancialChart.prototype.get_a2 = function () {
        return !this.ps;
    };
    Object.defineProperty(FinancialChart.prototype, "a2", {
        get: function () {
            return this.get_a2();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "py", {
        get: function () {
            return (this.externalObject._dynamicContent);
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.us = function (a, b) {
        this.uf(a, b);
        this.tg();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.t9();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.ud();
        this.ut(a, b);
    };
    FinancialChart.prototype.t9 = function () {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        var a = new List$1(Series.$, 0);
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            var d = void 0;
            var e = this.n9;
            e = this.n8(e);
            switch (e) {
                case 1:
                    d = this.o2();
                    this.of.setDisplayType(d, 1);
                    break;
                case 2:
                    d = this.o2();
                    this.of.setDisplayType(d, 0);
                    break;
                case 4:
                    d = this.o1();
                    break;
                case 5:
                    d = this.oz();
                    break;
                default:
                case 3:
                    d = this.o0();
                    break;
            }
            if (d.cj && !d.cp) {
                this.oh.setCategoryMode(d, 1);
                this.oh.setXAxis(d, this.zoomSliderXAxis);
                this.oh.setYAxis(d, this.zoomSliderAxis);
                this.oh.setValueMemberPath(d, this.s != null && this.s.dataSeries != null && this.s.dataSeries.count > b ? this.rt(this.s.dataSeries._inner[b]) : null);
            }
            else if (d.cp) {
                this.of.setCategoryMode(d, 1);
                this.of.setXAxis(d, this.zoomSliderXAxis);
                this.of.setYAxis(d, this.zoomSliderAxis);
                if (this.s != null && this.s.dataSeries != null && this.s.dataSeries.count > b) {
                    this.of.setOpenMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(11));
                    this.of.setHighMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(12));
                    this.of.setLowMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(13));
                    this.of.setCloseMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(14));
                    this.of.setVolumeMemberPath(d, this.s.dataSeries._inner[b].getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + b;
            d.itemsSource = c.itemsSource;
            d.fj = c.fj;
            a.add(d);
        }
        try {
            for (var _a = tslib_1.__values(fromEnum(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var f = _b.value;
                this.zoomSliderChart.series.add(f);
            }
        }
        catch (e_14_1) { e_14 = { error: e_14_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_14) throw e_14.error; }
        }
        var e_14, _c;
    };
    FinancialChart.prototype.ff = function (a, b) {
        _super.prototype.ff.call(this, a, b);
        if (a == null || !b) {
            return;
        }
        if (this.indicatorCharts != null) {
            try {
                for (var _a = tslib_1.__values(fromEnum(this.indicatorCharts)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var c = _b.value;
                    a(c);
                }
            }
            catch (e_15_1) { e_15 = { error: e_15_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_15) throw e_15.error; }
            }
        }
        if (this.volumeChart != null) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
        var e_15, _c;
    };
    FinancialChart.prototype.tm = function (a, b) {
        var c = b;
        var d = a;
        var e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.bp);
        }
        e -= this.ob == null ? 0 : this.ob.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    };
    FinancialChart.prototype.ld = function (a) {
        _super.prototype.ld.call(this, a);
        var b = a;
        this.t2(b);
        if (a.a7 != null) {
            try {
                for (var _a = tslib_1.__values(fromEnum(a.a7.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var c = _b.value;
                    if (this.pl(c)) {
                        this.oh.setXAxis(c, b);
                    }
                    else if (this.pp(c)) {
                        this.of.setXAxis(c, b);
                    }
                    else if (this.pn(c)) {
                        this.oj.setXAxis(c, b);
                    }
                    else if (this.po(c)) {
                        this.oo.setXAxis(c, b);
                    }
                }
            }
            catch (e_16_1) { e_16 = { error: e_16_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_16) throw e_16.error; }
            }
        }
        var e_16, _c;
    };
    FinancialChart.prototype.lf = function (a) {
        _super.prototype.lf.call(this, a);
        if (a.a7 != null) {
            try {
                for (var _a = tslib_1.__values(fromEnum(a.a7.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                    var b = _b.value;
                    if (this.pl(b)) {
                        this.oh.setYAxis(b, this.yAxis);
                    }
                    else if (this.pp(b)) {
                        this.of.setYAxis(b, this.yAxis);
                    }
                    else if (this.pn(b)) {
                        this.oj.setYAxis(b, this.yAxis);
                    }
                    else if (this.po(b)) {
                        this.oo.setYAxis(b, this.yAxis);
                    }
                }
            }
            catch (e_17_1) { e_17 = { error: e_17_1 }; }
            finally {
                try {
                    if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                }
                finally { if (e_17) throw e_17.error; }
            }
        }
        a.i0 = this.pv;
        a.jo = this.qo;
        a.jn = this.qn;
        a.jk = this.qm;
        var e_17, _c;
    };
    FinancialChart.prototype.t2 = function (a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.er = XYChart.i7(a, this.s.dataSeries);
        if (this.s.dataSeries.count > 0) {
            var b = this.s.dataSeries._inner[0].getMemberPathFor(17);
            a.f9(b);
        }
    };
    FinancialChart.prototype.e2 = function (a, b) {
        _super.prototype.e2.call(this, a, b);
        if (a == null) {
            return;
        }
        var c = this.dataChart != null && this.dataChart.series.contains(a);
        if (c && a.cx) {
            a.iy(this.m6 != null ? ArrayExtension.getModulus$1(Brush.$, this.m6, b) : null, this.m7 != null ? ArrayExtension.getModulus$1(Brush.$, this.m7, b) : null);
        }
        if (this.po(a)) {
            a.kk = this.m8 != null ? ArrayExtension.getModulus$1(Brush.$, this.m8, b) : null;
            a.kn = this.m9 != null ? ArrayExtension.getModulus$1(Brush.$, this.m9, b) : null;
            a.en = this.qh;
        }
        else if (this.pn(a)) {
            a.kk = this.m4 != null ? ArrayExtension.getModulus$1(Brush.$, this.m4, b) : null;
            a.en = this.qg;
        }
        else if (c) {
            a.kk = this.j != null ? ArrayExtension.getModulus$1(Brush.$, this.j, b) : null;
            a.kn = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, b) : null;
        }
        var d = this.volumeChart != null && this.volumeChart.series.count > b && this.volumeChart.series._inner[b] == a;
        if (d) {
            a.en = this.qj;
        }
    };
    FinancialChart.prototype.fi = function (a, b, c) {
        var _this = this;
        _super.prototype.fi.call(this, a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.i5 = this.pw;
                break;
            case "YAxisLogarithmBase":
                this.yAxis.js = this.q8;
                break;
            case "VolumeType":
                var d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.n2 == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((function () {
                        var $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.t8();
                }
                break;
            case "VolumeChart":
                this.uq(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    var e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.to));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.tl));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.tt));
                }
                if (this.dataChart != null) {
                    var f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.to));
                    var g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.tl));
                    var h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.tt));
                }
                this.up();
                break;
            case "XAxisMode":
                this.xAxis = this.nh(this.n4);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.nh(this.n4);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.nh(this.n4);
                this.indicatorXAxis.name = "indicatorXAxis";
                this.zoomSliderXAxis = this.nh(this.n4);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.lb(this.zoomSliderXAxis, function (i) { return i.visibility = 1; });
                this.tg();
                break;
            case "YAxisMode":
                this.yAxis = this.ot(this.n6);
                this.yAxis.name = "yAxis";
                break;
            case "Toolbar":
                var i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.ts));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.tv));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.tw));
                }
                if (this.nv != null) {
                    this.nv.aj = this.ob;
                    this.nv.al = this.od;
                    this.nv.v = this.ns;
                    this.un(true);
                    var j = this.nv;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.ts));
                    var k = this.nv;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.tv));
                    var l = this.nv;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.tw));
                }
                break;
            case "XAxis":
                var m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                var n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.actualRangeChanged = delegateRemove(n.actualRangeChanged, runOn(this, this.tz));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.aw) {
                    this.ld(this.xAxis);
                    this.ep();
                }
                this.un(false);
                this.uo();
                if (typeCast(ITimeRangeSelectorAxis_$type, this.xAxis) !== null) {
                    var o = this.xAxis;
                    o.actualRangeChanged = delegateCombine(o.actualRangeChanged, runOn(this, this.tz));
                }
                break;
            case "ChartType":
                this.fy();
                break;
            case "VolumeXAxis":
                this.uh(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.uh(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.uk();
                break;
            case "YAxis":
                var p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.aw) {
                    this.lf(this.yAxis);
                    this.lf(this.yAxis);
                }
                var q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.t0));
                break;
            case "VolumeAxis":
                var r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.aw) {
                    this.lf(this.volumeAxis);
                }
                var s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.t0));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (var t = 0; t < this.indicatorCharts.count; t++) {
                        var u = this.indicatorCharts._inner[t];
                        var v = new List$1(Axis.$, 0);
                        try {
                            for (var _a = tslib_1.__values(fromEnum(u.axes)), _b = _a.next(); !_b.done; _b = _a.next()) {
                                var w = _b.value;
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                        }
                        catch (e_18_1) { e_18 = { error: e_18_1 }; }
                        finally {
                            try {
                                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                            }
                            finally { if (e_18) throw e_18.error; }
                        }
                        try {
                            for (var _d = tslib_1.__values(fromEnum(v)), _e = _d.next(); !_e.done; _e = _d.next()) {
                                var x = _e.value;
                                u.axes.remove(x);
                            }
                        }
                        catch (e_19_1) { e_19 = { error: e_19_1 }; }
                        finally {
                            try {
                                if (_e && !_e.done && (_f = _d.return)) _f.call(_d);
                            }
                            finally { if (e_19) throw e_19.error; }
                        }
                        var y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.n6 == 1) {
                            y = this.ot(this.n6);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.aw) {
                            this.lf(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.nn = this.a3 && this.a2;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.nn = this.a3 && this.a2;
                }
                if (this.ps) {
                    this.ui(this.dataChart);
                }
                break;
            case "IndicatorTypes":
                var z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.tp));
                }
                var aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.tp));
                }
                this.uk();
                break;
            case "OverlayTypes":
                var ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.tq));
                }
                var ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.tq));
                }
                this.um();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.lk(function (ad) { return ad.i0 = _this.pv; });
                break;
            case "YAxisMinimumValue":
                this.ll(function (ad) { return ad.jo = _this.qo; }, false);
                break;
            case "YAxisMaximumValue":
                this.ll(function (ad) { return ad.jn = _this.qn; }, false);
                break;
            case "YAxisInterval":
                this.ll(function (ad) { return ad.jk = _this.qm; }, false);
                break;
            case "ZoomSliderType":
                this.up();
                break;
            case "ZoomSliderChart":
                if (!this.px) {
                    return;
                }
                this.us(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.tj(function (ad, ae) {
                    if (ad.cx) {
                        ad.iy(_this.m6 != null ? ArrayExtension.getModulus$1(Brush.$, _this.m6, ae) : null, _this.m7 != null ? ArrayExtension.getModulus$1(Brush.$, _this.m7, ae) : null);
                    }
                });
                break;
            case "OverlayBrushes":
                this.er(function (ad, ae) {
                    if (!(_this.po(ad))) {
                        return;
                    }
                    ad.kk = _this.m8 != null ? ArrayExtension.getModulus$1(Brush.$, _this.m8, ae) : null;
                });
                break;
            case "OverlayOutlines":
                this.er(function (ad, ae) {
                    if (!(_this.po(ad))) {
                        return;
                    }
                    ad.kn = _this.m9 != null ? ArrayExtension.getModulus$1(Brush.$, _this.m9, ae) : null;
                });
                break;
            case "OverlayThickness":
                this.er(function (ad, ae) {
                    if (!(_this.po(ad))) {
                        return;
                    }
                    ad.en = _this.qh;
                });
                break;
            case "VolumeBrushes":
                this.tk(function (ad, ae) { return ad.kk = ArrayExtension.getModulus$1(Brush.$, _this.na, ae); });
                break;
            case "VolumeOutlines":
                this.tk(function (ad, ae) { return ad.kn = ArrayExtension.getModulus$1(Brush.$, _this.nb, ae); });
                break;
            case "VolumeThickness":
                this.tk(function (ad, ae) { return ad.en = _this.qj; });
                break;
            case "IndicatorNegativeBrushes":
                this.ti(function (ad, ae) { return _this.oj.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, _this.m5, ae)); });
                break;
            case "IndicatorBrushes":
                this.ti(function (ad, ae) { return ad.kk = ArrayExtension.getModulus$1(Brush.$, _this.m4, ae); });
                break;
            case "IndicatorThickness":
                this.ti(function (ad, ae) { return ad.en = _this.qg; });
                break;
            case "IndicatorDisplayTypes":
                this.ti(function (ad, ae) { return _this.oj.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, _this.ol, ae)); });
                break;
            case "IndicatorPeriod":
                this.ti(function (ad, ae) {
                    if (_this.q3 == -2147483648 || !(_this.pn(ad))) {
                        return;
                    }
                    _this.oj.setPeriodOverride(ad, _this.q3);
                });
                break;
            case "IndicatorMultiplier":
                this.ti(function (ad, ae) {
                    if (!(_this.po(ad))) {
                        return;
                    }
                    _this.oo.setMultiplier(ad, _this.qf);
                });
                break;
            case "IndicatorSmoothingPeriod":
                this.ti(function (ad, ae) {
                    if (!(_this.pn(ad))) {
                        return;
                    }
                    _this.oj.setSmoothingPeriod(ad, _this.q6);
                });
                break;
            case "IndicatorShortPeriod":
                this.ti(function (ad, ae) {
                    if (!(_this.pn(ad))) {
                        return;
                    }
                    _this.oj.setShortPeriod(ad, _this.q4);
                });
                break;
            case "IndicatorLongPeriod":
                this.ti(function (ad, ae) {
                    if (!(_this.pn(ad))) {
                        return;
                    }
                    _this.oj.setLongPeriod(ad, _this.q2);
                });
                break;
            case "IndicatorSignalPeriod":
                this.ti(function (ad, ae) {
                    if (!(_this.pn(ad))) {
                        return;
                    }
                    _this.oj.setSignalPeriod(ad, _this.q5);
                });
                break;
            case "RangeSelectorOptions":
                var ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.tr));
                }
                if (this.nt != null) {
                    var ae = this.nt;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.tr));
                }
                this.ub();
                break;
            case "CustomIndicatorNames":
                var af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.tn));
                }
                if (this.customIndicatorNames != null) {
                    var ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.tn));
                }
                this.uk();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.ay = null;
                }
                break;
            case "Brushes":
                this.tj(function (ah, ai) {
                    if (_this.po(ah)) {
                        return;
                    }
                    ah.kk = _this.j != null ? ArrayExtension.getModulus$1(Brush.$, _this.j, ai) : null;
                });
                break;
            case "Outlines":
                this.tj(function (ah, ai) {
                    if (_this.po(ah)) {
                        return;
                    }
                    ah.kn = _this.n != null ? ArrayExtension.getModulus$1(Brush.$, _this.n, ai) : null;
                });
                break;
            case "XAxisLabelVisibility":
                if (this.mu != 0 || this.zoomSliderXAxis == null) {
                    break;
                }
                this.lb(this.zoomSliderXAxis, function (ah) { return ah.visibility = 1; });
                break;
            case "YAxisLabelVisibility":
                if (this.mv != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.lb(this.zoomSliderAxis, function (ah) { return ah.visibility = 1; });
                break;
        }
        var e_18, _c, e_19, _f;
    };
    FinancialChart.prototype.uh = function (a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.aw) {
            this.ld(c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "px", {
        get: function () {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.tn = function (a, b) {
        this.uk();
    };
    FinancialChart.prototype.pq = function (a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    };
    FinancialChart.prototype.ub = function () {
        var a = this.nt != null ? this.nt : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        var b = new FinancialChartRangeSelectorOptionCollection(0);
        var c = this.xAxis;
        var d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        try {
            for (var _a = tslib_1.__values(fromEnum(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var e = _b.value;
                if (this.pq(e, d)) {
                    b.add(e);
                }
            }
        }
        catch (e_20_1) { e_20 = { error: e_20_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_20) throw e_20.error; }
        }
        this.ns = b;
        if (this.nv != null) {
            this.nv.v = this.ns;
        }
        var e_20, _c;
    };
    FinancialChart.prototype.tr = function (a, b) {
        this.ub();
    };
    FinancialChart.prototype.tw = function (a, b) {
        this.od = this.nv.al;
    };
    FinancialChart.prototype.tv = function (a, b) {
        this.ob = this.nv.aj;
    };
    FinancialChart.prototype.tp = function (a, b) {
        this.uk();
    };
    FinancialChart.prototype.tq = function (a, b) {
        this.um();
    };
    FinancialChart.prototype.t0 = function (a, b) {
        var c = a;
        if (c.a7 == null) {
            return;
        }
        if (this.ps) {
            this.ui(c.a7);
        }
    };
    FinancialChart.prototype.t3 = function (a) {
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.to));
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.ds = this.volumeAxis.ds = this.indicatorAxis.ds = 0;
            this.xAxis.as.visibility = this.mu;
        }
    };
    FinancialChart.prototype.t1 = function (a) {
        var b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.my = new Rect(0, this.dataChart.mk.x, a.my.y, this.dataChart.mk.width, a.my.height);
            }
            var c = ((function () {
                var $ret = new SyncSettings();
                $ret.ae = "one";
                $ret.ac = true;
                $ret.ad = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.to));
        this.ew(a);
    };
    FinancialChart.prototype.tg = function () {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.lb(this.xAxis, function (a) { return a.visibility = 1; });
        }
        var _loop_1 = function (a) {
            var b = this_1.p4._inner[a];
            var c = a < this_1.p4.count - 1 || this_1.volumeChart != null;
            this_1.lb(b, function (d) { return d.visibility = c ? 1 : 0; });
        };
        var this_1 = this;
        for (var a = 0; a < this.p4.count; a++) {
            _loop_1(a);
        }
    };
    FinancialChart.prototype.uf = function (a, b) {
        if (a != null) {
            this.t3(a);
        }
        if (b != null) {
            this.t1(b);
        }
    };
    FinancialChart.prototype.uq = function (a, b) {
        this.uf(a, b);
        this.tg();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.t8();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.ur(a, b);
    };
    FinancialChart.prototype.ts = function (a, b) {
        this.uo();
    };
    FinancialChart.prototype.uo = function () {
        if (this.nv == null || +(this.nv.az) == +(dateMaxValue()) || +(this.nv.ay) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        var a = this.xAxis;
        var b = a.getWindowRectForSelection(this.nv.az, this.nv.ay);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.pt = true;
        this.dataChart.my = new Rect(0, b.left, this.dataChart.my.top, b.width, this.dataChart.my.height);
        if (this.pc != null) {
            this.pc.r = this.dataChart.mk;
        }
        if (this.ps) {
            this.ui(this.dataChart);
        }
        this.pt = false;
    };
    FinancialChart.prototype.tz = function (a, b) {
        this.ub();
        this.un(true);
    };
    FinancialChart.prototype.tl = function (a, b) {
        var _this = this;
        if (!this.pt) {
            if (this.ps) {
                this.ui(a);
            }
            var c = false;
            var d = this.fm(function () { return _this.un(true); }, c);
            c = d.p1;
            if (this.pc != null) {
                this.pc.r = this.dataChart.mk;
            }
        }
    };
    FinancialChart.prototype.uj = function (a, b, c, d) {
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.pt = true;
            a.my = new Rect(0, d, a.mk.top, c, a.mk.height);
            this.pt = false;
        }
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        var g = new Rect(0, 0, 0, 1, 1);
        var h = new ScalerParams(0, g, g, this.yAxis.bz, a.mo);
        try {
            for (var _a = tslib_1.__values(fromEnum(a.series)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var i = _b.value;
                h.b = i.d8();
                var j = i.an();
                var k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                var l = b.dj(j.c, h);
                var m = b.dj(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
        }
        catch (e_21_1) { e_21 = { error: e_21_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_21) throw e_21.error; }
        }
        var n = a.mk.width;
        if (c != -1) {
            n = c;
        }
        var o = a.mk.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.pt = true;
        var p = new Rect(0, o, e, n, f - e);
        a.my = p;
        this.pt = false;
        var e_21, _c;
    };
    FinancialChart.prototype.ui = function (a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.uj(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.uj(this.volumeChart, this.volumeAxis, this.dataChart.mk.width, this.dataChart.mk.left);
            }
        }
        else if (a == this.volumeChart) {
            this.uj(this.volumeChart, this.volumeAxis, -1, -1);
            this.uj(this.dataChart, this.yAxis, this.volumeChart.mk.width, this.volumeChart.mk.left);
        }
    };
    FinancialChart.prototype.tt = function (a, b) {
        if (this.ps) {
            this.ui(a);
        }
    };
    FinancialChart.prototype.up = function () {
        if (!this.py) {
            return;
        }
        if (this.n9 == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((function () {
                var $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.t9();
        }
    };
    Object.defineProperty(FinancialChart.prototype, "pw", {
        get: function () {
            return this.pg;
        },
        set: function (a) {
            var b = this.pw;
            if (a != b) {
                this.pg = a;
                this.fi("YAxisIsLogarithmic", b, this.pw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q8", {
        get: function () {
            return this.q0;
        },
        set: function (a) {
            var b = this.q8;
            if (a != b) {
                this.q0 = a;
                this.fi("YAxisLogarithmBase", b, this.q8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qm", {
        get: function () {
            return this.qa;
        },
        set: function (a) {
            var b = this.qm;
            if (a != b) {
                this.qa = a;
                this.fi("YAxisInterval", b, this.qm);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qo", {
        get: function () {
            return this.qc;
        },
        set: function (a) {
            var b = this.qo;
            if (a != b) {
                this.qc = a;
                this.fi("YAxisMinimumValue", b, this.qo);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qn", {
        get: function () {
            return this.qb;
        },
        set: function (a) {
            var b = this.qn;
            if (a != b) {
                this.qb = a;
                this.fi("YAxisMaximumValue", b, this.qn);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qp", {
        get: function () {
            return this.qd;
        },
        set: function (a) {
            var b = this.qp;
            if (a != b) {
                this.qd = a;
                this.fi("YAxisMinorInterval", b, this.qp);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ql", {
        get: function () {
            return this.yAxis.jg;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qk", {
        get: function () {
            return this.yAxis.jf;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "n2", {
        get: function () {
            return this.n0;
        },
        set: function (a) {
            var b = this.n2;
            if (a != b) {
                this.n0 = a;
                this.fi("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.n2));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "n4", {
        get: function () {
            return this.n3;
        },
        set: function (a) {
            var b = this.n4;
            if (a != b) {
                this.n3 = a;
                this.fi("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.n4));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "n6", {
        get: function () {
            return this.n5;
        },
        set: function (a) {
            var b = this.n6;
            if (a != b) {
                this.n5 = a;
                this.fi("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.n6));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pr", {
        get: function () {
            return this.pd;
        },
        set: function (a) {
            var b = this.pr;
            if (a != b) {
                this.pd = a;
                this.fi("IsToolbarVisible", b, this.pr);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "nx", {
        get: function () {
            return this.nw;
        },
        set: function (a) {
            var b = this.nx;
            if (a != b) {
                this.nw = a;
                this.fi("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.nx));
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_lt = function () {
        return _super.prototype.get_lt.call(this);
    };
    FinancialChart.prototype.set_lt = function (a) {
        _super.prototype.set_lt.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "lt", {
        get: function () {
            return this.get_lt();
        },
        set: function (a) {
            this.set_lt(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ps", {
        get: function () {
            return this.pe;
        },
        set: function (a) {
            var b = this.ps;
            if (a != b) {
                this.pe = a;
                this.fi("IsWindowSyncedToVisibleRange", b, this.ps);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ob", {
        get: function () {
            return this.oa;
        },
        set: function (a) {
            var b = this.ob;
            if (a != b) {
                this.oa = a;
                this.fi("IndicatorTypes", b, this.ob);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "od", {
        get: function () {
            return this.oc;
        },
        set: function (a) {
            var b = this.od;
            if (a != b) {
                this.oc = a;
                this.fi("OverlayTypes", b, this.od);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorCharts", {
        get: function () {
            return this.p0;
        },
        set: function (a) {
            var b = this.indicatorCharts;
            if (a != b) {
                this.p0 = a;
                this.fi("IndicatorCharts", b, this.indicatorCharts);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "pv", {
        get: function () {
            return this.pf;
        },
        set: function (a) {
            var b = this.pv;
            if (a != b) {
                this.pf = a;
                this.fi("YAxisAbbreviateLargeNumbers", b, this.pv);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_by = function () {
        return _super.prototype.get_by.call(this);
    };
    FinancialChart.prototype.set_by = function (a) {
        _super.prototype.set_by.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "by", {
        get: function () {
            return this.get_by();
        },
        set: function (a) {
            this.set_by(a);
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_gq = function () {
        return _super.prototype.get_gq.call(this);
    };
    FinancialChart.prototype.set_gq = function (a) {
        _super.prototype.set_gq.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "gq", {
        get: function () {
            return this.get_gq();
        },
        set: function (a) {
            this.set_gq(a);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderChart", {
        get: function () {
            return this.o8;
        },
        set: function (a) {
            var b = this.zoomSliderChart;
            if (a != b) {
                this.o8 = a;
                this.fi("ZoomSliderChart", b, this.zoomSliderChart);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderAxis", {
        get: function () {
            return this.os;
        },
        set: function (a) {
            var b = this.zoomSliderAxis;
            if (a != b) {
                this.os = a;
                this.fi("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderXAxis", {
        get: function () {
            return this.nf;
        },
        set: function (a) {
            var b = this.zoomSliderXAxis;
            if (a != b) {
                this.nf = a;
                this.fi("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "n9", {
        get: function () {
            return this.n7;
        },
        set: function (a) {
            var b = this.n9;
            if (a != b) {
                this.n7 = a;
                this.fi("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.n9));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "m6", {
        get: function () {
            return this.my;
        },
        set: function (a) {
            var b = this.m6;
            if (a != b) {
                this.my = a;
                this.fi("NegativeBrushes", b, this.m6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "m7", {
        get: function () {
            return this.mz;
        },
        set: function (a) {
            var b = this.m7;
            if (a != b) {
                this.mz = a;
                this.fi("NegativeOutlines", b, this.m7);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "m8", {
        get: function () {
            return this.m0;
        },
        set: function (a) {
            var b = this.m8;
            if (a != b) {
                this.m0 = a;
                this.fi("OverlayBrushes", b, this.m8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "m9", {
        get: function () {
            return this.m1;
        },
        set: function (a) {
            var b = this.m9;
            if (a != b) {
                this.m1 = a;
                this.fi("OverlayOutlines", b, this.m9);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "nb", {
        get: function () {
            return this.m3;
        },
        set: function (a) {
            var b = this.nb;
            if (a != b) {
                this.m3 = a;
                this.fi("VolumeOutlines", b, this.nb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "na", {
        get: function () {
            return this.m2;
        },
        set: function (a) {
            var b = this.na;
            if (a != b) {
                this.m2 = a;
                this.fi("VolumeBrushes", b, this.na);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "m5", {
        get: function () {
            return this.mx;
        },
        set: function (a) {
            var b = this.m5;
            if (a != b) {
                this.mx = a;
                this.fi("IndicatorNegativeBrushes", b, this.m5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "m4", {
        get: function () {
            return this.mw;
        },
        set: function (a) {
            var b = this.m4;
            if (a != b) {
                this.mw = a;
                this.fi("IndicatorBrushes", b, this.m4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qj", {
        get: function () {
            return this.p9;
        },
        set: function (a) {
            var b = this.qj;
            if (a != b) {
                this.p9 = a;
                this.fi("VolumeThickness", b, this.qj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qh", {
        get: function () {
            return this.p7;
        },
        set: function (a) {
            var b = this.qh;
            if (a != b) {
                this.p7 = a;
                this.fi("OverlayThickness", b, this.qh);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qg", {
        get: function () {
            return this.p6;
        },
        set: function (a) {
            var b = this.qg;
            if (a != b) {
                this.p6 = a;
                this.fi("IndicatorThickness", b, this.qg);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ol", {
        get: function () {
            return this.ok;
        },
        set: function (a) {
            var b = this.ol;
            if (a != b) {
                this.ok = a;
                this.fi("IndicatorDisplayTypes", b, this.ol);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q3", {
        get: function () {
            return this.qw;
        },
        set: function (a) {
            var b = this.q3;
            if (a != b) {
                this.qw = a;
                this.fi("IndicatorPeriod", b, this.q3);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "qf", {
        get: function () {
            return this.p5;
        },
        set: function (a) {
            var b = this.qf;
            if (a != b) {
                this.p5 = a;
                this.fi("IndicatorMultiplier", b, this.qf);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q6", {
        get: function () {
            return this.qz;
        },
        set: function (a) {
            var b = this.q6;
            if (a != b) {
                this.qz = a;
                this.fi("IndicatorSmoothingPeriod", b, this.q6);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q4", {
        get: function () {
            return this.qx;
        },
        set: function (a) {
            var b = this.q4;
            if (a != b) {
                this.qx = a;
                this.fi("IndicatorShortPeriod", b, this.q4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q2", {
        get: function () {
            return this.qv;
        },
        set: function (a) {
            var b = this.q2;
            if (a != b) {
                this.qv = a;
                this.fi("IndicatorLongPeriod", b, this.q2);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "q5", {
        get: function () {
            return this.qy;
        },
        set: function (a) {
            var b = this.q5;
            if (a != b) {
                this.qy = a;
                this.fi("IndicatorSignalPeriod", b, this.q5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "nt", {
        get: function () {
            return this.nr;
        },
        set: function (a) {
            var b = this.nt;
            if (a != b) {
                this.nr = a;
                this.fi("RangeSelectorOptions", b, this.nt);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "customIndicatorNames", {
        get: function () {
            return this.nn;
        },
        set: function (a) {
            var b = this.nn;
            if (a != b) {
                this.nn = a;
                this.fi("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.prototype.get_a3 = function () {
        return _super.prototype.get_a3.call(this);
    };
    FinancialChart.prototype.set_a3 = function (a) {
        _super.prototype.set_a3.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "a3", {
        get: function () {
            return this.get_a3();
        },
        set: function (a) {
            this.set_a3(a);
        },
        enumerable: true,
        configurable: true
    });
    FinancialChart.q7 = 0;
    FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
    return FinancialChart;
}(XYChart));
export { FinancialChart };
var FinancialChartEnumCollectionPickerTool$2 = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartEnumCollectionPickerTool$2, _super);
    function FinancialChartEnumCollectionPickerTool$2($tColl, $tEnum, a, b, c) {
        var _this = _super.call(this, a, b, c) || this;
        _this.$tColl = null;
        _this.$tEnum = null;
        _this.o = null;
        _this.p = null;
        _this.changed = null;
        _this.$tColl = $tColl;
        _this.$tEnum = $tEnum;
        _this.$type = _this.$type.specialize(_this.$tColl, _this.$tEnum);
        _this.o = new FinancialChartEnumCollectionPickerToolView();
        _this.p = new FinancialChartEnumCollectionPickerToolViewModel();
        _this.p.onSelectionChanged = runOn(_this, _this.w);
        return _this;
    }
    FinancialChartEnumCollectionPickerTool$2.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.o.d(this.j, this.d, this.p, this.s());
    };
    FinancialChartEnumCollectionPickerTool$2.prototype.u = function (a) {
    };
    Object.defineProperty(FinancialChartEnumCollectionPickerTool$2.prototype, "n", {
        get: function () {
            var a = Type.createInstance(this.$tColl);
            var d = this.p.selection;
            for (var c = 0; c < d.length; c++) {
                var b = d[c];
                a.add(typeCastObjTo$t(this.$tEnum, EnumUtil.parse(this.$tEnum, b, true)));
            }
            return a;
        },
        set: function (a) {
            var b = this.n;
            if (!FinancialChartToolbar.ar(b, a)) {
                var c = new List$1(String_$type, 0);
                if (a != null) {
                    for (var d = 0; d < a.count; d++) {
                        var e = a._inner[d];
                        c.add(stringToString$1(this.$tEnum, e));
                    }
                }
                this.p.selection = c.b();
                this.v("Selection", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartEnumCollectionPickerTool$2.prototype.w = function () {
        if (this.changed != null) {
            this.changed(this, EventArgs.empty);
        }
    };
    FinancialChartEnumCollectionPickerTool$2.prototype.v = function (a, b, c) {
        switch (a) {
            case "Selection":
                this.p.updateUI();
                this.o.g(this.p);
                break;
        }
    };
    FinancialChartEnumCollectionPickerTool$2.prototype.q = function () {
        return this.o.b(this.g);
    };
    FinancialChartEnumCollectionPickerTool$2.$t = markType(FinancialChartEnumCollectionPickerTool$2, 'FinancialChartEnumCollectionPickerTool$2', TemplatedHtmlControl.$);
    return FinancialChartEnumCollectionPickerTool$2;
}(TemplatedHtmlControl));
export { FinancialChartEnumCollectionPickerTool$2 };
var FinancialChartIndicatorPicker = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartIndicatorPicker, _super);
    function FinancialChartIndicatorPicker(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = [null];
                    {
                        var e = c[0];
                        _this = _super.call(this, FinancialIndicatorTypeCollection.$, FinancialIndicatorType_$type, "financialChartIndicatorPicker", e, "") || this;
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    _this = _super.call(this, FinancialIndicatorTypeCollection.$, FinancialIndicatorType_$type, "financialChartIndicatorPicker", c, "") || this;
                }
                break;
        }
        return _this;
    }
    FinancialChartIndicatorPicker.prototype.u = function (a) {
        _super.prototype.u.call(this, a);
        if (this.p.isOpen) {
            for (var b = 0; b < a.length; b++) {
                if (a[b] == "financialChartIndicatorPickerDropDownButton") {
                    return;
                }
            }
            this.p.isOpen = false;
            this.p.updateUI();
        }
    };
    FinancialChartIndicatorPicker.prototype.s = function () {
        return this.d != null ? new SRProvider(this.d).ac : null;
    };
    FinancialChartIndicatorPicker.$t = markType(FinancialChartIndicatorPicker, 'FinancialChartIndicatorPicker', FinancialChartEnumCollectionPickerTool$2.$.specialize(FinancialIndicatorTypeCollection.$, FinancialIndicatorType_$type));
    return FinancialChartIndicatorPicker;
}(FinancialChartEnumCollectionPickerTool$2));
export { FinancialChartIndicatorPicker };
var FinancialChartOverlayPicker = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartOverlayPicker, _super);
    function FinancialChartOverlayPicker(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = [null];
                    {
                        var e = c[0];
                        _this = _super.call(this, FinancialOverlayTypeCollection.$, FinancialOverlayType_$type, "financialChartOverlayPicker", e, "") || this;
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    _this = _super.call(this, FinancialOverlayTypeCollection.$, FinancialOverlayType_$type, "financialChartOverlayPicker", c, "") || this;
                }
                break;
        }
        return _this;
    }
    FinancialChartOverlayPicker.prototype.u = function (a) {
        _super.prototype.u.call(this, a);
        if (this.p.isOpen) {
            for (var b = 0; b < a.length; b++) {
                if (a[b] == "financialChartOverlayPickerDropDownButton") {
                    return;
                }
            }
            this.p.isOpen = false;
            this.p.updateUI();
        }
    };
    FinancialChartOverlayPicker.prototype.s = function () {
        return this.d != null ? new SRProvider(this.d).ad : null;
    };
    FinancialChartOverlayPicker.$t = markType(FinancialChartOverlayPicker, 'FinancialChartOverlayPicker', FinancialChartEnumCollectionPickerTool$2.$.specialize(FinancialOverlayTypeCollection.$, FinancialOverlayType_$type));
    return FinancialChartOverlayPicker;
}(FinancialChartEnumCollectionPickerTool$2));
export { FinancialChartOverlayPicker };
var FinancialChartToolbar = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartToolbar, _super);
    function FinancialChartToolbar(a, b) {
        var _this = _super.call(this, "financialChartToolbar", b, "") || this;
        _this.n = null;
        _this.s = null;
        _this.ac = null;
        _this.y = null;
        _this.ag = null;
        _this.o = null;
        _this.q = null;
        _this.x = null;
        _this.av = dateMaxValue();
        _this.au = dateMinValue();
        _this.at = dateMaxValue();
        _this.as = dateMinValue();
        _this.rangeChanged = null;
        _this.chartTypeChanged = null;
        _this.trendLineTypeChanged = null;
        _this.volumeTypeChanged = null;
        _this.indicatorTypesChanged = null;
        _this.overlayTypesChanged = null;
        _this.aa = 0;
        _this.am = 0;
        _this.ae = 0;
        _this.ai = null;
        _this.ak = null;
        _this.u = null;
        _this.ap = false;
        _this.n = a;
        _this.x = new FinancialChartToolbarViewModel();
        _this.t = new FinancialChartRangeSelector(a != null ? a.rj : null);
        _this.ad = new FinancialChartTypePicker(a != null ? a.rg : null);
        _this.z = new FinancialChartTrendLinePicker(1, a != null ? a.rl : null);
        _this.ah = new FinancialChartVolumeTypePicker(a != null ? a.rm : null);
        _this.p = new FinancialChartIndicatorPicker(1, a != null ? a.rh : null);
        _this.r = new FinancialChartOverlayPicker(1, a != null ? a.ri : null);
        return _this;
    }
    FinancialChartToolbar.prototype.bp = function (a) {
        var b = this.d.querySelector(".financialChartRangeSelector");
        this.t.g = b;
        var c = this.d.querySelector(".financialChartChartTypePicker");
        this.ad.g = c;
        var d = this.d.querySelector(".financialChartIndicatorPicker");
        this.p.g = d;
        var e = this.d.querySelector(".financialChartOverlayPicker");
        this.r.g = e;
        var f = this.d.querySelector(".financialChartTrendLineTypePicker");
        this.z.g = f;
        var g = this.d.querySelector(".financialChartVolumeTypePicker");
        this.ah.g = g;
    };
    FinancialChartToolbar.prototype.bx = function (a) {
        this.p.u(a);
        this.r.u(a);
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "t", {
        get: function () {
            return this.s;
        },
        set: function (a) {
            var b = this.t;
            if (a != b) {
                this.s = a;
                this.by("RangeSelector", b, this.t);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ad", {
        get: function () {
            return this.ac;
        },
        set: function (a) {
            var b = this.ad;
            if (a != b) {
                this.ac = a;
                this.by("ChartTypePicker", b, this.ad);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "z", {
        get: function () {
            return this.y;
        },
        set: function (a) {
            var b = this.z;
            if (a != b) {
                this.y = a;
                this.by("TrendLineTypePicker", b, this.z);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ah", {
        get: function () {
            return this.ag;
        },
        set: function (a) {
            var b = this.ah;
            if (a != b) {
                this.ag = a;
                this.by("VolumeTypePicker", b, this.ah);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "p", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            var b = this.p;
            if (a != b) {
                this.o = a;
                this.by("IndicatorPicker", b, this.p);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "r", {
        get: function () {
            return this.q;
        },
        set: function (a) {
            var b = this.r;
            if (a != b) {
                this.q = a;
                this.by("OverlayPicker", b, this.r);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.prototype.by = function (a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.t != null) {
                    this.t.s = this.ax;
                }
                break;
            case "RangeEnd":
                if (this.t != null) {
                    this.t.r = this.aw;
                }
                break;
            case "SelectionStart":
                if (this.t != null) {
                    this.t.u = this.az;
                }
                break;
            case "SelectionEnd":
                if (this.t != null) {
                    this.t.t = this.ay;
                }
                break;
            case "RangeSelector":
                var d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bt));
                }
                if (this.t != null) {
                    this.t.s = this.ax;
                    this.t.r = this.aw;
                    this.t.n = this.v;
                    this.t.u = this.az;
                    this.t.t = this.ay;
                    var e = this.t;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bt));
                }
                break;
            case "ChartTypePicker":
                var f = b;
                if (f != null) {
                    f.changed = delegateRemove(f.changed, runOn(this, this.bs));
                }
                if (this.ad != null) {
                    this.ad.n = this.ab;
                    var g = this.ad;
                    g.changed = delegateCombine(g.changed, runOn(this, this.bs));
                }
                break;
            case "ChartType":
                if (this.ad != null) {
                    this.ad.n = this.ab;
                }
                break;
            case "TrendLineTypePicker":
                var h = b;
                if (h != null) {
                    h.changed = delegateRemove(h.changed, runOn(this, this.bu));
                }
                if (this.z != null) {
                    this.z.n = this.an;
                    var i = this.z;
                    i.changed = delegateCombine(i.changed, runOn(this, this.bu));
                }
                break;
            case "VolumeType":
                if (this.ah != null) {
                    this.ah.n = this.af;
                }
                break;
            case "VolumeTypePicker":
                var j = b;
                if (j != null) {
                    j.changed = delegateRemove(j.changed, runOn(this, this.bv));
                }
                if (this.ah != null) {
                    this.ah.n = this.af;
                    var k = this.ah;
                    k.changed = delegateCombine(k.changed, runOn(this, this.bv));
                }
                break;
            case "TrendLineType":
                if (this.z != null) {
                    this.z.n = this.an;
                }
                break;
            case "IndicatorPicker":
                var l = b;
                if (l != null) {
                    l.changed = delegateRemove(l.changed, runOn(this, this.bq));
                }
                if (this.p != null) {
                    this.p.n = this.aj;
                    var m = this.p;
                    m.changed = delegateCombine(m.changed, runOn(this, this.bq));
                }
                break;
            case "IndicatorTypes":
                if (this.p != null) {
                    this.p.n = this.aj;
                }
                break;
            case "OverlayPicker":
                var n = b;
                if (n != null) {
                    n.changed = delegateRemove(n.changed, runOn(this, this.br));
                }
                if (this.r != null) {
                    this.r.n = this.al;
                    var o = this.r;
                    o.changed = delegateCombine(o.changed, runOn(this, this.br));
                }
                break;
            case "OverlayTypes":
                if (this.r != null) {
                    this.r.n = this.al;
                }
                break;
            case "RangeSelectorOptions":
                if (this.t != null) {
                    this.t.n = this.v;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.aq) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
        }
    };
    FinancialChartToolbar.prototype.br = function (a, b) {
        this.al = this.r.n;
        if (this.overlayTypesChanged != null) {
            this.overlayTypesChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bq = function (a, b) {
        this.aj = this.p.n;
        if (this.indicatorTypesChanged != null) {
            this.indicatorTypesChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bs = function (a, b) {
        this.ab = this.ad.n;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bu = function (a, b) {
        this.an = this.z.n;
        if (this.trendLineTypeChanged != null) {
            this.trendLineTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bv = function (a, b) {
        this.af = this.ah.n;
        if (this.volumeTypeChanged != null) {
            this.volumeTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bt = function (a, b) {
        this.az = this.t.u;
        this.ay = this.t.t;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.w = function () {
        var _this = this;
        var a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.x;
        a.vm.financialChartChartTypePicker = ((function () {
            var $ret = new FinancialChartChartTypePickerContext();
            $ret.vm = _this.ad.p;
            return $ret;
        })());
        a.vm.financialChartIndicatorPicker = ((function () {
            var $ret = new FinancialChartIndicatorPickerContext();
            $ret.vm = _this.p.p;
            return $ret;
        })());
        a.vm.financialChartOverlayPicker = ((function () {
            var $ret = new FinancialChartOverlayPickerContext();
            $ret.vm = _this.r.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((function () {
            var $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = _this.t.p;
            return $ret;
        })());
        a.vm.financialChartTrendLineTypePicker = ((function () {
            var $ret = new FinancialChartTrendLinePickerContext();
            $ret.vm = _this.z.p;
            return $ret;
        })());
        a.vm.financialChartVolumeTypePicker = ((function () {
            var $ret = new FinancialChartVolumeTypePickerContext();
            $ret.vm = _this.ah.p;
            return $ret;
        })());
        return a;
    };
    FinancialChartToolbar.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        if (a == null) {
            return;
        }
        this.bw();
    };
    FinancialChartToolbar.prototype.bw = function () {
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "az", {
        get: function () {
            return this.av;
        },
        set: function (a) {
            var b = this.az;
            if (+a != +b) {
                this.av = a;
                this.by("SelectionStart", b, this.az);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ay", {
        get: function () {
            return this.au;
        },
        set: function (a) {
            var b = this.ay;
            if (+a != +b) {
                this.au = a;
                this.by("SelectionEnd", b, this.ay);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ax", {
        get: function () {
            return this.at;
        },
        set: function (a) {
            var b = this.ax;
            if (+a != +b) {
                this.at = a;
                this.by("RangeStart", b, this.ax);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aw", {
        get: function () {
            return this.as;
        },
        set: function (a) {
            var b = this.aw;
            if (+a != +b) {
                this.as = a;
                this.by("RangeEnd", b, this.aw);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.prototype.bz = function () {
        if (this.t != null) {
            this.t.z();
        }
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "ab", {
        get: function () {
            return this.aa;
        },
        set: function (a) {
            var b = this.ab;
            if (a != b) {
                this.aa = a;
                this.by("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.ab));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "an", {
        get: function () {
            return this.am;
        },
        set: function (a) {
            var b = this.an;
            if (a != b) {
                this.am = a;
                this.by("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.an));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "af", {
        get: function () {
            return this.ae;
        },
        set: function (a) {
            var b = this.af;
            if (a != b) {
                this.ae = a;
                this.by("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.af));
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aj", {
        get: function () {
            return this.ai;
        },
        set: function (a) {
            var b = this.aj;
            if (!FinancialChartToolbar.ar(b, a)) {
                this.ai = a;
                this.by("IndicatorTypes", b, this.aj);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "al", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.al;
            if (!FinancialChartToolbar.ar(b, a)) {
                this.ak = a;
                this.by("OverlayTypes", b, this.al);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.ar = function (a, b) {
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        try {
            for (var _a = tslib_1.__values(fromEn(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var c = _b.value;
                if (!b.contains(c)) {
                    return false;
                }
            }
        }
        catch (e_22_1) { e_22 = { error: e_22_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_22) throw e_22.error; }
        }
        return true;
        var e_22, _c;
    };
    FinancialChartToolbar.prototype.ao = function () {
        var _this = this;
        return ((function () {
            var $ret = new FinancialChartToolbarVisualData();
            $ret.indicatorPicker = _this.p == null ? null : _this.p.q();
            $ret.overlayPicker = _this.r == null ? null : _this.r.q();
            $ret.trendLineTypePicker = _this.z == null ? null : _this.z.q();
            $ret.chartTypePicker = _this.ad == null ? null : _this.ad.q();
            $ret.volumeTypePicker = _this.ah == null ? null : _this.ah.q();
            $ret.rangeSelector = _this.t == null ? null : _this.t.q();
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "v", {
        get: function () {
            return this.u;
        },
        set: function (a) {
            var b = this.v;
            if (a != b) {
                this.u = a;
                this.by("RangeSelectorOptions", b, this.v);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aq", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.aq;
            if (a != b) {
                this.ap = a;
                this.by("IsToolbarVisible", b, this.aq);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartToolbar.a6 = 0;
    FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
}(TemplatedHtmlControl));
export { FinancialChartToolbar };
var FinancialChartRangeSelector = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialChartRangeSelector, _super);
    function FinancialChartRangeSelector(a) {
        var _this = _super.call(this, "financialChartRangeSelector", a, "") || this;
        _this.p = null;
        _this.rangeChanged = null;
        _this.o = null;
        _this.o = new FinancialChartRangeSelectorView();
        _this.p = new FinancialChartRangeSelectorViewModel();
        _this.p.onRangeChanged = runOn(_this, _this.y);
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelector.prototype, "u", {
        get: function () {
            return this.p.selectionStart;
        },
        set: function (a) {
            this.p.selectionStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "t", {
        get: function () {
            return this.p.selectionEnd;
        },
        set: function (a) {
            this.p.selectionEnd = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "s", {
        get: function () {
            return this.p.rangeStart;
        },
        set: function (a) {
            this.p.rangeStart = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "r", {
        get: function () {
            return this.p.rangeEnd;
        },
        set: function (a) {
            this.p.rangeEnd = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.z = function () {
        if (this.p.onPropertiesChanged()) {
            this.o.e(this.p);
        }
    };
    FinancialChartRangeSelector.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.o.d(this.d, this.p);
    };
    FinancialChartRangeSelector.prototype.y = function () {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    };
    FinancialChartRangeSelector.prototype.q = function () {
        return this.o.c(this.g);
    };
    Object.defineProperty(FinancialChartRangeSelector.prototype, "n", {
        get: function () {
            return this.p.options;
        },
        set: function (a) {
            var b = !FinancialChartToolbar.ar(this.p.options, a);
            if (b) {
                this.p.options = a;
                if (this.o != null) {
                    this.o.g(this.n);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialChartRangeSelector.w = 0;
    FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    return FinancialChartRangeSelector;
}(TemplatedHtmlControl));
export { FinancialChartRangeSelector };
//# sourceMappingURL=FinancialChart_combined.js.map