import { EventArgs, IList$1, Base, Type, IEnumerable$1, Point } from "./type";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "./IFastItemColumn$1";
import { Series } from "./Series";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { IHasCategoryAxis } from "./IHasCategoryAxis";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Brush } from "./Brush";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "./List$1";
import { Dictionary$2 } from "./Dictionary$2";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { FastItemsSourceEventAction } from "./FastItemsSourceEventAction";
import { CalculatedColumn } from "./CalculatedColumn";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { RenderSurface } from "./RenderSurface";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
export declare class FinancialEventArgs extends EventArgs {
    constructor(a: number, b: number, c: FinancialCalculationDataSource, d: FinancialCalculationSupportingCalculations, e: FinancialSeries);
    private _position;
    position: number;
    private _count;
    count: number;
    private _dataSource;
    dataSource: FinancialCalculationDataSource;
    private _supportingCalculations;
    supportingCalculations: FinancialCalculationSupportingCalculations;
    private _basedOn;
    basedOn: IList$1<string>;
    static $t: Type;
}
export declare class FinancialBucketCalculator extends Base implements IBucketizer {
    protected a: FinancialSeriesView;
    constructor(a: FinancialSeriesView);
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    c: number;
    d: number;
    b: number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
    static $t: Type;
}
export declare abstract class FinancialSeries extends Series implements IHasCategoryAxis, IHasCategoryModePreference {
    h9(a: SeriesView): void;
    l3: FinancialSeriesView;
    protected get_cp(): boolean;
    readonly cp: boolean;
    protected nk(): number;
    ag(a: Point): Point[][];
    ah(a: Point): Point[][];
    constructor();
    op: Brush;
    ko(): Brush;
    hc(): void;
    ln: CategoryAxisBase;
    l7: NumericYAxis;
    n0: string;
    mf: IFastItemColumn$1<number>;
    private me;
    nr: string;
    mb: IFastItemColumn$1<number>;
    private ma;
    nw: string;
    md: IFastItemColumn$1<number>;
    private mc;
    no: string;
    l9: IFastItemColumn$1<number>;
    private l8;
    n4: string;
    mi: IFastItemColumn$1<number>;
    private mh;
    mr: boolean;
    protected ml: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    protected mt(): boolean;
    protected oc(a: AssigningCategoryStyleEventArgs): void;
    protected lv: CategorySeriesRenderManager;
    protected oa(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    nb(a: Point): number;
    e3(a: Point, b: boolean): number;
    e1(a: Point, b: boolean): number;
    d0(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    k0(a: Point, b: boolean, c: boolean): Point;
    ed(a: Point, b: boolean, c: boolean): number;
    d9(a: Point, b: boolean, c: boolean): number;
    eb(a: Point, b: boolean, c: boolean): number;
    nd(a: Point, b: boolean, c: boolean): number;
    ne(a: Point, b: boolean, c: boolean): number;
    nf(a: Point, b: boolean, c: boolean): number;
    kw(a: Point, b: boolean, c: boolean): Point;
    ky(a: Point, b: boolean, c: boolean): Point;
    or(a: Point, b: boolean, c: boolean): Point;
    oq(a: Point, b: boolean, c: boolean): Point;
    os(a: Point, b: boolean, c: boolean): Point;
    ht(): void;
    protected i8(a: Rect, b: Rect): void;
    protected i7(a: Rect, b: Rect): void;
    protected mw: Dictionary$2<IFastItemColumn$1<number>, string>;
    protected mx: Dictionary$2<string, string>;
    private mg(a, b, c);
    private n9(a, b);
    private mk;
    protected ie(a: any, b: string, c: any, d: any): void;
    mn(a: any): boolean;
    mm(a: any): boolean;
    protected lg(a: number, b: number, c: Axis): any[];
    protected ni(a: SeriesView): number;
    protected nj(a: SeriesView): number;
    lf(a: number, b: number): any[];
    private l6;
    protected get_mp(): boolean;
    protected readonly mp: boolean;
    protected get_ct(): boolean;
    protected readonly ct: boolean;
    as(a: any, b: Point): HighlightingInfo;
    nl(a: Point): number;
    protected l5(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected l4(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected mo(): boolean;
    d2(a: Point): number;
    ex(a: Point): number;
    protected get_cz(): boolean;
    readonly cz: boolean;
    ao(): CategoryAxisBase;
    ez(a: Point): number;
    fe(a: Point): any;
    lq: CategoryFrame;
    ls: CategoryFrame;
    lp: CategoryFrame;
    protected nc(a: Rect, b: Rect, c: Rect): number;
    lx: CategoryTransitionInMode;
    ms: boolean;
    protected c8(): boolean;
    protected lw(): CategoryTransitionInMode;
    protected bn(): TransitionInSpeedType;
    od(a: CategoryFrame, b: FinancialSeriesView): void;
    private ot;
    protected readonly ou: Rect;
    ob(a: CategoryFrame, b: FinancialSeriesView): void;
    ds(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    ly: CategoryTransitionSourceFramePreparer;
    ng(a: FinancialSeriesView): number;
    protected hf(): void;
    iu(a: boolean): void;
    typical: (sender: any, e: FinancialEventArgs) => void;
    typicalBasedOn: (sender: any, e: FinancialEventArgs) => void;
    protected mu(a: IList$1<string>): boolean;
    readonly mv: boolean;
    protected mq(): boolean;
    protected n8(a: FinancialEventArgs): void;
    protected readonly m3: IEnumerable$1<number>;
    private _m0();
    private m0();
    protected readonly m2: IEnumerable$1<number>;
    private _mz();
    private mz();
    protected readonly m1: IEnumerable$1<number>;
    private _my();
    private my();
    m5(a: IList$1<number>): IList$1<number>;
    private mj;
    protected m4(): IList$1<string>;
    private m9;
    getOpenColumnAsArray(): number[];
    private m7;
    getHighColumnAsArray(): number[];
    private m8;
    getLowColumnAsArray(): number[];
    private m6;
    getCloseColumnAsArray(): number[];
    private na;
    getVolumeColumnAsArray(): number[];
    protected hh(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected lz(a: number, b: number): FinancialCalculationDataSource;
    nh(a: number): number;
    protected l0(a: FinancialCalculationDataSource): FinancialCalculationSupportingCalculations;
    readonly categoryAxis: CategoryAxisBase;
    private lr;
    iv(a: Rect, b: RenderSurface): void;
    private lo;
    is(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    al(a: Axis): Axis;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private lt;
    lu: CategoryMode;
    protected get_cx(): boolean;
    readonly cx: boolean;
    iy(a: Brush, b: Brush): void;
    static $$p: string[];
    static $t: Type;
}
export declare class FinancialCalculationSupportingCalculations extends Base {
    a: ColumnSupportingCalculation;
    c: ColumnSupportingCalculation;
    d: ColumnSupportingCalculation;
    b: ColumnSupportingCalculation;
    h: DataSourceSupportingCalculation;
    f: DataSourceSupportingCalculation;
    g: DataSourceSupportingCalculation;
    e: DataSourceSupportingCalculation;
    k: (arg1: (arg1: number) => number, arg2: number, arg3: number) => IEnumerable$1<number>;
    j: (arg1: (arg1: number) => number, arg2: number) => IEnumerable$1<number>;
    i: (arg1: number) => number;
    static $t: Type;
}
export declare class DataSourceSupportingCalculation extends SupportingCalculation$1<(dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>> {
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>);
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>, c: IList$1<string>);
    constructor(a: number, ..._rest: any[]);
    static $t: Type;
}
export declare class FinancialCalculationDataSource extends Base {
    private _openColumn;
    openColumn: IList$1<number>;
    private _closeColumn;
    closeColumn: IList$1<number>;
    private _highColumn;
    highColumn: IList$1<number>;
    private _lowColumn;
    lowColumn: IList$1<number>;
    private _volumeColumn;
    volumeColumn: IList$1<number>;
    private _indicatorColumn;
    indicatorColumn: IList$1<number>;
    private _typicalColumn;
    typicalColumn: CalculatedColumn;
    private _trueRange;
    trueRange: CalculatedColumn;
    private _trueLow;
    trueLow: CalculatedColumn;
    private _period;
    period: number;
    private _shortPeriod;
    shortPeriod: number;
    private _longPeriod;
    longPeriod: number;
    private _count;
    count: number;
    private _calculateFrom;
    calculateFrom: number;
    private _calculateCount;
    calculateCount: number;
    private _multiplier;
    multiplier: number;
    private _minimumValue;
    minimumValue: number;
    private _maximumValue;
    maximumValue: number;
    private _specifiesRange;
    specifiesRange: boolean;
    private _series;
    series: FinancialSeries;
    static $t: Type;
}
export declare abstract class FinancialSeriesView extends SeriesView {
    bu: FinancialSeries;
    bs: FinancialBucketCalculator;
    bw: number;
    bv(a: CategoryFrame): boolean;
    bx(a: CategoryFrame): void;
    constructor(a: FinancialSeries);
    protected abstract bt(): FinancialBucketCalculator;
    ap(): void;
    getDefaultTooltipTemplate(): string;
    protected ac(): void;
    static $t: Type;
}
