/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { EventArgs, Base, Type, markType, typeCast, Point_$type, String_$type, runOn, Number_$type, enumGetBox, fromEnum, toEnum, Delegate_$type } from "./type";
import { IBucketizer_$type } from "./IBucketizer";
import { ArgumentNullException } from "./ArgumentNullException";
import { IFastItemColumn$1_$type } from "./IFastItemColumn$1";
import { Series } from "./Series";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { SeriesView } from "./SeriesView";
import { truncate, intDivide, isInfinity, isNaN_ } from "./number";
import { IHasCategoryAxis_$type } from "./IHasCategoryAxis";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Brush } from "./Brush";
import { DependencyProperty } from "./DependencyProperty";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode_$type } from "./CategoryMode";
import { List$1 } from "./List$1";
import { Dictionary$2 } from "./Dictionary$2";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { IFastItemsSource_$type } from "./IFastItemsSource";
import { FinancialValueList } from "./FinancialValueList";
import { CategoryXAxis } from "./CategoryXAxis";
import { SafeSortedReadOnlyDoubleCollection } from "./SafeSortedReadOnlyDoubleCollection";
import { SafeReadOnlyDoubleCollection } from "./SafeReadOnlyDoubleCollection";
import { SafeEnumerable } from "./SafeEnumerable";
import { CalculatedColumn } from "./CalculatedColumn";
import { TrendCalculators } from "./TrendCalculators";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { PropertyMetadata } from "./PropertyMetadata";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
import { Color } from "./Color";
import { stringIsNullOrEmpty } from "./string";
var FinancialEventArgs = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialEventArgs, _super);
    function FinancialEventArgs(a, b, c, d, e) {
        var _this = _super.call(this) || this;
        _this._position = 0;
        _this._count = 0;
        _this._dataSource = null;
        _this._supportingCalculations = null;
        _this._basedOn = null;
        _this.position = a;
        _this.count = b;
        _this.dataSource = c;
        _this.supportingCalculations = d;
        if (c != null) {
            c.series = e;
        }
        return _this;
    }
    Object.defineProperty(FinancialEventArgs.prototype, "position", {
        get: function () {
            return this._position;
        },
        set: function (a) {
            this._position = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "count", {
        get: function () {
            return this._count;
        },
        set: function (a) {
            this._count = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "dataSource", {
        get: function () {
            return this._dataSource;
        },
        set: function (a) {
            this._dataSource = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "supportingCalculations", {
        get: function () {
            return this._supportingCalculations;
        },
        set: function (a) {
            this._supportingCalculations = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialEventArgs.prototype, "basedOn", {
        get: function () {
            return this._basedOn;
        },
        set: function (a) {
            this._basedOn = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialEventArgs.$t = markType(FinancialEventArgs, 'FinancialEventArgs', EventArgs.$);
    return FinancialEventArgs;
}(EventArgs));
export { FinancialEventArgs };
var FinancialBucketCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialBucketCalculator, _super);
    function FinancialBucketCalculator(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.c = 0;
        _this.d = 0;
        _this.b = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        _this.a = a;
        _this.c = -1;
        _this.d = _this.d;
        _this.b = 0;
        return _this;
    }
    FinancialBucketCalculator.prototype.getBucket = function (a) {
        return null;
    };
    FinancialBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        return this.getBucket(a);
    };
    FinancialBucketCalculator.prototype.getErrorBucket = function (a, b) {
        return NaN;
    };
    FinancialBucketCalculator.prototype.getBucketInfo = function (a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.bu.ej;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    };
    FinancialBucketCalculator.prototype.e = function (a) {
        var b = this.a.bq;
        var c = this.a.bp;
        var d = this.a.bp;
        if (this.a.bu != null) {
            d = this.a.bu.getEffectiveViewport1(this.a);
        }
        if (b.isEmpty || c.isEmpty || this.a.bu.ln == null) {
            this.b = 0;
            return;
        }
        var e = (this.a.bu.ln != null) ? this.a.bu.ln.bz : false;
        var f = new ScalerParams(0, b, c, e, d);
        var g = this.a.bu.k5(this.a);
        var h = typeCast(ISortingAxis_$type, this.a.bu.ln);
        if (h == null || h.i$b == null) {
            var i = Math.floor(this.a.bu.ln.dm(g.left, f));
            var j = Math.ceil(this.a.bu.ln.dm(g.right, f));
            if (this.a.bu.ln.bz) {
                j = Math.ceil(this.a.bu.ln.dm(g.left, f));
                i = Math.floor(this.a.bu.ln.dm(g.right, f));
            }
            var k = Math.floor((j - i + 1) * a / g.width);
            this.b = truncate(Math.max(1, k));
            this.c = truncate(Math.floor(i / this.b));
            this.d = truncate(Math.ceil(j / this.b));
        }
        else {
            this.c = h.i$e(b, c, d, g);
            this.d = h.i$g(b, c, d, g);
            this.b = 1;
        }
    };
    FinancialBucketCalculator.prototype.cacheValues = function () {
    };
    FinancialBucketCalculator.prototype.unCacheValues = function () {
    };
    FinancialBucketCalculator.$t = markType(FinancialBucketCalculator, 'FinancialBucketCalculator', Base.$, [IBucketizer_$type]);
    return FinancialBucketCalculator;
}(Base));
export { FinancialBucketCalculator };
var FinancialSeries = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialSeries, _super);
    function FinancialSeries() {
        var _this = _super.call(this) || this;
        _this.me = null;
        _this.ma = null;
        _this.mc = null;
        _this.l8 = null;
        _this.mh = null;
        _this.ml = false;
        _this.assigningCategoryStyle = null;
        _this.lv = null;
        _this.mw = new Dictionary$2(IFastItemColumn$1_$type.specialize(Number_$type), String_$type, 0);
        _this.mx = new Dictionary$2(String_$type, String_$type, 0);
        _this.mk = false;
        _this.l6 = null;
        _this.lq = null;
        _this.ls = null;
        _this.lp = null;
        _this.ot = null;
        _this.ly = null;
        _this.typical = null;
        _this.typicalBasedOn = null;
        _this.mj = false;
        _this.m9 = null;
        _this.m7 = null;
        _this.m8 = null;
        _this.m6 = null;
        _this.na = null;
        _this.lr = null;
        _this.lo = null;
        _this.lt = 0;
        _this.lv = new CategorySeriesRenderManager();
        _this.ml = false;
        _this.ly = new CategoryTransitionSourceFramePreparer();
        _this.lr = new CategoryFrame(3);
        _this.ab = FinancialSeries.$;
        _this.lu = 0;
        return _this;
    }
    FinancialSeries.prototype.h9 = function (a) {
        _super.prototype.h9.call(this, a);
        this.l3 = a;
    };
    FinancialSeries.prototype.get_cp = function () {
        return true;
    };
    Object.defineProperty(FinancialSeries.prototype, "cp", {
        get: function () {
            return this.get_cp();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.nk = function () {
        return 2;
    };
    FinancialSeries.prototype.ag = function (a) {
        var b = this.ai(this.ln, this.lp.f, this.ni(this.bh), this.nj(this.bh), this.k3(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        var g = this.nk();
        f[0] = { $type: Point_$type, x: c[0], y: c[g] };
        f[1] = { $type: Point_$type, x: d[0], y: d[g] };
        e[0] = f;
        return e;
    };
    FinancialSeries.prototype.ah = function (a) {
        var b = this.ai(this.ln, this.lp.f, this.ni(this.bh), this.nj(this.bh), this.k3(a), true);
        if (b == null) {
            return null;
        }
        var c = b[0];
        var d = b[1];
        var e = new Array(1);
        var f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    };
    FinancialSeries.prototype.ko = function () {
        return this.op;
    };
    FinancialSeries.prototype.hc = function () {
        _super.prototype.hc.call(this);
        this.ln = null;
        this.l7 = null;
    };
    Object.defineProperty(FinancialSeries.prototype, "mf", {
        get: function () {
            return this.me;
        },
        set: function (a) {
            if (this.me != a) {
                var b = this.me;
                this.me = a;
                this.raisePropertyChanged("OpenColumn", b, this.me);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "mb", {
        get: function () {
            return this.ma;
        },
        set: function (a) {
            if (this.ma != a) {
                var b = this.ma;
                this.ma = a;
                this.raisePropertyChanged("HighColumn", b, this.ma);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "md", {
        get: function () {
            return this.mc;
        },
        set: function (a) {
            if (this.mc != a) {
                var b = this.mc;
                this.mc = a;
                this.raisePropertyChanged("LowColumn", b, this.mc);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "l9", {
        get: function () {
            return this.l8;
        },
        set: function (a) {
            if (this.l8 != a) {
                var b = this.l8;
                this.l8 = a;
                this.raisePropertyChanged("CloseColumn", b, this.l8);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialSeries.prototype, "mi", {
        get: function () {
            return this.mh;
        },
        set: function (a) {
            if (this.mh != a) {
                var b = this.mh;
                this.mh = a;
                this.raisePropertyChanged("VolumeColumn", b, this.mh);
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.mt = function () {
        return (this.assigningCategoryStyle != null && this.ml) || this.cs;
    };
    FinancialSeries.prototype.oc = function (a) {
        if (this.assigningCategoryStyle != null && this.ml) {
            this.assigningCategoryStyle(this, a);
        }
    };
    FinancialSeries.prototype.oa = function (a, b, c, d, e, f) {
        var g = this.b8;
        this.lv.ac(a, b, c, d, e, f, g);
        var h = this.lv.c;
        var i = null;
        var j = this.by;
        if (g && this.br != null) {
            i = this.br.az.getHighlightingInfo(this, j, d, h.m, h.l, false);
            h.b = i;
        }
        h.f = f;
        this.oc(h);
        this.lv.aa(i, f, g);
    };
    FinancialSeries.prototype.nb = function (a) {
        return this.d4(a, this.ln);
    };
    FinancialSeries.prototype.e3 = function (a, b) {
        return this.e4(a, b, this.ln, runOn(this, this.nb), new FinancialValueList(this.mf, this.mb, this.md, this.l9, this.mi));
    };
    FinancialSeries.prototype.e1 = function (a, b) {
        return this.e2(a, b, this.ln, runOn(this, this.nb), new FinancialValueList(this.mf, this.mb, this.md, this.l9, this.mi));
    };
    FinancialSeries.prototype.d0 = function (a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        var f = this.ln.ja;
        return this.d1(a, b, this.ln, d, e, f, runOn(this, this.nb));
    };
    FinancialSeries.prototype.getOffsetValue = function () {
        return this.nc(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh));
    };
    FinancialSeries.prototype.getCategoryWidth = function () {
        return this.ln.getCategorySize(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh));
    };
    FinancialSeries.prototype.k0 = function (a, b, c) {
        return this.k2(a, b, c, this.nc(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.l7, this.ln, null, null, null);
    };
    FinancialSeries.prototype.ed = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bh);
        var e = this.nc(this.bh.bq, this.bh.bp, d);
        var f = new ScalerParams(0, this.bh.bq, this.bh.bp, this.ln.bz, d);
        return this.ef(new FinancialValueList(this.mf, this.mb, this.md, this.l9, this.mi), a, this.ln, f, e, runOn(this, this.nb), b, c);
    };
    FinancialSeries.prototype.d9 = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bh);
        var e = this.nc(this.bh.bq, this.bh.bp, d);
        var f = new ScalerParams(0, this.bh.bq, this.bh.bp, this.ln.bz, d);
        return this.ef(this.mb, a, this.ln, f, e, runOn(this, this.nb), b, c);
    };
    FinancialSeries.prototype.eb = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bh);
        var e = this.nc(this.bh.bq, this.bh.bp, d);
        var f = new ScalerParams(0, this.bh.bq, this.bh.bp, this.ln.bz, d);
        return this.ef(this.md, a, this.ln, f, e, runOn(this, this.nb), b, c);
    };
    FinancialSeries.prototype.nd = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bh);
        var e = this.nc(this.bh.bq, this.bh.bp, d);
        var f = new ScalerParams(0, this.bh.bq, this.bh.bp, this.ln.bz, d);
        return this.ef(this.l9, a, this.ln, f, e, runOn(this, this.nb), b, c);
    };
    FinancialSeries.prototype.ne = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bh);
        var e = this.nc(this.bh.bq, this.bh.bp, d);
        var f = new ScalerParams(0, this.bh.bq, this.bh.bp, this.ln.bz, d);
        return this.ef(this.mf, a, this.ln, f, e, runOn(this, this.nb), b, c);
    };
    FinancialSeries.prototype.nf = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bh);
        var e = this.nc(this.bh.bq, this.bh.bp, d);
        var f = new ScalerParams(0, this.bh.bq, this.bh.bp, this.ln.bz, d);
        return this.ef(this.mi, a, this.ln, f, e, runOn(this, this.nb), b, c);
    };
    FinancialSeries.prototype.kw = function (a, b, c) {
        var _this = this;
        return this.k2(a, b, c, this.nc(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.l7, this.ln, runOn(this, this.d9), function (d, e) { return _this.e4(d, e, _this.ln, runOn(_this, _this.nb), _this.mb); }, function (d, e) { return _this.e2(d, e, _this.ln, runOn(_this, _this.nb), _this.mb); });
    };
    FinancialSeries.prototype.ky = function (a, b, c) {
        var _this = this;
        return this.k2(a, b, c, this.nc(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.l7, this.ln, runOn(this, this.eb), function (d, e) { return _this.e4(d, e, _this.ln, runOn(_this, _this.nb), _this.md); }, function (d, e) { return _this.e2(d, e, _this.ln, runOn(_this, _this.nb), _this.md); });
    };
    FinancialSeries.prototype.or = function (a, b, c) {
        var _this = this;
        return this.k2(a, b, c, this.nc(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.l7, this.ln, runOn(this, this.ne), function (d, e) { return _this.e4(d, e, _this.ln, runOn(_this, _this.nb), _this.mf); }, function (d, e) { return _this.e2(d, e, _this.ln, runOn(_this, _this.nb), _this.mf); });
    };
    FinancialSeries.prototype.oq = function (a, b, c) {
        var _this = this;
        return this.k2(a, b, c, this.nc(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.l7, this.ln, runOn(this, this.nd), function (d, e) { return _this.e4(d, e, _this.ln, runOn(_this, _this.nb), _this.l9); }, function (d, e) { return _this.e2(d, e, _this.ln, runOn(_this, _this.nb), _this.l9); });
    };
    FinancialSeries.prototype.os = function (a, b, c) {
        var _this = this;
        return this.k2(a, b, c, this.nc(this.bh.bq, this.bh.bp, this.getEffectiveViewport1(this.bh)), this.l7, this.ln, runOn(this, this.nf), function (d, e) { return _this.e4(d, e, _this.ln, runOn(_this, _this.nb), _this.mi); }, function (d, e) { return _this.e2(d, e, _this.ln, runOn(_this, _this.nb), _this.mi); });
    };
    FinancialSeries.prototype.ht = function () {
        _super.prototype.ht.call(this);
        if (this.ln != null) {
            this.ln.gj(false);
        }
        if (this.l7 != null) {
            this.l7.gj(false);
        }
    };
    FinancialSeries.prototype.i8 = function (a, b) {
        this.l3.bs.e(this.ej);
        this.it(false);
    };
    FinancialSeries.prototype.i7 = function (a, b) {
        if (this.di && this.eo < 0.05) {
            this.dj = true;
        }
        this.l3.bs.e(this.ej);
        this.it(false);
    };
    FinancialSeries.prototype.mg = function (a, b, c) {
        var d = this.bv(b);
        this.mw.addItem(d, b);
        this.mx.addItem(b, c);
        return d;
    };
    FinancialSeries.prototype.n9 = function (a, b) {
        if (b == null) {
            return;
        }
        a.deregisterColumn(b);
        var c = this.mw.item(b);
        this.mx.removeItem(c);
        this.mw.removeItem(b);
    };
    FinancialSeries.prototype.ie = function (a, b, c, d) {
        _super.prototype.ie.call(this, a, b, c, d);
        switch (b) {
            case "SyncLink":
                if (this.bm != null && this.br != null) {
                    this.l3.bs.e(this.ej);
                    this.it(false);
                }
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.ln != null) {
                        this.ln.bn(this);
                    }
                    if (this.l7 != null) {
                        this.l7.bn(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.ln != null) {
                        this.ln.b8(this);
                    }
                    if (this.l7 != null) {
                        this.l7.b8(this);
                    }
                }
                this.l3.bs.e(this.ej);
                this.it(false);
                break;
            case "FastItemsSource":
                this.mk = true;
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    this.n9(typeCast(IFastItemsSource_$type, c), this.mf);
                    this.n9(typeCast(IFastItemsSource_$type, c), this.mb);
                    this.n9(typeCast(IFastItemsSource_$type, c), this.md);
                    this.n9(typeCast(IFastItemsSource_$type, c), this.l9);
                    this.n9(typeCast(IFastItemsSource_$type, c), this.mi);
                    this.mf = null;
                    this.mb = null;
                    this.md = null;
                    this.l9 = null;
                    this.mi = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    if (this.n0 != null) {
                        this.mf = this.mg(typeCast(IFastItemsSource_$type, d), this.n0, "OpenColumn");
                    }
                    if (this.nr != null) {
                        this.mb = this.mg(typeCast(IFastItemsSource_$type, d), this.nr, "HighColumn");
                    }
                    if (this.nw != null) {
                        this.md = this.mg(typeCast(IFastItemsSource_$type, d), this.nw, "LowColumn");
                    }
                    if (this.no != null) {
                        this.l9 = this.mg(typeCast(IFastItemsSource_$type, d), this.no, "CloseColumn");
                    }
                    if (this.n4 != null) {
                        this.mi = this.mg(typeCast(IFastItemsSource_$type, d), this.n4, "VolumeColumn");
                    }
                }
                this.mk = false;
                if (this.l7 != null && !this.l7.cb()) {
                    this.l3.bs.e(this.ej);
                    this.it(false);
                }
                break;
            case FinancialSeries.$$p[6]:
                if (this.by != null) {
                    this.n9(this.by, this.mf);
                    this.mf = this.mg(this.by, this.n0, "OpenColumn");
                }
                break;
            case "OpenColumn":
                if (this.l7 != null && !this.l7.cb() && !this.mk) {
                    this.l3.bs.e(this.ej);
                    this.it(false);
                }
                break;
            case FinancialSeries.$$p[1]:
                if (this.by != null) {
                    this.n9(this.by, this.mb);
                    this.mb = this.mg(this.by, this.nr, "HighColumn");
                }
                break;
            case "HighColumn":
                if (this.l7 != null && !this.l7.cb() && !this.mk) {
                    this.l3.bs.e(this.ej);
                    this.it(false);
                }
                break;
            case FinancialSeries.$$p[4]:
                if (this.by != null) {
                    this.n9(this.by, this.md);
                    this.md = this.mg(this.by, this.nw, "LowColumn");
                }
                break;
            case "LowColumn":
                if (this.l7 != null && !this.l7.cb() && !this.mk) {
                    this.l3.bs.e(this.ej);
                    this.it(false);
                }
                break;
            case FinancialSeries.$$p[0]:
                if (this.by != null) {
                    this.n9(this.by, this.l9);
                    this.l9 = this.mg(this.by, this.no, "CloseColumn");
                }
                break;
            case "CloseColumn":
                if (this.l7 != null && !this.l7.cb() && !this.mk) {
                    this.l3.bs.e(this.ej);
                    this.it(false);
                }
                break;
            case FinancialSeries.$$p[8]:
                if (this.by != null) {
                    this.n9(this.by, this.mi);
                    this.mi = this.mg(this.by, this.n4, "VolumeColumn");
                }
                break;
            case "VolumeColumn":
                if (this.l7 != null && !this.l7.cb() && !this.mk) {
                    this.l3.bs.e(this.ej);
                    this.it(false);
                }
                break;
            case FinancialSeries.$$p[9]:
                if (c != null) {
                    c.bn(this);
                }
                if (d != null) {
                    d.b8(this);
                }
                this.l3.bs.e(this.ej);
                this.it(false);
                this.h1();
                break;
            case FinancialSeries.$$p[10]:
                if (c != null) {
                    c.bn(this);
                }
                if (d != null) {
                    d.b8(this);
                }
                this.l3.bs.e(this.ej);
                if (this.l7 != null) {
                    this.l7.cb();
                }
                {
                    this.it(false);
                }
                this.h1();
                break;
            case "TransitionProgress":
                this.ls.c(this.eo, this.lq, this.lp);
                if (this.cb(this.bh)) {
                    return;
                }
                if (this.eo == 1) {
                    this.lp.v();
                    this.od(this.lp, this.l3);
                    if (this.di) {
                        this.di = false;
                        this.hf();
                        this.bs.r = truncate(this.eg());
                        this.bs.b = this.bt;
                    }
                }
                else {
                    this.od(this.ls, this.l3);
                }
                break;
            case FinancialSeries.$$p[5]:
                this.it(false);
                break;
            case "IsCustomCategoryStyleAllowed":
                this.ml = this.mo();
                this.it(false);
                break;
            case "CategoryMode":
                if (this.ln != null) {
                    this.ln.jz(true);
                }
                break;
        }
    };
    FinancialSeries.prototype.mn = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    FinancialSeries.prototype.mm = function (a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.bw) {
            return true;
        }
        return false;
    };
    FinancialSeries.prototype.lg = function (a, b, c) {
        if (b < a || a < 0 || a > this.by.count || b < 0 || b > this.by.count || c == null) {
            return null;
        }
        var d = new Array((b - a) + 1);
        var e = c.b3;
        var f = null;
        if (e) {
            f = c.i$b;
        }
        for (var g = a; g <= b; g++) {
            var h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.by.item(g);
        }
        return d;
    };
    FinancialSeries.prototype.ni = function (a) {
        return a.bs.b;
    };
    FinancialSeries.prototype.nj = function (a) {
        return a.bs.c;
    };
    FinancialSeries.prototype.lf = function (a, b) {
        return this.lg(a, b, this.l7);
    };
    FinancialSeries.prototype.get_mp = function () {
        return false;
    };
    Object.defineProperty(FinancialSeries.prototype, "mp", {
        get: function () {
            return this.get_mp();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.get_ct = function () {
        return true;
    };
    Object.defineProperty(FinancialSeries.prototype, "ct", {
        get: function () {
            return this.get_ct();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.as = function (a, b) {
        if (this.mp) {
            var c = this.l5(a, b, this.l6);
            this.l6 = c;
            return c;
        }
        else {
            var d = this.l4(a, b, this.l6);
            this.l6 = d;
            return d;
        }
    };
    FinancialSeries.prototype.nl = function (a) {
        var b = this.lp;
        if (this.b9()) {
            b = this.ls;
        }
        var c = this.bh.bp;
        var d = this.bh.bq;
        var e = this.ln;
        var f = 0;
        if (e.b5) {
            var g = (a.y - d.top) / d.height;
            f = g * c.height + c.top;
        }
        else {
            var h = (a.x - d.left) / d.width;
            f = h * c.width + c.left;
        }
        var i = b.f.count;
        var j = 0;
        for (j = 0; j < i; j++) {
            var k = b.f._inner[j];
            var l = null;
            if (j < i - 1) {
                l = b.f._inner[j + 1];
            }
            if (k[0] <= f && l == null || l[0] >= f) {
                if (l != null) {
                    if (Math.abs(k[0] - f) < Math.abs(l[0] - f)) {
                        return j;
                    }
                    else {
                        return j + 1;
                    }
                }
                else {
                    return j;
                }
            }
        }
        return j;
    };
    FinancialSeries.prototype.l5 = function (a, b, c) {
        var d = this.by.count;
        var e = this.l3.bs.c;
        var f = this.l3.bs.d;
        var g = this.l3.bs.b;
        var h = this.ln;
        var i = -1;
        var j = -1;
        if (h.b3) {
            var k = this.lp;
            if (this.b9()) {
                k = this.ls;
            }
            var l = this.nl(b);
            i = l;
            j = l;
        }
        else {
            var m = this.ex(b);
            i = truncate(Math.floor((intDivide(m, g)))) * g;
            j = i + (g - 1);
        }
        if (c != null && c.f == i && c.e == j) {
            return c;
        }
        var n = new HighlightingInfo();
        n.b = this;
        n.f = i;
        n.e = j;
        return n;
    };
    FinancialSeries.prototype.l4 = function (a, b, c) {
        var d = new HighlightingInfo();
        d.b = this;
        d.f = 0;
        d.e = this.by.count - 1;
        if (c != null && c.f == d.f && c.e == d.e) {
            return c;
        }
        return d;
    };
    FinancialSeries.prototype.mo = function () {
        return this.mr;
    };
    FinancialSeries.prototype.d2 = function (a) {
        var b = this.bh.bq;
        var c = this.bh.bp;
        var d = -1;
        if (!b.isEmpty && !c.isEmpty && this.ln != null) {
            var e = this.getEffectiveViewport1(this.bh);
            var f = new ScalerParams(0, b, c, this.ln.bz, e);
            var g = this.k5(this.bh);
            var h = this.ln.dm(g.left, f);
            var i = this.ln.dm(g.right, f);
            var j = (a.x - b.left) / b.width;
            var k = h + (j * (i - h));
            if (this.ln.categoryMode != 0) {
                k -= 0.5;
            }
            d = k;
        }
        return d;
    };
    FinancialSeries.prototype.ex = function (a) {
        return truncate(Math.round(this.d2(a)));
    };
    FinancialSeries.prototype.get_cz = function () {
        return typeCast(ISortingAxis_$type, this.ln) !== null;
    };
    Object.defineProperty(FinancialSeries.prototype, "cz", {
        get: function () {
            return this.get_cz();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.ao = function () {
        return this.ln;
    };
    FinancialSeries.prototype.ez = function (a) {
        var b = this.bh.bq;
        var c = this.bh.bp;
        var d = this.getEffectiveViewport1(this.bh);
        if (b.isEmpty || c.isEmpty) {
            return -1;
        }
        var e = new Rect(0, 0, 0, 1, 1);
        var f = new ScalerParams(0, b, c, this.ln.bz, d);
        var g = typeCast(ISortingAxis_$type, this.ln);
        var h = this.k5(this.bh);
        var i = h.left;
        var j = h.right;
        var k = this.kv(a).x;
        var l = this.ln.dm(k, f);
        var m = this.ln.dm(i, f);
        var n = this.ln.dm(j, f);
        l = Math.max(m, Math.min(n, l));
        var o = g.i$f(l);
        return o;
    };
    FinancialSeries.prototype.fe = function (a) {
        var b = 0;
        if (typeCast(ISortingAxis_$type, this.ln) !== null) {
            b = this.ez(a);
            if (b == -1) {
                return null;
            }
        }
        else {
            b = this.ex(a);
        }
        return b >= 0 && this.by != null && b < this.by.count ? this.by.item(b) : null;
    };
    FinancialSeries.prototype.nc = function (a, b, c) {
        if (this.ln == null) {
            return 0;
        }
        return this.ln.getOffset(a, b, c, this.e6);
    };
    FinancialSeries.prototype.c8 = function () {
        return this.ms;
    };
    FinancialSeries.prototype.lw = function () {
        return 11;
    };
    FinancialSeries.prototype.bn = function () {
        return 3;
    };
    FinancialSeries.prototype.od = function (a, b) {
        this.k4 = a.aa;
        b.ar();
    };
    Object.defineProperty(FinancialSeries.prototype, "ou", {
        get: function () {
            return this.ot;
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.ob = function (a, b) {
        a.u();
    };
    FinancialSeries.prototype.ds = function (a, b, c) {
        var d = _super.prototype.ds.call(this, a, b, c);
        var e = c;
        if (this.by == null || this.by.count == 0 || !c.l() || b.isEmpty || a.isEmpty || this.ln == null || this.l7 == null || e.bs.b < 1 || this.ln.a9 == null || this.l7.a9 == null || this.l7.jg == this.l7.jf || this.ln.itemsSource == null || this.ln.ja < 1) {
            e.bs.b = 0;
            d = false;
        }
        return d;
    };
    FinancialSeries.prototype.getViewInfo = function (a, b) {
        b = this.bh.bq;
        a = this.bh.bp;
        return {
            p0: a,
            p1: b
        };
    };
    FinancialSeries.prototype.ng = function (a) {
        var b = 0;
        var c = a.bq;
        var d = a.bp;
        var e = this.getEffectiveViewport1(this.bh);
        if (!c.isEmpty && !d.isEmpty && this.l7 != null) {
            var f = new ScalerParams(0, c, d, this.l7.bz, e);
            b = this.l7.dj(this.l7.jq, f);
        }
        return b;
    };
    FinancialSeries.prototype.hf = function () {
        _super.prototype.hf.call(this);
        this.lq.v();
        this.lp.v();
        this.ls.v();
    };
    FinancialSeries.prototype.iu = function (a) {
        var _this = this;
        _super.prototype.iu.call(this, a);
        this.l3.bs.e(this.ej);
        if (this.cb(this.bh)) {
            return;
        }
        if (this.da) {
            if (this.b9()) {
                this.od(this.ls, this.l3);
            }
            else {
                this.od(this.lp, this.l3);
            }
            return;
        }
        if (this.c6(a)) {
            var b = this.lq;
            if (this.b9()) {
                if (this.bs.g) {
                    this.bs.t();
                }
                this.lq = this.ls;
                this.ls = b;
            }
            else {
                this.lq = this.lp;
                this.lp = b;
            }
            this.ob(this.lp, this.l3);
            if (this.dk) {
                this.bs.w();
                this.bs.r = truncate(this.eh());
                this.bs.b = this.bu != null ? this.bu : this.bt;
                this.ly.p(this.lq, this.lp, this.isVertical, this.ln, this.l7, this.lx, this.lw(), this.bo, this.bn(), function () { return _this.ng(_this.l3); }, this.l3.bp);
            }
            this.hb();
            this.i1();
            if (this.dk) {
                this.dj = false;
                this.di = true;
            }
        }
        else {
            this.ob(this.lp, this.l3);
            this.od(this.lp, this.l3);
        }
    };
    FinancialSeries.prototype.mu = function (a) {
        try {
            for (var _a = tslib_1.__values(fromEnum(a)), _b = _a.next(); !_b.done; _b = _a.next()) {
                var b = _b.value;
                switch (b) {
                    case "HighColumn":
                        if (this.mb == null) {
                            return false;
                        }
                        break;
                    case "LowColumn":
                        if (this.md == null) {
                            return false;
                        }
                        break;
                    case "OpenColumn":
                        if (this.mf == null) {
                            return false;
                        }
                        break;
                    case "CloseColumn":
                        if (this.l9 == null) {
                            return false;
                        }
                        break;
                    case "VolumeColumn":
                        if (this.mi == null) {
                            return false;
                        }
                        break;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return true;
        var e_1, _c;
    };
    Object.defineProperty(FinancialSeries.prototype, "mv", {
        get: function () {
            return this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null;
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.mq = function () {
        return this.typical != null;
    };
    FinancialSeries.prototype.n8 = function (a) {
        this.typical(this, a);
    };
    Object.defineProperty(FinancialSeries.prototype, "m3", {
        get: function () {
            return this.m0();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype._m0 = function () {
        var a, b, _a, _b, c, e_2_1, d, e, f, g, h, e_2, _c;
        return tslib_1.__generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    a = false;
                    if (!this.mq()) return [3 /*break*/, 8];
                    b = this.lz(0, this.by.count);
                    this.n8(new FinancialEventArgs(0, this.by.count, b, this.l0(b), this));
                    if (!(b.typicalColumn != null)) return [3 /*break*/, 8];
                    a = true;
                    _d.label = 1;
                case 1:
                    _d.trys.push([1, 6, 7, 8]);
                    _a = tslib_1.__values(fromEnum(b.typicalColumn)), _b = _a.next();
                    _d.label = 2;
                case 2:
                    if (!!_b.done) return [3 /*break*/, 5];
                    c = _b.value;
                    return [4 /*yield*/, c];
                case 3:
                    _d.sent();
                    _d.label = 4;
                case 4:
                    _b = _a.next();
                    return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 8];
                case 6:
                    e_2_1 = _d.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 8];
                case 7:
                    try {
                        if (_b && !_b.done && (_c = _a.return)) _c.call(_a);
                    }
                    finally { if (e_2) throw e_2.error; }
                    return [7 /*endfinally*/];
                case 8:
                    if (!!a) return [3 /*break*/, 17];
                    if (!(this.mv && this.ln.i$b != null)) return [3 /*break*/, 13];
                    d = this.by.count;
                    e = this.ln.i$b;
                    f = 0;
                    _d.label = 9;
                case 9:
                    if (!(f < d)) return [3 /*break*/, 12];
                    return [4 /*yield*/, (this.mb.item(e.item(f)) + this.md.item(e.item(f)) + this.l9.item(e.item(f))) / 3];
                case 10:
                    _d.sent();
                    _d.label = 11;
                case 11:
                    ++f;
                    return [3 /*break*/, 9];
                case 12: return [3 /*break*/, 17];
                case 13:
                    g = this.by.count;
                    h = 0;
                    _d.label = 14;
                case 14:
                    if (!(h < g)) return [3 /*break*/, 17];
                    return [4 /*yield*/, (this.mb.item(h) + this.md.item(h) + this.l9.item(h)) / 3];
                case 15:
                    _d.sent();
                    _d.label = 16;
                case 16:
                    ++h;
                    return [3 /*break*/, 14];
                case 17: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.m0 = function () {
        var _this = this;
        return toEnum(function () { return _this._m0(); });
    };
    Object.defineProperty(FinancialSeries.prototype, "m2", {
        get: function () {
            return this.mz();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype._mz = function () {
        var a, b, c, d, e;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(this.mv && this.ln.i$b != null)) return [3 /*break*/, 7];
                    a = this.mb.count;
                    b = this.ln.i$b;
                    if (!(a > 0)) return [3 /*break*/, 2];
                    return [4 /*yield*/, this.nh(this.mb.item(b.item(0)) - this.md.item(b.item(0)))];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    c = 1;
                    _a.label = 3;
                case 3:
                    if (!(c < a)) return [3 /*break*/, 6];
                    return [4 /*yield*/, Math.max(this.nh(this.mb.item(b.item(c)) - this.md.item(b.item(c))), Math.max(this.nh(Math.abs(this.mb.item(b.item(c)) - this.l9.item(b.item(c - 1)))), this.nh(Math.abs(this.md.item(b.item(c)) - this.l9.item(b.item(c - 1))))))];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    ++c;
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 13];
                case 7:
                    d = this.mb.count;
                    if (!(d > 0)) return [3 /*break*/, 9];
                    return [4 /*yield*/, this.nh(this.mb.item(0) - this.md.item(0))];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9:
                    e = 1;
                    _a.label = 10;
                case 10:
                    if (!(e < d)) return [3 /*break*/, 13];
                    return [4 /*yield*/, Math.max(this.nh(this.mb.item(e) - this.md.item(e)), Math.max(this.nh(Math.abs(this.mb.item(e) - this.l9.item(e - 1))), this.nh(Math.abs(this.md.item(e) - this.l9.item(e - 1)))))];
                case 11:
                    _a.sent();
                    _a.label = 12;
                case 12:
                    ++e;
                    return [3 /*break*/, 10];
                case 13: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.mz = function () {
        var _this = this;
        return toEnum(function () { return _this._mz(); });
    };
    Object.defineProperty(FinancialSeries.prototype, "m1", {
        get: function () {
            return this.my();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype._my = function () {
        var a, b, c, d, e;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(this.mv && this.ln.i$b != null)) return [3 /*break*/, 7];
                    a = this.md.count;
                    b = this.ln.i$b;
                    if (!(a > 0)) return [3 /*break*/, 2];
                    return [4 /*yield*/, this.nh(this.md.item(b.item(0)))];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    c = 1;
                    _a.label = 3;
                case 3:
                    if (!(c < a)) return [3 /*break*/, 6];
                    return [4 /*yield*/, Math.min(this.nh(this.md.item(b.item(c))), this.nh(this.l9.item(b.item(c - 1))))];
                case 4:
                    _a.sent();
                    _a.label = 5;
                case 5:
                    c++;
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 13];
                case 7:
                    d = this.md.count;
                    if (!(d > 0)) return [3 /*break*/, 9];
                    return [4 /*yield*/, this.nh(this.md.item(0))];
                case 8:
                    _a.sent();
                    _a.label = 9;
                case 9:
                    e = 1;
                    _a.label = 10;
                case 10:
                    if (!(e < d)) return [3 /*break*/, 13];
                    return [4 /*yield*/, Math.min(this.nh(this.md.item(e)), this.nh(this.l9.item(e - 1)))];
                case 11:
                    _a.sent();
                    _a.label = 12;
                case 12:
                    e++;
                    return [3 /*break*/, 10];
                case 13: return [2 /*return*/];
            }
        });
    };
    FinancialSeries.prototype.my = function () {
        var _this = this;
        return toEnum(function () { return _this._my(); });
    };
    FinancialSeries.prototype.m5 = function (a) {
        if (a == null) {
            return null;
        }
        if (this.mv && this.ln.i$b != null) {
            return new SafeSortedReadOnlyDoubleCollection(0, a, this.ln.i$b);
        }
        return new SafeReadOnlyDoubleCollection(0, a);
    };
    FinancialSeries.prototype.m4 = function () {
        var a = new List$1(String_$type, 0);
        a.add("HighColumn");
        a.add("LowColumn");
        a.add("CloseColumn");
        if (this.typicalBasedOn != null && this.by != null && !this.mj) {
            this.mj = true;
            var b = this.lz(0, this.by.count);
            this.mj = false;
            var c = new FinancialEventArgs(0, this.by.count, b, this.l0(b), this);
            this.typicalBasedOn(this, c);
            if (c.basedOn != null && c.basedOn.count > 0) {
                return c.basedOn;
            }
        }
        return a;
    };
    FinancialSeries.prototype.getOpenColumnAsArray = function () {
        if (this.mf == null) {
            return null;
        }
        if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
            if (this.m9 != null) {
                return this.m9.asArray();
            }
            var a = new List$1(Number_$type, 2, this.mf.count);
            var b = this.ln.i$b;
            var c = this.mf.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.m9 = a;
            return this.m9.asArray();
        }
        else {
            return this.mf.asArray();
        }
    };
    FinancialSeries.prototype.getHighColumnAsArray = function () {
        if (this.mb == null) {
            return null;
        }
        if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
            if (this.m7 != null) {
                return this.m7.asArray();
            }
            var a = new List$1(Number_$type, 2, this.mb.count);
            var b = this.ln.i$b;
            var c = this.mb.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.m7 = a;
            return this.m7.asArray();
        }
        else {
            return this.mb.asArray();
        }
    };
    FinancialSeries.prototype.getLowColumnAsArray = function () {
        if (this.md == null) {
            return null;
        }
        if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
            if (this.m8 != null) {
                return this.m8.asArray();
            }
            var a = new List$1(Number_$type, 2, this.md.count);
            var b = this.ln.i$b;
            var c = this.md.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.m8 = a;
            return this.m8.asArray();
        }
        else {
            return this.md.asArray();
        }
    };
    FinancialSeries.prototype.getCloseColumnAsArray = function () {
        if (this.l9 == null) {
            return null;
        }
        if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
            if (this.m6 != null) {
                return this.m6.asArray();
            }
            var a = new List$1(Number_$type, 2, this.l9.count);
            var b = this.ln.i$b;
            var c = this.l9.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.m6 = a;
            return this.m6.asArray();
        }
        else {
            return this.l9.asArray();
        }
    };
    FinancialSeries.prototype.getVolumeColumnAsArray = function () {
        if (this.mi == null) {
            return null;
        }
        if (this.ln != null && typeCast(ISortingAxis_$type, this.ln) !== null) {
            if (this.na != null) {
                return this.na.asArray();
            }
            var a = new List$1(Number_$type, 2, this.mi.count);
            var b = this.ln.i$b;
            var c = this.mi.asArray();
            for (var d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.na = a;
            return this.na.asArray();
        }
        else {
            return this.mi.asArray();
        }
    };
    FinancialSeries.prototype.hh = function (a, b, c, d) {
        _super.prototype.hh.call(this, a, b, c, d);
        if (this.ln == null || !(typeCast(ISortingAxis_$type, this.ln) !== null)) {
            return;
        }
        var e = this.ln.i$b;
        switch (a) {
            case 1:
                for (var f = b; f < c; f++) {
                    var g = e._inner[f];
                    if (this.m9 != null) {
                        this.m9.insert(f, this.mf.item(g));
                    }
                    if (this.m7 != null) {
                        this.m7.insert(f, this.mb.item(g));
                    }
                    if (this.m8 != null) {
                        this.m8.insert(f, this.md.item(g));
                    }
                    if (this.m6 != null) {
                        this.m6.insert(f, this.l9.item(g));
                    }
                    if (this.na != null) {
                        this.na.insert(f, this.mi.item(g));
                    }
                }
                break;
            case 0:
                if (this.m9 != null) {
                    this.m9.v(b, c);
                }
                if (this.m7 != null) {
                    this.m7.v(b, c);
                }
                if (this.m8 != null) {
                    this.m8.v(b, c);
                }
                if (this.m6 != null) {
                    this.m6.v(b, c);
                }
                if (this.na != null) {
                    this.na.v(b, c);
                }
                break;
            case 4:
                if (this.m9 != null) {
                    this.m9 = new List$1(Number_$type, 0);
                }
                if (this.m7 != null) {
                    this.m7 = new List$1(Number_$type, 0);
                }
                if (this.m8 != null) {
                    this.m8 = new List$1(Number_$type, 0);
                }
                if (this.m6 != null) {
                    this.m6 = new List$1(Number_$type, 0);
                }
                if (this.na != null) {
                    this.na = new List$1(Number_$type, 0);
                }
                break;
            case 3:
            case 2:
                for (var h = b; h < c; h++) {
                    var i = e._inner[h];
                    if (this.m9 != null) {
                        this.m9._inner[h] = this.mf.item(i);
                    }
                    if (this.m7 != null) {
                        this.m7._inner[h] = this.mb.item(i);
                    }
                    if (this.m8 != null) {
                        this.m8._inner[h] = this.md.item(i);
                    }
                    if (this.m6 != null) {
                        this.m6._inner[h] = this.l9.item(i);
                    }
                    if (this.na != null) {
                        this.na._inner[h] = this.mi.item(i);
                    }
                }
                break;
        }
    };
    FinancialSeries.prototype.lz = function (a, b) {
        var _this = this;
        var c = this.m5(this.mf);
        var d = this.m5(this.l9);
        var e = this.m5(this.mb);
        var f = this.m5(this.md);
        var g = this.m5(this.mi);
        var h = ((function () {
            var $ret = new FinancialCalculationDataSource();
            $ret.typicalColumn = new CalculatedColumn(1, new SafeEnumerable(_this.m3), _this.m4());
            $ret.trueRange = new CalculatedColumn(1, new SafeEnumerable(_this.m2), ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("HighColumn");
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.trueLow = new CalculatedColumn(1, new SafeEnumerable(_this.m1), ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.openColumn = c;
            $ret.closeColumn = d;
            $ret.highColumn = e;
            $ret.lowColumn = f;
            $ret.volumeColumn = g;
            $ret.calculateFrom = a;
            $ret.calculateCount = b;
            $ret.minimumValue = NaN;
            $ret.maximumValue = NaN;
            $ret.count = _this.by != null ? _this.by.count : 0;
            return $ret;
        })());
        return h;
    };
    FinancialSeries.prototype.nh = function (a) {
        if (isInfinity(a) || isNaN_(a)) {
            return 0;
        }
        return a;
    };
    FinancialSeries.prototype.l0 = function (a) {
        var _this = this;
        return ((function () {
            var $ret = new FinancialCalculationSupportingCalculations();
            $ret.a = new ColumnSupportingCalculation(1, TrendCalculators.b, new List$1(String_$type, 0));
            $ret.c = new ColumnSupportingCalculation(1, TrendCalculators.e, new List$1(String_$type, 0));
            $ret.d = new ColumnSupportingCalculation(1, TrendCalculators.f, new List$1(String_$type, 0));
            $ret.b = new ColumnSupportingCalculation(1, TrendCalculators.d, new List$1(String_$type, 0));
            $ret.h = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.volumeColumn, b.shortPeriod); }, ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.f = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.volumeColumn, b.longPeriod); }, ((function () {
                var $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.g = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.typicalColumn, b.shortPeriod); }, a.typicalColumn.basedOn);
            $ret.e = new DataSourceSupportingCalculation(1, function (b) { return TrendCalculators.b(b.typicalColumn, b.longPeriod); }, a.typicalColumn.basedOn);
            $ret.k = Series.dv;
            $ret.j = Series.du;
            $ret.i = runOn(_this, _this.nh);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialSeries.prototype, "categoryAxis", {
        get: function () {
            return this.ln;
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.iv = function (a, b) {
        _super.prototype.iv.call(this, a, b);
        if (!this.dh) {
            this.bh.az(b);
            return;
        }
        var c = typeCast(FinancialSeriesView.$, this.bg);
        this.bh.az(b);
        c.bs.e(this.ej);
        if (this.cb(this.bg)) {
            return;
        }
        if (!this.db) {
            this.ob(this.lr, c);
        }
        this.db = false;
        this.od(this.lr, c);
        this.dh = false;
    };
    FinancialSeries.prototype.is = function (a, b, c, d, e) {
        _super.prototype.is.call(this, a, b, c, d, e);
        var f = this.az.a$h.item(d);
        var g = f;
        g.bs.e(this.ej);
        f.ay(c);
        if (this.cb(g)) {
            return;
        }
        if (this.lo == null) {
            this.lo = new CategoryFrame(3);
        }
        this.lo.u();
        this.ob(this.lo, g);
        this.od(this.lo, g);
    };
    FinancialSeries.prototype.al = function (a) {
        if (this.ln == a) {
            return this.l7;
        }
        if (this.l7 == a) {
            return this.ln;
        }
        return null;
    };
    FinancialSeries.prototype.preferredCategoryMode = function (a) {
        var b = typeCast(IDateTimeAxis_$type, this.ln);
        return b != null ? b.preferredCategoryMode(this) : this.lu;
    };
    Object.defineProperty(FinancialSeries.prototype, "lu", {
        get: function () {
            return this.lt;
        },
        set: function (a) {
            var b = this.lu;
            if (a != b) {
                this.lt = a;
                this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.lu));
            }
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.get_cx = function () {
        return true;
    };
    Object.defineProperty(FinancialSeries.prototype, "cx", {
        get: function () {
            return this.get_cx();
        },
        enumerable: true,
        configurable: true
    });
    FinancialSeries.prototype.iy = function (a, b) {
        _super.prototype.iy.call(this, a, b);
        this.op = a;
    };
    FinancialSeries.$t = markType(FinancialSeries, 'FinancialSeries', Series.$, [IHasCategoryAxis_$type, IHasCategoryModePreference_$type]);
    return FinancialSeries;
}(Series));
export { FinancialSeries };
Type.dep(DependencyProperty, PropertyMetadata, FinancialSeries, 'raisePropertyChanged', ['CloseMemberPath:no:oe', [2, null], 'HighMemberPath:nr:of', [2, null], 'IsCustomCategoryStyleAllowed:mr:og', [0, false], 'IsTransitionInEnabled:ms:oh', [0, false], 'LowMemberPath:nw:oi', [2, null], 'NegativeBrush:op:oj', [Brush.$, null], 'OpenMemberPath:n0:ok', [2, null], 'TransitionInMode:lx:ol', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'VolumeMemberPath:n4:om', [2, null], 'XAxis:ln:on', [CategoryAxisBase.$, null], 'YAxis:l7:oo', [NumericYAxis.$, null]]);
var FinancialCalculationSupportingCalculations = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialCalculationSupportingCalculations, _super);
    function FinancialCalculationSupportingCalculations() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.c = null;
        _this.d = null;
        _this.b = null;
        _this.h = null;
        _this.f = null;
        _this.g = null;
        _this.e = null;
        _this.k = null;
        _this.j = null;
        _this.i = null;
        return _this;
    }
    FinancialCalculationSupportingCalculations.$t = markType(FinancialCalculationSupportingCalculations, 'FinancialCalculationSupportingCalculations');
    return FinancialCalculationSupportingCalculations;
}(Base));
export { FinancialCalculationSupportingCalculations };
var DataSourceSupportingCalculation = /** @class */ (function (_super) {
    tslib_1.__extends(DataSourceSupportingCalculation, _super);
    function DataSourceSupportingCalculation(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = _rest[0];
                    _this = _super.call(this, Delegate_$type, 0, c) || this;
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    _this = _super.call(this, Delegate_$type, 1, c, d) || this;
                }
                break;
        }
        return _this;
    }
    DataSourceSupportingCalculation.$t = markType(DataSourceSupportingCalculation, 'DataSourceSupportingCalculation', SupportingCalculation$1.$.specialize(Delegate_$type));
    return DataSourceSupportingCalculation;
}(SupportingCalculation$1));
export { DataSourceSupportingCalculation };
var FinancialCalculationDataSource = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialCalculationDataSource, _super);
    function FinancialCalculationDataSource() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._openColumn = null;
        _this._closeColumn = null;
        _this._highColumn = null;
        _this._lowColumn = null;
        _this._volumeColumn = null;
        _this._indicatorColumn = null;
        _this._typicalColumn = null;
        _this._trueRange = null;
        _this._trueLow = null;
        _this._period = 0;
        _this._shortPeriod = 0;
        _this._longPeriod = 0;
        _this._count = 0;
        _this._calculateFrom = 0;
        _this._calculateCount = 0;
        _this._multiplier = 0;
        _this._minimumValue = 0;
        _this._maximumValue = 0;
        _this._specifiesRange = false;
        _this._series = null;
        return _this;
    }
    Object.defineProperty(FinancialCalculationDataSource.prototype, "openColumn", {
        get: function () {
            return this._openColumn;
        },
        set: function (a) {
            this._openColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "closeColumn", {
        get: function () {
            return this._closeColumn;
        },
        set: function (a) {
            this._closeColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "highColumn", {
        get: function () {
            return this._highColumn;
        },
        set: function (a) {
            this._highColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "lowColumn", {
        get: function () {
            return this._lowColumn;
        },
        set: function (a) {
            this._lowColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "volumeColumn", {
        get: function () {
            return this._volumeColumn;
        },
        set: function (a) {
            this._volumeColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "indicatorColumn", {
        get: function () {
            return this._indicatorColumn;
        },
        set: function (a) {
            this._indicatorColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "typicalColumn", {
        get: function () {
            return this._typicalColumn;
        },
        set: function (a) {
            this._typicalColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "trueRange", {
        get: function () {
            return this._trueRange;
        },
        set: function (a) {
            this._trueRange = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "trueLow", {
        get: function () {
            return this._trueLow;
        },
        set: function (a) {
            this._trueLow = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "period", {
        get: function () {
            return this._period;
        },
        set: function (a) {
            this._period = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "shortPeriod", {
        get: function () {
            return this._shortPeriod;
        },
        set: function (a) {
            this._shortPeriod = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "longPeriod", {
        get: function () {
            return this._longPeriod;
        },
        set: function (a) {
            this._longPeriod = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "count", {
        get: function () {
            return this._count;
        },
        set: function (a) {
            this._count = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "calculateFrom", {
        get: function () {
            return this._calculateFrom;
        },
        set: function (a) {
            this._calculateFrom = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "calculateCount", {
        get: function () {
            return this._calculateCount;
        },
        set: function (a) {
            this._calculateCount = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "multiplier", {
        get: function () {
            return this._multiplier;
        },
        set: function (a) {
            this._multiplier = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "minimumValue", {
        get: function () {
            return this._minimumValue;
        },
        set: function (a) {
            this._minimumValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "maximumValue", {
        get: function () {
            return this._maximumValue;
        },
        set: function (a) {
            this._maximumValue = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "specifiesRange", {
        get: function () {
            return this._specifiesRange;
        },
        set: function (a) {
            this._specifiesRange = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialCalculationDataSource.prototype, "series", {
        get: function () {
            return this._series;
        },
        set: function (a) {
            this._series = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialCalculationDataSource.$t = markType(FinancialCalculationDataSource, 'FinancialCalculationDataSource');
    return FinancialCalculationDataSource;
}(Base));
export { FinancialCalculationDataSource };
var FinancialSeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialSeriesView, _super);
    function FinancialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.bu = null;
        _this.bs = null;
        _this.bw = 0;
        _this.bw = -1;
        _this.bu = a;
        _this.bs = _this.bt();
        return _this;
    }
    FinancialSeriesView.prototype.bv = function (a) {
        if (this.bw != a.t) {
            return true;
        }
        return false;
    };
    FinancialSeriesView.prototype.bx = function (a) {
        this.bw = a.t;
    };
    FinancialSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bi = 6;
        }
    };
    FinancialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.bu.ln.bw) {
            var b = this.bu.ln;
            a += "<span>${item." + b.dateTimeMemberPath + "}</span><br/>";
        }
        else if (this.bu.ln.er != null) {
            a += "<span>${item." + this.bu.ln.er + "}</span><br/>";
        }
        a += "<span class='ui-priority-primary'";
        var c = this.e.az.a$q(this.e);
        if (!stringIsNullOrEmpty(c)) {
            a += " style='color:" + c + "'";
        }
        a += ">" + this.bu.fj + "</span><table><tr><td>" + "Open:</td><td>" + "${item." + this.bu.n0 + "}</td></tr><tr><td>" + "High:</td><td>" + "${item." + this.bu.nr + "}</td></tr><tr><td>" + "Low:</td><td>" + "${item." + this.bu.nw + "}</td></tr><tr><td>" + "Close:</td><td>" + "${item." + this.bu.no + "}</td></tr>";
        if (!stringIsNullOrEmpty(this.bu.n4)) {
            a += "<tr><td>" + "Volume:</td><td>" + "${item." + this.bu.n4 + "}</td></tr>";
        }
        a += "</table></div>";
        return a;
    };
    FinancialSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.kp = a;
        this.e.ek = 5;
        this.e.el = 2;
        this.e.em = 2;
    };
    FinancialSeriesView.$t = markType(FinancialSeriesView, 'FinancialSeriesView', SeriesView.$);
    return FinancialSeriesView;
}(SeriesView));
export { FinancialSeriesView };
/*<BeginStatics Name="Infragistics.Controls.Charts.FinancialSeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.FinancialSeries" />*/
//# sourceMappingURL=FinancialEventArgs_combined.js.map