/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { FastItemDateTimeColumn } from "./FastItemDateTimeColumn";
import { CategoryXAxis } from "./CategoryXAxis";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { TimeAxisLabelFormatCollection } from "./TimeAxisLabelFormatCollection";
import { IFastItemsSource_$type } from "./IFastItemsSource";
import { TimeAxisBase } from "./TimeAxisBase";
import { runOn, delegateCombine, typeCast, Date_$type, markType } from "./type";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "./Rect";
import { TimeXAxis } from "./TimeXAxis";
import { truncate } from "./number";
import { dateMaxValue, dateMinValue } from "./date";
var OrdinalTimeXAxis = /** @class */ (function (_super) {
    tslib_1.__extends(OrdinalTimeXAxis, _super);
    function OrdinalTimeXAxis() {
        var _this = _super.call(this) || this;
        _this.k1 = dateMaxValue();
        _this.k0 = dateMinValue();
        _this.k3 = dateMaxValue();
        _this.k2 = dateMinValue();
        _this.k8 = null;
        _this.ky = null;
        _this.kw = null;
        _this.actualRangeChanged = null;
        FastItemDateTimeColumn.m();
        _this.kw = new TimeAxisLabelFormatCollection();
        var a = _this.kx;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(_this, _this.le));
        return _this;
    }
    OrdinalTimeXAxis.prototype.f7 = function (a, b, c, d) {
        _super.prototype.f7.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                var e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.kz);
                    this.kz = null;
                }
                if (this.ir != null) {
                    this.kz = TimeAxisBase.kc(this.la, this);
                }
                break;
            case "DateTimeMemberPath":
                if (this.ir != null) {
                    this.ir.deregisterColumn(this.kz);
                    this.kz = TimeAxisBase.kc(this.la, this);
                }
                break;
            case "DateTimeColumn":
                this.lf();
                break;
        }
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "actualMinimumValue", {
        get: function () {
            return this.k1;
        },
        set: function (a) {
            this.k1 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrdinalTimeXAxis.prototype, "actualMaximumValue", {
        get: function () {
            return this.k0;
        },
        set: function (a) {
            this.k0 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrdinalTimeXAxis.prototype, "visibleMinimum", {
        get: function () {
            return this.k3;
        },
        set: function (a) {
            this.k3 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrdinalTimeXAxis.prototype, "visibleMaximum", {
        get: function () {
            return this.k2;
        },
        set: function (a) {
            this.k2 = a;
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.jw = function (a) {
        _super.prototype.jw.call(this, a);
        this.lf();
    };
    OrdinalTimeXAxis.prototype.lf = function () {
        if (this.kz == null || this.kz.count == 0) {
            this.actualMinimumValue = dateMinValue();
            this.actualMaximumValue = dateMaxValue();
            return;
        }
        var a = +(this.actualMinimumValue) != +(this.kz.item(0)) && +(this.actualMaximumValue) != +(this.kz.item(this.kz.count - 1));
        if (a) {
            var b = this.actualMinimumValue;
            var c = this.actualMaximumValue;
            this.actualMinimumValue = this.kz.item(0);
            this.actualMaximumValue = this.kz.item(this.kz.count - 1);
            this.lg();
            if (this.actualRangeChanged != null) {
                this.actualRangeChanged(this, new AxisRangeChangedEventArgs(b.getTime(), this.actualMinimumValue.getTime(), c.getTime(), this.actualMaximumValue.getTime()));
            }
        }
    };
    OrdinalTimeXAxis.prototype.lg = function () {
        if (this.kz == null || this.kz.count == 0 || this.a9 == null) {
            this.visibleMinimum = this.actualMinimumValue;
            this.visibleMaximum = this.actualMaximumValue;
            return;
        }
        var a = new ScalerParams(1, this.a9.my, this.ib, this.bz);
        var b = truncate(Math.ceil(this.dm(this.ib.left, a)));
        var c = truncate(Math.ceil(this.dm(this.ib.right, a)));
        this.visibleMinimum = b >= 0 && b < this.kz.count ? this.kz.item(b) : this.actualMinimumValue;
        this.visibleMaximum = c >= 0 && c < this.kz.count ? this.kz.item(c) : this.actualMaximumValue;
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "la", {
        get: function () {
            return this.k8;
        },
        set: function (a) {
            var b = this.la;
            if (a != b) {
                this.k8 = a;
                this.gd("DateTimeMemberPath", b, this.la);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OrdinalTimeXAxis.prototype, "kz", {
        get: function () {
            return this.ky;
        },
        set: function (a) {
            if (this.ky != a) {
                var b = this.ky;
                this.ky = a;
                this.gd("DateTimeColumn", b, this.ky);
            }
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.gv = function (a, b) {
        _super.prototype.gv.call(this, a, b);
        this.lg();
    };
    OrdinalTimeXAxis.prototype.getWindowRectForSelection = function (a, b) {
        if (this.kz == null) {
            return Rect.empty;
        }
        var c = a > b;
        var d = c ? b : a;
        var e = c ? a : b;
        var f = -1;
        while (++f < this.kz.count && this.kz.item(f) < d) {
            ;
        }
        var g = this.kz.count;
        while (--g >= 0 && this.kz.item(g) > e) {
            ;
        }
        var h = new ScalerParams(0, new Rect(0, 0, 0, 1, 1), new Rect(0, 0, 0, 1, 1), this.bz, this.a9.mo);
        var i = this.dj(f, h);
        var j = this.dj(g + 1, h);
        return new Rect(0, i, NaN, Math.max(0, j - i), NaN);
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "kx", {
        get: function () {
            return this.kw;
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.le = function (a, b) {
        this.gj(false);
    };
    OrdinalTimeXAxis.prototype.f9 = function (a) {
        _super.prototype.f9.call(this, a);
        this.la = a;
    };
    OrdinalTimeXAxis.prototype.eq = function (a) {
        if (!(typeCast(Date_$type, a) !== null)) {
            return _super.prototype.eq.call(this, a);
        }
        var b = TimeXAxis.lu(a, this.ld, this.kx);
        return b == null ? _super.prototype.eq.call(this, a) : b;
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "ld", {
        get: function () {
            return +(this.visibleMaximum) - +(this.visibleMinimum);
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.ka = function () {
        return this.kz;
    };
    OrdinalTimeXAxis.prototype.gu = function (a, b) {
        _super.prototype.gu.call(this, a, b);
        this.lg();
    };
    OrdinalTimeXAxis.prototype.kg = function (a, b) {
        return _super.prototype.kg.call(this, a + 0.5, b);
    };
    OrdinalTimeXAxis.prototype.kf = function (a, b, c, d) {
        return b;
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "isVertical", {
        get: function () {
            return this.b5;
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.prototype.j$c = function (a, b) {
        return this.dm.apply(this, arguments);
    };
    OrdinalTimeXAxis.prototype.j$b = function (a, b) {
        return this.dj.apply(this, arguments);
    };
    OrdinalTimeXAxis.prototype.j$d = function (a, b, c, d, e) {
        this.fz.apply(this, arguments);
    };
    OrdinalTimeXAxis.prototype.j$e = function (a, b, c, d) {
        this.f0.apply(this, arguments);
    };
    OrdinalTimeXAxis.prototype.j$f = function (a, b, c, d) {
        this.f1.apply(this, arguments);
    };
    Object.defineProperty(OrdinalTimeXAxis.prototype, "j$a", {
        get: function () {
            return this.bz;
        },
        enumerable: true,
        configurable: true
    });
    OrdinalTimeXAxis.$t = markType(OrdinalTimeXAxis, 'OrdinalTimeXAxis', CategoryXAxis.$, [ITimeRangeSelectorAxis_$type]);
    return OrdinalTimeXAxis;
}(CategoryXAxis));
export { OrdinalTimeXAxis };
//# sourceMappingURL=OrdinalTimeXAxis.js.map