/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { Type, markType, typeCast, Point_$type } from "./type";
import { isNaN_ } from "./number";
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { IHasHighLowValueCategory_$type } from "./IHasHighLowValueCategory";
import { RangeCategoryFramePreparer } from "./RangeCategoryFramePreparer";
import { DependencyProperty } from "./DependencyProperty";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ICategoryScaler_$type } from "./ICategoryScaler";
import { IScaler_$type } from "./IScaler";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { Rect } from "./Rect";
import { ScalerParams } from "./ScalerParams";
import { IFastItemsSource_$type } from "./IFastItemsSource";
import { AxisRange } from "./AxisRange";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CollisionAvoider } from "./CollisionAvoider";
import { ISupportsMarkers_$type } from "./ISupportsMarkers";
import { PropertyMetadata } from "./PropertyMetadata";
import { FastFlattener } from "./FastFlattener";
import { stringIsNullOrEmpty } from "./string";
var RangeCategoryBucketCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(RangeCategoryBucketCalculator, _super);
    function RangeCategoryBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.j = null;
        _this.l = 0;
        _this.k = 0;
        _this.i = null;
        _this.h = null;
        _this.j = a;
        return _this;
    }
    RangeCategoryBucketCalculator.prototype.getBucketWithoutUnknowns = function (a) {
        var b = false;
        var c = this.i;
        var d = this.h;
        var e = this.l;
        var f = this.k;
        var g = Math.min(e, f);
        var h = a * this.d;
        var i = Math.min(h + this.d - 1, g - 1);
        var j = 1.7976931348623157E+308;
        var k = -1.7976931348623157E+308;
        var l = true;
        var m = 0;
        var n = 0;
        var o;
        var p;
        for (var q = h; q <= i; ++q) {
            m = c[q];
            n = d[q];
            if (m < n) {
                o = m;
                p = n;
            }
            else {
                p = m;
                o = n;
            }
            if (!l) {
                j = j < o ? j : o;
                k = k > o ? k : o;
                j = j < p ? j : p;
                k = k > p ? k : p;
            }
            else {
                j = Math.min(j, o);
                k = Math.max(k, o);
                k = Math.max(k, p);
                j = Math.min(j, p);
                l = false;
            }
        }
        if (b && n < m) {
            var r = j;
            j = k;
            k = r;
        }
        if (!l) {
            var s = new Array(3);
            s[0] = 0.5 * (h + i);
            s[1] = j;
            s[2] = k;
            return s;
        }
        var t = new Array(3);
        t[0] = NaN;
        t[1] = NaN;
        t[2] = NaN;
        return t;
    };
    RangeCategoryBucketCalculator.prototype.getBucket = function (a) {
        var b = false;
        var c = this.i;
        var d = this.h;
        var e = this.l;
        var f = this.k;
        var g = Math.min(e, f);
        var h = a * this.d;
        var i = Math.min(h + this.d - 1, g - 1);
        var j = NaN;
        var k = NaN;
        var l = true;
        var m = 0;
        var n = 0;
        var o;
        var p;
        for (var q = h; q <= i; ++q) {
            m = c[q];
            n = d[q];
            if (m < n) {
                o = m;
                p = n;
            }
            else {
                p = m;
                o = n;
            }
            if (!l) {
                if (!isNaN_(o)) {
                    j = j < o ? j : o;
                    k = k > o ? k : o;
                }
                if (!isNaN_(p)) {
                    j = j < p ? j : p;
                    k = k > p ? k : p;
                }
            }
            else {
                if (!isNaN_(o)) {
                    if (isNaN_(j)) {
                        j = o;
                    }
                    else {
                        j = Math.min(j, o);
                    }
                    if (!isNaN_(k)) {
                        k = Math.max(k, o);
                    }
                }
                if (!isNaN_(p)) {
                    if (isNaN_(k)) {
                        k = p;
                    }
                    else {
                        k = Math.max(k, p);
                    }
                    if (!isNaN_(j)) {
                        j = Math.min(j, p);
                    }
                }
                if (!isNaN_(j) && !isNaN_(k)) {
                    l = false;
                }
            }
        }
        if (n < m && b) {
            var r = j;
            j = k;
            k = r;
        }
        if (!l) {
            var s = new Array(3);
            s[0] = 0.5 * (h + i);
            s[1] = j;
            s[2] = k;
            return s;
        }
        var t = new Array(3);
        t[0] = NaN;
        t[1] = NaN;
        t[2] = NaN;
        return t;
    };
    RangeCategoryBucketCalculator.prototype.cacheValues = function () {
        this.l = this.j.cu.lowColumn.count;
        this.k = this.j.cu.highColumn.count;
        this.i = this.j.cu.lowColumn.asArray();
        this.h = this.j.cu.highColumn.asArray();
    };
    RangeCategoryBucketCalculator.prototype.unCacheValues = function () {
        this.i = null;
        this.h = null;
    };
    RangeCategoryBucketCalculator.$t = markType(RangeCategoryBucketCalculator, 'RangeCategoryBucketCalculator', CategoryBucketCalculator.$);
    return RangeCategoryBucketCalculator;
}(CategoryBucketCalculator));
export { RangeCategoryBucketCalculator };
var RangeCategorySeries = /** @class */ (function (_super) {
    tslib_1.__extends(RangeCategorySeries, _super);
    function RangeCategorySeries() {
        var _this = _super.call(this) || this;
        _this._RangeFramePreparer = null;
        _this.og = null;
        _this.oe = null;
        _this.ob = null;
        _this.RangeFramePreparer = new RangeCategoryFramePreparer(1, _this, _this.od, _this, _this, _this.od.cl);
        return _this;
    }
    RangeCategorySeries.prototype.be = function () {
        return new RangeCategorySeriesView(this);
    };
    RangeCategorySeries.prototype.h9 = function (a) {
        _super.prototype.h9.call(this, a);
        this.od = a;
    };
    Object.defineProperty(RangeCategorySeries.prototype, "RangeFramePreparer", {
        get: function () {
            return this._RangeFramePreparer;
        },
        set: function (a) {
            this._RangeFramePreparer = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeCategorySeries.prototype, "lowColumn", {
        get: function () {
            return this.og;
        },
        set: function (a) {
            if (this.og != a) {
                var b = this.og;
                this.og = a;
                this.raisePropertyChanged("LowColumn", b, this.og);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeCategorySeries.prototype, "highColumn", {
        get: function () {
            return this.oe;
        },
        set: function (a) {
            if (this.oe != a) {
                var b = this.oe;
                this.oe = a;
                this.raisePropertyChanged("HighColumn", b, this.oe);
            }
        },
        enumerable: true,
        configurable: true
    });
    RangeCategorySeries.prototype.mv = function () {
        return 11;
    };
    RangeCategorySeries.prototype.n2 = function (a, b) {
        _super.prototype.n2.call(this, a, b);
        b.by = true;
        CategoryMarkerManager.b(this, a.m, b.co, this.lk);
        this.nw(b, a);
    };
    RangeCategorySeries.prototype.oo = function (a, b, c, d, e, f) {
        this.od.cv(a, b, c, d, e, f);
    };
    RangeCategorySeries.prototype.c5 = function (a) {
        var b = new Rect(0, 0, 0, 1, 1);
        var c = this.bh != null ? this.bh.bq : Rect.empty;
        c = c.copy();
        var d = this.bh != null ? this.bh.bp : Rect.empty;
        var e = !c.isEmpty && !d.isEmpty && this.by != null ? this.by.indexOf(a) : -1;
        var f = this.fetchXAxis();
        var g = this.fetchYAxis();
        var h = this.k7(this.bh);
        var i;
        if (f != null) {
            var j = new ScalerParams(0, b, b, f.bz, h);
            i = f.dj(e, j);
        }
        else {
            i = NaN;
        }
        var k = f != null ? this.RangeFramePreparer.r(typeCast(ICategoryScaler_$type, f), b, b, h) : 0;
        i += k;
        if (e >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (!isNaN_(i)) {
                if (i < c.left + 0.1 * c.width) {
                    i = i + 0.4 * c.width;
                }
                if (i > c.right - 0.1 * c.width) {
                    i = i - 0.4 * c.width;
                }
                c.x = i - 0.5 * c.width;
            }
            if (g != null && this.highColumn != null && e < this.highColumn.count) {
                var l = new ScalerParams(0, b, b, g.bz, h);
                var m = g.dj(this.highColumn.item(e), l);
                var n = g.dj(this.lowColumn.item(e), l);
                if (!isNaN_(m) && !isNaN_(n)) {
                    var o = Math.abs(n - m);
                    if (c.height < o) {
                        c.height = o;
                        c.y = Math.min(n, m);
                    }
                    else {
                        if (n < c.top + 0.1 * c.height) {
                            n = n + 0.4 * c.height;
                        }
                        if (n > c.bottom - 0.1 * c.height) {
                            n = n - 0.4 * c.height;
                        }
                        c.y = n - 0.5 * c.height;
                    }
                }
            }
            if (this.bm != null) {
                this.bm.ap(this.br, c, true);
            }
        }
        return e >= 0;
    };
    RangeCategorySeries.prototype.ie = function (a, b, c, d) {
        _super.prototype.ie.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.lowColumn);
                    c.deregisterColumn(this.highColumn);
                    this.lowColumn = null;
                    this.highColumn = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.lowColumn = this.bv(this.om);
                    this.highColumn = this.bv(this.oj);
                }
                if (!this.ng()) {
                    this.mu.cl.g(this.ej);
                    this.it(false);
                }
                break;
            case RangeCategorySeries.$$p[1]:
                if (this.by != null) {
                    this.by.deregisterColumn(this.lowColumn);
                    this.lowColumn = this.bv(this.om);
                }
                break;
            case "LowColumn":
                if (!this.ng()) {
                    this.mu.cl.g(this.ej);
                    this.it(false);
                }
                break;
            case RangeCategorySeries.$$p[0]:
                if (this.by != null) {
                    this.by.deregisterColumn(this.highColumn);
                    this.highColumn = this.bv(this.oj);
                }
                break;
            case "HighColumn":
                if (!this.ng()) {
                    this.mu.cl.g(this.ej);
                    this.it(false);
                }
                break;
        }
    };
    RangeCategorySeries.prototype.am = function (a) {
        if (this.lowColumn == null || this.lowColumn.count == 0 || this.highColumn == null || this.highColumn.count == 0) {
            return null;
        }
        if (a == this.fetchXAxis()) {
            var b = Math.min(this.lowColumn.count, this.highColumn.count);
            return new AxisRange(0, b - 1);
        }
        if (a == this.fetchYAxis()) {
            var c = Math.min(this.lowColumn.minimum, this.highColumn.minimum);
            var d = Math.max(this.lowColumn.maximum, this.highColumn.maximum);
            return new AxisRange(Math.min(c, d), Math.max(c, d));
        }
        return null;
    };
    RangeCategorySeries.prototype.hh = function (a, b, c, d) {
        if (this.fetchXAxis() != null && typeCast(ISortingAxis_$type, this.fetchXAxis()) !== null) {
            this.fetchXAxis().i$i();
        }
        var e = this.fetchXAxis();
        switch (a) {
            case 3:
                if (d == this.om || d == this.oj) {
                    if (e != null) {
                        e.cb();
                    }
                    if (!this.ng()) {
                        this.it(true);
                    }
                }
                break;
            case 1:
                if (e != null) {
                    e.cb();
                }
                this.mu.cl.g(this.ej);
                if (!this.ng()) {
                    this.it(true);
                }
                break;
            case 0:
                if (e != null) {
                    e.cb();
                }
                this.mu.cl.g(this.ej);
                if (!this.ng()) {
                    this.it(true);
                }
                break;
            case 2:
                if (e != null) {
                    e.cb();
                }
                if (this.om != null && this.oj != null && this.mu.cl.d > 0 && !this.ng()) {
                    this.it(true);
                }
                break;
            case 4:
                if (e != null) {
                    e.cb();
                }
                this.mu.cl.g(this.ej);
                if (!this.ng()) {
                    this.it(true);
                }
                break;
        }
    };
    RangeCategorySeries.prototype.ds = function (a, b, c) {
        var d = _super.prototype.ds.call(this, a, b, c);
        if (this.lowColumn == null || this.lowColumn.count == 0 || this.highColumn == null || this.highColumn.count == 0) {
            d = false;
        }
        return d;
    };
    RangeCategorySeries.prototype.nz = function (a, b) {
        _super.prototype.nz.call(this, a, b);
        this.RangeFramePreparer.d(a, b);
    };
    Object.defineProperty(RangeCategorySeries.prototype, "currentCategoryMode", {
        get: function () {
            return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.fetchXAxis()));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeCategorySeries.prototype, "scaler", {
        get: function () {
            return typeCast(ICategoryScaler_$type, this.fetchXAxis());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeCategorySeries.prototype, "yScaler", {
        get: function () {
            return typeCast(IScaler_$type, this.fetchYAxis());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeCategorySeries.prototype, "bucketizer", {
        get: function () {
            return this.mu.cl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RangeCategorySeries.prototype, "currentMode2Index", {
        get: function () {
            return this.no();
        },
        enumerable: true,
        configurable: true
    });
    RangeCategorySeries.prototype.provideCollisionDetector = function () {
        return new CollisionAvoider();
    };
    Object.defineProperty(RangeCategorySeries.prototype, "mayContainUnknowns", {
        get: function () {
            return this.lowColumn == null || this.lowColumn.mayContainUnknowns || this.highColumn == null || this.highColumn.mayContainUnknowns;
        },
        enumerable: true,
        configurable: true
    });
    RangeCategorySeries.prototype.iv = function (a, b) {
        var c = this.dh;
        _super.prototype.iv.call(this, a, b);
        if (!c) {
            this.bh.az(b);
            return;
        }
        this.bh.az(b);
        if (this.cb(this.bg)) {
            return;
        }
        var d = new RangeCategoryFramePreparer(1, this, typeCast(ISupportsMarkers_$type, this.bg), this.br.bk.m, this, this.bg.cl);
        if (!this.db) {
            this.mo = new CategoryFrame(3);
            this.mo.u();
            d.d(this.mo, this.bg);
        }
        this.db = false;
        this.n2(this.mo, this.bg);
        this.dh = false;
    };
    RangeCategorySeries.prototype.is = function (a, b, c, d, e) {
        _super.prototype.is.call(this, a, b, c, d, e);
        var f = this.az.a$h.item(d);
        var g = f;
        g.cl.g(this.ej);
        f.ay(c);
        if (this.cb(g)) {
            return;
        }
        var h = new RangeCategoryFramePreparer(1, this, typeCast(ISupportsMarkers_$type, f), f, this, f.cl);
        if (this.ob == null) {
            this.ob = new CategoryFrame(3);
        }
        this.ob.u();
        h.d(this.ob, g);
        this.n2(this.ob, g);
    };
    RangeCategorySeries.prototype.d8 = function () {
        return this.lowColumn == null || this.lowColumn.count == 0 ? NaN : this.lowColumn.item(0);
    };
    Object.defineProperty(RangeCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.nh;
        },
        enumerable: true,
        configurable: true
    });
    RangeCategorySeries.$t = markType(RangeCategorySeries, 'RangeCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasHighLowValueCategory_$type]);
    return RangeCategorySeries;
}(CategorySeries));
export { RangeCategorySeries };
Type.dep(DependencyProperty, PropertyMetadata, RangeCategorySeries, 'raisePropertyChanged', ['HighMemberPath:oj:op', [2, null], 'LowMemberPath:om:oq', [2, null]]);
var RangeCategorySeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(RangeCategorySeriesView, _super);
    function RangeCategorySeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cu = null;
        _this.cu = a;
        return _this;
    }
    RangeCategorySeriesView.prototype.cv = function (a, b, c, d, e, f) {
        a.aj.clear();
        b.aj.clear();
        c.aj.clear();
        var g = FastFlattener.b(d, e, true, f, this.e.ej);
        var h = FastFlattener.b(d, e, false, f, this.e.ej);
        var i = g.count;
        var j = h.count;
        var k;
        var l;
        var m;
        var n;
        for (var o = 0; o < i; o++) {
            k = g.item(o);
            l = e._inner[k];
            m = l[0];
            n = l[1];
            a.aj.add({ $type: Point_$type, x: m, y: n });
            b.aj.add({ $type: Point_$type, x: m, y: n });
        }
        var p;
        var q;
        for (var r = 0; r < j; r++) {
            k = h.item(r);
            l = e._inner[k];
            if (f) {
                p = l[0];
                q = l[2];
            }
            else {
                p = l[2];
                q = l[3];
            }
            c.aj.add({ $type: Point_$type, x: p, y: q });
            b.aj.add({ $type: Point_$type, x: p, y: q });
        }
        a.ab = a.aj.count > 0;
        b.ab = b.aj.count > 0;
        c.ab = c.aj.count > 0;
    };
    RangeCategorySeriesView.prototype.cm = function () {
        return new RangeCategoryBucketCalculator(this);
    };
    RangeCategorySeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        var b = null;
        if (this.cu.fetchXAxis().bt) {
            b = this.cu.fetchXAxis();
        }
        else if (this.cu.fetchYAxis().bt) {
            b = this.cu.fetchYAxis();
        }
        if (b.bw) {
            var c = b;
            a += "<span>${item." + c.dateTimeMemberPath + "}</span><br/>";
        }
        else if (b != null && b.er != null) {
            a += "<span>${item." + b.er + "}</span><br/>";
        }
        a += "<span";
        var d = this.e.az.a$q(this.e);
        if (!stringIsNullOrEmpty(d)) {
            a += " style='color:" + d + "'";
        }
        a += ">" + this.cu.fj + ": </span><span class='ui-priority-primary'>" + "${item." + this.cu.om + "} - ${item." + this.cu.oj + "}</span></div>";
        return a;
    };
    RangeCategorySeriesView.$t = markType(RangeCategorySeriesView, 'RangeCategorySeriesView', CategorySeriesView.$);
    return RangeCategorySeriesView;
}(CategorySeriesView));
export { RangeCategorySeriesView };
/*<BeginStatics Name="Infragistics.Controls.Charts.RangeCategorySeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.RangeCategorySeries" />*/
//# sourceMappingURL=RangeCategoryBucketCalculator_combined.js.map