import { Control } from "./Control";
import { INotifyPropertyChanged, Type, Point, PropertyChangedEventArgs, IEnumerable, EventArgs, IEnumerable$1, IList$1, Base, DomRenderer, DomWrapper } from "./type";
import { ILegendOwner } from "./ILegendOwner";
import { IInternalLegendOwner } from "./IInternalLegendOwner";
import { SRProvider } from "./SRProvider";
import { DoubleAnimator } from "./DoubleAnimator";
import { IChartLegend } from "./IChartLegend";
import { DependencyProperty } from "./DependencyProperty";
import { DependencyObject } from "./DependencyObject";
import { Rect } from "./Rect";
import { ChartHitTestMode } from "./ChartHitTestMode";
import { InteractionState } from "./InteractionState";
import { WindowResponse } from "./WindowResponse";
import { Visibility } from "./Visibility";
import { IOverviewPlusDetailPane } from "./IOverviewPlusDetailPane";
import { SeriesViewerComponentsFromView } from "./SeriesViewerComponentsFromView";
import { Brush } from "./Brush";
import { ModifierKeys } from "./ModifierKeys";
import { DataTemplate } from "./DataTemplate";
import { HorizontalAlignment } from "./HorizontalAlignment";
import { CanvasRenderScheduler } from "./CanvasRenderScheduler";
import { SyncSettings } from "./SyncSettings";
import { SeriesViewerComponentsForView } from "./SeriesViewerComponentsForView";
import { Dictionary$2 } from "./Dictionary$2";
import { PropertyUpdatedEventArgs } from "./PropertyUpdatedEventArgs";
import { NotifyCollectionChangedEventArgs } from "./NotifyCollectionChangedEventArgs";
import { ObservableCollection$1 } from "./ObservableCollection$1";
import { Size } from "./Size";
import { List$1 } from "./List$1";
import { FrameworkElement } from "./FrameworkElement";
import { MouseEventArgs } from "./MouseEventArgs";
import { MouseButtonEventArgs } from "./MouseButtonEventArgs";
import { Key } from "./Key";
import { RectChangedEventArgs } from "./RectChangedEventArgs";
import { Thickness } from "./Thickness";
import { AxisTitlePosition } from "./AxisTitlePosition";
import { FontInfo } from "./FontInfo";
import { IFastItemsSource } from "./IFastItemsSource";
import { CoercionInfo } from "./CoercionInfo";
import { ChartContentType } from "./ChartContentType";
import { ISchedulableRender } from "./ISchedulableRender";
import { Rectangle } from "./Rectangle";
import { Path } from "./Path";
import { Line } from "./Line";
import { RenderingContext } from "./RenderingContext";
import { EventProxy } from "./EventProxy";
import { TextBlock } from "./TextBlock";
import { ITileZoomTile } from "./ITileZoomTile";
import { RenderSurface } from "./RenderSurface";
import { PathGeometry } from "./PathGeometry";
import { DataContext } from "./DataContext";
import { LabelPanelsArrangeState } from "./LabelPanelsArrangeState";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { IProvidesViewport } from "./IProvidesViewport";
import { PointerTooltipStyle } from "./PointerTooltipStyle";
import { BrushCollection } from "./BrushCollection";
import { DefaultPaletteInfo } from "./DefaultPaletteInfo";
import { AxisRange } from "./AxisRange";
import { VerticalAlignment } from "./VerticalAlignment";
import { Canvas } from "./Canvas";
import { IFastItemsSourceProvider } from "./IFastItemsSourceProvider";
import { AxisExtentType } from "./AxisExtentType";
import { DoubleCollection } from "./DoubleCollection";
import { LabelPosition } from "./LabelPosition";
import { LabelFontHeuristics } from "./LabelFontHeuristics";
import { AxisOrientation } from "./AxisOrientation";
import { Pool$1 } from "./Pool$1";
import { AxisComponentsFromView } from "./AxisComponentsFromView";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { GeometryCollection } from "./GeometryCollection";
import { PathRenderingInfo } from "./PathRenderingInfo";
import { RenderRequestedEventArgs } from "./RenderRequestedEventArgs";
import { ScalerParams } from "./ScalerParams";
import { CategoryMode } from "./CategoryMode";
import { GridMode } from "./GridMode";
import { Panel } from "./Panel";
import { TickmarkValues } from "./TickmarkValues";
import { UIElement } from "./UIElement";
import { ICategoryScaler } from "./ICategoryScaler";
import { FastItemsSourceEventArgs } from "./FastItemsSourceEventArgs";
import { FastItemsSourceEventAction } from "./FastItemsSourceEventAction";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { AxisRenderingParametersBase } from "./AxisRenderingParametersBase";
import { Marker } from "./Marker";
import { Polyline } from "./Polyline";
import { ContentControl } from "./ContentControl";
import { Polygon } from "./Polygon";
import { ILegendSeries } from "./ILegendSeries";
import { ILegendTemplateProvider } from "./ILegendTemplateProvider";
import { StandardLegendItems } from "./StandardLegendItems";
import { StandardLegendBadges } from "./StandardLegendBadges";
import { PenLineCap } from "./PenLineCap";
import { Color } from "./Color";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { SeriesComponentsFromView } from "./SeriesComponentsFromView";
import { IFastItemColumn$1 } from "./IFastItemColumn$1";
import { MarkerType } from "./MarkerType";
import { Style } from "./Style";
import { HighlightingState } from "./HighlightingState";
import { HashPool$2 } from "./HashPool$2";
export declare abstract class SeriesViewer extends Control implements INotifyPropertyChanged, ILegendOwner, IInternalLegendOwner {
    bk: SeriesViewerView;
    static staticInit(): void;
    private bv;
    private readonly bw;
    private a0;
    readonly a1: ISeriesViewerInteractionManager;
    readonly cs: boolean;
    constructor();
    private bg;
    hm(): void;
    private i5(a, b);
    hn(): void;
    readonly series: SeriesCollection;
    private a3;
    private jx(a, b);
    private _skipDataCleanup;
    skipDataCleanup: boolean;
    protected jr(a: any): void;
    private jy(a, b);
    hq(a: number, b: number, c: boolean, d: boolean): {
        p0?: number;
        p1?: number;
    };
    ci(): boolean;
    protected readonly cp: boolean;
    readonly az: IHighlightingManager;
    bl: DoubleAnimator;
    private hl(a, b);
    j9(a: number): void;
    hk(): void;
    l0(a: number): Brush;
    l6(a: number): Brush;
    l4(a: number): Brush;
    l5(a: number): Brush;
    al: ChartContentManager;
    mc: Point;
    private mb;
    readonly cr: boolean;
    ay: IChartLegend;
    static readonly k5: DependencyProperty;
    ca: boolean;
    static readonly ku: DependencyProperty;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected jd(a: string, b: any, c: any): void;
    id(): void;
    ie(a: IEnumerable): void;
    ip(a: Series, b: any, c: any): void;
    it(a: Series, b: any, c: any): void;
    iq(a: Series, b: any, c: any): void;
    ir(a: Series, b: any, c: any): void;
    is(a: Series, b: any, c: any): void;
    iu(a: Series, b: any, c: any): void;
    iv(a: Series, b: any, c: any): void;
    seriesCursorMouseMove: (sender: any, e: ChartCursorEventArgs) => void;
    jf(a: Series, b: any): void;
    seriesMouseLeftButtonDown: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    jj(a: Series, b: any, c: MouseButtonEventArgs): void;
    seriesMouseLeftButtonUp: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    jk(a: Series, b: any, c: MouseButtonEventArgs): void;
    seriesMouseMove: (sender: any, e: ChartMouseEventArgs) => void;
    jl(a: Series, b: any, c: MouseEventArgs): void;
    seriesMouseEnter: (sender: any, e: ChartMouseEventArgs) => void;
    jh(a: Series, b: any, c: MouseEventArgs): void;
    seriesMouseLeave: (sender: any, e: ChartMouseEventArgs) => void;
    ji(a: Series, b: any, c: MouseEventArgs): void;
    private mj;
    protected get_mx(): Rect;
    readonly mx: Rect;
    private mh;
    mo: Rect;
    ms(a: Rect, b: Rect, c: Rect): Rect;
    private by;
    private mg;
    protected get_mn(): Rect;
    readonly mn: Rect;
    mq(a: Rect, b: Rect, c: Rect): Rect;
    protected mm(a: Rect): Rect;
    mr(): Rect;
    protected j5(a: Axis): void;
    my: Rect;
    dg: boolean;
    b8: boolean;
    c8: boolean;
    e3: number;
    private ew;
    ez: number;
    e2: number;
    i8(a: Rect, b: Rect): void;
    private a5;
    a6(): SeriesViewerComponentsForView;
    cv: boolean;
    private an;
    ap: ChartHitTestMode;
    jn(): void;
    protected aq(): ChartHitTestMode;
    private am;
    ao: ChartHitTestMode;
    cw: boolean;
    abstract c0(): boolean;
    abstract c1(): boolean;
    cz(): boolean;
    h5(): void;
    h0(): void;
    bf: InteractionState;
    private b0;
    private be;
    ih(a: Point): void;
    ii(a: Point): void;
    c6(a: Point, b: number): boolean;
    h6(a: Point): void;
    c5(a: Key): boolean;
    private b4;
    ce: boolean;
    private bz;
    cb: boolean;
    protected get_ct(): boolean;
    readonly ct: boolean;
    h8(a: Point): void;
    readonly ch: boolean;
    gw: string;
    im(a: Point): void;
    h9(a: Point, b: boolean): void;
    h7(a: Point): void;
    c7: boolean;
    private i3();
    il(a: Point): void;
    i4(a: Point, b: number, c: number, d: number): void;
    ik(a: number): void;
    i0(a: Point, b: number, c: number, d: number): void;
    ig(a: Point): void;
    ij(a: number): void;
    ia(a: Point): void;
    iz(a: Point, b: number, c: number, d: number): void;
    ic(a: Size): void;
    hj(): void;
    h3(a: Point, b: boolean): void;
    bd(a: boolean): InteractionState;
    i2(): void;
    i1(): void;
    j2(): void;
    hf(): void;
    ha(): void;
    g9(): void;
    i6(): void;
    jq(): void;
    jo(): void;
    h2(a: Point, b: boolean): void;
    private b5;
    dc: boolean;
    h1(a: Point, b: boolean): void;
    ke(a: any, b: PropertyUpdatedEventArgs): void;
    kd(a: SyncLink, b: SyncLink): void;
    hb(a: Point): void;
    kg(a: Rect, b: boolean): void;
    kh(a: Rect, b: boolean, c: boolean): void;
    i7(a: Rect, b: boolean): void;
    readonly cx: boolean;
    private _dj();
    dj(): IEnumerable$1<SeriesViewer>;
    me(a: Point): Point;
    mw(a: Rect): Rect;
    windowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private jm(a, b);
    iy(a: Rect, b: Rect): void;
    sizeChanged: (sender: any, e: RectChangedEventArgs) => void;
    iw(a: Size, b: Size): void;
    ck: boolean;
    c9(a: Rect, b: Rect): boolean;
    actualWindowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private jb(a, b);
    jw(): void;
    gridAreaRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private jc(a, b);
    protected get_cu(): boolean;
    readonly cu: boolean;
    io(a: Rect, b: Rect): void;
    ba: WindowResponse;
    cg: boolean;
    eu: number;
    gk: string;
    private a7;
    a8: SyncLink;
    hp(): void;
    m2: Visibility;
    readonly bh: IOverviewPlusDetailPane;
    protected ka(a: boolean): void;
    m1: Visibility;
    cj: boolean;
    df: boolean;
    l8: Brush;
    ly: Brush;
    l7: Brush;
    cd(): boolean;
    b9(): boolean;
    private ey;
    private notifyCrosshairUpdate();
    protected kf(a: number, b: number): void;
    ed(): number;
    ee(): number;
    protected i9(a: any, b: string, c: any, d: any): void;
    kc(): void;
    protected hz(): void;
    kb(): void;
    private b6;
    protected dd: boolean;
    bc: InteractionState;
    lu: ModifierKeys;
    lv: ModifierKeys;
    private mi;
    mt: Rect;
    dk: Date;
    dh: boolean;
    protected j4(): void;
    g5(): void;
    es: number;
    et: number;
    private mv(a);
    refreshCompleted: (sender: any, e: EventArgs) => void;
    je(): void;
    protected abstract bj(): SeriesViewerView;
    protected ix(a: SeriesViewerView): void;
    static mu: Rect;
    ki: DataTemplate;
    kr: DataTemplate;
    ko: DataTemplate;
    kp: DataTemplate;
    kj: DataTemplate;
    km: DataTemplate;
    kk: DataTemplate;
    kq: DataTemplate;
    kn: DataTemplate;
    kl: DataTemplate;
    gm: string;
    lt: HorizontalAlignment;
    ls: HorizontalAlignment;
    private e8;
    gt: string;
    private e7;
    gh: string;
    private lx;
    ma: Brush;
    private lw;
    l9: Brush;
    private d4;
    eq: number;
    private d2;
    eo: number;
    private d3;
    ep: number;
    private d1;
    en: number;
    private d0;
    em: number;
    private dy;
    ek: number;
    private dz;
    el: number;
    private dx;
    ej: number;
    ga: string;
    mz(): Thickness;
    m0(): Thickness;
    aj(a: Axis): AxisTitlePosition;
    ak(a: Axis): AxisTitlePosition;
    abstract getFontInfo(): FontInfo;
    getFontHeight(): number;
    abstract getFontBrush(): Brush;
    abstract lz(): Brush;
    e5: any;
    provideContainer(a: any): void;
    h4(a: number, b: number): void;
    notifyContainerResized(): void;
    mp(): Rect;
    hg(): void;
    md(): Point;
    bn(): FontInfo;
    bm(): FontInfo;
    l1(): Brush;
    l2(): Brush;
    g7(a: Series): void;
    js(a: Series): void;
    ah: CanvasRenderScheduler;
    ai: CanvasRenderScheduler;
    ag: CanvasRenderScheduler;
    private b3;
    c4: boolean;
    private bx;
    b7: boolean;
    a9: SyncSettings;
    g6(a: any): void;
    ju(a: any): void;
    hw(source_: any, a: number, b: any, c: any): void;
    hr(source_: any): void;
    hu(source_: any, a: number, b: any): void;
    hv(source_: any, a: number, b: any): void;
    destroyed: boolean;
    protected e4: any;
    protected di: Dictionary$2<string, any>;
    c3: boolean;
    hd(): void;
    protected he(): void;
    j1(source_: any): void;
    jv(): void;
    j0(a: string, source_: any): void;
    jt(a: string, b: boolean): void;
    protected jz(a: Series, b: any): void;
    protected j7(a: any): void;
    protected j8(): void;
    private d5;
    er: number;
    private du;
    eg: number;
    private dw;
    ei: number;
    private ds;
    ec: number;
    private dr;
    eb: number;
    private dq;
    ea: number;
    da(): boolean;
    private b1;
    cm: boolean;
    private dv;
    eh: number;
    private dt;
    ef: number;
    static bb(a: string, b: any): CoercionInfo;
    private e6;
    fy: string;
    private dm;
    d7: number;
    private dl;
    d6: number;
    private mf;
    mk: Rect;
    private ho();
    protected ml(): Rect;
    private dn;
    d8: number;
    private dp;
    d9: number;
    hy(): void;
    hx(): void;
    hh(): void;
    hi(a: boolean, b: boolean): void;
    de(): boolean;
    private ks;
    private ar;
    protected jp(a: DependencyObject, b: (arg1: boolean) => void): void;
    protected j3(a: DependencyObject): void;
    hc(): void;
    cn: boolean;
    co: boolean;
    cl: boolean;
    ib(): void;
    private b2;
    readonly cy: boolean;
    g8(): void;
    c2(): boolean;
    private ex;
    e1(): number;
    bq(): FontInfo;
    bp(): FontInfo;
    j6(): void;
    protected cc: boolean;
    cq: boolean;
    seriesDataUpdated: (sender: any, e: EventArgs) => void;
    jg(): void;
    static $$p: string[];
    static $t: Type;
}
export declare abstract class SeriesViewerView extends Base implements ISchedulableRender {
    constructor(a: SeriesViewer);
    ch(): void;
    n: SeriesViewer;
    cv(): void;
    private cg();
    a: CanvasRenderScheduler;
    l: IOverviewPlusDetailPane;
    private dd(a, b);
    private dc(a, b);
    ec(): void;
    private cm(a, b);
    private cl(a, b);
    m: OverviewPlusDetailViewportHost;
    b4(a: number, b: number, c: RenderSurface): void;
    dv(): void;
    b6(): void;
    dx(): void;
    cd(): void;
    b5(): void;
    b7(): void;
    dn(a: Series): void;
    c2(): void;
    ao(a: Series): boolean;
    protected f: SeriesCollection;
    protected b: AxisCollection;
    private ag;
    as: boolean;
    bm(a: Series): void;
    di(a: RenderingContext): void;
    bu(): void;
    bq(): void;
    b8(): void;
    b3(): void;
    dg(): void;
    protected e5: Rectangle;
    protected e4: Path;
    dy(): void;
    d6(a: Rect): void;
    bt(): void;
    c5(): void;
    ee(a: number, b: number, c: number, d: number): void;
    protected e3: Line;
    protected e2: Line;
    d3(): void;
    ce(): void;
    d7(a: number, b: number, c: number, d: number): void;
    dz(): void;
    b9(): void;
    cc(): void;
    private ev(a);
    private ew(a);
    ed(a: Rect, b: Rect): void;
    d2(): void;
    ef(a: Rect): void;
    dl(a: Axis): void;
    dm(a: Axis): void;
    bl(a: Axis): void;
    bi(a: Axis): void;
    private g;
    h(): SeriesViewerComponentsFromView;
    static au(a: Series): List$1<Series>;
    ds(): void;
    i: SeriesViewerViewManager;
    protected u: RenderingContext;
    x: RenderingContext;
    w: RenderingContext;
    protected v: RenderingContext;
    al: boolean;
    am: boolean;
    protected bg: any;
    cs(a: any): void;
    private aj(a, b, c);
    protected cq(a: Point, b: boolean): void;
    protected cr(a: Point, b: boolean): void;
    protected cu(a: Point): void;
    protected cp(a: Point, b: boolean): void;
    dj(a: RenderingContext): void;
    protected get_an(): boolean;
    readonly an: boolean;
    j: EventProxy;
    d5(): void;
    a7: number;
    e(a: Point, b: boolean, c: DataContext, d: boolean): {
        ret: Series;
        p2: DataContext;
    };
    bb(): number;
    ba(): number;
    a6: number;
    a5: number;
    private ey;
    private ah;
    cn(): void;
    ct(a: number, b: number): void;
    dt(): void;
    private az;
    private ax;
    private ay;
    private aw;
    private ai;
    private y;
    private bz();
    private ea();
    t(): FontInfo;
    s(): FontInfo;
    private eu();
    private et();
    private bd();
    private a0;
    private bc();
    e9(): Thickness;
    e8(): Thickness;
    protected dk(a: Rect): void;
    cj(): void;
    private ez;
    protected dq(): void;
    isValid(): boolean;
    preRender(): void;
    protected dh(): void;
    protected z: boolean;
    protected dr(): void;
    e0(): Rect;
    ex(): Point;
    private dw();
    d4(): void;
    de(): void;
    protected aq(a: Point): boolean;
    cz(a: Point, b: boolean, c: boolean): void;
    protected cy(a: Point): void;
    protected cx(a: Point): void;
    protected c0(a: Point): void;
    du(): void;
    readonly eo: ModifierKeys;
    eg(a: Rect): void;
    ck(a: boolean): void;
    bh(a: boolean): void;
    protected eb(): void;
    private ad;
    isDirty: boolean;
    undirty(a: boolean): void;
    readonly index: number;
    postRender(): void;
    b2(): void;
    protected ac: boolean;
    ca(): void;
    d0(): void;
    bs(a: boolean): void;
    bj(a: any): void;
    d8(a: number): void;
    d9(a: number): void;
    bk(a: any): void;
    dp(a: any): void;
    c1(a: Brush): void;
    br(a: Point): void;
    at: boolean;
    k(a: boolean): InteractionState;
    cw(): void;
    private ei;
    private eh;
    a9(a: TextBlock, b: FontInfo): number;
    a8(a: string, b: FontInfo): number;
    c9(): void;
    private ej(a, b, c, d);
    c8(): void;
    c4(): void;
    c(a: Axis): AxisTitlePosition;
    d(a: Axis): AxisTitlePosition;
    da(): void;
    db(): void;
    r(): FontInfo;
    es(): Brush;
    o(): FontInfo;
    ep(): Brush;
    q(): FontInfo;
    p(): FontInfo;
    er(): Brush;
    eq(): Brush;
    readonly a2: number;
    readonly a3: number;
    readonly a4: number;
    readonly a1: number;
    readonly el: TextBlock;
    readonly ek: TextBlock;
    e1(): Rect;
    e7(): Thickness;
    e6(): Thickness;
    private ab;
    private aa;
    c3(a: any, b: any): void;
    c7(a: any, b: any): void;
    en(): HorizontalAlignment;
    em(): HorizontalAlignment;
    private ae;
    bn(): void;
    ak(): boolean;
    b1(): void;
    ci(): void;
    ar(a: Point): boolean;
    df(): void;
    private av;
    b0(a: Dictionary$2<any, ITileZoomTile>, b: List$1<ITileZoomTile>, c: number): void;
    bf(a: Rect, b: ITileZoomTile, c: number): any;
    bx(): void;
    by(a: ITileZoomTile): void;
    cf(): void;
    ap: boolean;
    private be;
    bv(): void;
    bo(): void;
    bw(a: number): void;
    bp(): void;
    private af;
    cb(): void;
    d1(): void;
    c6(): void;
    co(): void;
    static $t: Type;
}
export declare class OverviewPlusDetailViewportHost extends Base implements IProvidesViewport {
    constructor(a: SeriesViewerView);
    a: SeriesViewerView;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    getEffectiveViewport(): Rect;
    static $t: Type;
}
export declare class SeriesViewerViewManager extends Base {
    af: DomRenderer;
    protected ag: DomWrapper;
    protected ak: DomWrapper;
    protected aj: DomWrapper;
    protected ah: DomWrapper;
    al: DomWrapper;
    t: RenderingContext;
    w: RenderingContext;
    v: RenderingContext;
    u: RenderingContext;
    x: RenderingContext;
    f: EventProxy;
    private j;
    constructor(a: SeriesViewerView);
    protected ai: DomWrapper;
    bf(): void;
    be(a: any): void;
    private ae;
    a9(): void;
    g(): IOverviewPlusDetailPane;
    bi(): void;
    bj(): void;
    by(): Brush;
    private ab;
    private aa;
    private ac;
    ay(a: number, b: number, c: number): void;
    b3(): Point;
    y(): boolean;
    bb(a: boolean): void;
    a7(a: BrushCollection, b: BrushCollection, c: Brush, d: FontInfo, e: Brush): {
        p0: BrushCollection;
        p1: BrushCollection;
        p2: Brush;
        p3: FontInfo;
        p4: Brush;
    };
    e(): DefaultPaletteInfo;
    a6(a: number, b: number[], c: Brush, d: Brush, e: number, f: boolean): {
        p0: number;
        p1: number[];
        p2: Brush;
        p3: Brush;
        p4: number;
        p5: boolean;
    };
    ax(): void;
    bq(x_: number): void;
    private ad;
    br(y_: number): void;
    at(a: any): void;
    a8(): void;
    bk(): void;
    au(a: any): void;
    bg(a: any): void;
    bc(): void;
    private l;
    p(): FontInfo;
    private b5;
    b9(): Thickness;
    private aq;
    as(): string;
    private ap;
    ar(): string;
    private b4;
    b8(): Thickness;
    private bv;
    b0(): Brush;
    private bu;
    bz(): Brush;
    private k;
    o(): FontInfo;
    private a;
    c(): AxisTitlePosition;
    private b;
    d(): AxisTitlePosition;
    private n;
    r(): FontInfo;
    private bx;
    b2(): Brush;
    private m;
    q(): FontInfo;
    private bw;
    b1(): Brush;
    private b6;
    ca(): Thickness;
    private b7;
    cb(): Thickness;
    bl(): void;
    private bt();
    private bn();
    private bm();
    private bo();
    private bp();
    a5(a: number, b: number): void;
    private h;
    i(): PointerTooltipStyle;
    ba(a: boolean): void;
    private z;
    ao(a: Rect, b: ITileZoomTile, c: number): any;
    a2(a: ITileZoomTile): void;
    a1(): void;
    bh(a: List$1<ITileZoomTile>): void;
    private am;
    az(): void;
    av(): void;
    private an;
    a0(a: number): void;
    aw(): void;
    private s;
    bd(): void;
    bs(a: boolean): void;
    a3(): void;
    a4(): void;
    static $t: Type;
}
export declare class AutoRangeCalculator extends Base {
    static a(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
    static $t: Type;
}
export declare class AxisLabelSettings extends Base implements INotifyPropertyChanged {
    constructor();
    private aa;
    textStyle: string;
    private ax;
    textColor: Brush;
    location: AxisLabelsLocation;
    private b;
    visibility: Visibility;
    private a2;
    showFirstLabel: boolean;
    private h;
    c: AxisLabelsLocation;
    a: Axis;
    registerAxis(a: Axis): void;
    unregisterAxis(a: Axis): void;
    angle: number;
    private m;
    extent: number;
    private o;
    margin: number;
    leftMargin: number;
    private p;
    rightMargin: number;
    private q;
    topMargin: number;
    private r;
    bottomMargin: number;
    private n;
    private au;
    horizontalAlignment: HorizontalAlignment;
    private az;
    verticalAlignment: VerticalAlignment;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    ar(a: string, b: any, c: any): void;
    protected aq(a: any, b: string, c: any, d: any): void;
    j(): boolean;
    k(): boolean;
    static readonly extentPropertyDefault: number;
    readonly i: boolean;
    private f;
    g(a: DomRenderer): FontInfo;
    static $t: Type;
}
export declare class TitleSettings extends AxisLabelSettings {
    constructor();
    private a4;
    position: AxisTitlePosition;
    protected aq(a: any, b: string, c: any, d: any): void;
    static $t: Type;
}
export declare abstract class Axis extends Control implements INotifyPropertyChanged {
    ax(): AxisView;
    ay: AxisView;
    f5(a: AxisView): void;
    private bi;
    readonly bj: SRProvider;
    private a0;
    readonly a1: IAxisVisualDataManager;
    di(): number;
    et(): any;
    es(): any;
    protected get_bt(): boolean;
    readonly bt: boolean;
    protected get_b1(): boolean;
    readonly b1: boolean;
    protected get_bs(): boolean;
    readonly bs: boolean;
    protected get_b2(): boolean;
    readonly b2: boolean;
    protected get_b5(): boolean;
    readonly b5: boolean;
    protected get_b3(): boolean;
    readonly b3: boolean;
    protected get_bw(): boolean;
    readonly bw: boolean;
    protected get_bu(): boolean;
    readonly bu: boolean;
    protected get_bv(): boolean;
    readonly bv: boolean;
    ah(): Axis;
    constructor();
    provideRenderer(a: DomRenderer): void;
    an: (item: any) => string;
    f2(a: Rect, b: Rect): void;
    abstract ao(): AxisLabelPanelBase;
    ac(): void;
    gw: Canvas;
    bf: IFastItemsSourceProvider;
    private be;
    a9: SeriesViewer;
    private a8;
    a7: XamDataChart;
    readonly bh: (sender: any, e: RectChangedEventArgs) => void;
    private bm;
    cf: boolean;
    private cr;
    d0: number;
    private cm;
    c2: number;
    private cx;
    d6: number;
    private cu;
    d3: number;
    private al;
    am: AxisExtentType;
    private cq;
    dz: number;
    c1: number;
    private cw;
    d5: number;
    private ct;
    d2: number;
    private bb;
    private ba;
    bd: FontInfo;
    private eu;
    fg: string;
    private cs;
    d1: number;
    c3: number;
    private cy;
    d7: number;
    private cv;
    d4: number;
    private eh;
    em: number;
    private eg;
    el: number;
    private ef;
    ek: number;
    ei: number;
    private ii;
    il: VerticalAlignment;
    private c0;
    d9: number;
    private cz;
    d8: number;
    go(): void;
    private gg();
    private gh(a);
    gx: TextBlock;
    fp: string;
    hy: Brush;
    hu: Brush;
    ea: number;
    h2: DoubleCollection;
    hx: Brush;
    hv: Brush;
    hs: Brush;
    dr: number;
    h0: DoubleCollection;
    hw: Brush;
    ht: Brush;
    du: number;
    h1: DoubleCollection;
    hz: Brush;
    ec: number;
    h3: DoubleCollection;
    eb: number;
    c4: number;
    private gq();
    bx: boolean;
    bz: boolean;
    b0: boolean;
    ce: boolean;
    static readonly hp: DependencyProperty;
    ej: number;
    as: AxisLabelSettings;
    c8(): number;
    hq(): HorizontalAlignment;
    ij(): VerticalAlignment;
    hr(): HorizontalAlignment;
    ik(): VerticalAlignment;
    da(): number;
    dc(): number;
    db(): number;
    c9(): number;
    df(): number;
    dh(): number;
    dg(): number;
    de(): number;
    at(): AxisLabelsLocation;
    au(): AxisLabelsLocation;
    ag: Axis;
    eo: any;
    rangeChanged: (sender: any, e: AxisRangeChangedEventArgs) => void;
    protected ge(a: AxisRangeChangedEventArgs): void;
    a6: TitleSettings;
    dd(): number;
    c7(): number;
    private h4;
    ib: Rect;
    ia: Rect;
    gr(): void;
    ch(a: Rect, b: Rect, c: AxisView): boolean;
    b4(): boolean;
    cj: List$1<any>;
    ck: List$1<LabelPosition>;
    ap: AxisLabelPanelBase;
    protected gu(a: Rect, b: Rect): void;
    private bl;
    b6: boolean;
    protected h8(): Rect;
    protected gv(a: Rect, b: Rect): void;
    gf(): void;
    az: ContentInfo;
    ee: DomRenderer;
    protected f7(a: any, b: string, c: any, d: any): void;
    private _coercionMethods;
    coercionMethods: any;
    private bk;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    expectFunctions: boolean;
    b9: boolean;
    private gm();
    cg: boolean;
    protected f4(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected f3(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    protected gt(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected gs(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    private by(a, b, c, d);
    protected gn(a: number, b: number, c: Rect, d: Rect, e: Rect, f: number, g: number): {
        p0: number;
        p1: number;
    };
    c5(a: number, b: number, c: number, d: PathRenderingInfo): number;
    fv(a: GeometryCollection): void;
    protected fu(): void;
    gi(): void;
    gj(a: boolean): void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    a3: LabelFontHeuristics;
    static dt: number;
    dx(): number;
    dv(): number;
    dw(): number;
    protected readonly ca: boolean;
    fx(a: boolean): void;
    private co;
    private bo();
    gl(): void;
    private cp;
    a2(): LabelFontHeuristics;
    bc(): FontInfo;
    private fy();
    b7: boolean;
    cb(): boolean;
    cc(a: boolean): boolean;
    cd(): boolean;
    protected gk(a: boolean): void;
    gp(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected gd(a: string, b: any, c: any): void;
    cl: List$1<Series>;
    b8(a: Series): boolean;
    bn(a: Series): boolean;
    er: any;
    eq(a: any): any;
    dj(a: number, b: ScalerParams): number;
    dk(a: number, b: ScalerParams, c: CategoryMode): number;
    h7(a: Rect): Rect;
    h6(): Rect;
    h5(): Rect;
    protected h9(a: Rect, b: Rect): Rect;
    dl(a: number, b: Rect, c: Rect): number;
    f0(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    fz(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    dm(a: number, b: ScalerParams): number;
    dn(a: number, b: ScalerParams, c: CategoryMode): number;
    dp(a: number, b: Rect, c: Rect): number;
    f1(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    dy(a: number): number;
    readonly abstract av: AxisOrientation;
    ih: Size;
    f6(): void;
    ai: AxisComponentsForView;
    aj(): AxisComponentsForView;
    c6: number;
    private cn;
    ds: number;
    br(): boolean;
    dq(): number;
    protected ft(): void;
    fw(a: AxisRangeChangedEventArgs): void;
    bg: Pool$1<TextBlock>;
    readonly ic: Path;
    readonly id: Path;
    readonly ig: Path;
    readonly ie: Path;
    a5(): SyncSettings;
    ak(): AxisComponentsFromView;
    private aq;
    readonly ar: AxisLabelSettings;
    f8(a: RenderingContext, b: RenderingContext): void;
    bq(): boolean;
    ep(): any;
    private _ci();
    ci(): IEnumerable$1<Series>;
    f9(a: string): void;
    gc(a: any): void;
    gb(a: any): void;
    static $$p: string[];
    static $t: Type;
}
export declare class AxisCollection extends ObservableCollection$1<Axis> {
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
    static $t: Type;
}
export declare class AxisLabelManager extends Base {
    e: List$1<any>;
    f: List$1<LabelPosition>;
    b: AxisLabelPanelBase;
    a: Axis;
    c: (arg1: number) => void;
    constructor();
    k(a: Rect, b: Rect): void;
    h(a: any, b: LabelPosition): void;
    q(): void;
    static i(a: FrameworkElement): void;
    static j(a: FrameworkElement): void;
    g(a: FrameworkElement): void;
    o(a: number): void;
    l(a: number): void;
    r(a: number): FrameworkElement;
    p(a: number): void;
    readonly d: boolean;
    n(): void;
    m(): void;
    static $t: Type;
}
export declare abstract class AxisLabelPanelBase extends Panel {
    ad(): AxisLabelPanelBaseView;
    b6(a: AxisLabelPanelBaseView): void;
    ae: AxisLabelPanelBaseView;
    cj: Rect;
    bx(): void;
    cc(): void;
    cb(): void;
    constructor();
    bl: number;
    ac: Axis;
    private aj;
    at: boolean;
    private ax;
    a1: List$1<any>;
    a2: List$1<LabelPosition>;
    cm: Rect;
    private ci;
    cn: Rect;
    private ch;
    cl: Rect;
    private a4;
    a6: number;
    bm: () => boolean;
    a3: List$1<FrameworkElement>;
    a0: List$1<Rect>;
    af: AxisLabelSettings;
    am: boolean;
    ap: boolean;
    aq: boolean;
    ar: boolean;
    bo: any;
    ak: boolean;
    protected al(a: List$1<Rect>): boolean;
    protected bn(a: number, b: List$1<Rect>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    ay(): List$1<Rect>;
    bv(): void;
    br(a: Size): void;
    bb(): number;
    bf(): number;
    ao(a: number, b: Rect): boolean;
    ba(a: any): number;
    bk(a: any): number;
    bc(a: any): number;
    a9(a: any): number;
    an(): boolean;
    protected cf(a: Rect, b: Rect): void;
    protected b2(a: Rect, b: Rect): void;
    az(): List$1<Rect>;
    be(a: number, b: Size): number;
    bd(a: number, b: Size): number;
    bi(): number;
    bg(): number;
    bh(): number;
    bj(): number;
    co(a: Size): Size;
    ck(): Rect;
    protected bu(a: Size): void;
    protected bt(a: Size): void;
    protected by(): void;
    protected aw(): IEnumerable$1<number>;
    readonly ag: AxisLabelsLocation;
    ce(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    b1(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    b9(a: FrameworkElement, b: number): void;
    ca(a: FrameworkElement): void;
    b0(a: FrameworkElement, b: number): void;
    cp(a: Size): Size;
    static readonly cg: DependencyProperty;
    a7: number;
    a5: number;
    ai(a: TitleSettings): AxisTitlePosition;
    ah(): AxisLabelsLocation;
    as(a: AxisLabelsLocation): boolean;
    private _au();
    au(): IEnumerable$1<any>;
    bq(a: number, b: TextBlock, c: number, d: number, e: number): string;
    bw(a: any): void;
    b5(a: FrameworkElement): void;
    private _av();
    av(): IEnumerable$1<any>;
    bz(): void;
    cd(): void;
    b3(): void;
    a8(a: Rect): number;
    b4(): void;
    b7(a: RenderingContext): void;
    bs(): void;
    b8(): void;
    static $t: Type;
}
export declare abstract class CategoryAxisBase extends Axis implements ICategoryScaler {
    ax(): AxisView;
    protected get_bv(): boolean;
    readonly bv: boolean;
    f5(a: AxisView): void;
    im: CategoryAxisBaseView;
    constructor();
    ch(a: Rect, b: Rect, c: AxisView): boolean;
    jv(): void;
    ju(): void;
    iy: List$1<number>;
    protected get_bt(): boolean;
    readonly bt: boolean;
    j6(a: Point, b: boolean, c: number): Rect;
    j7(a: Point, b: boolean, c: number, d: boolean): Rect;
    ir: IFastItemsSource;
    private iq;
    itemsSource: IEnumerable;
    static readonly j3: DependencyProperty;
    private i9;
    ja: number;
    jb: number;
    categoryMode: CategoryMode;
    private io;
    i0: number;
    i7: number;
    iv: boolean;
    jd: number;
    private jc;
    dm(a: number, b: ScalerParams): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    i3(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    i8(a: number): number;
    private _ix();
    private ix();
    private it(a);
    iu(a: SeriesViewer): boolean;
    private _iw();
    private iw();
    private is;
    jz(a: boolean): void;
    protected f7(a: any, b: string, c: any, d: any): void;
    private jn();
    jp(a: any, b: FastItemsSourceEventArgs): void;
    protected jw(a: FastItemsSourceEventArgs): void;
    private j0();
    b8(a: Series): boolean;
    bn(a: Series): boolean;
    private jx();
    jm(): void;
    jy(): void;
    jo(a: NotifyCollectionChangedEventArgs): void;
    jt(a: number, b: any, c: any): void;
    jq(): void;
    jr(a: number, b: any): void;
    js(a: number, b: any): void;
    getOffset(a: Rect, b: Rect, c: Rect, d: number): number;
    getOffset1(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare abstract class HorizontalAxisLabelPanelBase extends AxisLabelPanelBase {
    ad(): AxisLabelPanelBaseView;
    b6(a: AxisLabelPanelBaseView): void;
    cq: HorizontalAxisLabelPanelBaseView;
    c2: number;
    cz: number;
    c1: number;
    c0: number;
    bv(): void;
    cs(): boolean;
    ct(): boolean;
    an(): boolean;
    ay(): List$1<Rect>;
    private c3(a);
    private c4(a);
    protected c5(a: List$1<Rect>): void;
    protected c6(): void;
    b9(a: FrameworkElement, b: number): void;
    protected cu(): boolean;
    protected cr(): boolean;
    protected bn(a: number, b: List$1<Rect>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    ck(): Rect;
    cp(a: Size): Size;
    cy(): number;
    cv(): number;
    cx(): number;
    cw(): number;
    protected by(): void;
    static $t: Type;
}
export declare class HorizontalAxisLabelPanel extends HorizontalAxisLabelPanelBase {
    ah(): AxisLabelsLocation;
    as(a: AxisLabelsLocation): boolean;
    static $t: Type;
}
export declare abstract class NumericAxisBase extends Axis {
    ax(): AxisView;
    f5(a: AxisView): void;
    io: NumericAxisBaseView;
    protected get_b1(): boolean;
    readonly b1: boolean;
    constructor();
    jo: number;
    jg: number;
    private ja;
    jm: number;
    et(): any;
    jj: number;
    private jd;
    jn: number;
    jf: number;
    private i9;
    es(): any;
    jl: number;
    private jc;
    ji: number;
    jk: number;
    private i8;
    je: number;
    jp: number;
    private jb;
    jh: number;
    jq: number;
    i5: boolean;
    private iz;
    i1: boolean;
    readonly i6: boolean;
    js: number;
    jt: number;
    ir: NumericAxisRenderer;
    protected i7: boolean;
    protected gk(a: boolean): void;
    gc(a: any): void;
    gb(a: any): void;
    protected f7(a: any, b: string, c: any, d: any): void;
    protected kd(): void;
    im(): AxisRange;
    kb(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
    cd(): boolean;
    ke(a: AxisRangeChangedEventArgs): void;
    b8(a: Series): boolean;
    bn(a: Series): boolean;
    iq(a: AxisLabelManager): NumericAxisRenderer;
    ip(): NumericAxisRenderer;
    it(): NumericAxisRenderingParameters;
    kc(): void;
    iu(): NumericScaler;
    is(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    jr(a: number): number;
    i2(): boolean;
    readonly i4: boolean;
    readonly i3: boolean;
    private kf();
    static readonly kn: DependencyProperty;
    ix: TickmarkValues;
    private iv;
    iw: TickmarkValues;
    private iy;
    i0: boolean;
    static $$p: string[];
    static $t: Type;
}
export declare abstract class NumericScaler extends DependencyObject {
    static readonly ac: Rect;
    abstract t(a: NumericAxisBase, b: number, c: number, d: number, e: number): {
        p3: number;
        p4: number;
    };
    l: number;
    k: number;
    protected o: number;
    protected n: number;
    y(a: number): void;
    x(a: number): void;
    protected w(a: string, b: any, c: any): void;
    private z();
    protected m: number;
    abstract q(a: number, b: ScalerParams): number;
    abstract p(a: number, b: ScalerParams): number;
    j(a: IList$1<number>, b: number, c: number, d: ScalerParams): IList$1<number>;
    v(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    u(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    static $$p: string[];
    static $t: Type;
}
export declare class AxisRendererBase extends Base {
    constructor(a: AxisLabelManager);
    u: () => void;
    o: (viewportRect: Rect, windowRect: Rect) => boolean;
    v: () => void;
    m: (p: AxisRenderingParametersBase, value: number) => number;
    l: (p: AxisRenderingParametersBase, geometry: GeometryCollection, startValue: number, endValue: number) => void;
    k: (p: AxisRenderingParametersBase, geometry: GeometryCollection, value: number) => void;
    q: (p: AxisRenderingParametersBase, value: number) => boolean;
    n: (p: AxisRenderingParametersBase, value: number) => boolean;
    j: (p: AxisRenderingParametersBase) => void;
    e: (p: AxisRenderingParametersBase) => void;
    p: (p: AxisRenderingParametersBase, position: number, isLastLabel: boolean) => boolean;
    h: (p: AxisRenderingParametersBase, value: number) => LabelPosition;
    t: (p: AxisRenderingParametersBase, value: number) => number;
    b: AxisLabelManager;
    g: (item: any) => any;
    d: (viewportRect: Rect, windowRect: Rect, effectiveViewportRect: Rect, contentViewport: Rect) => AxisRenderingParametersBase;
    r: (p: AxisRenderingParametersBase, value: number, absoluteIndex: number, interval: number) => number;
    a: (p: AxisRenderingParametersBase, value: number, absolueIndex: number, interval: number) => number;
    f: (index: number, window: Rect, viewport: Rect, effectiveViewport: Rect) => number;
    i: (index: number) => number;
    c(a: boolean, b: Rect, c: Rect, d: Rect, e: Rect): AxisRenderingParametersBase;
    private aa();
    private ab(a);
    protected x(a: Rect, b: Rect): void;
    private z();
    private s(a);
    private y(a);
    protected w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
    static $t: Type;
}
export declare class NumericAxisRenderer extends AxisRendererBase {
    constructor(a: AxisLabelManager);
    protected w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
    private ac;
    private ad;
    private ae(a);
    static $t: Type;
}
export declare class VerticalAxisLabelPanel extends AxisLabelPanelBase {
    ad(): AxisLabelPanelBaseView;
    b6(a: AxisLabelPanelBaseView): void;
    cq: VerticalAxisLabelPanelView;
    cz: number;
    cw: number;
    cy: number;
    cx: number;
    bv(): void;
    bf(): number;
    cs(): number;
    cu(): number;
    cv(): number;
    ct(): number;
    ay(): List$1<Rect>;
    private c0(a, b, c);
    private c1(a);
    b9(a: FrameworkElement, b: number): void;
    protected cr(): boolean;
    ck(): Rect;
    ai(a: TitleSettings): AxisTitlePosition;
    ah(): AxisLabelsLocation;
    as(a: AxisLabelsLocation): boolean;
    cp(a: Size): Size;
    protected by(): void;
    static $t: Type;
}
export interface IHasCategoryAxis {
    readonly categoryAxis: CategoryAxisBase;
    getOffsetValue(): number;
    getCategoryWidth(): number;
}
export declare let IHasCategoryAxis_$type: Type;
export interface IHasCategoryModePreference extends IHasCategoryAxis {
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
}
export declare let IHasCategoryModePreference_$type: Type;
export interface ISeriesInteractionManager {
    a$i(a: Series, b: Point, c: number, d: Axis, e: ScalerParams, f: number, g: number, h: (arg1: Point) => number): number;
    a$l(a: Series, b: IList$1<number>, c: Point, d: Axis, e: ScalerParams, f: number, g: (arg1: Point) => number, h: boolean, i: boolean): number;
    a$k(a: Series, b: number, c: IList$1<number>, d: number, e: number, f: number, g: number, h: number, i: boolean): number;
    a$n(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$d(a: Series, b: Point, c: boolean): boolean;
    a$a(a: Series, b: CategoryAxisBase, c: List$1<number[]>, d: number, e: number, f: Point, g: boolean): number[][];
    a$e(a: Series, b: Point, c: boolean, d: PathGeometry): boolean;
    a$f(a: Series, b: Point, c: PathGeometry): boolean;
    a$m(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$j(a: Series, b: Point, c: Axis): number;
    a$g(a: Series, b: Point, c: boolean): boolean;
    a$aj(a: Series, b: Point, c: boolean, d: boolean, e: number, f: Axis, g: Axis, h: (arg1: Point, arg2: boolean, arg3: boolean) => number, i: (arg1: Point, arg2: boolean) => number, j: (arg1: Point, arg2: boolean) => number): Point;
    a$t(a: Series, b: any, c: Point, d: boolean, e: boolean): void;
    a$ai(a: Series, b: HighlightingInfo, c: Brush): Brush;
    a$w(a: Series, b: Point, c: any, d: any): void;
    a$ag(a: Series, b: Point): void;
    a$z(a: Series, b: Point, c: any, d: any): void;
    a$x(a: Series, b: Point, c: any, d: any): void;
    a$u(a: Series, b: Point, c: any, d: any): void;
    a$y(a: Series, b: Point, c: any, d: any): void;
    a$v(a: Series, b: Point, c: any, d: any): void;
    a$aa(a: Series, b: Point, c: any, d: any): void;
    a$ab(a: Series, b: Point, c: any, d: any): void;
    a$p(a: Series): string;
    a$q(a: Series): string;
    readonly a$b: boolean;
    readonly a$o: any;
    a$ah(a: Series, b: any): void;
    a$af(a: Series, b: Point, c: (arg1: any) => void): void;
    a$s(a: Series): void;
    a$ae(a: Series): void;
    readonly a$c: boolean;
    readonly a$h: Dictionary$2<string, SeriesView>;
    a$r(a: Series, b: Rect, c: Rect, d: string, e: number): void;
    a$ac(a: Series, b: SeriesViewer): void;
    a$ad(a: Series, b: string, c: SeriesViewer): void;
}
export declare let ISeriesInteractionManager_$type: Type;
export interface ISeriesViewerInteractionManager {
    f$a(a: SeriesViewer): ChartHitTestMode;
    f$ae(a: SeriesViewer): void;
    f$p(a: SeriesViewer, b: Point): void;
    f$ac(a: SeriesViewer, b: Point): void;
    f$q(a: SeriesViewer, b: Point, c: boolean): void;
    f$o(a: SeriesViewer, b: Point): void;
    f$aj(a: SeriesViewer): void;
    f$ab(a: SeriesViewer, b: Point): void;
    f$ak(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$aa(a: SeriesViewer, b: number): void;
    f$ag(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$x(a: SeriesViewer, b: Point): void;
    f$z(a: SeriesViewer, b: number): void;
    f$r(a: SeriesViewer, b: Point): void;
    f$af(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$m(a: SeriesViewer, b: Point, c: boolean): void;
    f$ai(a: SeriesViewer): void;
    f$ah(a: SeriesViewer): void;
    f$am(a: SeriesViewer): void;
    f$j(a: SeriesViewer): void;
    f$g(a: SeriesViewer): void;
    f$l(a: SeriesViewer, b: Point, c: boolean): void;
    f$k(a: SeriesViewer, b: Point, c: boolean): void;
    f$al(a: SeriesViewer): void;
    f$ad(a: SeriesViewer): void;
    f$d(a: SeriesViewer, b: Key): boolean;
    f$e(a: SeriesViewer, b: Point, c: number): boolean;
    f$n(a: SeriesViewer, b: Point): void;
    f$i(a: SeriesViewer): void;
    f$h(a: SeriesViewer): void;
    readonly f$b: IHighlightingManager;
    f$c(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: DataContext, g: boolean): {
        ret: Series;
        p5: DataContext;
    };
    f$f(a: SeriesViewer, b: Point): boolean;
    f$v(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: boolean): void;
    f$u(a: SeriesViewer, b: Point): void;
    f$t(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$w(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$s(a: SeriesViewer, b: Point, c: boolean): void;
    f$y(a: SeriesViewer, b: boolean): void;
}
export declare let ISeriesViewerInteractionManager_$type: Type;
export interface IDataChartVisualDataManager {
    exportVisualData(a: XamDataChart): any;
}
export declare let IDataChartVisualDataManager_$type: Type;
export interface IAxisVisualDataManager {
    exportVisualData(a: Axis): any;
}
export declare let IAxisVisualDataManager_$type: Type;
export interface ISeriesVisualDataManager {
    exportVisualData(a: Series, b: Rect): any;
    exportMarkerVisualData(a: MarkerSeries, b: any): void;
    getMarkerVisualData(a: Series, b: Marker, c: DataTemplate): any;
    copyVisualData(a: any, b: any): void;
    exportTrendlineData(a: Series, b: any, c: Polyline): void;
    exportStackedVisualData(a: Series, b: Rect): any;
    createFragmentVisualData(a: Series, b: Rect, c: string, d: string): any;
    addSubSeriesVisualData(a: any, b: any): void;
    exportRectangleData(a: any, b: Rectangle, c: string, d: string[]): void;
    exportMarkerVisualDataFromMarker(a: Series, b: any, c: ContentControl): void;
    exportPathData(a: any, b: Path, c: string, d: string[]): void;
    exportPolylineData(a: any, b: Polyline, c: string, d: string[]): void;
    exportPolygonData(a: any, b: Polygon, c: string, d: string[]): void;
    exportSeriesPixelsData(a: any, b: number[], c: number, d: number): void;
    addPointerTooltipData(a: any, b: any, c: number, d: number, e: List$1<string>): void;
    exportPointerTooltipData(a: Polygon, b: Polyline, c: Rectangle, d: Rect): any;
}
export declare let ISeriesVisualDataManager_$type: Type;
export declare class XamDataChart extends SeriesViewer {
    static n0: number;
    static nz: number;
    private _xsr;
    private readonly XSRP;
    private nb;
    readonly nc: IDataChartVisualDataManager;
    static staticInit(): void;
    static n7(a: Series): number;
    constructor();
    protected i9(a: any, b: string, c: any, d: any): void;
    private ow();
    nm: boolean;
    ed(): number;
    ee(): number;
    protected j4(): void;
    n5: number;
    n6: number;
    private nr;
    nx: number;
    private ns;
    ny: number;
    c0(): boolean;
    c1(): boolean;
    nk: boolean;
    np: boolean;
    nl: boolean;
    nn: boolean;
    na: GridMode;
    nh: boolean;
    no: boolean;
    m3: BrushCollection;
    m4: BrushCollection;
    m6: BrushCollection;
    m5: BrushCollection;
    pi: Brush;
    pg: Brush;
    ph: Brush;
    readonly axes: AxisCollection;
    private m7;
    private ot(a, b);
    private ou(a, b);
    axisRangeChanged: (sender: any, e: ChartAxisRangeChangedEventArgs) => void;
    private ov(a, b);
    private static ox(a, b, c);
    kd(a: SyncLink, b: SyncLink): void;
    private ne;
    getFontInfo(): FontInfo;
    oy(): void;
    getFontBrush(): Brush;
    protected he(): void;
    lz(): Brush;
    da(): boolean;
    protected j8(): void;
    l0(a: number): Brush;
    private pj(a, b);
    l4(a: number): Brush;
    l5(a: number): Brush;
    l6(a: number): Brush;
    ci(): boolean;
    private nj();
    protected bj(): SeriesViewerView;
    protected ix(a: SeriesViewerView): void;
    nd: XamDataChartView;
    jo(): void;
    private nu;
    n2: number;
    private nw;
    n4: number;
    private nv;
    n3: number;
    private nt;
    n1: number;
    protected mm(a: Rect): Rect;
    mr(): Rect;
    n8(): any;
    og(): string;
    i6(): void;
    jq(): void;
    nq(a: Axis): List$1<Axis>;
    static $$p: string[];
    static $t: Type;
}
export declare class LabelPanelArranger extends Base {
    static e(a: List$1<AxisLabelPanelBase>, b: Rect): Rect;
    private static a(a, b, c);
    static b(a: AxisLabelPanelBase): AxisLabelsLocation;
    private static c(a, b, c, d);
    static d(a: List$1<AxisLabelPanelBase>, b: LabelPanelsArrangeState, c: Rect, d: (arg1: AxisLabelPanelBase, arg2: Rect) => void): void;
    static $t: Type;
}
export declare class ChartContentManager extends DependencyObject {
    private l;
    private q;
    private s;
    private t;
    constructor(a: SeriesViewer);
    k(a: ChartContentType, b: DependencyObject, c: (arg1: boolean) => void): ContentInfo;
    ac(a: ChartContentType, b: DependencyObject): void;
    private m;
    private u;
    z(a: DomRenderer): void;
    y(): void;
    ab(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: boolean): void;
    private p;
    private j(a, b);
    x(): void;
    private v();
    private _r();
    private r();
    w(a: Size): void;
    n: boolean;
    o: boolean;
    ad(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: Rect): void;
    aa(a: Axis, b: ContentInfo): void;
    static $t: Type;
}
export declare class ContentInfo extends Base {
    h: DependencyObject;
    a: (arg1: boolean) => void;
    b: boolean;
    c: boolean;
    i: Rect;
    readonly d: boolean;
    g(): void;
    f(): void;
    e: boolean;
    static $t: Type;
}
export declare abstract class Series extends Control implements INotifyPropertyChanged, IProvidesViewport, ILegendSeries, ILegendOwner, ILegendTemplateProvider {
    bh: SeriesView;
    private static eu;
    e9: number;
    k4: Rect;
    private es;
    et: DomRenderer;
    provideRenderer(a: DomRenderer): void;
    ge(): string;
    constructor();
    private static readonly kh;
    protected g7(a: any, b: PropertyChangedEventArgs): void;
    private b0;
    readonly b1: SRProvider;
    private a0;
    readonly a1: ISeriesVisualDataManager;
    protected readonly dt: Dictionary$2<string, SeriesView>;
    private ay;
    readonly az: ISeriesInteractionManager;
    readonly cv: boolean;
    bs: DoubleAnimator;
    h9(a: SeriesView): void;
    h7(): void;
    h8(): void;
    bf(): SeriesView;
    protected be(): SeriesView;
    jc: Canvas;
    dp(): boolean;
    d2(a: Point): number;
    ez(a: Point): number;
    protected get_cz(): boolean;
    readonly cz: boolean;
    ao(): CategoryAxisBase;
    ex(a: Point): number;
    fe(a: Point): any;
    protected fg(a: Series, b: Point): any;
    ew(): number;
    e0(): number;
    e5(): number;
    readonly container: ILegendOwner;
    readonly hasSubItems: boolean;
    protected cg(): boolean;
    forSubItems(a: (arg1: any) => void): void;
    protected hp(a: (arg1: any) => void): void;
    hq(a: (arg1: Series) => boolean): void;
    ko(): Brush;
    resolveLegendIndex(): number;
    a5(): Series;
    protected get_ch(): boolean;
    readonly ch: boolean;
    protected get_isVertical(): boolean;
    readonly isVertical: boolean;
    protected get_cq(): boolean;
    readonly cq: boolean;
    protected get_ci(): boolean;
    readonly ci: boolean;
    protected get_cy(): boolean;
    readonly cy: boolean;
    protected get_c2(): boolean;
    readonly c2: boolean;
    protected get_c0(): boolean;
    readonly c0: boolean;
    protected get_isStacked(): boolean;
    readonly isStacked: boolean;
    protected get_cp(): boolean;
    readonly cp: boolean;
    protected get_c1(): boolean;
    readonly c1: boolean;
    protected get_cj(): boolean;
    readonly cj: boolean;
    protected get_cr(): boolean;
    readonly cr: boolean;
    a4(): Series;
    protected get_ck(): boolean;
    readonly ck: boolean;
    protected get_cl(): boolean;
    readonly cl: boolean;
    d0(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    protected d1(a: Point, b: number, c: Axis, d: ScalerParams, e: number, f: number, g: (arg1: Point) => number): number;
    protected get_dr(): boolean;
    readonly dr: boolean;
    protected ef(a: IList$1<number>, b: Point, c: Axis, d: ScalerParams, e: number, f: (arg1: Point) => number, g: boolean, h: boolean): number;
    d6(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    e4(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    d5(a: boolean): number;
    ag(a: Point): Point[][];
    ah(a: Point): Point[][];
    protected dc(a: Point, b: boolean): boolean;
    ai(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[][];
    protected de(a: Point, b: boolean, c: PathGeometry): boolean;
    protected df(a: Point, b: PathGeometry): boolean;
    e2(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    d4(a: Point, b: Axis): number;
    e3(a: Point, b: boolean): number;
    e1(a: Point, b: boolean): number;
    ed(a: Point, b: boolean, c: boolean): number;
    k0(a: Point, b: boolean, c: boolean): Point;
    k9(a: Point): Rect;
    aj(a: Point): Rect[];
    la(a: Point): Rect;
    ak(a: Point): Rect[];
    lb(a: Point): Rect;
    lc(a: Point): Rect;
    protected dg(a: Point, b: boolean): boolean;
    protected k2(a: Point, b: boolean, c: boolean, d: number, e: Axis, f: Axis, g: (arg1: Point, arg2: boolean, arg3: boolean) => number, h: (arg1: Point, arg2: boolean) => number, i: (arg1: Point, arg2: boolean) => number): Point;
    d9(a: Point, b: boolean, c: boolean): number;
    kw(a: Point, b: boolean, c: boolean): Point;
    eb(a: Point, b: boolean, c: boolean): number;
    ky(a: Point, b: boolean, c: boolean): Point;
    k1(a: Point, b: boolean, c: boolean): Point;
    ee(a: Point, b: boolean, c: boolean): number;
    kx(a: Point, b: boolean, c: boolean): Point;
    ea(a: Point, b: boolean, c: boolean): number;
    kz(a: Point, b: boolean, c: boolean): Point;
    ec(a: Point, b: boolean, c: boolean): number;
    ey(a: Point): number;
    d7(): number;
    d3(a: Point): number;
    ff(a: Point): any;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected raisePropertyChanged(a: string, b: any, c: any): void;
    protected get_hasMarkers(): boolean;
    readonly hasMarkers: boolean;
    kl(): Brush;
    km(): Brush;
    je(): DataTemplate;
    k3(a: Point): Point;
    kv(a: Point): Point;
    fh(a: any, b: Point): any;
    c5(a: any): boolean;
    am(a: Axis): AxisRange;
    an(): AxisRange;
    it(a: boolean): void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    private hk(a);
    iu(a: boolean): void;
    protected di: boolean;
    protected hb(): void;
    protected hf(): void;
    bg: SeriesView;
    iv(a: Rect, b: RenderSurface): void;
    is(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    getEffectiveViewport1(a: SeriesView): Rect;
    k5(a: SeriesView): Rect;
    k8(a: Rect): Rect;
    k7(a: SeriesView): Rect;
    getEffectiveViewport(): Rect;
    io(): void;
    private ip(a);
    iq(a: string): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    ds(a: Rect, b: Rect, c: SeriesView): boolean;
    he(a: boolean, b: SeriesView): void;
    protected ca(): boolean;
    cb(a: SeriesView): boolean;
    ia(a: Rect, b: Rect): void;
    protected i8(a: Rect, b: Rect): void;
    protected i7(a: Rect, b: Rect): void;
    ap: ContentInfo;
    private b5;
    dh: boolean;
    protected ho(a: Series): void;
    protected h2(): void;
    h1(): void;
    protected get_cu(): boolean;
    readonly cu: boolean;
    protected get_isUsableInLegend(): boolean;
    readonly isUsableInLegend: boolean;
    protected h5(): void;
    h3(): void;
    protected ib(): void;
    ic(): void;
    protected da: boolean;
    protected db: boolean;
    protected c4(): boolean;
    protected id(a: boolean): void;
    private b6;
    protected dj: boolean;
    protected readonly dk: boolean;
    protected ie(a: any, b: string, c: any, d: any): void;
    hm(): void;
    protected cf(): boolean;
    protected get_ct(): boolean;
    protected readonly ct: boolean;
    cc: boolean;
    protected hj(a: Series): void;
    bm: SyncLink;
    private bl;
    br: SeriesViewer;
    private bq;
    bp: XamDataChart;
    readonly dx: (sender: any, e: NotifyCollectionChangedEventArgs) => void;
    readonly a3: (sender: any, e: PropertyUpdatedEventArgs) => void;
    readonly bz: (sender: any, e: RectChangedEventArgs) => void;
    itemsSource: IEnumerable;
    static readonly js: DependencyProperty;
    by: IFastItemsSource;
    ep: (sender: any, e: FastItemsSourceEventArgs) => void;
    protected hh(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    ax: IChartLegend;
    static readonly jw: DependencyProperty;
    jb: Control;
    private ja;
    fi(): any;
    protected i9(): Control;
    av: IChartLegend;
    private au;
    le: Visibility;
    legendItemBadgeTemplate: DataTemplate;
    static readonly jt: DependencyProperty;
    bk: StandardLegendItems;
    bi: StandardLegendBadges;
    bj: StandardLegendItems;
    legendItemTemplate: DataTemplate;
    static readonly ju: DependencyProperty;
    jd: DataTemplate;
    static readonly jm: DependencyProperty;
    e6: number;
    static readonly jp: DependencyProperty;
    i6(): void;
    hl(): void;
    protected i4(): void;
    bt: (time: number) => number;
    bu: (time: number) => number;
    ce: boolean;
    e7: number;
    eo: number;
    b9(): boolean;
    i1(): void;
    ej: number;
    fj: any;
    kk: Brush;
    ki: Brush;
    kn: Brush;
    kj: Brush;
    ei: number;
    en: number;
    kr: PenLineCap;
    kq: DoubleCollection;
    toolTip: any;
    cs: boolean;
    cn: boolean;
    protected get_co(): boolean;
    readonly co: boolean;
    ek: number;
    kp: Color;
    dq: boolean;
    el: number;
    em: number;
    b8: boolean;
    dz: number;
    dy: number;
    i3(): void;
    private b4;
    cm: boolean;
    c9: boolean;
    ar(a: any): DataContext;
    e8: number;
    bo: TransitionInSpeedType;
    protected bn(): TransitionInSpeedType;
    fc: any;
    ir(): void;
    iw(): void;
    hc(): void;
    ht(): void;
    private static _dv(a, b, c);
    static dv(a: (arg1: number) => number, b: number, c: number): IEnumerable$1<number>;
    static du(a: (arg1: number) => number, b: number): IEnumerable$1<number>;
    kt: PenLineCap;
    ks: PenLineCap;
    private a6;
    a7(): SeriesComponentsForView;
    ix(a: Canvas): void;
    eg(): number;
    eh(): number;
    private b7;
    protected get_dl(): boolean;
    protected set_dl(a: boolean): void;
    protected dl: boolean;
    readonly c7: boolean;
    c3: boolean;
    as(a: any, b: Point): HighlightingInfo;
    at(a: any, b: Point): HighlightingInfo;
    h6(a: Point, b: any, c: any): void;
    i0(a: Point): void;
    private g9(a, b);
    private hd();
    g8(a: IChartLegend, b: IChartLegend): void;
    private ha(a, b);
    im(a: IFastItemsSourceProvider): void;
    il(a: IFastItemsSourceProvider): void;
    protected aw(): IChartLegend;
    protected c8(): boolean;
    c6(a: boolean): boolean;
    protected hi(a: Axis): void;
    protected ik(a: Axis): void;
    a8(): SeriesComponentsFromView;
    i5(a: Canvas): void;
    iz(a: Point, b: (arg1: any) => void): void;
    protected get_dn(): boolean;
    readonly dn: boolean;
    ig(a: RenderingContext, b: RenderingContext): void;
    ii(a: Rect): void;
    hs(a: NotifyCollectionChangedEventArgs): void;
    hz(a: number, b: any, c: any): void;
    hw(): void;
    hx(a: number, b: any): void;
    hy(a: number, b: any): void;
    i2(): void;
    fl: any;
    er: (arg1: any) => any;
    dd(a: Point, b: boolean): boolean;
    protected _coercionMethods: any;
    protected get_coercionMethods(): any;
    protected set_coercionMethods(a: any): void;
    coercionMethods: any;
    private b3;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    expectFunctions: boolean;
    aq(a: Point, b: boolean): DataContext;
    private ba;
    bd: SeriesHitTestMode;
    protected bc(): SeriesHitTestMode;
    private a9;
    bb: SeriesHitTestMode;
    protected bv(a: string): IFastItemColumn$1<number>;
    protected bw(a: string): IFastItemColumn$1<number>;
    protected bx(a: string): IFastItemColumn$1<any>;
    protected readonly ld: Rect;
    protected get_cx(): boolean;
    readonly cx: boolean;
    protected get_cw(): boolean;
    readonly cw: boolean;
    iy(a: Brush, b: Brush): void;
    b2: (arg1: SeriesViewer) => void;
    protected hg(a: any, b: any): void;
    fd(): any;
    protected hn(a: any): void;
    private ku;
    hu(a: Point): void;
    protected h4(a: Point): void;
    hv(): void;
    h0(): void;
    al(a: Axis): Axis;
    d8(): number;
    static $$p: string[];
    static $t: Type;
}
export declare abstract class MarkerSeries extends Series {
    lf: MarkerSeriesView;
    constructor();
    h9(a: SeriesView): void;
    protected get_hasMarkers(): boolean;
    readonly hasMarkers: boolean;
    kl(): Brush;
    km(): Brush;
    je(): DataTemplate;
    lg: MarkerType;
    lz: DataTemplate;
    lx: DataTemplate;
    ly: DataTemplate;
    private static lw;
    static readonly l0: DataTemplate;
    mc: Brush;
    static readonly l4: DependencyProperty;
    ma: Brush;
    md: Brush;
    mb: Brush;
    me: Style;
    lk: boolean;
    li(): boolean;
    protected ie(a: any, b: string, c: any, d: any): void;
    static lp(a: MarkerType): string;
    static lh(a: Series, b: MarkerType): MarkerType;
    protected i4(): void;
    protected hn(a: any): void;
    protected lj(a: Point, b: boolean): boolean;
    aq(a: Point, b: boolean): DataContext;
    static $$p: string[];
    static $t: Type;
}
export declare class SyncLink extends FrameworkElement implements INotifyPropertyChanged, IFastItemsSourceProvider {
    constructor();
    ai: string;
    protected am(a: any, b: string, c: any, d: any): void;
    releaseFastItemsSource(a: IEnumerable): IFastItemsSource;
    static ah: (arg1: IEnumerable) => IFastItemsSource;
    private static ad(a);
    getFastItemsSource(a: IEnumerable): IFastItemsSource;
    ae(a: IEnumerable): IFastItemsSource;
    private af;
    aq: Rect;
    private ar(a, b, c);
    private as(a, b, c, d);
    readonly ag: IList$1<SeriesViewer>;
    ab: ChartCollection;
    private aj(a, b);
    ak(a: SeriesViewer, b: Point): void;
    al(a: SeriesViewer, b: Rect): void;
    ao(a: SeriesViewer, b: Rect): void;
    ap(a: SeriesViewer, b: Rect, c: boolean): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected an(a: string, b: any, c: any): void;
    static $t: Type;
}
export declare class SyncLinkManager extends Base {
    private static b;
    static c(): SyncLinkManager;
    private d;
    readonly e: number;
    constructor();
    a(a: string): SyncLink;
    f(a: SyncLink): void;
    static $t: Type;
}
export declare class SyncManager extends Base {
    static e(a: SeriesViewer): void;
    static c(a: SeriesViewer): void;
    static b(a: SeriesViewer, b: string, c: string): void;
    static d(a: DependencyObject, b: SyncSettings): void;
    static a(a: DependencyObject): SyncSettings;
    static $t: Type;
}
export declare class ChartCollection extends ObservableCollection$1<SeriesViewer> {
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
    static $t: Type;
}
export declare class SeriesCollection extends ObservableCollection$1<Series> {
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
    static $t: Type;
}
export declare class ChartCursorEventArgs extends EventArgs {
    constructor(a: SeriesViewer, b: Series, c: any);
    toString(): string;
    private _item;
    item: any;
    private _series;
    series: Series;
    private _seriesViewer;
    seriesViewer: SeriesViewer;
    readonly chart: XamDataChart;
    static $t: Type;
}
export declare class DataChartMouseButtonEventArgs extends EventArgs {
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseButtonEventArgs);
    toString(): string;
    protected g: MouseButtonEventArgs;
    handled: boolean;
    getPosition(a: UIElement): Point;
    readonly originalSource: any;
    private _item;
    item: any;
    private _series;
    series: Series;
    private _chart;
    chart: SeriesViewer;
    static $t: Type;
}
export declare class ChartMouseEventArgs extends EventArgs {
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseEventArgs);
    toString(): string;
    private f;
    getPosition(a: UIElement): Point;
    readonly originalSource: any;
    private _item;
    item: any;
    private _series;
    series: Series;
    private _chart;
    chart: SeriesViewer;
    static $t: Type;
}
export declare class HighlightingInfo extends Base {
    constructor();
    f: number;
    e: number;
    a: HighlightingState;
    d: number;
    c: boolean;
    b: Series;
    static $t: Type;
}
export interface IHighlightingManager {
    startHighlight(a: HighlightingInfo): void;
    endHighlight(a: HighlightingInfo): void;
    clear(): void;
    getHighlightingInfo(a: Series, b: IFastItemsSource, c: Axis, d: number, e: number, f: boolean): HighlightingInfo;
    tick(a: number): boolean;
    inProgress: boolean;
    maxHighlightingProgress: number;
    sumHighlightingProgress: number;
    maxMarkerHighlightingProgress: number;
    sumMarkerHighlightingProgress: number;
    readonly dirtySeries: List$1<Series>;
}
export declare let IHighlightingManager_$type: Type;
export declare class AxisComponentsForView extends Base {
    a: AxisLabelPanelBase;
    static $t: Type;
}
export declare class AxisLabelPanelBaseView extends Base {
    protected a: AxisLabelPanelBase;
    at: Path;
    constructor(a: AxisLabelPanelBase);
    z(a: FrameworkElement, b: Rect, c: number, d: number, e: number, f: number): void;
    ac(a: FrameworkElement): void;
    af(a: any): void;
    ag(a: any, b: Size): void;
    ah(a: FrameworkElement, b: number): void;
    x(a: TextBlock, b: number, c: number, d: number): string;
    ad(): void;
    g(): IEnumerable$1<any>;
    l(a: any): number;
    n(a: any): number;
    al(): void;
    m(a: any): number;
    w(a: any): number;
    ab(): void;
    ai(): void;
    protected e: RenderingContext;
    f(): RenderingContext;
    aj(a: RenderingContext): void;
    y(): void;
    protected ak(): void;
    private as;
    protected an(a: TextBlock): void;
    am(): void;
    d(): FontInfo;
    aq(): Brush;
    private c;
    ae(): void;
    private h;
    private ap();
    private i;
    j(): number;
    k(): number;
    protected ao(): void;
    aa(a: Size): void;
    protected au(): Thickness;
    v(): number;
    s(): number;
    t(): number;
    u(): number;
    ar(): GeometryCollection;
    b(): PathRenderingInfo;
    r(): number;
    p(): number;
    q(): number;
    o(): number;
    static $t: Type;
}
export declare class AxisView extends Base implements ISchedulableRender {
    protected a: Axis;
    constructor(a: Axis);
    ab(): void;
    ad(a: any): void;
    a2: Path;
    a3: Path;
    a5: Path;
    a4: Path;
    as(): TextBlock;
    al(a: TextBlock): void;
    an(a: TextBlock): void;
    am(a: TextBlock): void;
    ae(): void;
    l(): boolean;
    readonly index: number;
    y(): void;
    w(): void;
    s(): void;
    aq(a: Visibility): void;
    ai(): void;
    r(a: AxisLabelSettings): void;
    private b;
    c(): AxisComponentsFromView;
    u(a: GeometryCollection): void;
    at(): GeometryCollection;
    e(): PathRenderingInfo;
    aw(): GeometryCollection;
    au(): GeometryCollection;
    f(): PathRenderingInfo;
    av(): GeometryCollection;
    g(): PathRenderingInfo;
    protected readonly d: AxisLabelPanelBase;
    ao(a: Axis, b: Rect, c: Rect): void;
    t(): void;
    ak(a: number): void;
    ap(a: List$1<any>, b: List$1<LabelPosition>): void;
    aj(a: number): void;
    q(): void;
    m(dataItem_: any): any;
    protected j: RenderingContext;
    i: RenderingContext;
    aa(a: RenderingContext, b: RenderingContext): void;
    private _isDirty;
    isDirty: boolean;
    protected z(): void;
    undirty(a: boolean): void;
    private a6;
    protected ag(a: boolean): void;
    postRender(): void;
    private a0;
    protected ah(): void;
    x(): void;
    v(a: SeriesViewer): void;
    p(a: SeriesViewer): void;
    h(): FontInfo;
    k(): boolean;
    af(): void;
    o(): void;
    ar(): void;
    n(a: AxisLabelSettings, b: string): void;
    preRender(): void;
    isValid(): boolean;
    ax(a: TextBlock): Point;
    ay(): Point;
    a1(): Rect;
    az(a: TextBlock): Point;
    a7(a: TextBlock): Thickness;
    ac(): void;
    static $t: Type;
}
export declare class CategoryAxisBaseView extends AxisView {
    protected a8: CategoryAxisBase;
    constructor(a: CategoryAxisBase);
    a9(a: List$1<any>): number;
    static $t: Type;
}
export declare class HorizontalAxisLabelPanelBaseView extends AxisLabelPanelBaseView {
    protected av: HorizontalAxisLabelPanelBase;
    constructor(a: HorizontalAxisLabelPanelBase);
    ax(): void;
    ay(a: List$1<Rect>, b: number): void;
    aw(): boolean;
    az(a: List$1<Rect>): void;
    static $t: Type;
}
export declare class NumericAxisBaseView extends AxisView {
    protected a8: NumericAxisBase;
    constructor(a: NumericAxisBase);
    a9(): void;
    static $t: Type;
}
export declare class VerticalAxisLabelPanelView extends AxisLabelPanelBaseView {
    protected av: VerticalAxisLabelPanel;
    constructor(a: VerticalAxisLabelPanel);
    aw(): void;
    d(): FontInfo;
    protected au(): Thickness;
    aq(): Brush;
    ax(a: List$1<Rect>, b: number): void;
    static $t: Type;
}
export declare class XamDataChartView extends SeriesViewerView {
    constructor(a: XamDataChart);
    protected fa: XamDataChart;
    fe(a: any): void;
    protected dh(): void;
    du(): void;
    fj: Brush;
    ff: Brush;
    fg: Brush;
    fi: Brush;
    fh: Brush;
    fc: number;
    fd: number;
    cs(a: any): void;
    protected dr(): void;
    fb: FontInfo;
    static $t: Type;
}
export declare class SeriesView extends Base implements ISchedulableRender, IProvidesViewport {
    protected e: Series;
    p: boolean;
    constructor(a: Series);
    getDefaultTooltipTemplate(): string;
    am(): void;
    d: DataContext;
    ap(): void;
    getEffectiveViewport(): Rect;
    aw(): void;
    ag(): void;
    readonly t: DomRenderer;
    private _isDirty;
    isDirty: boolean;
    protected get_index(): number;
    readonly index: number;
    protected an(): void;
    undirty(a: boolean): void;
    private br;
    ar(): void;
    s: number;
    private r();
    protected a1(a: boolean): void;
    private bm;
    protected ba(a: any, b: number, c: boolean): void;
    protected bd(a: any, b: number, c: boolean): void;
    protected x(a: number, b: boolean): any;
    protected y(a: number): any;
    protected z(a: number): any;
    protected bb(a: any, b: number): void;
    protected be(a: any, b: number): void;
    protected bc(a: any, b: number): void;
    protected bf(a: any, b: number): void;
    protected a7(a: boolean): void;
    protected a8(): void;
    protected a9(): void;
    private bj;
    protected bl(a: number): Brush;
    protected bk(): Brush;
    protected a3(a: RenderingContext, b: boolean): void;
    protected a2(a: RenderingContext, b: boolean): void;
    au(): void;
    aj(): void;
    ak(): void;
    private f;
    g(): SeriesComponentsFromView;
    a6(a: Canvas): void;
    q(): boolean;
    at(): void;
    as(): void;
    a4(): void;
    ae(): void;
    a5(): void;
    af(): void;
    c(a: any): DataContext;
    protected h: RenderingContext;
    protected i: RenderingContext;
    ao(a: RenderingContext, b: RenderingContext): void;
    private bn;
    bp: Rect;
    bo: Rect;
    protected get_bq(): Rect;
    readonly bq: Rect;
    private j;
    n: boolean;
    ah(a: SeriesViewer): void;
    a: CanvasRenderScheduler;
    ad(a: SeriesViewer): void;
    postRender(): void;
    protected ax(): void;
    b(a: number): DataContext;
    az(a: RenderSurface): void;
    ai(a: any): void;
    bg(): void;
    aq(): void;
    av(): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    l(): boolean;
    protected o: boolean;
    bh(): void;
    a0(): void;
    protected ac(): void;
    al(): void;
    preRender(): void;
    isValid(): boolean;
    k: boolean;
    m: boolean;
    ay(a: RenderSurface): void;
    aa: string;
    bi(type_: StandardLegendItems): DataTemplate;
    static $t: Type;
}
export declare abstract class MarkerSeriesView extends SeriesView {
    protected bw: MarkerSeries;
    private b0;
    private b2;
    private b1;
    constructor(a: MarkerSeries);
    ap(): void;
    cb(): void;
    ci(a: boolean): void;
    protected bz: List$1<Marker>;
    bv(): Marker;
    abstract ca(a: (arg1: Marker) => void): void;
    ce(a: Marker): void;
    cg(a: Marker): void;
    cf(a: Marker): void;
    bx(): boolean;
    b9(): void;
    b3(): void;
    ck(a: Marker): Rect;
    b6(a: string): void;
    b7(): void;
    b4(): void;
    b8(): void;
    b5(): void;
    ch(): void;
    by: boolean;
    protected be(a: any, b: number): void;
    private bs;
    protected bf(a: any, b: number): void;
    b(a: number): DataContext;
    private cj;
    protected a2(a: RenderingContext, b: boolean): void;
    cc(a: HashPool$2<any, Marker>): void;
    cd(a: Pool$1<Marker>): void;
    bt(a: Point): Marker;
    private bu(a, b);
    static $t: Type;
}
export declare class ChartAxisRangeChangedEventArgs extends EventArgs {
    constructor(a: SeriesViewer, b: Axis, c: number, d: number, e: number, f: number);
    private _chart;
    chart: SeriesViewer;
    private _axis;
    axis: Axis;
    private _oldMinimumValue;
    oldMinimumValue: number;
    private _minimumValue;
    minimumValue: number;
    private _oldMaximumValue;
    oldMaximumValue: number;
    private _maximumValue;
    maximumValue: number;
    static $t: Type;
}
