import { NgZone, Renderer2 } from '@angular/core';
import { DomRenderer, DomWrapper } from './type';
export declare class AngularRenderer implements DomRenderer {
    private container;
    constructor(container: any, renderer: Renderer2, document: any, ngZone: NgZone, useDefaultsSource: boolean, defaultsSource: {
        [key: string]: any;
    });
    private _container;
    private _renderer;
    private _document;
    private _ngZone;
    private _useDefaultsSource;
    private _defaultsSource;
    private _rootWrapper;
    private _rootElement;
    private _cssHelper;
    private _checkResized;
    private _resizeListener;
    private _resizeTicking;
    addSizeWatcher(onResized: () => void): void;
    destroy(): void;
    removeSizeWatcher(): void;
    withRenderer(act: (ren: Renderer2) => void): void;
    supportsAnimation(): boolean;
    getRequestAnimationFrame(): (act: () => void) => void;
    setTimeout(act: () => void, millisecondsDelay: number): number;
    clearTimeout(timerId: any): void;
    readonly rootWrapper: DomWrapper;
    querySelector(selector: string): DomWrapper;
    getWrapper(ele: any): DomWrapper;
    getResourceString(resourceId: string): string;
    append(child: DomWrapper): DomRenderer;
    appendToBody(element: DomWrapper): void;
    createElement(elementName: any): AngularWrapper;
    private _discStack;
    endCSSQuery(): void;
    expandTemplate(template: string, args: any): AngularWrapper;
    get2DCanvasContext(canvas: AngularWrapper): CanvasRenderingContext2D;
    private readonly isComputedFontQuery;
    getCssDefaultPropertyValue(className: string, propertyName: string): string;
    getCssDefaultValuesForClassCollection(classPrefix: string, propertyNames: string[]): any[];
    getDefaultFontHeight(): number;
    getHeightForFontString(fontString: any, text: any, useOffsetHeight: any): any;
    getSubRenderer(root: DomWrapper): DomRenderer;
    private _toUnbind;
    globalListen(element: string, eventName: string, handler: (ev: any) => void): () => void;
    hasBody(): boolean;
    hasWindow(): boolean;
    getCurrentDiscovery(): AngularWrapper;
    private _currentFontQuery;
    setCssQueryFontString(fontString: any): void;
    startCSSQuery(): void;
    supportsDOMEvents(): boolean;
}
export declare class AngularWrapper implements DomWrapper {
    private ele;
    private renderer;
    private ngZone;
    constructor(ele: any, renderer: Renderer2, ngZone: NgZone);
    destroy(): void;
    withRenderer(act: (ren: Renderer2) => void): void;
    private _toUnbind;
    private _attrCache;
    private _styleCache;
    addClass(className: string): DomWrapper;
    append(child: DomWrapper): DomWrapper;
    getAttribute(propertyName: string): string;
    setAttribute(propertyName: string, value: string): this;
    before(child: any): DomWrapper;
    clone(): DomWrapper;
    getStyleProperty(propertyName: string): string;
    setStyleProperty(propertyName: string, value: string): DomWrapper;
    findByClass(className: any): DomWrapper[];
    focus(): DomWrapper;
    getChildAt(i: any): DomWrapper;
    getChildCount(): number;
    getNativeElement(): any;
    height(): number;
    hide(): DomWrapper;
    listen(eventName: string, handler: (ev: any) => void): () => void;
    getOffsetHelper(ele: Element): AngularWrapperPosition;
    getOffset(): AngularWrapperPosition;
    setOffset(x: number, y: number): DomWrapper;
    outerHeight(): number;
    outerHeightWithMargin(): number;
    outerWidth(): number;
    outerWidthWithMargin(): number;
    getProperty(propertyName: string): any;
    setProperty(propertyName: string, value: any): DomWrapper;
    remove(): DomWrapper;
    removeChild(child: DomWrapper): this;
    removeChildren(): DomWrapper;
    removeClass(className: string): DomWrapper;
    setRawStyleProperty(propertyName: string, value: string): DomWrapper;
    setRawPosition(x: number, y: number): DomWrapper;
    setRawXPosition(x: number): DomWrapper;
    setRawYPosition(y: number): DomWrapper;
    setRawSize(width: number, height: number): DomWrapper;
    show(): DomWrapper;
    getText(): string;
    private _innerText;
    setText(value: string): DomWrapper;
    unlistenAll(): DomWrapper;
    width(): number;
}
export interface AngularWrapperPosition {
    left: number;
    top: number;
}
