import * as tslib_1 from "tslib";
import { IgxCollection } from './IgxCollection';
import { markType } from './type';
import { SyncableObservableCollection$2 } from './SyncableObservableCollection$2';
import { Axis as Axis_internal } from './Axis';
import { IgxAxisComponent as IgxAxisComponent } from './igx-axis-component';
var AxisCollection = /** @class */ (function (_super) {
    tslib_1.__extends(AxisCollection, _super);
    function AxisCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgxAxisComponent.$type) {
            IgxAxisComponent.$type = markType(IgxAxisComponent, "IgxAxisComponent");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    AxisCollection.prototype._createInnerColl = function () {
        if (!IgxAxisComponent.$type) {
            IgxAxisComponent.$type = markType(IgxAxisComponent, "IgxAxisComponent");
        }
        var coll = new SyncableObservableCollection$2(IgxAxisComponent.$type, Axis_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgxAxisComponent._createFromInternal(int);
                ext._implementation = int;
            }
            return ext;
        };
        return coll;
    };
    return AxisCollection;
}(IgxCollection));
export { AxisCollection };
//# sourceMappingURL=igx-axis-collection.js.map