/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Output, EventEmitter, Input } from '@angular/core';
import { Visibility, Visibility_$type } from './Visibility';
import { HorizontalAlignment, HorizontalAlignment_$type } from './HorizontalAlignment';
import { VerticalAlignment, VerticalAlignment_$type } from './VerticalAlignment';
import { AxisLabelsLocation, AxisLabelsLocation_$type } from './AxisLabelsLocation';
import { AxisLabelSettings } from './AxisLabelSettings';
import { TitleSettings } from './TitleSettings';
import { AxisTitlePosition, AxisTitlePosition_$type } from './AxisTitlePosition';
import { ensureEnum, brushToString, stringToBrush, ensureBool } from './componentUtil';
import { delegateCombine } from './type';
import { RenderRequestedEventArgs } from './RenderRequestedEventArgs';
import { TypeRegistrar } from './type';
export var IgxAxisComponent_PROVIDERS = [];
/**
 * Represents the base class from which all axis types are derived.
*/
var IgxAxisComponent = /** @class */ (function () {
    function IgxAxisComponent() {
        this._renderer = null;
        this._renderRequested = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    Object.defineProperty(IgxAxisComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxAxisComponent.prototype.onImplementationCreated = function () {
    };
    Object.defineProperty(IgxAxisComponent.prototype, "axisInternal", {
        get: function () {
            return this.i;
        },
        enumerable: true,
        configurable: true
    });
    IgxAxisComponent.prototype.createImplementation = function () {
        return null;
    };
    IgxAxisComponent.prototype.ngOnInit = function () {
    };
    Object.defineProperty(IgxAxisComponent.prototype, "name", {
        get: function () {
            console.log("getting axis anme: " + this.i.name);
            return this.i.name;
        },
        set: function (value) {
            console.log("setting axis name: " + value);
            this.i.name = value;
            console.log("checking axis anme: " + this.i.name);
        },
        enumerable: true,
        configurable: true
    });
    IgxAxisComponent.prototype.provideData = function (data) {
    };
    IgxAxisComponent.prototype._provideRenderer = function (renderer) {
        this._renderer = renderer;
        this._zoneRunner = function (act) { return renderer._ngZone.run(act); };
    };
    IgxAxisComponent._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    Object.defineProperty(IgxAxisComponent.prototype, "isCategory", {
        /**
     * Gets or sets if the current axis is of category axis type
    */
        get: /**
             * Gets or sets if the current axis is of category axis type
            */
        function () {
            return this.i.bt;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "isNumeric", {
        /**
         * Gets or sets if the current axis is of numeric axis type
        */
        get: /**
             * Gets or sets if the current axis is of numeric axis type
            */
        function () {
            return this.i.b1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "isAngular", {
        /**
         * Gets if the current axis is of angular axis type
        */
        get: /**
             * Gets if the current axis is of angular axis type
            */
        function () {
            return this.i.bs;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "isRadial", {
        /**
         * Gets or sets if the current axis is of radial axis type
        */
        get: /**
             * Gets or sets if the current axis is of radial axis type
            */
        function () {
            return this.i.b2;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "isVertical", {
        /**
         * Gets if the current axis is a vertical axis.
        */
        get: /**
             * Gets if the current axis is a vertical axis.
            */
        function () {
            return this.i.b5;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "isSorting", {
        /**
         * Gets or sets if the current axis is sorting data items
        */
        get: /**
             * Gets or sets if the current axis is sorting data items
            */
        function () {
            return this.i.b3;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "isDateTime", {
        /**
         * Gets or sets if the current axis is of date time axis type
        */
        get: /**
             * Gets or sets if the current axis is of date time axis type
            */
        function () {
            return this.i.bw;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "isCategoryDateTime", {
        /**
         * Gets or sets if the current axis is of category date time axis type
        */
        get: /**
             * Gets or sets if the current axis is of category date time axis type
            */
        function () {
            return this.i.bu;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "isContinuous", {
        /**
         * Gets if the current axis is a continuous rather than a discrete scale
        */
        get: /**
             * Gets if the current axis is a continuous rather than a discrete scale
            */
        function () {
            return this.i.bv;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "formatLabel", {
        /**
         * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
        */
        get: /**
             * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
            */
        function () {
            return this.i.an;
        },
        set: function (v) {
            this.i.an = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "title", {
        /**
         * Gets or sets the Title property.
        */
        get: /**
             * Gets or sets the Title property.
            */
        function () {
            return this.i.fp;
        },
        set: function (v) {
            this.i.fp = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "stroke", {
        /**
         * Gets or sets the Stroke property.
         * Null is treated as auto. The axis stroke will be displayed or not based on the axis type and series used with it.
        */
        get: /**
             * Gets or sets the Stroke property.
             * Null is treated as auto. The axis stroke will be displayed or not based on the axis type and series used with it.
            */
        function () {
            return brushToString(this.i.hy);
        },
        set: function (v) {
            this.i.hy = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "actualStroke", {
        /**
         * Gets or sets the effective stroke used for the axis.
        */
        get: /**
             * Gets or sets the effective stroke used for the axis.
            */
        function () {
            return brushToString(this.i.hu);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "strokeThickness", {
        /**
         * Gets or sets the StrokeThickness property.
        */
        get: /**
             * Gets or sets the StrokeThickness property.
            */
        function () {
            return this.i.ea;
        },
        set: function (v) {
            this.i.ea = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "strip", {
        /**
         * Gets or sets the Strip property.
        */
        get: /**
             * Gets or sets the Strip property.
            */
        function () {
            return brushToString(this.i.hx);
        },
        set: function (v) {
            this.i.hx = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "majorStroke", {
        /**
         * Gets or sets the MajorStroke property.
         * Null is treated as auto. Major lines will be displayed or not based on the axis type and series used with it.
        */
        get: /**
             * Gets or sets the MajorStroke property.
             * Null is treated as auto. Major lines will be displayed or not based on the axis type and series used with it.
            */
        function () {
            return brushToString(this.i.hv);
        },
        set: function (v) {
            this.i.hv = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "actualMajorStroke", {
        /**
         * Gets or sets the ActualMajorStroke property.
        */
        get: /**
             * Gets or sets the ActualMajorStroke property.
            */
        function () {
            return brushToString(this.i.hs);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "majorStrokeThickness", {
        /**
         * Gets or sets the MajorStrokeThickness property.
        */
        get: /**
             * Gets or sets the MajorStrokeThickness property.
            */
        function () {
            return this.i.dr;
        },
        set: function (v) {
            this.i.dr = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "minorStroke", {
        /**
         * Gets or sets the MinorStroke property.
        */
        get: /**
             * Gets or sets the MinorStroke property.
            */
        function () {
            return brushToString(this.i.hw);
        },
        set: function (v) {
            this.i.hw = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "actualMinorStroke", {
        /**
         * Gets or sets the ActualMinorStroke property.
        */
        get: /**
             * Gets or sets the ActualMinorStroke property.
            */
        function () {
            return brushToString(this.i.ht);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "minorStrokeThickness", {
        /**
         * Gets or sets the MinorStrokeThickness property.
        */
        get: /**
             * Gets or sets the MinorStrokeThickness property.
            */
        function () {
            return this.i.du;
        },
        set: function (v) {
            this.i.du = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "tickStroke", {
        /**
         * Gets or sets the TickStroke property.
        */
        get: /**
             * Gets or sets the TickStroke property.
            */
        function () {
            return brushToString(this.i.hz);
        },
        set: function (v) {
            this.i.hz = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "tickStrokeThickness", {
        /**
         * Gets or sets the TickStrokeThickness property.
        */
        get: /**
             * Gets or sets the TickStrokeThickness property.
            */
        function () {
            return this.i.ec;
        },
        set: function (v) {
            this.i.ec = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "tickLength", {
        /**
         * Gets or sets the TickLength property.
        */
        get: /**
             * Gets or sets the TickLength property.
            */
        function () {
            return this.i.eb;
        },
        set: function (v) {
            this.i.eb = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "isDisabled", {
        /**
         * Gets or sets the IsDisabled property. If true, the axis will not be rendered.
        */
        get: /**
             * Gets or sets the IsDisabled property. If true, the axis will not be rendered.
            */
        function () {
            return this.i.bx;
        },
        set: function (v) {
            this.i.bx = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "isInverted", {
        /**
         * Gets or sets the IsInverted property.
        */
        get: /**
             * Gets or sets the IsInverted property.
            */
        function () {
            return this.i.bz;
        },
        set: function (v) {
            this.i.bz = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "useEnhancedIntervalManagement", {
        /**
         * Gets or sets whether to use more advanced heuristics when determining the initial number of labels to render, before resolving collisions, etc.
        */
        get: /**
             * Gets or sets whether to use more advanced heuristics when determining the initial number of labels to render, before resolving collisions, etc.
            */
        function () {
            return this.i.ce;
        },
        set: function (v) {
            this.i.ce = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "enhancedIntervalMinimumCharacters", {
        /**
         * Gets or sets the mininum desired characters to be displayed for horizontal axes when using advanced label heuristics. -1 will attempt to adjust the interval to precisely fit the horizontal labels.
        */
        get: /**
             * Gets or sets the mininum desired characters to be displayed for horizontal axes when using advanced label heuristics. -1 will attempt to adjust the interval to precisely fit the horizontal labels.
            */
        function () {
            return this.i.ej;
        },
        set: function (v) {
            this.i.ej = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "labelTextStyle", {
        /**
         * Gets or sets the text style to use for axis labels.
        */
        get: /**
             * Gets or sets the text style to use for axis labels.
            */
        function () {
            return this.i.as ? this.i.as.textStyle : null;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.as.textStyle = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "labelTextColor", {
        /**
         * The color of the {0}.
        */
        get: /**
             * The color of the {0}.
            */
        function () {
            return brushToString(this.i.as ? this.i.as.textColor : null);
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.as.textColor = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "labelLocation", {
        /**
         * Gets or sets the location of the {0}.
        */
        get: /**
             * Gets or sets the location of the {0}.
            */
        function () {
            return this.i.as ? this.i.as.location : 0;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.as.location = ensureEnum(AxisLabelsLocation_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "labelVisibility", {
        /**
         * Gets or sets the visibility of the {0}.
        */
        get: /**
             * Gets or sets the visibility of the {0}.
            */
        function () {
            return this.i.as ? this.i.as.visibility : 0;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.as.visibility = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "labelShowFirstLabel", {
        /**
         * Gets or sets whether the first label is displayed when the zoom level is set to 1.
        */
        get: /**
             * Gets or sets whether the first label is displayed when the zoom level is set to 1.
            */
        function () {
            return this.i.as ? this.i.as.showFirstLabel : false;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.as.showFirstLabel = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "labelAngle", {
        /**
         * Gets or sets the angle of the {0}.
        */
        get: /**
             * Gets or sets the angle of the {0}.
            */
        function () {
            return this.i.as ? this.i.as.angle : NaN;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.as.angle = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "labelExtent", {
        /**
         * Distance between the axis and the edge of the control.
        */
        get: /**
             * Distance between the axis and the edge of the control.
            */
        function () {
            return this.i.as ? this.i.as.extent : NaN;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.as.extent = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "labelLeftMargin", {
        /**
         * Margin applied to the left of the {0}.
        */
        get: /**
             * Margin applied to the left of the {0}.
            */
        function () {
            return this.i.as ? this.i.as.leftMargin : NaN;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.as.leftMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "labelRightMargin", {
        /**
         * Margin applied to the right of the {0}.
        */
        get: /**
             * Margin applied to the right of the {0}.
            */
        function () {
            return this.i.as ? this.i.as.rightMargin : NaN;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.as.rightMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "labelTopMargin", {
        /**
         * Margin applied above the {0}.
        */
        get: /**
             * Margin applied above the {0}.
            */
        function () {
            return this.i.as ? this.i.as.topMargin : NaN;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.as.topMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "labelBottomMargin", {
        /**
         * Margin applied below the {0}.
        */
        get: /**
             * Margin applied below the {0}.
            */
        function () {
            return this.i.as ? this.i.as.bottomMargin : NaN;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.as.bottomMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "labelHorizontalAlignment", {
        /**
         * Gets or sets the horizontal alignment of the {0}.
        */
        get: /**
             * Gets or sets the horizontal alignment of the {0}.
            */
        function () {
            return this.i.as ? this.i.as.horizontalAlignment : 0;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.as.horizontalAlignment = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "labelVerticalAlignment", {
        /**
         * Gets or sets the vertical alignment of the {0}.
        */
        get: /**
             * Gets or sets the vertical alignment of the {0}.
            */
        function () {
            return this.i.as ? this.i.as.verticalAlignment : 0;
        },
        set: function (v) {
            this.ensureLabelSettings();
            this.i.as.verticalAlignment = ensureEnum(VerticalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    IgxAxisComponent.prototype.ensureLabelSettings = function () {
        if (this.i.as) {
            return;
        }
        this.i.as = new AxisLabelSettings();
        this.i.as.location = this.i.at();
        this.i.as.angle = this.i.c8();
        this.i.as.leftMargin = this.i.da();
        this.i.as.rightMargin = this.i.db();
        this.i.as.topMargin = this.i.dc();
        this.i.as.bottomMargin = this.i.c9();
        this.i.as.horizontalAlignment = this.i.hq();
        this.i.as.verticalAlignment = this.i.ij();
    };
    Object.defineProperty(IgxAxisComponent.prototype, "crossingAxis", {
        /**
         * Gets or sets the CrossingAxis property.
        */
        get: /**
             * Gets or sets the CrossingAxis property.
            */
        function () {
            if (this.i.ag == null) {
                return null;
            }
            return this.i.ag.externalObject;
        },
        set: function (v) {
            v == null ? this.i.ag = null : this.i.ag = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "crossingValue", {
        /**
         * Gets or sets the CrossingValue property.
        */
        get: /**
             * Gets or sets the CrossingValue property.
            */
        function () {
            return this.i.eo;
        },
        set: function (v) {
            this.i.eo = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "titlePosition", {
        /**
         * Gets or sets the title position relative to the axis labels.
        */
        get: /**
             * Gets or sets the title position relative to the axis labels.
            */
        function () {
            return this.i.a6 ? this.i.a6.position : 0;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.a6.position = ensureEnum(AxisTitlePosition_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "titleTextStyle", {
        /**
         * Gets or sets the text style to use for axis labels.
        */
        get: /**
             * Gets or sets the text style to use for axis labels.
            */
        function () {
            return this.i.a6 ? this.i.a6.textStyle : null;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.a6.textStyle = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "titleTextColor", {
        /**
         * The color of the {0}.
        */
        get: /**
             * The color of the {0}.
            */
        function () {
            return brushToString(this.i.a6 ? this.i.a6.textColor : null);
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.a6.textColor = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "titleLocation", {
        /**
         * Gets or sets the location of the {0}.
        */
        get: /**
             * Gets or sets the location of the {0}.
            */
        function () {
            return this.i.a6 ? this.i.a6.location : 0;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.a6.location = ensureEnum(AxisLabelsLocation_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "titleVisibility", {
        /**
         * Gets or sets the visibility of the {0}.
        */
        get: /**
             * Gets or sets the visibility of the {0}.
            */
        function () {
            return this.i.a6 ? this.i.a6.visibility : 0;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.a6.visibility = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "titleShowFirstLabel", {
        /**
         * Gets or sets whether the first label is displayed when the zoom level is set to 1.
        */
        get: /**
             * Gets or sets whether the first label is displayed when the zoom level is set to 1.
            */
        function () {
            return this.i.a6 ? this.i.a6.showFirstLabel : false;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.a6.showFirstLabel = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "titleAngle", {
        /**
         * Gets or sets the angle of the {0}.
        */
        get: /**
             * Gets or sets the angle of the {0}.
            */
        function () {
            return this.i.a6 ? this.i.a6.angle : NaN;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.a6.angle = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "titleExtent", {
        /**
         * Distance between the axis and the edge of the control.
        */
        get: /**
             * Distance between the axis and the edge of the control.
            */
        function () {
            return this.i.a6 ? this.i.a6.extent : NaN;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.a6.extent = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "titleLeftMargin", {
        /**
         * Margin applied to the left of the {0}.
        */
        get: /**
             * Margin applied to the left of the {0}.
            */
        function () {
            return this.i.a6 ? this.i.a6.leftMargin : NaN;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.a6.leftMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "titleRightMargin", {
        /**
         * Margin applied to the right of the {0}.
        */
        get: /**
             * Margin applied to the right of the {0}.
            */
        function () {
            return this.i.a6 ? this.i.a6.rightMargin : NaN;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.a6.rightMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "titleTopMargin", {
        /**
         * Margin applied above the {0}.
        */
        get: /**
             * Margin applied above the {0}.
            */
        function () {
            return this.i.a6 ? this.i.a6.topMargin : NaN;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.a6.topMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "titleBottomMargin", {
        /**
         * Margin applied below the {0}.
        */
        get: /**
             * Margin applied below the {0}.
            */
        function () {
            return this.i.a6 ? this.i.a6.bottomMargin : NaN;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.a6.bottomMargin = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "titleHorizontalAlignment", {
        /**
         * Gets or sets the horizontal alignment of the {0}.
        */
        get: /**
             * Gets or sets the horizontal alignment of the {0}.
            */
        function () {
            return this.i.a6 ? this.i.a6.horizontalAlignment : 0;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.a6.horizontalAlignment = ensureEnum(HorizontalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "titleVerticalAlignment", {
        /**
         * Gets or sets the vertical alignment of the {0}.
        */
        get: /**
             * Gets or sets the vertical alignment of the {0}.
            */
        function () {
            return this.i.a6 ? this.i.a6.verticalAlignment : 0;
        },
        set: function (v) {
            this.ensureTitleSettings();
            this.i.a6.verticalAlignment = ensureEnum(VerticalAlignment_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    IgxAxisComponent.prototype.ensureTitleSettings = function () {
        if (this.i.a6) {
            return;
        }
        this.i.a6 = new TitleSettings();
        this.i.a6.location = this.i.au();
        this.i.a6.angle = this.i.dd();
        this.i.a6.leftMargin = this.i.df();
        this.i.a6.rightMargin = this.i.dg();
        this.i.a6.topMargin = this.i.dh();
        this.i.a6.bottomMargin = this.i.de();
        this.i.a6.horizontalAlignment = this.i.hr();
        this.i.a6.verticalAlignment = this.i.ik();
    };
    Object.defineProperty(IgxAxisComponent.prototype, "coercionMethods", {
        /**
         * Gets or sets the coercion methods to use when loading data from data sources.
         * Should be specified before setting any member paths, if being used. Setting it later
         * will not cause data to be re-imported into the chart.
        */
        get: /**
             * Gets or sets the coercion methods to use when loading data from data sources.
             * Should be specified before setting any member paths, if being used. Setting it later
             * will not cause data to be re-imported into the chart.
            */
        function () {
            return this.i.coercionMethods;
        },
        set: function (v) {
            this.i.coercionMethods = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "expectFunctions", {
        /**
         * Gets or sets whether the series should expect that properties in its items source may be functions that need to be
         * evaluated to yield their value. This defaults to false, as there will be a subtle performance impact to using this feature.
         * This value must be set before assigning an item's source to take effect.
        */
        get: /**
             * Gets or sets whether the series should expect that properties in its items source may be functions that need to be
             * evaluated to yield their value. This defaults to false, as there will be a subtle performance impact to using this feature.
             * This value must be set before assigning an item's source to take effect.
            */
        function () {
            return this.i.expectFunctions;
        },
        set: function (v) {
            this.i.expectFunctions = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxAxisComponent.prototype, "label", {
        /**
         * Gets or sets the axis label format string.
        */
        get: /**
             * Gets or sets the axis label format string.
            */
        function () {
            return this.i.er;
        },
        set: function (v) {
            this.i.er = v;
        },
        enumerable: true,
        configurable: true
    });
    /**
 * Renders the axis with no animation.

*/
    /**
         * Renders the axis with no animation.
        
        */
    IgxAxisComponent.prototype.renderAxis = /**
         * Renders the axis with no animation.
        
        */
    function () {
        this.i.gi();
    };
    /**
     * If using enhanced interval management and precise interval fitting, this will reset the cached maximum label width, and recalculate using the current labels.
    
    */
    /**
         * If using enhanced interval management and precise interval fitting, this will reset the cached maximum label width, and recalculate using the current labels.
        
        */
    IgxAxisComponent.prototype.resetCachedEnhancedInterval = /**
         * If using enhanced interval management and precise interval fitting, this will reset the cached maximum label width, and recalculate using the current labels.
        
        */
    function () {
        this.i.gl();
    };
    /**
     * Scales a value from axis space into screen space.
    
    * @param unscaledValue  * The unscaled axis value to scale.
    */
    /**
         * Scales a value from axis space into screen space.
        
        * @param unscaledValue  * The unscaled axis value to scale.
        */
    IgxAxisComponent.prototype.scaleValue = /**
         * Scales a value from axis space into screen space.
        
        * @param unscaledValue  * The unscaled axis value to scale.
        */
    function (unscaledValue) {
        var iv = this.i.dy(unscaledValue);
        return (iv);
    };
    Object.defineProperty(IgxAxisComponent.prototype, "renderRequested", {
        get: /**
             * This event is raised every time a render has been requested from a series.
            */
        function () {
            var _this = this;
            if (this._renderRequested == null) {
                this._renderRequested = new EventEmitter();
                this.i.renderRequested = delegateCombine(this.i.renderRequested, function (o, e) {
                    _this._runInZone(function () {
                        var outerArgs = new RenderRequestedEventArgs();
                        outerArgs._provideImplementation(e);
                        _this._renderRequested.emit({
                            sender: _this,
                            args: outerArgs
                        });
                    });
                });
            }
            return this._renderRequested;
        },
        enumerable: true,
        configurable: true
    });
    IgxAxisComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    IgxAxisComponent.propDecorators = {
        "name": [{ type: Input },],
        "formatLabel": [{ type: Input },],
        "title": [{ type: Input },],
        "stroke": [{ type: Input },],
        "strokeThickness": [{ type: Input },],
        "strip": [{ type: Input },],
        "majorStroke": [{ type: Input },],
        "majorStrokeThickness": [{ type: Input },],
        "minorStroke": [{ type: Input },],
        "minorStrokeThickness": [{ type: Input },],
        "tickStroke": [{ type: Input },],
        "tickStrokeThickness": [{ type: Input },],
        "tickLength": [{ type: Input },],
        "isDisabled": [{ type: Input },],
        "isInverted": [{ type: Input },],
        "useEnhancedIntervalManagement": [{ type: Input },],
        "enhancedIntervalMinimumCharacters": [{ type: Input },],
        "labelTextStyle": [{ type: Input },],
        "labelTextColor": [{ type: Input },],
        "labelLocation": [{ type: Input },],
        "labelVisibility": [{ type: Input },],
        "labelShowFirstLabel": [{ type: Input },],
        "labelAngle": [{ type: Input },],
        "labelExtent": [{ type: Input },],
        "labelLeftMargin": [{ type: Input },],
        "labelRightMargin": [{ type: Input },],
        "labelTopMargin": [{ type: Input },],
        "labelBottomMargin": [{ type: Input },],
        "labelHorizontalAlignment": [{ type: Input },],
        "labelVerticalAlignment": [{ type: Input },],
        "crossingAxis": [{ type: Input },],
        "crossingValue": [{ type: Input },],
        "titlePosition": [{ type: Input },],
        "titleTextStyle": [{ type: Input },],
        "titleTextColor": [{ type: Input },],
        "titleLocation": [{ type: Input },],
        "titleVisibility": [{ type: Input },],
        "titleShowFirstLabel": [{ type: Input },],
        "titleAngle": [{ type: Input },],
        "titleExtent": [{ type: Input },],
        "titleLeftMargin": [{ type: Input },],
        "titleRightMargin": [{ type: Input },],
        "titleTopMargin": [{ type: Input },],
        "titleBottomMargin": [{ type: Input },],
        "titleHorizontalAlignment": [{ type: Input },],
        "titleVerticalAlignment": [{ type: Input },],
        "coercionMethods": [{ type: Input },],
        "expectFunctions": [{ type: Input },],
        "label": [{ type: Input },],
        "renderRequested": [{ type: Output },],
    };
    return IgxAxisComponent;
}());
export { IgxAxisComponent };
//# sourceMappingURL=igx-axis-component.js.map