/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Component, EventEmitter, Output, ViewChild, ChangeDetectionStrategy, TemplateRef, ChangeDetectorRef } from '@angular/core';
import { TypeRegistrar } from './type';
var IgxDataChartDefaultTooltipsComponent = /** @class */ (function () {
    function IgxDataChartDefaultTooltipsComponent(_changeDetectorRef) {
        this._changeDetectorRef = _changeDetectorRef;
        this.onContentReady = new EventEmitter();
    }
    IgxDataChartDefaultTooltipsComponent.prototype.ensureDefaultTooltip = function (series) {
        if (series.isCategory &&
            !series.isVertical &&
            !series.isFinancial &&
            !series.isRange) {
            if (series.showDefaultTooltip) {
                series.tooltipTemplate = this.anchoredCategoryTooltip;
            }
            else {
                if (series.tooltipTemplate === this.anchoredCategoryTooltip) {
                    series.tooltipTemplate = null;
                }
            }
        }
        if (series.isFinancial) {
            if (series.showDefaultTooltip) {
                series.tooltipTemplate = this.financialTooltip;
            }
            else {
                if (series.tooltipTemplate === this.financialTooltip) {
                    series.tooltipTemplate = null;
                }
            }
        }
    };
    IgxDataChartDefaultTooltipsComponent.prototype.format = function (value) {
        if (value.getTime) {
            return this.shortDate(value);
        }
        return value.toString();
    };
    IgxDataChartDefaultTooltipsComponent.prototype.shortDate = function (item) {
        return item.toLocaleDateString() + " " + item.toLocaleTimeString();
    };
    IgxDataChartDefaultTooltipsComponent.prototype.hasOpen = function (series) {
        return series.openMemberPath;
    };
    IgxDataChartDefaultTooltipsComponent.prototype.getOpenValue = function (series, item) {
        return item[series.openMemberPath];
    };
    IgxDataChartDefaultTooltipsComponent.prototype.hasHigh = function (series) {
        return series.highMemberPath;
    };
    IgxDataChartDefaultTooltipsComponent.prototype.getHighValue = function (series, item) {
        return item[series.highMemberPath];
    };
    IgxDataChartDefaultTooltipsComponent.prototype.hasLow = function (series) {
        return series.lowMemberPath;
    };
    IgxDataChartDefaultTooltipsComponent.prototype.getLowValue = function (series, item) {
        return item[series.lowMemberPath];
    };
    IgxDataChartDefaultTooltipsComponent.prototype.hasClose = function (series) {
        return series.closeMemberPath;
    };
    IgxDataChartDefaultTooltipsComponent.prototype.getCloseValue = function (series, item) {
        return item[series.closeMemberPath];
    };
    IgxDataChartDefaultTooltipsComponent.prototype.hasVolume = function (series) {
        return series.volumeMemberPath;
    };
    IgxDataChartDefaultTooltipsComponent.prototype.getVolumeValue = function (series, item) {
        return item[series.volumeMemberPath];
    };
    IgxDataChartDefaultTooltipsComponent.prototype.getAnchoredValue = function (series, item) {
        return item[series.valueMemberPath];
    };
    IgxDataChartDefaultTooltipsComponent.prototype.getBrush = function (series) {
        return series.actualBrush;
    };
    IgxDataChartDefaultTooltipsComponent.prototype.asAny = function (item) {
        return item;
    };
    IgxDataChartDefaultTooltipsComponent.register = function () {
        TypeRegistrar.registerCons("IgxDataChartDefaultTooltipsComponent", IgxDataChartDefaultTooltipsComponent);
    };
    IgxDataChartDefaultTooltipsComponent.prototype.ngAfterContentInit = function () {
        this.onContentReady.emit({});
    };
    IgxDataChartDefaultTooltipsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-data-chart-default-tooltips',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: "\n    <ng-template #anchoredCategoryTooltip let-series=\"series\" let-item=\"item\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\">            \n            <span *ngIf=\"series.xAxis.isDateTime\">{{shortDate(asAny(item)[asAny(series.xAxis).dateTimeMemberPath])}}</span>\n            <br *ngIf=\"series.xAxis.isDateTime\" />\n            <span *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\">{{format(asAny(item)[series.xAxis.label])}}</span>\n            <br *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\" />\n            <span [style.color]=\"getBrush(series)\">{{series.title}}: </span>\n            <span class=\"ui-tooltip-priority\">{{getAnchoredValue(series, item)}}</span>\n        </div>\n    </ng-template>\n    <ng-template #financialTooltip let-series=\"series\" let-item=\"item\">\n        <div class='ui-chart-default-tooltip-content' *ngIf=\"item\">            \n            <span *ngIf=\"series.xAxis.isDateTime\">{{shortDate(asAny(item)[asAny(series.xAxis).dateTimeMemberPath])}}</span>\n            <br *ngIf=\"series.xAxis.isDateTime\" />\n            <span *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\">{{format(asAny(item)[series.xAxis.label])}}</span>\n            <br *ngIf=\"!series.xAxis.isDateTime && series.xAxis.label\" />\n            <span [style.color]=\"getBrush(series)\">{{series.title}}: </span>\n            <table>\n                <tr *ngIf=\"hasOpen(series)\"><td>Open:</td><td>{{getOpenValue(series, item)}}</td></tr>\n                <tr *ngIf=\"hasHigh(series)\"><td>High:</td><td>{{getHighValue(series, item)}}</td></tr>\n                <tr *ngIf=\"hasLow(series)\"><td>Low:</td><td>{{getLowValue(series, item)}}</td></tr>\n                <tr *ngIf=\"hasClose(series)\"><td>Close:</td><td>{{getCloseValue(series, item)}}</td></tr>\n                <tr *ngIf=\"hasVolume(series)\"><td>Volume:</td><td>{{getVolumeValue(series, item)}}</td></tr>\n            </table>\n        </div>\n    </ng-template>\n  ",
                    styles: []
                },] },
    ];
    /** @nocollapse */
    IgxDataChartDefaultTooltipsComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef, },
    ]; };
    IgxDataChartDefaultTooltipsComponent.propDecorators = {
        "anchoredCategoryTooltip": [{ type: ViewChild, args: ["anchoredCategoryTooltip",] },],
        "financialTooltip": [{ type: ViewChild, args: ["financialTooltip",] },],
        "onContentReady": [{ type: Output },],
    };
    return IgxDataChartDefaultTooltipsComponent;
}());
export { IgxDataChartDefaultTooltipsComponent };
//# sourceMappingURL=igx-data-chart-default-tooltips-component.js.map