import { HighlightingState_$type } from './HighlightingState';
import { HighlightingInfo as HighlightingInfo_internal } from "./HighlightingInfo";
import { ensureEnum, ensureBool } from "./componentUtil";
/**
 * Contains contextual information about a highlighting.
*
* You can use the `HighlightingInfo` to get the current series is a range type series.
*
* <!-- Angular JS -->
*
*      N/A
*
* <!-- Ignite JS -->
*
*      N/A
*/
var /**
 * Contains contextual information about a highlighting.
*
* You can use the `HighlightingInfo` to get the current series is a range type series.
*
* <!-- Angular JS -->
*
*      N/A
*
* <!-- Ignite JS -->
*
*      N/A
*/
HighlightingInfo = /** @class */ (function () {
    function HighlightingInfo() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    HighlightingInfo.prototype.createImplementation = function () {
        return new HighlightingInfo_internal();
    };
    Object.defineProperty(HighlightingInfo.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    HighlightingInfo.prototype.onImplementationCreated = function () {
    };
    HighlightingInfo.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(HighlightingInfo.prototype, "startIndex", {
        /**
         * The index of the first highlighted item.
        *
        * You can use `startIndex` to get or set the first highlighted item for the series.
        */
        get: /**
             * The index of the first highlighted item.
            *
            * You can use `startIndex` to get or set the first highlighted item for the series.
            */
        function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HighlightingInfo.prototype, "endIndex", {
        /**
         * The index of the last highlighted item.
        *
        * You can use the `endIndex` to get or set the last highlighted item for the series.
        */
        get: /**
             * The index of the last highlighted item.
            *
            * You can use the `endIndex` to get or set the last highlighted item for the series.
            */
        function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HighlightingInfo.prototype, "state", {
        /**
         * The state of the highlighting.
        *
        * You can use the `state` to get or set the transitioning state of the highlighting, between In, Out, or Static.
        */
        get: /**
             * The state of the highlighting.
            *
            * You can use the `state` to get or set the transitioning state of the highlighting, between In, Out, or Static.
            */
        function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = ensureEnum(HighlightingState_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HighlightingInfo.prototype, "progress", {
        /**
         * A number between 0 and 1 representing the progress of the highlighting.
        *
        * You can use the `progress` property to set a number between 0 and 1 representing the progress of the highlighting.
        */
        get: /**
             * A number between 0 and 1 representing the progress of the highlighting.
            *
            * You can use the `progress` property to set a number between 0 and 1 representing the progress of the highlighting.
            */
        function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HighlightingInfo.prototype, "isMarker", {
        /**
         * True if this HighlightingInfo represents a marker highlighting.
        *
        * You can set the `isMarker` to True if the HighlightingInfo represents a marker highlighting. Otherwise set to false.
        */
        get: /**
             * True if this HighlightingInfo represents a marker highlighting.
            *
            * You can set the `isMarker` to True if the HighlightingInfo represents a marker highlighting. Otherwise set to false.
            */
        function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HighlightingInfo.prototype, "series", {
        /**
         * The series in context.
        *
        * You can use the `series` property to get the series in context.
        */
        get: /**
             * The series in context.
            *
            * You can use the `series` property to get the series in context.
            */
        function () {
            if (this.i.b == null) {
                return null;
            }
            return this.i.b.externalObject;
        },
        enumerable: true,
        configurable: true
    });
    return HighlightingInfo;
}());
/**
 * Contains contextual information about a highlighting.
*
* You can use the `HighlightingInfo` to get the current series is a range type series.
*
* <!-- Angular JS -->
*
*      N/A
*
* <!-- Ignite JS -->
*
*      N/A
*/
export { HighlightingInfo };
//# sourceMappingURL=igx-highlighting-info.js.map