import * as tslib_1 from "tslib";
import { forwardRef, Input } from '@angular/core';
import { toPoint, fromPoint } from './componentUtil';
import { IgxCategoryAxisBaseComponent } from './igx-category-axis-base-component';
import { IgxNumericYAxisComponent } from './igx-numeric-y-axis-component';
import { IgxRangeCategorySeriesComponent } from './igx-range-category-series-component';
import { IgxCategorySeriesComponent } from './igx-category-series-component';
import { IgxMarkerSeriesComponent } from './igx-marker-series-component';
import { IgxSeriesComponent } from './igx-series-component';
export var IgxHorizontalRangeCategorySeriesComponent_PROVIDERS = [{ provide: IgxRangeCategorySeriesComponent, useExisting: forwardRef(function () { return IgxHorizontalRangeCategorySeriesComponent; }) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(function () { return IgxHorizontalRangeCategorySeriesComponent; }) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(function () { return IgxHorizontalRangeCategorySeriesComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxHorizontalRangeCategorySeriesComponent; }) }];
/**
 * Base class for ranged category series with a category X-axis and a numeric Y-axis.
*
* Instantiate HorizontalAnchoredCategorySeries
*/
var IgxHorizontalRangeCategorySeriesComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxHorizontalRangeCategorySeriesComponent, _super);
    function IgxHorizontalRangeCategorySeriesComponent() {
        return _super.call(this) || this;
    }
    Object.defineProperty(IgxHorizontalRangeCategorySeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxHorizontalRangeCategorySeriesComponent.prototype, "xAxisName", {
        get: function () {
            return this._xAxisName;
        },
        set: function (value) {
            this._xAxisName = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxHorizontalRangeCategorySeriesComponent.prototype, "yAxisName", {
        get: function () {
            return this._yAxisName;
        },
        set: function (value) {
            this._yAxisName = value;
        },
        enumerable: true,
        configurable: true
    });
    IgxHorizontalRangeCategorySeriesComponent.prototype.bindAxes = function (axes) {
        this._boundAxes = axes;
        var ax = this._boundAxes;
        console.log("axes to check: " + ax.length);
        for (var i = 0; i < ax.length; i++) {
            console.log("checking for: " + ax[i].name);
            if (this.xAxisName == null) {
                this.xAxis = null;
            }
            if (this.xAxisName == ax[i].name) {
                this.xAxis = ax[i];
            }
            if (this.yAxisName == null) {
                this.yAxis = null;
            }
            if (this.yAxisName == ax[i].name) {
                this.yAxis = ax[i];
            }
        }
    };
    Object.defineProperty(IgxHorizontalRangeCategorySeriesComponent.prototype, "xAxis", {
        /**
     * Gets or sets the effective x-axis for the current CategorySeries object.
    *
    * Instantiate xAxis
    */
        get: /**
             * Gets or sets the effective x-axis for the current CategorySeries object.
            *
            * Instantiate xAxis
            */
        function () {
            if (this.i.xAxis == null) {
                return null;
            }
            return this.i.xAxis.externalObject;
        },
        set: function (v) {
            v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxHorizontalRangeCategorySeriesComponent.prototype, "yAxis", {
        /**
         * Gets or sets the effective y-axis for the current CategorySeries object.
        *
        * Instantiate yAxis
        */
        get: /**
             * Gets or sets the effective y-axis for the current CategorySeries object.
            *
            * Instantiate yAxis
            */
        function () {
            if (this.i.yAxis == null) {
                return null;
            }
            if (!this.i.yAxis.externalObject) {
                var e = new IgxNumericYAxisComponent();
                e._implementation = this.i.yAxis;
                this.i.yAxis.externalObject = e;
            }
            return this.i.yAxis.externalObject;
        },
        set: function (v) {
            v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxHorizontalRangeCategorySeriesComponent.prototype, "isRange", {
        /**
         * Checks if this series is a range series
        *
        * You can use the `isRange` to get the current series is a range type series.
        *
        * <!-- Angular JS -->
        *
        *       var r = this.series.isRange;
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
        get: /**
             * Checks if this series is a range series
            *
            * You can use the `isRange` to get the current series is a range type series.
            *
            * <!-- Angular JS -->
            *
            *       var r = this.series.isRange;
            *
            * <!-- Ignite JS -->
            *
            *      N/A
            */
        function () {
            return this.i.c1;
        },
        enumerable: true,
        configurable: true
    });
    /**
 * Returns the offset value for this series if grouped on a category axis.

*
* You can use the `getOffsetValue` to get the offset value for this series if grouped on a category axis.
*
* <!-- Angular JS -->
*
*       var g = series.getOffsetValue();
*
* <!-- Ignite JS -->
*
*      N/A
*/
    /**
         * Returns the offset value for this series if grouped on a category axis.
        
        *
        * You can use the `getOffsetValue` to get the offset value for this series if grouped on a category axis.
        *
        * <!-- Angular JS -->
        *
        *       var g = series.getOffsetValue();
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
    IgxHorizontalRangeCategorySeriesComponent.prototype.getOffsetValue = /**
         * Returns the offset value for this series if grouped on a category axis.
        
        *
        * You can use the `getOffsetValue` to get the offset value for this series if grouped on a category axis.
        *
        * <!-- Angular JS -->
        *
        *       var g = series.getOffsetValue();
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
    function () {
        var iv = this.i.getOffsetValue();
        return (iv);
    };
    /**
     * Returns the width of the category grouping this series is in.
    
    *
    * You can use the `getCategoryWidth` to get the width of the category grouping a series is in.
    *
    * <!-- Angular JS -->
    *
    *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    /**
         * Returns the width of the category grouping this series is in.
        
        *
        * You can use the `getCategoryWidth` to get the width of the category grouping a series is in.
        *
        * <!-- Angular JS -->
        *
        *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
    IgxHorizontalRangeCategorySeriesComponent.prototype.getCategoryWidth = /**
         * Returns the width of the category grouping this series is in.
        
        *
        * You can use the `getCategoryWidth` to get the width of the category grouping a series is in.
        *
        * <!-- Angular JS -->
        *
        *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
    function () {
        var iv = this.i.getCategoryWidth();
        return (iv);
    };
    IgxHorizontalRangeCategorySeriesComponent.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.e1(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgxHorizontalRangeCategorySeriesComponent.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.e3(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgxHorizontalRangeCategorySeriesComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ed(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgxHorizontalRangeCategorySeriesComponent.prototype.getSeriesLowValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.eb(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgxHorizontalRangeCategorySeriesComponent.prototype.getSeriesHighValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.d9(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgxHorizontalRangeCategorySeriesComponent.prototype.getSeriesHighValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.kw(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgxHorizontalRangeCategorySeriesComponent.prototype.getSeriesLowValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ky(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgxHorizontalRangeCategorySeriesComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.k0(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    *
    * You can use the `canUseAsYAxis` method to determine if object can be used as YAxis
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    /**
         * Determine if object can be used as YAxis
        
        * @param axis  * The object to check
        *
        * You can use the `canUseAsYAxis` method to determine if object can be used as YAxis
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
    IgxHorizontalRangeCategorySeriesComponent.prototype.canUseAsYAxis = /**
         * Determine if object can be used as YAxis
        
        * @param axis  * The object to check
        *
        * You can use the `canUseAsYAxis` method to determine if object can be used as YAxis
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
    function (axis) {
        var iv = this.i.ou(axis);
        return (iv);
    };
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    *
    * You can use the `canUseAsXAxis` method to determine if object can be used as XAxis
    *
    * <!-- Angular JS -->
    *
    *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    /**
         * Determine if object can be used as XAxis
        
        * @param axis  * The object to check
        *
        * You can use the `canUseAsXAxis` method to determine if object can be used as XAxis
        *
        * <!-- Angular JS -->
        *
        *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
    IgxHorizontalRangeCategorySeriesComponent.prototype.canUseAsXAxis = /**
         * Determine if object can be used as XAxis
        
        * @param axis  * The object to check
        *
        * You can use the `canUseAsXAxis` method to determine if object can be used as XAxis
        *
        * <!-- Angular JS -->
        *
        *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
        *
        * <!-- Ignite JS -->
        *
        *      N/A
        */
    function (axis) {
        var iv = this.i.ot(axis);
        return (iv);
    };
    IgxHorizontalRangeCategorySeriesComponent.propDecorators = {
        "xAxisName": [{ type: Input },],
        "yAxisName": [{ type: Input },],
        "xAxis": [{ type: Input },],
        "yAxis": [{ type: Input },],
    };
    return IgxHorizontalRangeCategorySeriesComponent;
}(IgxRangeCategorySeriesComponent));
export { IgxHorizontalRangeCategorySeriesComponent };
//# sourceMappingURL=igx-horizontal-range-category-series-component.js.map