import { Type, OnDestroy, Renderer2, ElementRef, NgZone } from '@angular/core';
import { IgxLegendBaseComponent } from './igx-legend-base-component';
import { Legend } from "./Legend";
import { LegendOrientation } from './LegendOrientation';
export declare const IgxLegendComponent_PROVIDERS: {
    provide: typeof IgxLegendBaseComponent;
    useExisting: Type<any>;
}[];
/**
 * Represents a legend in a IgxDataChartComponent control.
*
* The `IgxLegendComponent` helps end-user identify visuals of chart series with contextual information related to the data plotted in the chart control.
*
* ```html
* angular
* ```
*/
export declare class IgxLegendComponent extends IgxLegendBaseComponent implements OnDestroy {
    private renderer;
    private elRef;
    private document;
    private ngZone;
    container: Element;
    constructor(renderer: Renderer2, elRef: ElementRef, document: any, ngZone: NgZone);
    private _wrapper;
    ngOnDestroy(): void;
    protected createImplementation(): Legend;
    readonly i: Legend;
    /**
 * Gets or sets the current Legend object's orientation.
*/
    orientation: LegendOrientation;
    /**
     * Gets or sets color of text
    */
    textColor: string;
    /**
     * Gets or sets style of text.
    */
    textStyle: string;
}
