import { ensureBool } from "./componentUtil";
/**
 * Provides data for legend mouse button related events.
*/
var /**
 * Provides data for legend mouse button related events.
*/
LegendMouseButtonEventArgs = /** @class */ (function () {
    function LegendMouseButtonEventArgs() {
    }
    Object.defineProperty(LegendMouseButtonEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    LegendMouseButtonEventArgs.prototype.onImplementationCreated = function () {
    };
    LegendMouseButtonEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(LegendMouseButtonEventArgs.prototype, "handled", {
        /**
         * Gets or sets a value that indicates the present state of the event handling for a routed
         * event as it travels the route.
         * ChartMouseButton events are not routed events; setting this property effects the underlying
         * MouseButtonEvent.
        */
        get: /**
             * Gets or sets a value that indicates the present state of the event handling for a routed
             * event as it travels the route.
             * ChartMouseButton events are not routed events; setting this property effects the underlying
             * MouseButtonEvent.
            */
        function () {
            return this.i.handled;
        },
        set: function (v) {
            this.i.handled = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendMouseButtonEventArgs.prototype, "originalSource", {
        /**
         * Gets a reference to the object that raised the event.
        */
        get: /**
             * Gets a reference to the object that raised the event.
            */
        function () {
            return this.i.originalSource;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendMouseButtonEventArgs.prototype, "item", {
        /**
         * Gets the ItemsSource item associated with the current event.
        */
        get: /**
             * Gets the ItemsSource item associated with the current event.
            */
        function () {
            return this.i.item;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendMouseButtonEventArgs.prototype, "series", {
        /**
         * Gets the series associated with the current event.
        */
        get: /**
             * Gets the series associated with the current event.
            */
        function () {
            return this.i.series;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendMouseButtonEventArgs.prototype, "chart", {
        /**
         * Gets the Chart associated with the current event.
        */
        get: /**
             * Gets the Chart associated with the current event.
            */
        function () {
            return this.i.chart;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LegendMouseButtonEventArgs.prototype, "legendItem", {
        /**
         * The legend item that was the target of the mouse event.
        */
        get: /**
             * The legend item that was the target of the mouse event.
            */
        function () {
            return this.i.legendItem;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Provides a human readable description of the mouse button event.
    
    */
    /**
         * Provides a human readable description of the mouse button event.
        
        */
    LegendMouseButtonEventArgs.prototype.toString = /**
         * Provides a human readable description of the mouse button event.
        
        */
    function () {
        var iv = this.i.toString();
        return (iv);
    };
    return LegendMouseButtonEventArgs;
}());
/**
 * Provides data for legend mouse button related events.
*/
export { LegendMouseButtonEventArgs };
//# sourceMappingURL=igx-legend-mouse-button-event-args.js.map