import * as tslib_1 from "tslib";
import { Component, forwardRef, Input, ChangeDetectionStrategy } from '@angular/core';
import { IgxNumericAxisBaseComponent } from './igx-numeric-axis-base-component';
import { IgxAxisComponent } from './igx-axis-component';
import { NumericAngleAxis } from "./NumericAngleAxis";
/**
 * Represents a IgxDataChartComponent angle based axis for polar series.
*/
export var IgxNumericAngleAxisComponent_PROVIDERS = [{ provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(function () { return IgxNumericAngleAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: forwardRef(function () { return IgxNumericAngleAxisComponent; }) }];
var IgxNumericAngleAxisComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxNumericAngleAxisComponent, _super);
    function IgxNumericAngleAxisComponent() {
        return _super.call(this) || this;
    }
    IgxNumericAngleAxisComponent.prototype.createImplementation = function () {
        return new NumericAngleAxis();
    };
    Object.defineProperty(IgxNumericAngleAxisComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAngleAxisComponent.prototype, "isAngular", {
        /**
         * Gets if the current axis is of angular axis type
        */
        get: /**
             * Gets if the current axis is of angular axis type
            */
        function () {
            return this.i.bs;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxNumericAngleAxisComponent.prototype, "startAngleOffset", {
        /**
         * Indicates the angle in degress that the chart's 0th angle should be offset.
        */
        get: /**
             * Indicates the angle in degress that the chart's 0th angle should be offset.
            */
        function () {
            return this.i.ky;
        },
        set: function (v) {
            this.i.ky = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Gets the scaled angle value in radians based on the raw input.
    
    * @param unscaledValue  * The raw input value.
    */
    /**
         * Gets the scaled angle value in radians based on the raw input.
        
        * @param unscaledValue  * The raw input value.
        */
    IgxNumericAngleAxisComponent.prototype.getScaledAngle = /**
         * Gets the scaled angle value in radians based on the raw input.
        
        * @param unscaledValue  * The raw input value.
        */
    function (unscaledValue) {
        var iv = this.i.getScaledAngle(unscaledValue);
        return (iv);
    };
    /**
     * Gets the raw axis value back from the angle that would be used on the chart.
    
    * @param scaledValue  * The chart angle value.
    */
    /**
         * Gets the raw axis value back from the angle that would be used on the chart.
        
        * @param scaledValue  * The chart angle value.
        */
    IgxNumericAngleAxisComponent.prototype.getUnscaledAngle = /**
         * Gets the raw axis value back from the angle that would be used on the chart.
        
        * @param scaledValue  * The chart angle value.
        */
    function (scaledValue) {
        var iv = this.i.getUnscaledAngle(scaledValue);
        return (iv);
    };
    IgxNumericAngleAxisComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-numeric-angle-axis',
                    template: "",
                    providers: [{ provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(function () { return IgxNumericAngleAxisComponent; }) }, { provide: IgxAxisComponent, useExisting: forwardRef(function () { return IgxNumericAngleAxisComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxNumericAngleAxisComponent.ctorParameters = function () { return []; };
    IgxNumericAngleAxisComponent.propDecorators = {
        "startAngleOffset": [{ type: Input },],
    };
    return IgxNumericAngleAxisComponent;
}(IgxNumericAxisBaseComponent));
export { IgxNumericAngleAxisComponent };
//# sourceMappingURL=igx-numeric-angle-axis-component.js.map