import { Type } from '@angular/core';
import { IgxStraightNumericAxisBaseComponent } from './igx-straight-numeric-axis-base-component';
import { IgxAxisComponent } from './igx-axis-component';
import { NumericXAxis } from "./NumericXAxis";
/**
 * Represents a IgxDataChartComponent numeric X axis.
*
* The `IgxNumericXAxisComponent` treats the data as continuously varying numerical data items. Labels on this axis are placed along the X-axis. The location of labels varies according to the value in a data column that is mapped using the `IgxNumericXAxisComponent` property of Scatter Series or `IgxNumericXAxisComponent` property of Bar Series.
*
* ```html
*
* ```
*/
export declare const IgxNumericXAxisComponent_PROVIDERS: {
    provide: typeof IgxAxisComponent;
    useExisting: Type<any>;
}[];
export declare class IgxNumericXAxisComponent extends IgxStraightNumericAxisBaseComponent {
    protected createImplementation(): NumericXAxis;
    readonly i: NumericXAxis;
    constructor();
    scrollRangeIntoView(minimum: number, maximum: number): void;
}
