import * as tslib_1 from "tslib";
import { Component, forwardRef, ChangeDetectionStrategy } from '@angular/core';
import { IgxStrategyBasedIndicatorComponent } from './igx-strategy-based-indicator-component';
import { IgxFinancialIndicatorComponent } from './igx-financial-indicator-component';
import { IgxFinancialSeriesComponent } from './igx-financial-series-component';
import { IgxSeriesComponent } from './igx-series-component';
import { PriceVolumeTrendIndicator } from "./PriceVolumeTrendIndicator";
/**
 * Represents a IgxDataChartComponent Price Volume Trend Indicator series.
 * Default required members: Volume, Close
*
* You can use the `IgxPriceVolumeTrendIndicatorComponent` to measure money flow by adding or subtracting a portion of the daily volume.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-price-volume-trend-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-price-volume-trend-indicator>
* </igx-data-chart>
* ```
*/
export var IgxPriceVolumeTrendIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }];
var IgxPriceVolumeTrendIndicatorComponent = /** @class */ (function (_super) {
    tslib_1.__extends(IgxPriceVolumeTrendIndicatorComponent, _super);
    function IgxPriceVolumeTrendIndicatorComponent() {
        return _super.call(this) || this;
    }
    IgxPriceVolumeTrendIndicatorComponent.prototype.createImplementation = function () {
        return new PriceVolumeTrendIndicator();
    };
    Object.defineProperty(IgxPriceVolumeTrendIndicatorComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxPriceVolumeTrendIndicatorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-price-volume-trend-indicator',
                    template: "",
                    providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }, { provide: IgxSeriesComponent, useExisting: forwardRef(function () { return IgxPriceVolumeTrendIndicatorComponent; }) }],
                    changeDetection: ChangeDetectionStrategy.OnPush
                },] },
    ];
    /** @nocollapse */
    IgxPriceVolumeTrendIndicatorComponent.ctorParameters = function () { return []; };
    return IgxPriceVolumeTrendIndicatorComponent;
}(IgxStrategyBasedIndicatorComponent));
export { IgxPriceVolumeTrendIndicatorComponent };
//# sourceMappingURL=igx-price-volume-trend-indicator-component.js.map