import * as tslib_1 from "tslib";
import { IgxCollection } from './IgxCollection';
import { markType } from './type';
import { SyncableObservableCollection$2 } from './SyncableObservableCollection$2';
import { TimeAxisInterval as TimeAxisInterval_internal } from './TimeAxisInterval';
import { TimeAxisInterval as TimeAxisInterval } from './igx-time-axis-interval';
var TimeAxisIntervalCollection = /** @class */ (function (_super) {
    tslib_1.__extends(TimeAxisIntervalCollection, _super);
    function TimeAxisIntervalCollection(list) {
        var _this = _super.call(this) || this;
        if (!TimeAxisInterval.$type) {
            TimeAxisInterval.$type = markType(TimeAxisInterval, "TimeAxisInterval");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    TimeAxisIntervalCollection.prototype._createInnerColl = function () {
        if (!TimeAxisInterval.$type) {
            TimeAxisInterval.$type = markType(TimeAxisInterval, "TimeAxisInterval");
        }
        var coll = new SyncableObservableCollection$2(TimeAxisInterval.$type, TimeAxisInterval_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = new TimeAxisInterval();
                ext._implementation = int;
            }
            return ext;
        };
        return coll;
    };
    return TimeAxisIntervalCollection;
}(IgxCollection));
export { TimeAxisIntervalCollection };
//# sourceMappingURL=igx-time-axis-interval-collection.js.map