import { Type } from '@angular/core';
import { TimeAxisBreakCollection } from './igx-time-axis-break-collection';
import { IgxTimeAxisBaseComponent } from './igx-time-axis-base-component';
import { IgxAxisComponent } from './igx-axis-component';
import { TimeXAxis } from "./TimeXAxis";
/**
 * A horizontal axis that uses a DateTime scale.
*/
export declare const IgxTimeXAxisComponent_PROVIDERS: {
    provide: typeof IgxAxisComponent;
    useExisting: Type<any>;
}[];
export declare class IgxTimeXAxisComponent extends IgxTimeAxisBaseComponent {
    protected createImplementation(): TimeXAxis;
    readonly i: TimeXAxis;
    constructor();
    private _breaks;
    /**
     * TimeAxisBreaks to apply to this axis, representing spans of time to omit, such as weekends.
    */
    breaks: TimeAxisBreakCollection;
    readonly isCategoryDateTime: boolean;
    /**
     * Gets the index of the data item with the value nearest the given value.
    
    * @param unscaledValue  * The value to find a value close to.
    */
    getIndexClosestToUnscaledValue(unscaledValue: number): number;
}
