/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Component, EventEmitter, Output, ViewChild, ChangeDetectionStrategy, TemplateRef, ChangeDetectorRef } from '@angular/core';
import { TypeRegistrar } from './type';
var IgxFinancialChartDefaultTemplatesComponent = /** @class */ (function () {
    function IgxFinancialChartDefaultTemplatesComponent(_changeDetectorRef) {
        this._changeDetectorRef = _changeDetectorRef;
        this.onContentReady = new EventEmitter();
    }
    IgxFinancialChartDefaultTemplatesComponent.prototype.getSelection = function (ele) {
        var ret = [];
        for (var i = 0; i < ele.options.length; i++) {
            if (ele.options[i].selected) {
                ret.push(ele.options[i].value);
            }
        }
        return ret;
    };
    IgxFinancialChartDefaultTemplatesComponent.register = function () {
        TypeRegistrar.registerCons("IgxFinancialChartDefaultTemplatesComponent", IgxFinancialChartDefaultTemplatesComponent);
    };
    IgxFinancialChartDefaultTemplatesComponent.prototype.ngAfterContentInit = function () {
        this.onContentReady.emit({});
    };
    IgxFinancialChartDefaultTemplatesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'igx-financial-chart-default-templates',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: "\n    <ng-template #financialChartRangeSelectorTemplate let-vm=\"vm\">\n        <div class='financialChartRangeSelector'>\n            <label class='rangeSelectorOneMonth'><input type='radio' value='1m' [checked]=\"vm.oneMonthChecked\" (change)=\"vm.changeSelection($event.target.value)\"><span>1m</span></label>\n            <label class='rangeSelectorThreeMonths'><input type='radio' value='3m' [checked]=\"vm.threeMonthsChecked\" (change)=\"vm.changeSelection($event.target.value)\"/><span>3m</span></label>\n            <label class='rangeSelectorSixMonths'><input type='radio' value='6m' [checked]=\"vm.sixMonthsChecked\" (change)=\"vm.changeSelection($event.target.value)\"/><span>6m</span></label>\n            <label class='rangeSelectorYTD'><input type='radio' value='YTD' [checked]=\"vm.yearToDateChecked\" (change)=\"vm.changeSelection($event.target.value)\"/><span>YTD</span></label>\n            <label class='rangeSelectorOneYear'><input type='radio'value='1y' [checked]=\"vm.oneYearChecked\" (change)=\"vm.changeSelection($event.target.value)\"/><span>1y</span></label>\n            <label class='rangeSelectorAll'><input type='radio' value='all' [checked]=\"vm.allChecked\" (change)=\"vm.changeSelection($event.target.value)\"/><span>all</span></label>\n        </div>\n    </ng-template>   \n    <ng-template #financialChartTrendlinePickerTemplate let-vm=\"vm\">\n        <span class=\"trendLinePickerLabel\">Trendline</span>\n        <select class='financialChartTrendLinePicker' \n        [value]=\"vm.selection\" \n        (change)=\"vm.selection = $event.target.value; vm.onSelectionChanged()\">\n            <option value='None'>None</option>\n            <option value='LinearFit'>LinearFit</option>\n            <option value='QuadraticFit'>QuadraticFit</option>\n            <option value='CubicFit'>CubicFit</option>\n            <option value='QuarticFit'>QuarticFit</option>\n            <option value='QuinticFit'>QuinticFit</option>\n            <option value='LogarithmicFit'>LogarithmicFit</option>\n            <option value='ExponentialFit'>ExponentialFit</option>\n            <option value='PowerLawFit'>PowerLawFit</option>\n            <option value='SimpleAverage'>SimpleAverage</option>\n            <option value='ExponentialAverage'>ExponentialAverage</option>\n            <option value='ModifiedAverage'>ModifiedAverage</option>\n            <option value='CumulativeAverage'>CumulativeAverage</option>\n            <option value='WeightedAverage'>WeightedAverage</option>\n        </select>\n    </ng-template>\n     <ng-template #financialChartOverlayPickerTemplate let-vm=\"vm\">\n        <!--<div class='financialChartOverlayPicker'>-->\n            <button class='financialChartOverlayPickerDropDownButton' (click)=\"vm.onButtonPressed()\">Overlay</button>\n            <select class='financialChartOverlayPickerDropDownList' multiple='true'\n                [style.display]=\"vm.isOpen ? 'block' : 'none'\"\n                (change)=\"vm.selection = getSelection($event.target); vm.onSelectionChanged()\">\n                <option value='BollingerBands' [selected]=\"vm.selection && vm.selection.indexOf('BollingerBands') >= 0\">BollingerBands</option>\n                <option value='PriceChannel' [selected]=\"vm.selection && vm.selection.indexOf('PriceChannel') >= 0\">PriceChannel</option>\n            </select>\n        <!--</div>-->\n    </ng-template>\n    <ng-template #financialChartChartTypePickerTemplate let-vm=\"vm\">\n        <span class=\"chartTypePickerLabel\">Chart Type</span>\n        <select class='financialChartTypePicker' [value]=\"vm.selection\" (change)=\"vm.selection = $event.target.value; vm.onSelectionChanged()\">\n            <option value='Auto'>Auto</option>\n            <option value='Bar'>Bar</option>\n            <option value='Line'>Line</option>\n            <option value='Candle'>Candle</option>\n            <option value='Column'>Column</option>\n        </select>\n    </ng-template>\n    <ng-template #financialChartVolumeTypePickerTemplate let-vm=\"vm\">\n        <span class=\"volumeTypePickerLabel\">Volume</span>\n        <select class='financialChartVolumeTypePicker' [value]=\"vm.selection\" (change)=\"vm.selection = $event.target.value; vm.onSelectionChanged()\">\n            <option value='None'>None</option>\n            <option value='Column'>Column</option>\n            <option value='Line'>Line</option>\n            <option value='Area'>Area</option>\n        </select>\n    </ng-template>\n     <ng-template #financialChartIndicatorPickerTemplate let-vm=\"vm\">\n        <!--<div class='financialChartIndicatorPicker'>-->\n            <button class='financialChartIndicatorPickerDropDownButton' (click)=\"vm.onButtonPressed()\">Indicators</button>\n            <select class='financialChartIndicatorPickerDropDownList' \n                [style.display]=\"vm.isOpen ? 'block' : 'none'\"\n                multiple='true' \n                (change)=\"vm.selection = getSelection($event.target); vm.onSelectionChanged()\">\n                <option value='AbsoluteVolumeOscillator' [selected]=\"vm.selection && vm.selection.indexOf('AbsoluteVolumeOscillator') >= 0\">AbsoluteVolumeOscillator</option>\n                <option value='AccumulationDistribution' [selected]=\"vm.selection && vm.selection.indexOf('AccumulationDistribution') >= 0\">AccumulationDistribution</option>\n                <option value='AverageDirectionalIndex' [selected]=\"vm.selection && vm.selection.indexOf('AverageDirectionalIndex') >= 0\">AverageDirectionalIndex</option>\n                <option value='AverageTrueRange' [selected]=\"vm.selection && vm.selection.indexOf('AverageTrueRange') >= 0\">AverageTrueRange</option>\n                <option value='BollingerBandWidth' [selected]=\"vm.selection && vm.selection.indexOf('BollingerBandWidth') >= 0\">BollingerBandWidth</option>\n                <option value='ChaikinOscillator' [selected]=\"vm.selection && vm.selection.indexOf('ChaikinOscillator') >= 0\">ChaikinOscillator</option>\n                <option value='ChaikinVolatility' [selected]=\"vm.selection && vm.selection.indexOf('ChaikinVolatility') >= 0\">ChaikinVolatility</option>\n                <option value='CommodityChannelIndex' [selected]=\"vm.selection && vm.selection.indexOf('CommodityChannelIndex') >= 0\">CommodityChannelIndex</option>\n                <option value='DetrendedPriceOscillator' [selected]=\"vm.selection && vm.selection.indexOf('DetrendedPriceOscillator') >= 0\">DetrendedPriceOscillator</option>\n                <option value='ForceIndex' [selected]=\"vm.selection && vm.selection.indexOf('ForceIndex') >= 0\">ForceIndex</option>\n                <option value='FullStochasticOscillator' [selected]=\"vm.selection && vm.selection.indexOf('FullStochasticOscillator') >= 0\">FullStochasticOscillator</option>\n                <option value='MarketFacilitationIndex' [selected]=\"vm.selection && vm.selection.indexOf('MarketFacilitationIndex') >= 0\">MarketFacilitationIndex</option>\n                <option value='MassIndex' [selected]=\"vm.selection && vm.selection.indexOf('MassIndex') >= 0\">MassIndex</option>\n                <option value='MedianPrice' [selected]=\"vm.selection && vm.selection.indexOf('MedianPrice') >= 0\">MedianPrice</option>\n                <option value='MoneyFlowIndex' [selected]=\"vm.selection && vm.selection.indexOf('MoneyFlowIndex') >= 0\">MoneyFlowIndex</option>\n                <option value='MovingAverageConvergenceDivergence' [selected]=\"vm.selection && vm.selection.indexOf('MovingAverageConvergenceDivergence') >= 0\">MovingAverageConvergenceDivergence</option>\n                <option value='NegativeVolumeIndex' [selected]=\"vm.selection && vm.selection.indexOf('NegativeVolumeIndex') >= 0\">NegativeVolumeIndex</option>\n                <option value='OnBalanceVolume' [selected]=\"vm.selection && vm.selection.indexOf('OnBalanceVolume') >= 0\">OnBalanceVolume</option>\n                <option value='PercentagePriceOscillator' [selected]=\"vm.selection && vm.selection.indexOf('PercentagePriceOscillator') >= 0\">PercentagePriceOscillator</option>\n                <option value='PercentageVolumeOscillator' [selected]=\"vm.selection && vm.selection.indexOf('PercentageVolumeOscillator') >= 0\">PercentageVolumeOscillator</option>\n                <option value='PositiveVolumeIndex' [selected]=\"vm.selection && vm.selection.indexOf('PositiveVolumeIndex') >= 0\">PositiveVolumeIndex</option>\n                <option value='PriceVolumeTrend' [selected]=\"vm.selection && vm.selection.indexOf('PriceVolumeTrend') >= 0\">PriceVolumeTrend</option>\n                <option value='RateOfChangeAndMomentum' [selected]=\"vm.selection && vm.selection.indexOf('RateOfChangeAndMomentum') >= 0\">RateOfChangeAndMomentum</option>\n                <option value='RelativeStrengthIndex' [selected]=\"vm.selection && vm.selection.indexOf('RelativeStrengthIndex') >= 0\">RelativeStrengthIndex</option>\n                <option value='SlowStochasticOscillator' [selected]=\"vm.selection && vm.selection.indexOf('SlowStochasticOscillator') >= 0\">SlowStochasticOscillator</option>\n                <option value='StandardDeviation' [selected]=\"vm.selection && vm.selection.indexOf('StandardDeviation') >= 0\">StandardDeviation</option>\n                <option value='StochRSI' [selected]=\"vm.selection && vm.selection.indexOf('StochRSI') >= 0\">StochRSI</option>\n                <option value='TRIX' [selected]=\"vm.selection && vm.selection.indexOf('TRIX') >= 0\">TRIX</option>\n                <option value='TypicalPrice' [selected]=\"vm.selection && vm.selection.indexOf('TypicalPrice') >= 0\">TypicalPrice</option>\n                <option value='UltimateOscillator' [selected]=\"vm.selection && vm.selection.indexOf('UltimateOscillator') >= 0\">UltimateOscillator</option>\n                <option value='WeightedClose' [selected]=\"vm.selection && vm.selection.indexOf('WeightedClose') >= 0\">WeightedClose</option>\n                <option value='WilliamsPercentR' [selected]=\"vm.selection && vm.selection.indexOf('WilliamsPercentR') >= 0\">WilliamsPercentR</option>\n            </select>\n        <!--</div>-->\n    </ng-template>\n\n    <ng-template #financialChartToolbarTemplate let-vm=\"vm\">\n        <ng-template #defaultTemplate>\n            <div></div>\n        </ng-template>\n\n        <div class='financialChartToolbar'>\n            <div class='financialChartToolbar'>\n                <div class='financialChartIndicatorPicker' *ngIf='vm.isIndicatorPickerVisible'>\n                    <ng-container *ngTemplateOutlet=\"vm.financialChartIndicatorPicker.template ? vm.financialChartIndicatorPicker.template : defaultTemplate; context: vm.financialChartIndicatorPicker\">\n                    </ng-container>\n                </div>\n                <div class='financialChartOverlayPicker' *ngIf='vm.isOverlayPickerVisible'>\n                    <ng-container *ngTemplateOutlet=\"vm.financialChartOverlayPicker.template ? vm.financialChartOverlayPicker.template : defaultTemplate; context: vm.financialChartOverlayPicker\">\n                    </ng-container>\n                </div>\n                <div class='financialChartTrendLineTypePicker'>\n                    <ng-container *ngTemplateOutlet=\"vm.financialChartTrendLineTypePicker.template ? vm.financialChartTrendLineTypePicker.template : defaultTemplate; context: vm.financialChartTrendLineTypePicker\">\n                    </ng-container>\n                </div>\n                <div class='financialChartRangeSelector'>\n                    <ng-container *ngTemplateOutlet=\"vm.financialChartRangeSelector.template ? vm.financialChartRangeSelector.template : defaultTemplate; context: vm.financialChartRangeSelector\">\n                    </ng-container>\n                </div>\n                <div class='financialChartChartTypePicker'>\n                    <ng-container *ngTemplateOutlet=\"vm.financialChartChartTypePicker.template ? vm.financialChartChartTypePicker.template : defaultTemplate; context: vm.financialChartChartTypePicker\">\n                    </ng-container>\n                </div>\n                <div class='financialChartVolumeTypePicker'>\n                    <ng-container *ngTemplateOutlet=\"vm.financialChartVolumeTypePicker.template ? vm.financialChartVolumeTypePicker.template : defaultTemplate; context: vm.financialChartVolumeTypePicker\">\n                    </ng-container>\n                </div>\n            </div>\n        </div>\n    </ng-template>\n  ",
                    styles: ["\n.financialChartToolbar {\n\tfont-family: \"Verdana\",Arial,sans-serif;\n    font-size: 12px;\n    border-width: 0px;\n    width: 100%;\n    height: 100%;\n    -webkit-tap-highlight-color: rgba(0,0,0,0);\n}\n.financialChartToolbar {\n\tdisplay: grid;\n\tdisplay: -ms-grid;\n\tgrid-row: 1;\n\t-ms-grid-rows: 100%;\n\t-ms-grid-row: 1;\n\t-ms-grid-columns: 100%;\n}\n.financialChartRangeSelector {\n\tflex: 1 0 auto;\n    text-align: center;\n\tgrid-column: 4;\n\t-ms-grid-column: 4;\n}\n.financialChartRangeSelector input {\n\tdisplay: none;\n}\n.financialChartRangeSelector label {\n\tborder-right: 1px solid #758696;\n\tpadding: 0 10px;\n}\n.financialChartRangeSelectorLastOption {\n\tborder: none !important;\n\tpadding-right: 0;\n}\n.financialChartRangeSelector label:hover {\n\tcolor: #0090ff;\n\tcursor: pointer;\n}\n.financialChartRangeSelector input:checked + span\n{\n\tcolor: #0090ff;\n}\n.financialChartChartTypePicker {\n    flex: 1 0 auto;\n\tgrid-column: 5;\n    -ms-grid-column: 5;\n    padding-left: 3px;\n    padding-right: 3px; \n}\n.financialChartIndicatorPicker {\n    flex: 1 0 auto;\n\tgrid-column: 1;\n\t-ms-grid-column: 1;\n}\n.financialChartOverlayPicker {\n    flex: 1 0 auto;\n\tgrid-column: 2;\n\t-ms-grid-column: 2;\n}\n.financialChartTrendLineTypePicker {\n    flex: 1 0 auto;\n\tgrid-column: 3;\n\t-ms-grid-column: 3;\n}\n.financialChartVolumeTypePicker {\n    flex: 1 0 auto;\n\tgrid-column: 6;\n    -ms-grid-column: 6;\n    padding-left: 3px;\n    padding-right: 3px; \n}\n.financialChartIndicatorPicker, .financialChartOverlayPicker {\n\tposition: relative; \n\tdisplay: inline-block;\n}\n.financialChartIndicatorPickerDropDownList, .financialChartOverlayPickerDropDownList {\n\tposition: relative; \n\tdisplay: inline-block;\n\tz-index: 1;\n}\n.financialChartToolbar .financialChartToolbar {\n    display: flex;\n    display: -ms-flexbox;\n\tflex: 1 1 auto;\n    align-items: center;\n    justify-content: flex-start;\n    flex-flow: row nowrap;\n    -ms-flex-flow: row nowrap;\n    background: #eee;\n    border: 1px solid #ccc;\n}\n\n.financialChartIndicatorPickerDropDownList,\n.financialChartOverlayPickerDropDownList {\n    position: absolute!important;\n\ttop: 30px;\n\tleft:0;\n\t-webkit-box-shadow: 0px 4px 10px 1px rgba(0,0,0,0.2);\n\t-moz-box-shadow: 0px 4px 10px 1px rgba(0,0,0,0.2);\n\tbox-shadow: 0px 4px 10px 1px rgba(0,0,0,0.2);\n}\n\n.financialChartIndicatorPickerDropDownButton,.financialChartOverlayPickerDropDownButton {\n\tbackground-color:transparent;\n\tborder:none;\n\toutline:none;\n\tcursor:pointer;\n    display: flex;\n}\n\n.financialChartIndicatorPickerDropDownButton:after,.financialChartOverlayPickerDropDownButton:after {\n\twidth: 0; \n\theight: 0; \n\tborder-style: solid;\n    border-width: 4px 4px 0 4px;\n    border-color: #777 transparent transparent transparent;\n\tcontent:\"\";\n\tposition:relative;\n\ttop: calc(0.5em + 3px);\n\tmargin-left: 5px;\n}\n\n.financialChartRangeSelector label {\n\tpadding:0!important;\n}\n\n.financialChartRangeSelector label span {\n\tpadding:2px 8px 4px;\n}\n\n.financialChartRangeSelector input:checked+span {\n\tcolor:#444!important;\n\tbackground-color:#d5d5d5;\n}\n\n.financialChartRangeSelector label {\n\tborder:none!important;\n\tbackground-color:#eee;\n}\n\n.financialChartPrice {\n\tmargin-top:10px;\n}\n\n.financialChartRangeSelector {\n\ttext-transform:uppercase;\n}\n\n.financialChartToolbar,.financialChartToolbar button {\n\tfont:400 13px \"Verdana\", Arial, sans-serif!important;\n}\n\n.financialChartIndicatorPicker {\n\tbackground: url(\"data:image/svg+xml,%3Csvg id='Layer_1' data-name='Layer 1' xmlns='http://www.w3.org/2000/svg' viewBox='0 0 55 55'%3E%3Cdefs%3E%3Cstyle%3E.cls-1{fill:%23777;}%3C/style%3E%3C/defs%3E%3Ctitle%3EArtboard 2%3C/title%3E%3Crect class='cls-1' x='46.32' y='16.34' width='5.97' height='38.47'/%3E%3Cpolygon class='cls-1' points='36.73 54.8 42.7 54.8 42.7 20.71 40.34 20.71 36.73 23.92 36.73 54.8'/%3E%3Cpolygon class='cls-1' points='27.14 30.07 27.14 54.8 33.11 54.8 33.11 27.15 28.46 31.28 27.14 30.07'/%3E%3Cpolygon class='cls-1' points='30.74 20.71 29.62 20.71 30.12 21.22 30.74 20.71'/%3E%3Cpolygon class='cls-1' points='17.55 26.49 17.55 54.8 23.52 54.8 23.52 26.76 20.26 23.78 17.55 26.49'/%3E%3Cpolygon class='cls-1' points='7.96 24.97 7.96 26.49 9.48 24.97 7.96 24.97'/%3E%3Cpolygon class='cls-1' points='7.96 54.8 13.93 54.8 13.93 30.11 7.96 36.08 7.96 54.8'/%3E%3Cpolygon class='cls-1' points='37.29 0.2 43.23 6.14 30.12 16.96 21.68 8.51 2.5 27.69 7.29 32.48 20.26 19.52 28.46 27.02 47.33 10.23 52.5 15.4 52.5 14.57 52.5 0.2 37.29 0.2'/%3E%3C/svg%3E\") no-repeat 0 0;\n\tpadding-left:18px;\n}\n\n.financialChartIndicatorPicker:hover {\n\tbackground: url(\"data:image/svg+xml,%3Csvg id='Layer_1' data-name='Layer 1' xmlns='http://www.w3.org/2000/svg' viewBox='0 0 55 55'%3E%3Cdefs%3E%3Cstyle%3E.cls-1{fill:%230090ff;}.cls-2{fill:%23777;}%3C/style%3E%3C/defs%3E%3Ctitle%3EArtboard 2%3C/title%3E%3Crect class='cls-1' x='46.32' y='16.34' width='5.97' height='38.47'/%3E%3Cpolygon class='cls-1' points='36.73 54.8 42.7 54.8 42.7 20.71 40.34 20.71 36.73 23.92 36.73 54.8'/%3E%3Cpolygon class='cls-1' points='27.14 30.07 27.14 54.8 33.11 54.8 33.11 27.15 28.46 31.28 27.14 30.07'/%3E%3Cpolygon class='cls-2' points='30.74 20.71 29.62 20.71 30.12 21.22 30.74 20.71'/%3E%3Cpolygon class='cls-1' points='17.55 26.49 17.55 54.8 23.52 54.8 23.52 26.76 20.26 23.78 17.55 26.49'/%3E%3Cpolygon class='cls-2' points='7.96 24.97 7.96 26.49 9.48 24.97 7.96 24.97'/%3E%3Cpolygon class='cls-1' points='7.96 54.8 13.93 54.8 13.93 30.11 7.96 36.08 7.96 54.8'/%3E%3Cpolygon class='cls-1' points='37.29 0.2 43.23 6.14 30.12 16.96 21.68 8.51 2.5 27.69 7.29 32.48 20.26 19.52 28.46 27.02 47.33 10.23 52.5 15.4 52.5 14.57 52.5 0.2 37.29 0.2'/%3E%3C/svg%3E\") no-repeat 0 0;\n}\n\n.financialChartOverlayPicker {\n\tbackground: url(\"data:image/svg+xml,%3Csvg id='Layer_1' data-name='Layer 1' xmlns='http://www.w3.org/2000/svg' viewBox='0 0 55 55'%3E%3Cdefs%3E%3Cstyle%3E.cls-1{fill:%23777;}%3C/style%3E%3C/defs%3E%3Ctitle%3EArtboard 2 copy%3C/title%3E%3Cpolygon class='cls-1' points='27.5 45.87 8.96 36.2 0.63 40.54 27.5 54.56 54.38 40.54 46.04 36.2 27.5 45.87'/%3E%3Cpolygon class='cls-1' points='27.5 32.83 8.96 23.15 0.63 27.5 27.5 41.52 54.38 27.5 46.04 23.15 27.5 32.83'/%3E%3Cpolygon class='cls-1' points='27.5 28.48 0.63 14.46 27.5 0.44 54.38 14.46 27.5 28.48'/%3E%3C/svg%3E\") no-repeat 0 0;\n\tpadding-left:18px;\n}\n\n.financialChartOverlayPicker:hover {\n\tbackground: url(\"data:image/svg+xml,%3Csvg id='Layer_1' data-name='Layer 1' xmlns='http://www.w3.org/2000/svg' viewBox='0 0 55 55'%3E%3Cdefs%3E%3Cstyle%3E.cls-1{fill:%230090ff;}%3C/style%3E%3C/defs%3E%3Ctitle%3EArtboard 2 copy%3C/title%3E%3Cpolygon class='cls-1' points='27.5 45.87 8.96 36.2 0.63 40.54 27.5 54.56 54.38 40.54 46.04 36.2 27.5 45.87'/%3E%3Cpolygon class='cls-1' points='27.5 32.83 8.96 23.15 0.63 27.5 27.5 41.52 54.38 27.5 46.04 23.15 27.5 32.83'/%3E%3Cpolygon class='cls-1' points='27.5 28.48 0.63 14.46 27.5 0.44 54.38 14.46 27.5 28.48'/%3E%3C/svg%3E\") no-repeat 0 0;\n}\n\n.financialChartIndicatorPicker:hover,.financialChartOverlayPicker:hover {\n\tcursor:pointer;\n}\n.financialChartIndicatorPicker:hover button,.financialChartOverlayPicker:hover button {\n\tcolor:#0090ff;\n}\n.financialChartIndicatorPicker:hover .financialChartIndicatorPickerDropDownButton:after, .financialChartOverlayPicker:hover .financialChartOverlayPickerDropDownButton:after {\n\tborder-color: #0090ff transparent transparent transparent;\n}\n"]
                },] },
    ];
    /** @nocollapse */
    IgxFinancialChartDefaultTemplatesComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef, },
    ]; };
    IgxFinancialChartDefaultTemplatesComponent.propDecorators = {
        "financialChartRangeSelectorTemplate": [{ type: ViewChild, args: ["financialChartRangeSelectorTemplate",] },],
        "financialChartTrendlinePickerTemplate": [{ type: ViewChild, args: ["financialChartTrendlinePickerTemplate",] },],
        "financialChartOverlayPickerTemplate": [{ type: ViewChild, args: ["financialChartOverlayPickerTemplate",] },],
        "financialChartChartTypePickerTemplate": [{ type: ViewChild, args: ["financialChartChartTypePickerTemplate",] },],
        "financialChartVolumeTypePickerTemplate": [{ type: ViewChild, args: ["financialChartVolumeTypePickerTemplate",] },],
        "financialChartIndicatorPickerTemplate": [{ type: ViewChild, args: ["financialChartIndicatorPickerTemplate",] },],
        "financialChartToolbarTemplate": [{ type: ViewChild, args: ["financialChartToolbarTemplate",] },],
        "onContentReady": [{ type: Output },],
    };
    return IgxFinancialChartDefaultTemplatesComponent;
}());
export { IgxFinancialChartDefaultTemplatesComponent };
//# sourceMappingURL=igx-financial-chart-default-templates.js.map